﻿//application action
(function () {
    //var blog = getCode("http://51jk.cc/addtocart.html?app=m_cart&&invitationCode=dafafefefdaf&act=add&spec_id=80700&quantity=1",'invitationCode');
    var getCode = function(url){
        var results = new RegExp('[\?&]' + "invitationCode" + '=([^&#]*)').exec(url);
        if (results==null){
           return null;
        }
        else{
           return results[1] || 0;
        }
    };

    var getFavorite = function (url) {
        var results = new RegExp('[\?&]' + "favorite" + '=([^&#]*)').exec(url);
        if (results == null) {
            return null;
        }
        else {
            return results[1] || 0;
        }
    };

    Light.action = {
        status: 0,
        log: function (text) {
            //console.log("[action:"+ text + "]");
        },

        errorlog: function (text) {
            //console.log("[action error:" + text + "]");
        },

        showInShop: function(url) {
            //alert("to show");
            switch (DevExpress.devices.real().platform) {
                case "ios":
                    Light.action.serverTo51jkIos(Light.rtdata.memberAcc, url);
                    break;
                case "android":
                    var fullurl = Light.action.serverTo51jkAndroid(Light.rtdata.memberAcc, url);
                    Light.app.navigate({ view: 'Shop', url: fullurl }, { root: true });
                    break;
                default:
                    if (window.plugins && window.plugins.seioinappbrowser) {
                        window.plugins.seioinappbrowser(url, "_system", "location=no");
                    } else if (window.open) {
                        window.open(url, "_system", 'location=no');
                    }
                    break;
            }
        },

        favoriteAndToShop: function (url) {
            var message = "新收藏";
            var title = "收藏";
            var ft = getFavorite(url);
            if (ft != null && ft != 0) { message = ft; }

            var result = DevExpress.ui.dialog.confirm(message, title);
            result.done(function (dialogResult) {

                if (dialogResult) {
                    Light.action.favorite.add(message, url,
                        function (flg) {
                            if (flg) {
                                DevExpress.ui.notify("收藏成功。", "info", 1500);
                                Light.action.favorite.uploadToServer();
                            } else 
                            {
                                DevExpress.ui.notify("已收藏。", "info", 1500);
                            }
                        },
                        function () { });
                }

                Light.action.showInShop(url);
            });
        },

        serverGetIbeacon: function (donefunc, failfunc) {
            var onresponse = function (data) {
                if (donefunc) { donefunc(data); }
            };
            var data = {
            };
            Light.network.request("/app/ibeacon/getAllIbeacon", data, onresponse, failfunc, "post");
        },
        recordActivyDate: function(argplus) {
            var updateflg = false;
            var ndate = Light.tool.getDate();
            if (argplus) {
                //for test only
                ndate = Light.tool.addDate(ndate, argplus);
            }
            if (Light.rtdata.lastActivyDate == "") {
                updateflg = true;
                Light.action.honor.assess(false ,null,null);
            } else {
                var continueCount = Light.tool.dateDiff(ndate, Light.rtdata.lastActivyDate);
                if (continueCount == 0) {//同一天
                    //donothing
                } else if (continueCount == 1) {//continue
                    updateflg = true;
                    Light.action.honor.assess(true, null, null);
                } else {
                    updateflg = true;
                    Light.action.honor.assess(false, null, null);
                }
            }
            if (updateflg == true) {
                Light.rtdata.lastActivyDate = ndate;
                Light.action.setting.setLastActivyDate(ndate);
                Light.action.setting.uploadToServer(function () {}, function () {});
            }
        },

        onauth : function (uid) {
            try {
                //console.log("onauth:" + uid);

                //var key = "testkey001";
                var username = "";
                Light.action.serverthirdPartyLoginCheck(
                    uid, username,
                    function (retData) {
                        Light.action.setting.setThirdPartyType(Light.rtdata.thirdPartyType);
                        if (retData && retData.memberAcc && retData.memberAcc != "") {
                            Light.rtdata.thirdPartyKey = uid;
                            if (retData.currentUdid != null && retData.currentUdid != ""
                                && Light.rtdata.UDID != retData.currentUdid) {
                                Light.Login.setWarnning();
                                return;
                            }
                            Light.Login.thirdPartyLogin();
                        } else {
                            //未录入
                            Light.rtdata.thirdPartyKey = uid;
                            Light.app.navigate({ view: 'Gender', register: false, other: true });
                        }
                    }, null);
            }
            catch (exception) {
                //console.log(exception);
            }

        },

        onauthbak: function (uid) {
            try {
                //console.log("onauth:" + uid);

                //var key = "testkey001";
                var username = "";
                Light.action.serverthirdPartyLoginCheck(
                    uid, username,
                    function (retData) {
                        if (retData && retData.memberAcc && retData.memberAcc != "") {
                            if (Light.rtdata.UDID != retData.currentUdid) {
                                Light.Login.setWarnning();
                                return;
                            }

                            //已录入
                            Light.action.setting.saveAccPassword(retData.memberAcc, "");
                            Light.action.setting.thirdPartyType(retData.thirdPartyType);

                            Light.action.setting.setUserInfoUserName(retData.userName);
                            Light.action.setting.setUserInfoSex(retData.sex);
                            Light.action.setting.setUserInfoBirthday(retData.birthday);
                            Light.action.setting.setUserInfoHeight(retData.userHeight);
                            Light.action.setting.setUserInfoWeight(retData.userWeight);
                            Light.action.setting.setUserInfoJob(retData.userJob);
                            Light.action.setting.setUserInfoAddress(retData.address);
                            Light.action.setting.setUserHeadImg(retData.userHeadImg);
                            Light.rtdata.memberAcc = retData.memberAcc;
                            Light.rtdata.thirdPartyType = retData.thirdPartyType;
                            Light.rtdata.memberPassword = "";
                            Light.Login.serverForData();
                            Light.app.navigate('Home', { root: true });
                        } else {
                            //未录入
                            Light.rtdata.thirdPartyKey = uid;
                            Light.app.navigate({ view: 'Gender', register: false, other: true });
                        }
                    }, null);
            }
            catch (exception) {
                //console.log(exception);
            }

        },



        serverTo51jkAndroid: function (memberAcc, url) {
            
            /* 
            if (true) {
                
                var invitationCode = Light.config.CC_51JK.INVITATION_CODE;
                var code = getCode(url);
                if (code != null && code != 0) {
                    invitationCode = "" + code;
                }

                var tdate = Light.tool.getDate();
                var date = tdate.substring(0, 4) + "-" + tdate.substring(4, 6) + "-" + tdate.substring(6, 8);
                var sign = "" + CryptoJS.MD5(
                    memberAcc + "|" +
                    Light.config.CC_51JK.APP_NAME + "|" +
                    invitationCode + "|" +
                    date + "|" +
                    Light.config.CC_51JK.SECRET_KEY);
                var fullurl = Light.config.CC_51JK.URL + "?" +
                    $.param({
                        app: 'app_login',
                        user: memberAcc,
                        from: Light.config.CC_51JK.APP_NAME,
                        invitationCode: invitationCode,
                        returnUrl: url,
                        sign: sign
                    });
                return fullurl;
            }
            */
            return url;
        },

        serverTo51jkIos: function (memberAcc, url) {
            if (true) {
                /*
                var invitationCode = Light.config.CC_51JK.INVITATION_CODE;
                var code = getCode(url);
                if (code != null && code != 0) {
                    invitationCode = "" + code;
                }

                var tdate = Light.tool.getDate();
                var date = tdate.substring(0, 4) + "-" + tdate.substring(4, 6) + "-" + tdate.substring(6, 8);
                var sign = "" + CryptoJS.MD5(
                    memberAcc + "|" +
                    Light.config.CC_51JK.APP_NAME + "|" +
                    invitationCode + "|" +
                    date + "|" +
                    Light.config.CC_51JK.SECRET_KEY);
                var fullurl = Light.config.CC_51JK.URL + "?" +
                    $.param({
                        app: 'app_login',
                        user: memberAcc,
                        from: Light.config.CC_51JK.APP_NAME,
                        invitationCode: invitationCode,
                        returnUrl: url,
                        sign: sign
                    });

                */
                var fullurl = url;
                //alert("[" + fullurl + "}");

                if (window.plugins && window.plugins.seioinappbrowser) {

                    var redirectpage = function (event) {
                        if (event.tag == "exit2") {
                            Light.app.navigate('HealthIndex', { root: true });
                        } else if (event.tag == "exit3") {
                            Light.tool.toPartnerMessageList();
                        } else {
                            Light.app.navigate('Home', { root: true });
                        }
                    }
                    var ref = window.plugins.seioinappbrowser(fullurl, "_blank", "location=no,toolbar=yes,disallowoverscroll=yes,presentationstyle=pagesheet,transitionstyle=crossdissolve,toolbarposition=top,clearcache=yes,clearsessioncache=yes");
                    ref.addEventListener('exit', redirectpage);
                    //Light.app.navigate('Home', { root: true });
                } else if (window.open) {
                    var authWindow = window.open(fullurl, '_blank', 'location=no');
                }
            }
        },

        serverBindMemberDevice: function (memberAcc, memberPassword, donefunc, failfunc) {
            var data = {
                memberAcc: memberAcc,
                password: "" + memberPassword
            };
            Light.network.request("/app/member/acc/bindMemberDevice", { member: data }, donefunc, failfunc, "post");
        },

        serverUnbindMemberDevice: function (memberAcc, memberPassword, donefunc, failfunc) {
            var data = {
                memberAcc: memberAcc,
                memberPassword: memberPassword
            };
            Light.network.request("/app/member/acc/unbindMemberDevice", data, donefunc, failfunc, "post");
        },

        serverLogin: function (donefunc, failfunc) {
            var onresponse = function (data) {
                if (donefunc) { donefunc(); }
            };
            var data = {
            };
            Light.network.request("/app/member/acc/login", data, onresponse, failfunc, "post");
        },

        serverRegist: function (memberAcc, password, donefunc, failfunc) {

            var data = {
                memberAcc: memberAcc,
                password: "" + password,
                userHeadImg: Light.rtdata.common_imgHead,
                sex: Light.rtdata.common_sex,
                userHeight: Light.rtdata.common_height,
                userWeight: Light.rtdata.common_weight,
                birthday: Light.rtdata.common_birth,
                address: Light.rtdata.common_city,
                mobile: memberAcc
            };
            Light.network.request("/app/member/acc/regist", { member: data }, donefunc, failfunc, "post");
        },

        serverCheckMobile: function (mobile, donefunc, failfunc) {
            Light.network.request("/app/member/acc/chkMobileExist", { mobile: mobile }, donefunc, failfunc, "post");
        },

        serverEditPassword: function (oldPassword, newPassword, donefunc, failfunc) {
            Light.network.request("/app/member/acc/editMemberPassword", { oldPassword: oldPassword, newPassword: newPassword }, donefunc, failfunc, "post");
        },

        serverResetMemberPassword: function (mobile, newPassword, donefunc, failfunc) {
            Light.network.request("/app/member/acc/resetMemberPassword", { mobile: mobile, newPassword: newPassword }, donefunc, failfunc, "post");
        },

        serverthirdPartyLoginCheck: function (key, username, donefunc, failfunc) {
            var data = {
                key: key,
                userName: username
            };
            Light.network.request("/app/member/acc/thirdPartyLoginCheck", { thirdParty: data }, donefunc, failfunc, "post");
        },

        serverthirdPartyLogin: function (key, username, donefunc, failfunc) {
            var data = {
                key: key,
                userName: username
            };
            Light.network.request("/app/member/acc/thirdPartyLogin", { thirdParty: data }, donefunc, failfunc, "post");
        },

        serverthirdPartyRegist: function (thirdParty, member, donefunc, failfunc) {
            var data = {
                thirdParty: thirdParty,
                member: member
            };
            Light.network.request("/app/member/acc/thirdPartyRegist", data, donefunc, failfunc, "post");
        },

        serverChkAppVersion: function (versionInfo, donefunc, failfunc) {

            Light.network.request("/app/member/acc/chkAppVersion", { versionInfo: versionInfo }, donefunc, failfunc, "post");
        },

        serverChkMemStatus: function (UDID, memberAcc, donefunc, failfunc) {
            var data = {
                UDID: UDID,
                memberAcc: memberAcc
            };
            Light.network.request("/app/member/acc/chkMemStatus", { member: data }, donefunc, failfunc, "post");
        },

        resetNative: function () {
            var tUUID = Light.rtdata.UDID;

            if (window.plugins && window.plugins.SharesdkAuth) {
                if (Light.rtdata.thirdPartyType == 1) {
                    window.plugins.SharesdkAuth.unAuth("wx")
                } else if (Light.rtdata.thirdPartyType == 2) {
                    window.plugins.SharesdkAuth.unAuth("qq")
                } else if (Light.rtdata.thirdPartyType == 3) {
                    window.plugins.SharesdkAuth.unAuth("sinawb")
                }
            }
            Light.rtdata.thirdPartyType == 0;

            if (window.plugins && window.plugins.NativePush) {
                window.plugins.NativePush.resetNativePush();
            }

            Light.action.resetUserDB();
            Light.rtdata.UDID = tUUID;
            Light.action.setting.saveUDID(tUUID);
            Light.action.setting.initRtdata();

            Light.app.navigate('Login', { root: true });
        },

        resetAllDB: function () {
            Light.db.food.reset();
            Light.db.movement.reset();
            Light.db.healthSolution.reset();
            Light.db.healthSolutionExecute.reset();

            Light.db.setting.reset();
            Light.db.calorieRecord.reset();
            Light.db.customMedicine.reset();
            Light.db.customMedicinePlan.reset();
            Light.db.customMedicinePlanRecord.reset();
            Light.db.healthPlan.reset();
            Light.db.healthPlanRecord.reset();
            Light.db.notification.reset();
            Light.db.pedometer.reset();
            Light.db.pedometerSum.reset();
            Light.db.weight.reset();
            Light.db.weightAvg.reset();
            Light.db.surveys.reset();
            Light.db.honor.reset();
            Light.db.addressBook.reset();
            Light.db.coin.reset();
            Light.db.favorite.reset();
        },
        resetUserDB: function () {
            Light.db.setting.reset();
            Light.db.calorieRecord.reset();
            Light.db.customMedicine.reset();
            Light.db.customMedicinePlan.reset();
            Light.db.customMedicinePlanRecord.reset();
            Light.db.healthPlan.reset();
            Light.db.healthPlanRecord.reset();
            Light.db.notification.reset();
            Light.db.pedometer.reset();
            Light.db.pedometerSum.reset();
            Light.db.weight.reset();
            Light.db.weightAvg.reset();
            Light.db.surveys.reset();
            Light.db.honor.reset();
            Light.db.addressBook.reset();
            Light.db.coin.reset();
            Light.db.favorite.reset();
        },
        resetUserHealthDB: function () {
            Light.db.pedometer.reset();
            Light.db.pedometerSum.reset();
            Light.db.weight.reset();
            Light.db.weightAvg.reset();
        },

        checkNotification: function () {
            var renewdone = function (count) {
                Light.action.notification.renewSystemNotification(
                        function () { },
                        function () { }
                    );
            };

            var getNotificationdone = function (items) {

                var date = Light.tool.getDate();
                var time = Light.tool.getTime();

                for (var i = 0; i < items.length; i++) {
                    var ttime = items[i].time;
                    var tdate = items[i].date;

                    if (tdate < date || (tdate == date && ttime < time)) {
                        //alert("debug:" + tdate + "-" + ttime);
                        Light.action.notification.renewNotification(renewdone, function () { });
                        break;
                    }
                }
            };

            Light.db.notification.select(
                ["status", 1],
                getNotificationdone,
                function () { });
        }

    };

})();