﻿//action plan
(function () {

    Light.action.calorie = {

        getByDate: function (date, donefunc, failfunc) {
            Light.db.calorieRecord.getOneDate(date, donefunc, failfunc);
        },

        getWeekRecord: function (startdate, enddate, donefunc) {

            var ongetall = function (items) {
                var rt = [];
                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    rt.push({
                        date: item.calorieRecordDate,
                        input: item.calorieInput,
                        output: item.calorieOutput,
                        outputMovement: item.calorieOutputMovement,
                        outputPedometer: item.calorieOutputPedometer,
                        outputBase: item.calorieOutputBase
                    });
                }
                if (donefunc) { donefunc(rt); }
            };
            Light.db.calorieRecord.selectColumnsSort(null, [["calorieRecordDate", ">=", startdate], "and", ["calorieRecordDate", "<=", enddate]], "calorieRecordDate", ongetall);
        },

        getMonthRecord: function (month, donefunc) {
            var datert = Light.tool.getMonthStartEnd(month);
            var startdate = datert.startDate;
            var enddate = datert.endDate;

            var ongetall = function (items) {
                var rt = [];
                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    rt.push({
                        date: item.calorieRecordDate,
                        input: item.calorieInput,
                        output: item.calorieOutput,
                                                outputMovement: item.calorieOutputMovement,
                        outputPedometer: item.calorieOutputPedometer,
                        outputBase: item.calorieOutputBase
                    });
                }
                if (donefunc) { donefunc(rt); }
            };
            Light.db.calorieRecord.selectColumnsSort(null, [["calorieRecordDate", ">=", startdate], "and", ["calorieRecordDate", "<=", enddate]], "calorieRecordDate", ongetall);
        },

        getYearRecord: function (year, donefunc) {
            var rtdate = Light.tool.getYearStartEnd(year);
            var startdate = rtdate.startDate;
            var enddate = rtdate.endDate;

            var ongetall = function (items) {
                var rt = [];

                var summonth = "";
                var suminput = 0;
                var sumouput = 0;
                var sumcount = 0;
                var sumcountMovement = 0;
                var sumcountPedometer = 0;
                var sumcountBase = 0;

                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    if (item.calorieRecordDate.substring(0, 6) != summonth) {
                        if (summonth != "") {
                            rt.push({
                                date: summonth,
                                input: suminput / sumcount,
                                output: sumoutput / sumcount,
                                outputMovement: sumoutputMovement / sumcount,
                                outputPedometer: sumoutputPedometer / sumcount,
                                outputBase: sumoutputBase / sumcount,
                            });
                        }
                        summonth = item.calorieRecordDate.substring(0, 6);
                        suminput = item.calorieInput;
                        sumoutput = item.calorieOutput;
                        sumoutputMovement = item.calorieOutputMovement;
                        sumoutputPedometer = item.calorieOutputPedometer;
                        sumoutputBase = item.calorieOutputBase;
                        sumcount = 1;
                    } else {
                        suminput = suminput + item.calorieInput;
                        sumoutput = sumoutput + item.calorieOutput;
                        sumoutputMovement = sumoutputMovement + item.calorieOutputMovement;
                        sumoutputPedometer = sumoutputPedometer + item.calorieOutputPedometer;
                        sumoutputBase = sumoutputBase + item.calorieOutputBase;
                        sumcount = sumcount + 1;
                    }
                }
                if (summonth != "") {
                    rt.push({
                        date: summonth,
                        input: suminput / sumcount,
                        output: sumoutput / sumcount,
                        outputMovement: sumoutputMovement / sumcount,
                        outputPedometer: sumoutputPedometer / sumcount,
                        outputBase: sumoutputBase / sumcount,
                    });
                }

                if (donefunc) { donefunc(rt); }
            };
            Light.db.calorieRecord.selectColumnsSort(null, [["calorieRecordDate", ">=", startdate], "and", ["calorieRecordDate", "<=", enddate]], "calorieRecordDate", ongetall);
        },

        renewCalorieOneDate: function (date, donefunc, failfunc) {
            var cinput = 0;
            var coutput = 0;
            var coutputMovement = 0;
            var coutputPedometer = 0;
            var coutputBase = Light.action.health.getDefaultCalorie();

            var pedometerdone = function (items) {
                var tcalorie = 0;
                for (var i = 0; i < items.length; i++) {
                    if (items[i].calorie > tcalorie) {
                        tcalorie = items[i].calorie;
                    }
                }
                coutputPedometer = tcalorie;

                coutput = coutputBase + coutputMovement + coutputPedometer;
                Light.db.calorieRecord.set(date, cinput, coutput, coutputMovement,coutputPedometer , coutputBase ,donefunc, failfunc);
            };

            var plandone = function (records) {
                
                if (records && records.length > 0) {
                    for (var i = 0; i < records.length ; i++) {
                        var dtls = records[i].recordDtls;

                        for (var j = 0; j < dtls.length ; j++) {
                            var dtl = dtls[j];
                            if (dtl.dtlKbn == 1) {//input
                                cinput = cinput + dtl.calorie * dtl.dtlNum;
                            } else {//output
                                coutputMovement = coutputMovement + dtl.calorie * dtl.dtlNum;
                            }
                        }
                    }
                };

                Light.db.pedometer.select(["surveyDate", date], pedometerdone, null);
            };

            Light.db.healthPlanRecord.getOneDate(date, plandone, failfunc);
        },

        //********************************************
        
        uploadToServer: function (donefunc, failfunc) {
            if (Light.rtdata.memberAcc == Light.config.TRIAL_USER_KEY) {
                if (donefunc) donefunc();
                return;
            }

            var planlist = [];
            var foruploadplanlist = [];

            var onresponse = function (obj) {
                for (var j = 0; j < foruploadplanlist.length; j++) {
                    Light.db.calorieRecord.update(
                            foruploadplanlist[j],
                            { uploadFlg: 1 },
                            null, null);
                }

                if (donefunc) donefunc(obj);
            };

            var getplandone = function (items) {
                for (var i = 0; i < items.length; i++) {
                    //var item = items[i];
                    planlist.push(items[i]);
                    foruploadplanlist.push(items[i].calorieRecordId);
                }
                if (planlist.length == 0 ) {
                    if (donefunc) { donefunc(); }
                    return;
                }
                Light.network.requestBackground("/app/member/health/uploadCalorie",
                    { calorieList: planlist },
                    onresponse, failfunc, "post");
            }

            Light.db.calorieRecord.select(["uploadFlg", 0], getplandone, failfunc);
        },

        downloadFromServer: function (donefunc, failfunc) {

            var onresponse = function (obj) {
                var planlist = obj;
                for (var j = 0; j < planlist.length; j++) {
                    planlist[j].uploadFlg = 1;

                    Light.db.calorieRecord.insert(
                            planlist[j],
                            null, null);
                }

                if (donefunc) donefunc(obj);
            };

            Light.network.requestBackground("/app/member/health/getCalorie",
                    {},
                    onresponse, failfunc, "post");
        },
    };

})();
