﻿//action coin
(function () {

    Light.action.coin = {
        TYPE:[
            { name: "饮食", code: 0, limit: 3, count: 20 },
            { name: "用药", code: 1, limit: 5, count: 30 },
            { name: "刷牙", code: 2, limit: 1, count: 20 },
            { name: "运动", code: 3, limit: 1, count: 30 },
            { name: "称重", code: 4, limit: 2, count: 30 }
        ],

        record: function (type, donefunc, failfunc) {//0:饮食1:用药2:刷牙3:运动4:称体重
            var today = Light.tool.getDate();
            var limit = this.TYPE[type].limit;
            var count = this.TYPE[type].count;

            var done = function (items) {
                if (items) {
                    if (items.length < limit) {
                        var data = {
                            coinId: Light.tool.newGUID(),
                            coinType: type,
                            coinDate: today,
                            coinCount: count,
                            uploadFlg: 0
                        };
                        Light.db.coin.insert(data, null, null);
                        donefunc(count);
                    } else {
                        donefunc(0);
                    }
                } else {
                    var data = {
                        coinId: Light.tool.newGUID(),
                        coinType: type,
                        coinDate: today,
                        coinCount: count,
                        uploadFlg: 0
                    };
                    Light.db.coin.insert(data, null, null);
                    donefunc(count);
                }
            }

            Light.db.coin.select([
                                    ["coinType", type],
                                    "and",
                                    ["coinDate", today]
                                ]
                                , done, failfunc);
        },

        typeSum: function (type, donefunc, failfunc) {//0:饮食1:用药2:刷牙3:运动4:称体重
            var today = Light.tool.getDate();

            var done = function (items) {
                var rt = [];
                if (items && items.length > 0) {
                    var t0 = 0;
                    var t1 = 0;
                    var t2 = 0;
                    var t3 = 0;
                    var t4 = 0;
                    for (var i = 0; i < items.length; i++) {
                        if (items[i].coinType == 0) {
                            t0 = t0 + items[i].coinCount;
                        } else if (items[i].coinType == 1) {
                            t1 = t1 + items[i].coinCount;
                        } else if (items[i].coinType == 2) {
                            t2 = t2 + items[i].coinCount;
                        } else if (items[i].coinType == 3) {
                            t3 = t3 + items[i].coinCount;
                        } else if (items[i].coinType == 4) {
                            t4 = t4 + items[i].coinCount;
                        }
                    }

                    rt.push({ coinType: "type0", coinCount: t0 });
                    rt.push({ coinType: "type1", coinCount: t1 });
                    rt.push({ coinType: "type2", coinCount: t2 });
                    rt.push({ coinType: "type3", coinCount: t3 });
                    rt.push({ coinType: "type4", coinCount: t4 });
                    donefunc(rt);

                } else {
                    donefunc([]);
                }
            }

            Light.db.coin.select(["coinDate", today]
                                , done, failfunc);
        },

        getByDate: function (date, donefunc, failfunc) {//0:饮食1:用药2:刷牙3:运动4:称体重

            var done = function (items) {
                if (items && items.length > 0) {
                    donefunc(items);
                } else {
                    donefunc([]);
                }
            }

            Light.db.coin.select(["coinDate", date]
                                , done, failfunc);
        },

        getByPeriod: function (startDate, endDate, donefunc, failfunc) {//0:饮食1:用药2:刷牙3:运动4:称体重

            var done = function (items) {
                if (items && items.length > 0) {
                    donefunc(items);
                } else {
                    donefunc([]);
                }
            }

            Light.db.coin.selectColumnsSort(null
                                ,[
                                    ["coinDate", "<=", endDate],
                                    "and",
                                    ["coinDate", ">=", startDate]
                                ]
                                , [{ getter: "coinDate", desc: true }]
                                , done, failfunc);
        },

        uploadToServer: function (donefunc, failfunc) {

            var coinlist = [];
            var foruploadcoinlist = [];

            var onresponse = function (obj) {
                for (var j = 0; j < foruploadcoinlist.length; j++) {
                    Light.db.coin.update(
                            foruploadcoinlist[j],
                            { uploadFlg: 1 },
                            null, null);
                }

                if (donefunc) donefunc(obj);
            };

            var getplandone = function (items) {
                for (var i = 0; i < items.length; i++) {
                    coinlist.push(items[i]);
                    foruploadcoinlist.push(items[i].coinId);
                }
                if (coinlist.length == 0) {
                    if (donefunc) { donefunc(); }
                    return;
                }
                Light.network.requestBackground("/app/member/acc/syncMemberCoin",
                    { coinList: coinlist },
                    onresponse, failfunc, "post");
            }

            Light.db.coin.select(["uploadFlg", 0], getplandone, failfunc);
        },

        downloadFromServer: function (donefunc, failfunc) {

            var onresponse = function (obj) {
                var coinList = obj;
                for (var j = 0; j < coinList.length; j++) {
                    coinList[j].uploadFlg = 1;

                    Light.db.coin.insert(
                            coinList[j],
                            null, null);
                }

                if (donefunc) donefunc(obj);
            };

            Light.network.requestBackground("/app/member/acc/getMemberCoinList",
                    {},
                    onresponse, failfunc, "post");
        },
    };
})();
