﻿//action customMedicine
(function () {

    Light.action.customMedicine = {

        create: function (name, memo, frequency, dosage, unit,donefunc, failfunc) {
            var ongetall = function (items) {
                if (items && items.length > 0) {
                    failfunc();
                } else {
                    var values = {
                        customMedicineId: Light.tool.newGUID(),
                        medicineName: name,
                        medicineMemo: memo,
                        eatFrequency: frequency,
                        dosage: dosage,
                        unit: unit,
                        uploadFlg: 0,
                        timestamp: ""
                    };
                    Light.db.customMedicine.insert(values, donefunc, failfunc);
                }
            }

            Light.db.customMedicine.select(["medicineName", name], ongetall, failfunc);
        },

        update: function (id, name, memo, frequency, dosage, unit, donefunc, failfunc) {
            var values = {
                medicineName: name,
                medicineMemo: memo,
                eatFrequency: frequency,
                dosage: dosage,
                unit: unit,
                uploadFlg: 0
            };
            Light.db.customMedicine.update(id, values, donefunc, failfunc);
        },

        remove: function (id, donefunc, failfunc) {
            Light.db.customMedicine.remove(id, donefunc, failfunc);
        },

        getAllLike: function (name, donefunc, failfunc) {
            Light.db.customMedicine.select(["medicineName", "contains", name ], donefunc, failfunc);
        },

        getByName: function (name, donefunc, failfunc) {
            Light.db.customMedicine.select(["medicineName", name], donefunc, failfunc);
        },
        
        uploadToServer: function (donefunc, failfunc) {
            if (Light.rtdata.memberAcc == Light.config.TRIAL_USER_KEY) {
                if (donefunc) donefunc();
                return;
            }

            var foruploadlist = [];

            var onresponse = function () {
                for (var j = 0; j < foruploadlist.length; j++) {
                    Light.db.customMedicine.update(
                        foruploadlist[j],
                        { uploadFlg: 1 },
                        null, null);
                }

                if (donefunc) donefunc();
            };
            var getlocaldone = function (items) {
                var medicinelist = [];
                foruploadlist = [];
                for (var i = 0; i < items.length; i++) {
                    medicinelist.push(items[i]);
                    foruploadlist.push(items[i].customMedicineId);
                }
                if (medicinelist.length == 0) {
                    if (donefunc) { donefunc(); }
                    return;
                }
                Light.network.requestBackground("/app/member/cus/plan/uploadMedicineCusList", { medicineList: medicinelist }, onresponse, failfunc, "post");
            }

            Light.db.customMedicine.select(["uploadFlg", 0], getlocaldone, failfunc);
        },

        downloadFromServer: function (donefunc, failfunc) {
            var onresponse = function (obj) {

                var items = obj;
                for (var i = 0; i < items.length; i++) {
                    items[i].uploadFlg = 1;

                    Light.db.customMedicine.insert(items[i], null, null);
                }

                if (donefunc) { donefunc(); }
            };

            Light.network.requestBackground("/app/member/cus/plan/getMedicineCusList", {}, onresponse, failfunc, "post");
        },
        
    };

})();