﻿//action plan
(function () {

    var createDateListStartEnd = function (argStartDate, argEndDate) {
        var dates = [];
        var i = 0;
        while (true) {
            var newdate = Light.tool.addDate(argStartDate, i++);
            if (newdate <= argEndDate) {
                dates.push(newdate);
            } else {
                break;
            }
        }
        return dates;
    };

    var createDateListEveryDay = function (days, startDate) {
        var dates = [];
        for (var i = 0; i < days ; i++) {
            var newdate = Light.tool.addDate(startDate, i);
            dates.push(newdate);
        }

        return dates;
    };

    var createDateListIntervalDay = function (days, intervaldays, startDate) {
        var dates = [];
        for (var i = 0; i < days ; i++) {
            var newdate = Light.tool.addDate(startDate, i);
            dates.push(newdate);
        }

        var records = [];
        var intervalindex = 0;
        for (var i = 0; i < dates.length; i++) {
            if (i == 0) {
                records.push(dates[i]);
            } else {
                if (intervalindex >= intervaldays) {
                    intervalindex = 0;
                    records.push(dates[i]);
                } else {
                    intervalindex = intervalindex + 1;
                }
            }
        }

        return records;
    };

    var createTakenListWeek = function (weeks, weeklist, startDate) {

        var dates = [];
        for (var i = 0; i < weeks * 7 ; i++) {
            var newdate = Light.tool.addDate(startDate, i);
            dates.push(newdate);
        }

        var records = [];

        for (var i = 0; i < dates.length; i++) {
            var dayindex = Light.tool.getDateIndex(dates[i]);
                if (weeklist[dayindex - 1] == 1) {
                    records.push(dates[i]);
                }
        }

        return records;
    };

    var createDateListEveryDay2 = function (startDate, endDate) {
        var dates = createDateListStartEnd(startDate, endDate);

        return dates;
    };

    var createDateListIntervalDay2 = function (intervaldays, startDate, endDate) {
        var dates = createDateListStartEnd(startDate, endDate);

        var records = [];
        var intervalindex = 0;
        for (var i = 0; i < dates.length; i++) {
            if (i == 0) {
                records.push(dates[i]);
            } else {
                if (intervalindex >= intervaldays) {
                    intervalindex = 0;
                    records.push(dates[i]);
                } else {
                    intervalindex = intervalindex + 1;
                }
            }
        }

        return records;
    };

    var createTakenListWeek2 = function (weeklist, startDate, endDate) {

        var dates = createDateListStartEnd(startDate, endDate);

        var records = [];

        for (var i = 0; i < dates.length; i++) {
            var dayindex = Light.tool.getDateIndex(dates[i]);
            if (weeklist[dayindex - 1] == 1) {
                records.push(dates[i]);
            }
        }

        return records;
    };


    var savePlanCustom = function (
        medicineId, medicineName,
        type,
        datelist, timelist,
        startDate,
        memo, instruction,metadata,
        donefunc) {

        var planid = Light.tool.newGUID();
        var planvalues = {
            medicinePlanId: planid,
            medicineId: medicineId,
            medicineName: medicineName,
            planType: type,
            planMetadata: metadata,
            dateList: datelist,
            timeList: timelist,
            instruction: instruction,
            memo: memo,
            createDate: Light.tool.getDate(),
            startDate: startDate,
            endDate: datelist[datelist.length - 1],
            status: 0,
            uploadFlg: 0,
            timestamp: "",
        };
        Light.db.customMedicinePlan.insert(planvalues, null, null);

        if (donefunc) donefunc(planid);
    };

    Light.action.customMedicinePlan = {

        createPlanEveryDay: function (
            medicineId, medicineName,
            days, timelist, startDate,
            memo, instruction, metadata,
            donefunc) {

            var datelist = createDateListEveryDay(days, startDate);
            savePlanCustom(
                    medicineId, medicineName,
                    1,
                    datelist, timelist,
                    startDate, 
                    memo, instruction, metadata,
                    donefunc);
        },

        createPlanIntervalDay: function (
            medicineId, medicineName,
            days, intervaldays, timelist, startDate,
            memo, instruction, metadata,
            donefunc) {

            var datelist = createDateListIntervalDay(days, intervaldays, startDate);
            savePlanCustom(
                    medicineId, medicineName,
                    2,
                    datelist, timelist,
                    startDate,
                    memo, instruction, metadata,
                    donefunc);
        },

        createPlanWeek: function (
            medicineId, medicineName,
            weeks, weekList, timelist, startDate,
            memo, instruction,metadata,
            donefunc) {
            var datelist = createTakenListWeek(weeks, weekList, startDate);
            savePlanCustom(
                    medicineId, medicineName,
                    3,
                    datelist, timelist,
                    startDate,
                    memo, instruction,metadata,
                    donefunc);
        },

        createPlanEveryDay2: function (
            medicineId, medicineName,
            timelist, startDate, endDate,
            memo, instruction, metadata,
            donefunc) {

            var datelist = createDateListEveryDay2(startDate,endDate);
            savePlanCustom(
                    medicineId, medicineName,
                    1,
                    datelist, timelist,
                    startDate,
                    memo, instruction, metadata,
                    donefunc);
        },

        createPlanIntervalDay2: function (
            medicineId, medicineName,
            intervaldays, timelist, startDate, endDate,
            memo, instruction, metadata,
            donefunc) {

            var datelist = createDateListIntervalDay2(intervaldays, startDate, endDate);
            savePlanCustom(
                    medicineId, medicineName,
                    2,
                    datelist, timelist,
                    startDate,
                    memo, instruction, metadata,
                    donefunc);
        },

        createPlanWeek2: function (
            medicineId, medicineName,
            weekList, timelist, startDate, endDate,
            memo, instruction, metadata,
            donefunc) {
            var datelist = createTakenListWeek2(weekList, startDate, endDate);
            savePlanCustom(
                    medicineId, medicineName,
                    3,
                    datelist, timelist,
                    startDate,
                    memo, instruction, metadata,
                    donefunc);
        },

        createPlanCustomOnce: function (
            medicineId, medicineName,
            timelist, startDate,
            memo, instruction,metadata,
            donefunc) {

            var planid = Light.tool.newGUID();
            var planvalues = {
                medicinePlanId: planid,
                medicineId: medicineId,
                medicineName: medicineName,
                planType: 4,
                planMetadata: metadata,
                dateList: [startDate],
                timeList: timelist,
                instruction: instruction,
                memo: memo,
                createDate: Light.tool.getDate(),
                startDate: startDate,
                endDate: startDate,
                status: 0,
                uploadFlg: 0,
                timestamp: "",
            };
            Light.db.customMedicinePlan.insert(planvalues, null, null);

            if (donefunc) donefunc(planid);
        },

        endPlan: function (planid, enddate, donefunc, failfunc) {
            var done = function (items) {

                if (items) {

                    var datelist;
                    if (items.dateList == "") {
                        datelist = [];
                    } else {
                        datelist = (items.dateList).split(",");
                    }

                    if (datelist.length > 0 && (datelist[0] > enddate)) {
                        Light.db.customMedicinePlan.update(planid,
                            {
                            status: 1,//delete
                            dateList: [],
                            uploadFlg: 0
                            }, donefunc, failfunc);
                    }  else {

                        var newdatelist = [];
                        for (var i = 0; i < datelist.length; i++) {
                            if (datelist[i] <= enddate) {
                                newdatelist.push(datelist[i]);
                            }
                        }

                        var tenddate = enddate;
                        if (newdatelist.length > 0) {
                            tenddate = newdatelist[newdatelist.length -1];
                        }
                        Light.db.customMedicinePlan.update(planid,
                            {
                                endDate: tenddate,
                                dateList: newdatelist,
                                status: 2,//end
                                uploadFlg: 0
                            }, donefunc, failfunc);
                    }


                } else {
                    if (failfunc) failfunc();
                }
            };
            Light.db.customMedicinePlan.getOne(planid , done, failfunc);
        },

        deletePlan: function (planid, donefunc, failfunc) {
            var done = function (item) {
                if (item) {
                    Light.db.customMedicinePlan.update(planid,
                        {
                            status: 1,//delete
                            dateList: [],
                            uploadFlg: 0
                        }, donefunc, failfunc);
                } else {
                    if (failfunc) failfunc();
                }
            };
            Light.db.customMedicinePlan.getOne(planid, done, failfunc);
        },

        getPlanList: function (donefunc, failfunc) {
            var date = Light.tool.getDate();
            Light.db.customMedicinePlan.select(
                [
                    ["status", "<>", 1],//delete
                    "and",
                    ["endDate", ">=", date]
                ], donefunc, failfunc);
        },

        getPlanByDate: function (date, donefunc, failfunc) {
            var done = function (records) {
                var rt = [];
                for (var i = 0; i < records.length; i++) {
                    var record = records[i];
                    rt.push({
                        medicinePlanId: record.medicinePlanId,
                        medicineId: record.medicineId,
                        medicineName: record.medicineName,
                        timeList: record.timeList,
                        instruction: record.instruction,
                        memo: record.memo,
                    });
                }
                if (donefunc) donefunc(rt);
            };
            Light.db.customMedicinePlan.select(
                [
                    ["status","<>",1],//delete
                    "and",
                    ["startDate", "<=", date],
                    "and",
                    ["endDate", ">=", date],
                    "and",
                    ["dateList", "contains", date ]
                ], done, failfunc);
        },

        getRecordListByDate: function (date, donefunc, failfunc) {
            Light.db.customMedicinePlanRecord.getOneDate(date, donefunc, failfunc);
        },

        recordByDateTimeSE: function (date, timestart, timeend, takentime, takenstatus, memo, medicinelist, donefunc, failfunc) {

            Light.db.customMedicinePlanRecord.set(date, timestart, timeend, takentime, takenstatus, memo, medicinelist, donefunc, failfunc);
        },

        //********************************************
        
        uploadToServer: function (donefunc, failfunc) {
            if (Light.rtdata.memberAcc == Light.config.TRIAL_USER_KEY) {
                if (donefunc) donefunc();
                return;
            }
            var planlist = [];
            var foruploadplanlist = [];
            var planrecordlist = [];
            var foruploadplanrecordlist = [];

            var onresponse = function (obj) {

                for (var j = 0; j < foruploadplanlist.length; j++) {
                    Light.db.customMedicinePlan.update(
                            foruploadplanlist[j],
                            { uploadFlg: 1 },
                            null, null);
                }

                for (var j = 0; j < foruploadplanrecordlist.length; j++) {
                    Light.db.customMedicinePlanRecord.update(
                            foruploadplanrecordlist[j],
                            { uploadFlg: 1 },
                            null, null);
                }

                if (donefunc) donefunc(obj);
            };

            var getplandetaildone = function (items) {
                for (var i = 0; i < items.length; i++) {
                    for (var i = 0; i < items.length; i++) {
                        var uploaditem = {
                            customMedicinePlanRecordId: items[i].customMedicinePlanRecordId,
                            customMedicinePlanRecordDate: items[i].customMedicinePlanRecordDate,
                            timeStart: items[i].timeStart,
                            timeEnd: items[i].timeEnd,
                            takenTime: items[i].takenTime,
                            takenStatus: items[i].takenStatus,
                            takenMemo: items[i].takenMemo,
                            mediceineList: JSON.stringify(items[i].mediceineList),
                        };
                        planrecordlist.push(uploaditem);
                        foruploadplanrecordlist.push(items[i].customMedicinePlanRecordId);
                    }
                }
                if (planlist.length == 0 && planrecordlist.length == 0) {
                    if (donefunc) { donefunc(); }
                    return;
                }
                Light.network.requestBackground("/app/member/cus/plan/uploadCustomMedicinePlan",
                    { medicinePlanList: planlist, medicinePlanRecordList: planrecordlist },
                    onresponse, failfunc, "post");
            }

            var getplandone = function (items) {
                for (var i = 0; i < items.length; i++) {
                    var uploaditem = {
                        medicinePlanId: items[i].medicinePlanId,
                        medicineId: items[i].medicineId,
                        medicineName: items[i].medicineName,
                        planType: items[i].planType,
                        planMetadata: JSON.stringify(items[i].planMetadata),
                        dateList: items[i].dateList,
                        timeList: items[i].timeList,
                        instruction: items[i].instruction,
                        memo: items[i].memo,
                        createDate: items[i].createDate,
                        startDate: items[i].startDate,
                        endDate: items[i].endDate,
                        status: items[i].status
                    };
                    planlist.push(uploaditem);
                    foruploadplanlist.push(items[i].medicinePlanId);
                }

                Light.db.customMedicinePlanRecord.select(["uploadFlg", 0], getplandetaildone, failfunc);
            }

            Light.db.customMedicinePlan.select(["uploadFlg", 0], getplandone, failfunc);
        },

        downloadFromServer: function (donefunc, failfunc) {

            var onresponse = function (obj) {
                var planlist = obj.medicinePlanList;
                var planRecordList = obj.medicinePlanRecordList;

                for (var j = 0; j < planlist.length; j++) {
                    planlist[j].uploadFlg = 1;
                    planlist[j].planMetadata = $.parseJSON(planlist[j].planMetadata);
                    Light.db.customMedicinePlan.insert(
                            planlist[j],
                            null, null);
                }

                for (var j = 0; j < planRecordList.length; j++) {
                    planRecordList[j].uploadFlg = 1;
                    planRecordList[j].mediceineList = $.parseJSON(planRecordList[j].mediceineList);
                    Light.db.customMedicinePlanRecord.insert(
                            planRecordList[j],
                            null, null);
                }

                if (donefunc) donefunc(obj);
            };

            Light.network.requestBackground("/app/member/cus/plan/getCustomMedicinePlan",
                    {},
                    onresponse, failfunc, "post");
        },
    };

})();
