﻿// application tool
(function () {
    //var SERVER_URL = "http://192.168.1.94";
    var SERVER_URL = Light.config.APP_SERVER_URL;
    
    Light.action.datashare = {
        
        //设定对某用户的群分享定义
        createDefine: function (useridfrom, groupid, useridto, datestart, dateend, flags, okfunc, errorfunc) {
            var data = {
                userIdFrom: useridfrom,
                userIdTo: useridto,
                groupId: groupid,
                dateStart: datestart,
                dateEnd: dateend,
                flag1: flags[0],
                flag2: flags[1],
                flag3: flags[2],
                flag4: flags[3],
                flag5: flags[4],
            };

            var onresponse = function (data) {
                //alert("createDefine ok.");
                if (okfunc) okfunc(data);
            };
            Light.network.request("/app/groupShare/addGroupShare", data, onresponse, errorfunc, "post");

        },

        //设定对某用户的群分享定义
        updateDefine: function (id, datestart, dateend, flags, okfunc, errorfunc) {
            var data = {
                shareId: id,
                dateStart: datestart,
                dateEnd: dateend,
                flag1: flags[0],
                flag2: flags[1],
                flag3: flags[2],
                flag4: flags[3],
                flag5: flags[4],
            };

            var onresponse = function (data) {
                //alert("createDefine ok.");
                if (okfunc) okfunc(data);
            };
            Light.network.request("/app/groupShare/editGroupShare", data, onresponse, errorfunc, "post");
        },

        //取得用户在某群的所有分享定义
        getMyDefine: function (userid, groupid, okfunc, errorfunc) {
            var data = {
                userIdFrom: userid,
                groupId: groupid,
            };
            var onresponse = function (data) {
                //alert("createDefine ok.");
                if (okfunc) okfunc(data);
            };
            Light.network.request("/app/groupShare/getGroupShareList", data, onresponse, errorfunc, "post");
        },

        //取得用户在某群中他人对自己的所有分享定义
        getDefineForMe: function (userid, groupid, okfunc, errorfunc) {
            var data = {
                userIdTo: userid,
                groupId: groupid,
            };
            var onresponse = function (data) {
                //alert("createDefine ok.");
                if (okfunc) okfunc(data);
            };
            Light.network.request("/app/groupShare/getGroupShareList", data, onresponse, errorfunc, "post");

        },

        //取得用户在某群中某用户分享给自己的数据
        getDataForMe: function (userid, wdstart, wdend, date, okfunc, errorfunc) {

            var donefunc = function (data, healthPlanData) {
                data.healthPlanList = healthPlanData;
                data.weightDayList = data.weightDayList;
                data.pedometerList = data.pedometerList;
                data.medicinePlanList = data.medicinePlanList;
                data.medicinePlanRecordList = data.medicinePlanRecordList;
                data.healthPlanRecordList = data.healthPlanRecordList;
                if (okfunc) okfunc(data);
            };

            var onresponse = function (data) {
                //alert("getShareData ok.");

                var rt = [];
                var plans = [];
                var planindex = 0;
                var plan;
                var getsolutiondone = function (solution) {

                    if (solution != null) {
                        var items = solution.items;
                        for (var i = 0; i < items.length; i++) {
                            var item = items[i];
                            rt.push({
                                healthPlanId: plan.healthPlanId,
                                healthSolutionId: item.healthSolutionId,
                                day: item.day,
                                itemId: item.itemId,
                                itemName: item.itemName,
                                itemType: item.itemType,
                                itemStartTime: item.itemStartTime,
                                itemEndTime: item.itemEndTime,
                                itemDtls: item.itemDtls,
                            });
                        }
                    }

                    if (planindex < plans.length) {

                        plan = plans[planindex];
                        planindex = planindex + 1;

                        var day = 0;
                        var datelist = $.parseJSON(plan.planDateList);
                        for (var i = 0; i < datelist.length; i++) {
                            if (date == datelist[i].date) {
                                day = datelist[i].solutionIndex;
                                break;
                            }
                        }
                        if (day == 0) {
                            getsolutiondone(null);
                        } else {
                            Light.action.healthSolution.getSolutionByIdDay(plan.healthSolutionId, day, getsolutiondone, null);
                        }
                    } else {
                        //rt.sort(function (a, b) { return a.itemStartTime < b.itemStartTime;})
                        donefunc(data, rt);
                    }
                }

                var items = data.healthPlanList;
                if (items && items.length > 0) {
                    plans = items;
                    planindex = 0;
                    getsolutiondone(null);
                } else {
                    donefunc(data, []);
                }
            };

            //request to server
            var data = {
                memberId: userid,
                weightDateStart: wdstart,
                weightDateEnd: wdend,
                date: date,
            };
            Light.network.request("/app/groupShare/getShareData", data, onresponse, errorfunc, "post");

        },

    }
})();
