﻿//action plan
(function () {

    Light.action.favorite = {

        add: function (title, url, donefunc, failfunc) {
            var storeref = this.store;
            var schemeref = this.scheme;
            var md5id = "" + CryptoJS.MD5(url);
            var date = Light.tool.getDate();

            var getdone = function (items) {
                if (items && items.length > 0) {
                    /*
                    var item = items[0];
                    Light.db.favorite.update(
                    item.favoriteId,
                    {
                        favoriteTitle: title,
                        favoriteUrl: url,
                        favoriteDate: date,
                        uploadFlg: 0
                    },
                    function () { donefunc(false); }, failfunc);
                    */
                    donefunc(false);
                } else {
                    Light.db.favorite.insert(
                        {
                        favoriteId: md5id,
                        favoriteTitle: title,
                        favoriteUrl: url,
                        favoriteDate: date,
                        uploadFlg: 0,
                        }, function () {
                            Light.action.favorite.renewAll(
                                function () { donefunc(true); },
                                function () { donefunc(true); });
                        }, failfunc);
                }
            }
            Light.db.favorite.select(["favoriteId", md5id], getdone, failfunc);
        },

        remove: function (id,donefunc, failfunc) {
            Light.db.favorite.remove(id, function () {
                Light.action.favorite.renewAll(
                                function () { donefunc(true); },
                                function () { donefunc(true); });
            }, failfunc);
        },

        renewAll: function(donefunc, failfunc) {
            var getdone = function (items) {
                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    Light.db.favorite.update(
                    item.favoriteId,
                    {
                        uploadFlg: 0
                    });
                }
                donefunc();
            };

            Light.db.favorite.select(null, getdone, failfunc);
        },

        getAll: function( donefunc, failfunc) {
            Light.db.favorite.selectColumnsSort(
                ["favoriteId", "favoriteTitle", "favoriteUrl", "favoriteDate"],
                null,//condition
                [{ getter: "favoriteDate", desc: true },
                    { getter: "favoriteTitle", desc: false }],
                donefunc, failfunc);
        },

        //********************************************

        uploadToServer: function (donefunc, failfunc) {
            
            var favoritelist = [];
            var foruploadfavoritelist = [];

            var onresponse = function (obj) {
                for (var j = 0; j < foruploadfavoritelist.length; j++) {
                    Light.db.favorite.update(
                            foruploadfavoritelist[j],
                            { uploadFlg: 1 },
                            null, null);
                }

                if (donefunc) donefunc(obj);
            };

            var getplandone = function (items) {
                for (var i = 0; i < items.length; i++) {
                    favoritelist.push(items[i]);
                    foruploadfavoritelist.push(items[i].favoriteId);
                }

                Light.network.requestBackground("/app/member/acc/syncMemberFavorite",
                    { favoriteList: favoritelist },
                    onresponse, failfunc, "post");
            }

            Light.db.favorite.select(null, getplandone, failfunc);
        },

        downloadFromServer: function (donefunc, failfunc) {

            var onresponse = function (obj) {
                var favoriteList = obj;
                if (favoriteList) {
                    for (var j = 0; j < favoriteList.length; j++) {
                        favoriteList[j].uploadFlg = 1;

                        Light.db.favorite.insert(
                                favoriteList[j],
                                null, null);
                    }
                }

                if (donefunc) donefunc(obj);
            };

            Light.network.requestBackground("/app/member/acc/getMemberFavorite",
                    {},
                    onresponse, failfunc, "post");
                  
        },
    };

})();
