﻿// application tool
(function () {
    Light.action.health = {
        getDefaultCalorie: function () {
            var calorie = 0;
            var weight = Light.rtdata.common_weight;
            var height = Light.rtdata.common_height;
            var age = Light.rtdata.common_age;
            if (Light.rtdata.common_sex == 1) {
                //男
                calorie = 66 + (13.7 * weight) + (5.0 * height) - (6.8 * age);
            } else {
                //女
                calorie = 655 + (9.6 * weight) + (1.7 * height) - (4.7 * age);
            }

            return calorie;
        },

        getPlanCalorie: function (date, donefunc, failfunc) {
            var getplandone = function (rt) {
                if (rt.hasresult == true) {
                    donefunc(rt);
                } else {
                    var calorie = Light.action.health.getDefaultCalorie();
                    var rate = 1;
                    for (var i = 0; i < Light.config.groupList.length; i++) {
                        if (Light.config.groupList[i].id == Light.rtdata.common_job) {
                            rate = Light.config.groupList[i].rate;
                        }
                    }
                    rt.input = calorie * rate;
                    rt.output = calorie * rate - calorie;

                    donefunc(rt);
                }
            }

            Light.action.healthPlan.getPlanCalorieByDate(date, getplandone, failfunc);
        },
        getDistance: function (steps) {
            var distance = 0;
            if (Light.rtdata.common_sex == 1) {
                //男

                distance = (Light.rtdata.common_height / 100) * 0.415 * steps;
            } else {
                //女
                distance = (Light.rtdata.common_height / 100) * 0.413 * steps;
            }
            return distance;
        },
        getMaxBODYAGE: function () {
            var bodyage = Light.rtdata.common_age + 20;
            return bodyage;
        },
        getNormSfat: function () {
            var sfat = [];
            if (Light.rtdata.common_sex == 1) {
                //男
                sfat.push(8.6);
                sfat.push(16.7);
            } else {
                //女
                sfat.push(18.5);
                sfat.push(26.7);
            }

            return sfat;
        },
        getMaxSfat: function () {
            var sfat = 25;
            if (Light.rtdata.common_sex == 1) {
                //男
                sfat = 25;
            } else {
                //女
                sfat = 44;
            }
            return sfat;
        },
        getNormInfat: function () {
            var infat = [];
            if (Light.rtdata.common_sex == 1) {
                //男
                infat.push(9);
                infat.push(15);
            } else {
                //女
                infat.push(9);
                infat.push(15);
            }

            return infat;
        },
        getMaxInfat: function () {
            var infat = 24;
            return infat;
        },
        getNormWeight: function () {
            var weight = [];
            var paraWeight = 0;
            if (Light.rtdata.common_sex == 1) {
                //男
                paraWeight = (Light.rtdata.common_height - 80) * 0.7;
                weight.push(Globalize.parseFloat(Globalize.format(paraWeight * 0.9, "n1")));
                weight.push(Globalize.parseFloat(Globalize.format(paraWeight * 1.1, "n1")));
                weight.push(Globalize.parseFloat(Globalize.format(paraWeight * 1.2, "n1")));
            } else {
                //女
                paraWeight = (Light.rtdata.common_height - 70) * 0.6;
                weight.push(Globalize.parseFloat(Globalize.format(paraWeight * 0.9, "n1")));
                weight.push(Globalize.parseFloat(Globalize.format(paraWeight * 1.1, "n1")));
                weight.push(Globalize.parseFloat(Globalize.format(paraWeight * 1.2, "n1")));
            }
            return weight;
        },
        getMaxWeight: function () {
            var weight;

            if (Light.rtdata.common_height <= 135) {
                weight = 70.8;
            } else if (Light.rtdata.common_height > 135 && Light.rtdata.common_height <= 140) {
                weight = 76.2;
            } else if (Light.rtdata.common_height > 140 && Light.rtdata.common_height <= 145) {
                weight = 81.8;
            } else if (Light.rtdata.common_height > 145 && Light.rtdata.common_height <= 150) {
                weight = 87.6;
            } else if (Light.rtdata.common_height > 150 && Light.rtdata.common_height <= 155) {
                weight = 93.6;
            } else if (Light.rtdata.common_height > 155 && Light.rtdata.common_height <= 160) {
                weight = 99.9;
            } else if (Light.rtdata.common_height > 160 && Light.rtdata.common_height <= 165) {
                weight = 106.3;
            } else if (Light.rtdata.common_height > 165 && Light.rtdata.common_height <= 170) {
                weight = 112.9;
            } else if (Light.rtdata.common_height > 170 && Light.rtdata.common_height <= 175) {
                weight = 119.7;
            } else if (Light.rtdata.common_height > 175 && Light.rtdata.common_height <= 180) {
                weight = 126.7;
            } else if (Light.rtdata.common_height > 180 && Light.rtdata.common_height <= 185) {
                weight = 134.0;
            } else if (Light.rtdata.common_height > 185) {
                weight = 141.4;
            }
            return weight;
        },
        getNormBMI: function () {
            var BMI = [];

            BMI.push(Light.config.healthBMIList.low);
            BMI.push(Light.config.healthBMIList.normal);
            BMI.push(Light.config.healthBMIList.high);
            return BMI;
        },
        getMaxBMI: function () {
            var BMI = 40;
            return BMI;
        },
        getMaxBFR: function () {
            var BFR;

            if (Light.rtdata.common_sex == 1) {
                //男
                BFR = 30;
            } else {
                BFR = 35;
            }
            return BFR;
        },
        getNormBFR: function () {
            var BFR = [];

            if (Light.rtdata.common_sex == 1) {
                //男
                if (Light.rtdata.common_age <= 30) {
                    BFR.push(Light.config.healthBFR_manList[0].low);
                    BFR.push(Light.config.healthBFR_manList[0].normal);
                    BFR.push(Light.config.healthBFR_manList[0].high);
                } else {
                    BFR.push(Light.config.healthBFR_manList[1].low);
                    BFR.push(Light.config.healthBFR_manList[1].normal);
                    BFR.push(Light.config.healthBFR_manList[1].high);
                }
            } else {
                //女
                if (Light.rtdata.common_age <= 30) {
                    BFR.push(Light.config.healthBFR_womanList[0].low);
                    BFR.push(Light.config.healthBFR_womanList[0].normal);
                    BFR.push(Light.config.healthBFR_womanList[0].high);
                } else {
                    BFR.push(Light.config.healthBFR_womanList[1].low);
                    BFR.push(Light.config.healthBFR_womanList[1].normal);
                    BFR.push(Light.config.healthBFR_womanList[1].high);
                }
            }
            return BFR;
        },
        getNormWATER: function () {
            var WATER = [];

            if (Light.rtdata.common_sex == 1) {
                //男
                if (Light.rtdata.common_age <= 30) {
                    WATER.push(Light.config.healthWATER_manList[0].low);
                    WATER.push(Light.config.healthWATER_manList[0].normal);
                } else {
                    WATER.push(Light.config.healthWATER_manList[1].low);
                    WATER.push(Light.config.healthWATER_manList[1].normal);
                }
            } else {
                //女
                if (Light.rtdata.common_age <= 30) {
                    WATER.push(Light.config.healthWATER_womanList[0].low);
                    WATER.push(Light.config.healthWATER_womanList[0].normal);
                } else {
                    WATER.push(Light.config.healthWATER_womanList[1].low);
                    WATER.push(Light.config.healthWATER_womanList[1].normal);
                }
            }
            return WATER;
        },
        getMaxWATER: function () {
            var WATER = 66;
            return WATER;
        },
        getNormMUS: function () {
            var MUS = [];
            if (Light.rtdata.common_sex == 1) {
                //男
                if (Light.rtdata.common_height < 160) {
                    MUS.push(Light.config.healthMUS_manList[0].low);
                    MUS.push(Light.config.healthMUS_manList[0].normal);
                } else if (Light.rtdata.common_height >= 160 && Light.rtdata.common_height <= 170) {
                    MUS.push(Light.config.healthMUS_manList[1].low);
                    MUS.push(Light.config.healthMUS_manList[1].normal);
                } else if (Light.rtdata.common_height > 170) {
                    MUS.push(Light.config.healthMUS_manList[2].low);
                    MUS.push(Light.config.healthMUS_manList[2].normal);
                }
            } else {
                //女
                if (Light.rtdata.common_height < 150) {
                    MUS.push(Light.config.healthMUS_womanList[0].low);
                    MUS.push(Light.config.healthMUS_womanList[0].normal);
                } else if (Light.rtdata.common_height >= 150 && Light.rtdata.common_height <= 160) {
                    MUS.push(Light.config.healthMUS_womanList[1].low);
                    MUS.push(Light.config.healthMUS_womanList[1].normal);
                } else if (Light.rtdata.common_height > 160) {
                    MUS.push(Light.config.healthMUS_womanList[2].low);
                    MUS.push(Light.config.healthMUS_womanList[2].normal);
                }
            }

            return MUS;
        },
        getMaxMUS: function () {
            var MUS;
            if (Light.rtdata.common_sex == 1) {
                //男
                MUS = 70;
            } else {
                //女
                MUS = 50;
            }
            return MUS;
        },
        getNormBONE: function (weight) {
            var BONE = [];
            if (!weight || weight == 0) {
                weight = Light.rtdata.common_weight;
            }
            if (Light.rtdata.common_sex == 1) {
                //男
                
                BONE.push(Globalize.parseFloat(Globalize.format(Light.config.healthBONEList[0].low / weight * 100, "n1")));
                BONE.push(Globalize.parseFloat(Globalize.format(Light.config.healthBONEList[0].normal / weight * 100, "n1")));
            } else {
                //女
                BONE.push(Globalize.parseFloat(Globalize.format(Light.config.healthBONEList[1].low / weight * 100, "n1")));
                BONE.push(Globalize.parseFloat(Globalize.format(Light.config.healthBONEList[1].normal / weight * 100, "n1")));
            }

            return BONE;
        },
        getMaxBONE: function (weight) {
            if (!weight || weight == 0) {
                weight = Light.rtdata.common_weight;
            }
            if (Light.rtdata.common_sex == 1) {
                //男
                BONE = Globalize.parseFloat(Globalize.format(4 / weight * 100, "n1"));
            } else {
                //女
                BONE = Globalize.parseFloat(Globalize.format(3.3 / weight * 100, "n1"));
            }
            return BONE;
        },
        getNormBMR: function (weight) {
            if (!weight || weight == 0) {
                weight = Light.rtdata.common_weight;
            }
            var BMR = [];
            var bmrval = 0;

            if (Light.rtdata.common_sex == 1) {
                //男
                if (Light.rtdata.common_age >= 10 && Light.rtdata.common_age < 12) {
                    bmrval = weight * 37.4;
                } else if (Light.rtdata.common_age >= 12 && Light.rtdata.common_age < 15) {
                    bmrval = weight * 31.0;
                } else if (Light.rtdata.common_age >= 15 && Light.rtdata.common_age < 18) {
                    bmrval = weight * 27.0;
                } else if (Light.rtdata.common_age >= 18 && Light.rtdata.common_age < 30) {
                    bmrval = weight * 24.0;
                } else if (Light.rtdata.common_age >= 30 && Light.rtdata.common_age < 50) {
                    bmrval = weight * 22.3;
                } else if (Light.rtdata.common_age >= 50 && Light.rtdata.common_age < 70) {
                    bmrval = weight * 21.5;
                } else if (Light.rtdata.common_age >= 70) {
                    bmrval = weight * 21.5;
                } else {
                    bmrval = weight * 37.4;
                }
            } else {
                //女
                if (Light.rtdata.common_age >= 10 && Light.rtdata.common_age < 12) {
                    bmrval = weight * 34.8;
                } else if (Light.rtdata.common_age >= 12 && Light.rtdata.common_age < 15) {
                    bmrval = weight * 29.6;
                } else if (Light.rtdata.common_age >= 15 && Light.rtdata.common_age < 18) {
                    bmrval = weight * 25.3;
                } else if (Light.rtdata.common_age >= 18 && Light.rtdata.common_age < 30) {
                    bmrval = weight * 22.1;
                } else if (Light.rtdata.common_age >= 30 && Light.rtdata.common_age < 50) {
                    bmrval = weight * 21.7;
                } else if (Light.rtdata.common_age >= 50 && Light.rtdata.common_age < 70) {
                    bmrval = weight * 20.7;
                } else if (Light.rtdata.common_age >= 70) {
                    bmrval = weight * 20.7;
                } else {
                    bmrval = weight * 34.8;
                }
            }
            BMR.push(Globalize.format(bmrval, "d"));
            return BMR;
        },
        getMaxBMR: function () {
            var bmrval = 0;
            //alert("common_sex=" + Light.rtdata.common_sex + ";" + "common_age=" + Light.rtdata.common_age + ";" + "common_weight=" + Light.rtdata.common_weight);

            if (Light.rtdata.common_sex == 1) {
                //男
                if (Light.rtdata.common_age >= 10 && Light.rtdata.common_age <= 11) {
                    bmrval = 1529.5;
                } else if (Light.rtdata.common_age >= 12 && Light.rtdata.common_age <= 14) {
                    bmrval = 1713.5;
                } else if (Light.rtdata.common_age >= 15 && Light.rtdata.common_age <= 17) {
                    bmrval = 1817;
                } else if (Light.rtdata.common_age >= 18 && Light.rtdata.common_age <= 29) {
                    bmrval = 1736.5;
                } else if (Light.rtdata.common_age >= 30 && Light.rtdata.common_age <= 49) {
                    bmrval = 1759.5;
                } else if (Light.rtdata.common_age >= 50 && Light.rtdata.common_age <= 69) {
                    bmrval = 1610;
                } else if (Light.rtdata.common_age >= 70) {
                    bmrval = 1472;
                }
            } else {
                //女
                if (Light.rtdata.common_age >= 10 && Light.rtdata.common_age <= 11) {
                    bmrval = 1380;
                } else if (Light.rtdata.common_age >= 12 && Light.rtdata.common_age <= 14) {
                    bmrval = 1564;
                } else if (Light.rtdata.common_age >= 15 && Light.rtdata.common_age <= 17) {
                    bmrval = 1472;
                } else if (Light.rtdata.common_age >= 18 && Light.rtdata.common_age <= 29) {
                    bmrval = 1288;
                } else if (Light.rtdata.common_age >= 30 && Light.rtdata.common_age <= 49) {
                    bmrval = 1322.5;
                } else if (Light.rtdata.common_age >= 50 && Light.rtdata.common_age <= 69) {
                    bmrval = 1276.5;
                } else if (Light.rtdata.common_age >= 70) {
                    bmrval = 1161.5;
                }
            }
            return bmrval;
        },
        getMaxSteps: function () {
            var maxSteps = 33000;
            return maxSteps;
        },
        getMaxCalorie: function () {
            var maxCalorie = 1000;
            return maxCalorie;
        },
        getMaxDistance: function () {
            var maxDistance;
            if (Light.rtdata.common_sex == 1) {
                //男
                maxDistance = 21912;
            } else {
                //女
                maxDistance = 21123;
            }
            return maxDistance;
        },
    };
})();