﻿//0:normal 1:delete 2:end 3:suspend
(function () {
    var createDateListEveryDay = function (days, startDate) {
        var dates = [];
        for (var i = 0; i < days ; i++) {
            var newdate = Light.tool.addDate(startDate, i);
            dates.push(newdate);
        }

        return dates;
    };

    Light.action.healthPlan = {

        createPlan: function (healthSolutionId, startDate, donefunc, failfunc) {

            var getsolutiondone = function (solution) {
                if (solution) {
                    var endDate = Light.tool.addDate(startDate, (solution.movementDays - 1));
                    var tmpdatelist = createDateListEveryDay(solution.movementDays, startDate);
                    var datelist = [];
                    for (var i = 0; i < tmpdatelist.length; i++) {
                        datelist.push({ date: tmpdatelist[i], solutionIndex: (i + 1) });
                    }

                    var planid = Light.tool.newGUID();
                    var planvalues = {
                        healthPlanId: planid,
                        healthSolutionId: healthSolutionId,
                        planCreateDate: Light.tool.getDate(),
                        planStartDate: startDate,
                        planEndDate: endDate,
                        planDateList: datelist,
                        planSuspendCount: 0,
                        status: 0,//normal
                        uploadFlg: 0,
                        timestamp: "",
                    };
                    Light.db.healthPlan.insert(planvalues, donefunc, null);
                } 
            }

            var done = function (plan) {
                if (plan) {
                    if (failfunc) failfunc();
                } else {
                    Light.db.healthSolution.getOne(healthSolutionId, getsolutiondone, null);
                }
            }

            Light.action.healthPlan.getValidPlan(done, failfunc);
        },

        suspendPlan: function (planid, suspenddate, donefunc, failfunc) {
            var done = function (plan) {
                if (plan && plan.status == 0) {//0:normal
                    if (plan.planSuspendCount >= 2) {
                        if (failfunc) failfunc();
                        return;
                    }

                    var datelist = plan.planDateList;
                    var newdatelist = [];
                    for (var i = 0; i < datelist.length; i++) {
                        if (datelist[i].date <= suspenddate) {
                            newdatelist.push({
                                date: datelist[i].date,
                                solutionIndex: datelist[i].solutionIndex
                            });
                        } else {
                            break;
                        }
                    }

                    Light.db.healthPlan.update(planid,
                        {
                            planEndDate: suspenddate,
                            planDateList: newdatelist,
                            planSuspendCount: plan.planSuspendCount + 1,
                            status: 3,//suspend
                            uploadFlg: 0
                        }, donefunc, failfunc);
                } else {
                    if (failfunc) failfunc();
                }
            };
            Light.db.healthPlan.getOne(planid, done, failfunc);
        },

        continuePlan: function (planid, continuedate, donefunc, failfunc) {
            var olddatelist;

            var getsolutiondone = function (solution) {
                if (solution) {
                    var oldenddate = olddatelist[olddatelist.length - 1];
                    if (oldenddate.date >= continuedate) {
                        if (failfunc) failfunc();
                        return;
                    }

                    if (oldenddate.solutionIndex == solution.movementDays) {
                        if (failfunc) failfunc();
                        return;
                    }
                    var plandatecount = solution.movementDays - oldenddate.solutionIndex;
                    var solutionindexstart = oldenddate.solutionIndex + 1;

                    var endDate = Light.tool.addDate(continuedate, (plandatecount - 1));
                    var tmpdatelist = createDateListEveryDay(plandatecount, continuedate);
                    for (var i = 0; i < tmpdatelist.length; i++) {
                        olddatelist.push({
                            date: tmpdatelist[i],
                            solutionIndex: (solutionindexstart + i)
                        });
                    }

                    Light.db.healthPlan.update(planid,
                        {
                            planEndDate: endDate,
                            planDateList: olddatelist,
                            status: 0,//normal
                            uploadFlg: 0
                        }, donefunc, failfunc);
                } else {
                    if (failfunc) failfunc();
                }
            }

            var done = function (item) {

                if (item && item.status == 3) {//3:suspended
                    olddatelist = item.planDateList;
                    Light.db.healthSolution.getOne(item.healthSolutionId, getsolutiondone, failfunc);
                } else {
                    if (failfunc) failfunc();
                }
            };
            Light.db.healthPlan.getOne(planid, done, failfunc);
        },

        endPlan: function (planid, enddate, donefunc, failfunc) {
            var done = function (plan) {
                if (plan && plan.status != 1 && plan.status != 2) {//1:delete 2:end
                    var datelist = plan.planDateList;
                    var newdatelist = [];

                    if (plan.status == 3) {//3:suspend
                        Light.db.healthPlan.update(planid,
                            {
                                planEndDate: plan.planEndDate,
                                planDateList: plan.planDateList,
                                status: 2,//end
                                uploadFlg: 0
                            }, donefunc, failfunc);
                    } else {//0: normal
                        for (var i = 0; i < datelist.length; i++) {
                            if (datelist[i].date <= enddate) {
                                newdatelist.push({
                                    date: datelist[i].date,
                                    solutionIndex: datelist[i].solutionIndex
                                });
                            } else {
                                break;
                            }
                        }
                        Light.db.healthPlan.update(planid,
                            {
                                planEndDate: enddate,
                                planDateList: newdatelist,
                                status: 2,//end
                                uploadFlg: 0
                            }, donefunc, failfunc);
                    }


                } else {
                    if (failfunc) failfunc();
                }

            };
            Light.db.healthPlan.getOne(planid, done, failfunc);
        },

        deletePlan: function (planid, donefunc, failfunc) {
            var done = function (plan) {
                if (plan) {
                    if (plan.status == 0)//normal 
                    {
                       var date = Light.tool.getDate();
                       if (plan.planStartDate > date) {

                           Light.db.healthPlan.update(planid,
                               {
                                   status: 1,//delete
                                   planDateList: [],
                                   uploadFlg: 0
                               }, donefunc, failfunc);
                       } else {
                           if (failfunc) failfunc();
                       }
                    } else {
                        if (failfunc) failfunc();
                    }
                } else {
                    if (failfunc) failfunc();
                }
            };
            Light.db.healthPlan.getOne(planid, done, failfunc);
        },

        getPlanByDate: function (date, donefunc, failfunc) {
            var rt = [];
            var plans = [];
            var planindex = 0;
            var plan;
            var getsolutiondone = function (solution) {

                if (solution != null) {
                    var items = solution.items;
                    for (var i = 0; i < items.length; i++) {
                        var item = items[i];
                        rt.push({
                            healthPlanId: plan.healthPlanId,
                            healthSolutionId: item.healthSolutionId,
                            day: item.day,
                            itemId: item.itemId,
                            itemName: item.itemName,
                            itemType: item.itemType,
                            itemStartTime: item.itemStartTime,
                            itemEndTime: item.itemEndTime,
                            itemDtls: item.itemDtls,
                        });
                    }
                }

                if (planindex < plans.length) {

                    plan = plans[planindex];
                    planindex = planindex + 1;

                    var day = 0;
                    for (var i = 0; i < plan.planDateList.length; i++) {
                        if (date == plan.planDateList[i].date) {
                            day = plan.planDateList[i].solutionIndex;
                            break;
                        }
                    }
                    if (day == 0) {
                        getsolutiondone(null);
                    } else {
                        Light.action.healthSolution.getSolutionByIdDay(plan.healthSolutionId, day, getsolutiondone, null);
                    }
                } else {
                    //rt.sort(function (a, b) { return a.itemStartTime < b.itemStartTime;})
                    donefunc(rt);
                }
            }

            var getplandone = function (items) {
                if (items && items.length > 0) {
                    plans = items;
                    planindex = 0;
                    getsolutiondone(null);
                } else {
                    donefunc([]);
                }
            }

            Light.db.healthPlan.select(
                [
                    ["status", "<>", 1],//delete
                    "and",
                    ["planStartDate", "<=", date],
                    "and",
                    ["planEndDate", ">=", date]
                ]
                , getplandone, failfunc);
        },

        getPlanCalorieByDate: function (date, donefunc, failfunc) {
            var rt = { input: 0, output: 0 , hasresult:false};

            var plans = [];
            var planindex = 0;
            var plan;
            var getsolutiondone = function (solution) {
                if (solution != null) {
                    var items = solution.items;
                    for (var i = 0; i < items.length; i++) {
                        var dtls = items[i].itemDtls;

                        for (var j = 0; j < dtls.length; j++)
                        {
                            if (dtls[j].dtlKbn == "1") {
                                rt.input = rt.input + dtls[j].calorie * dtls[j].dtlNum;
                                rt.hasresult = true;
                            } else if (dtls[j].dtlKbn == "2") {
                                rt.output = rt.output + dtls[j].calorie * dtls[j].dtlNum;
                                rt.hasresult = true;
                            }
                        }
                    }
                }
                if (planindex < plans.length) {

                    plan = plans[planindex];
                    planindex = planindex + 1;

                    var day = 0;
                    for (var i = 0; i < plan.planDateList.length; i++) {
                        if (date == plan.planDateList[i].date) {
                            day = plan.planDateList[i].solutionIndex;
                            break;
                        }
                    }
                    if (day == 0) {
                        getsolutiondone(null);
                    } else {
                        Light.action.healthSolution.getSolutionByIdDay(plan.healthSolutionId, day, getsolutiondone, null);
                    }
                } else {
                    //rt.sort(function (a, b) { return a.itemStartTime < b.itemStartTime;})
                    donefunc(rt);
                }
            }

            var getplandone = function (items) {
                if (items && items.length > 0) {
                    plans = items;
                    planindex = 0;
                    getsolutiondone(null);
                } else {
                    donefunc(rt);
                }
            }

            Light.db.healthPlan.select(
                [
                    ["status", "<>", 1],//delete
                    "and",
                    ["planStartDate", "<=", date],
                    "and",
                    ["planEndDate", ">=", date]
                ]
                , getplandone, failfunc);
        },

        getPlanByPeriod: function (startDate, endDate, donefunc, failfunc) {

            Light.db.healthPlan.select(
                [
                    ["status", "<>", 1],//delete
                    "and",
                    [
                        [
                            ["planStartDate", "<=", endDate],
                            "and",
                            ["planStartDate", ">=", startDate]
                        ],
                        "or",
                        [
                            ["planEndDate", "<=", endDate],
                            "and",
                            ["planEndDate", ">=", startDate]
                        ],
                        "or",
                        [
                            ["planStartDate", "<=", startDate],
                            "and",
                            ["planEndDate", ">=", endDate]
                        ]
                    ]
                ]
                , donefunc, failfunc);
        },

        getValidPlan: function (donefunc, failfunc) {

            var getplandone = function (items) {
                if (items && items.length > 0) {
                    var plan = items[0];
                    var date = Light.tool.getDate();
                    if (plan.status == 3) {//suspend
                        donefunc(plan);
                    } else {//end,normal
                        if (plan.planEndDate >= date) {
                            donefunc(plan);
                        } else {
                            donefunc(null);
                        }
                    }
                } else {
                    donefunc(null);
                }
            }

            Light.db.healthPlan.selectColumnsSort(null,
                ["status", "<>", 1],//delete
                [{ getter: "planStartDate", desc: true }],
                getplandone, failfunc);
        },

        record: function (date, planid, itemid, recordlist, donefunc, failfunc) {
            Light.db.healthPlanRecord.set(date, planid, itemid, recordlist, donefunc, failfunc);
        },

        getRecordByDate: function (date, donefunc, failfunc) {
            Light.db.healthPlanRecord.getOneDate(date, donefunc, failfunc);
        },

        //********************************************
        
        uploadToServer: function (donefunc, failfunc) {
            if (Light.rtdata.memberAcc == Light.config.TRIAL_USER_KEY) {
                if (donefunc) donefunc();
                return;
            }

            var planlist = [];
            var foruploadplanlist = [];
            var planrecordlist = [];
            var foruploadplanrecordlist = [];

            var onresponse = function (obj) {

                for (var j = 0; j < foruploadplanlist.length; j++) {
                    Light.db.healthPlan.update(
                            foruploadplanlist[j],
                            { uploadFlg: 1 },
                            null, null);
                }

                for (var j = 0; j < foruploadplanrecordlist.length; j++) {
                    Light.db.healthPlanRecord.update(
                            foruploadplanrecordlist[j],
                            {uploadFlg: 1 },
                            null, null);
                }

                if (donefunc) donefunc(obj);
            };

            var getplandetaildone = function (items) {
                for (var i = 0; i < items.length; i++) {
                    for (var i = 0; i < items.length; i++) {
                        var uploaditem = {
                            healthPlanRecordId: items[i].healthPlanRecordId,
                            healthPlanRecordDate: items[i].healthPlanRecordDate,
                            healthPlanId: items[i].healthPlanId,
                            itemId: items[i].itemId,
                            recordDtls: JSON.stringify(items[i].recordDtls),
                        };

                        planrecordlist.push(uploaditem);
                        foruploadplanrecordlist.push(items[i].healthPlanRecordId);
                    }
                }
                if (planlist.length == 0 && planrecordlist.length == 0) {
                    if (donefunc) { donefunc(); }
                    return;
                }
                Light.network.requestBackground("/app/member/health/uploadAppHealthPlanList",
                    { healthPlanList: planlist, healthPlanRecordList: planrecordlist },
                    onresponse, failfunc, "post");
            }
            var getplandone = function (items) {
                for (var i = 0; i < items.length; i++) {
                    var uploaditem = {
                        healthPlanId: items[i].healthPlanId,
                        healthSolutionId: items[i].healthSolutionId,
                        planCreateDate: items[i].planCreateDate,
                        planStartDate: items[i].planStartDate,
                        planEndDate: items[i].planEndDate,
                        status: items[i].status,
                        planDateList: JSON.stringify(items[i].planDateList),
                        planSuspendCount: items[i].planSuspendCount,
                    };

                    planlist.push(uploaditem);

                    foruploadplanlist.push(items[i].healthPlanId);
                }

                Light.db.healthPlanRecord.select(["uploadFlg", 0], getplandetaildone, failfunc);
            }

            Light.db.healthPlan.select(["uploadFlg", 0], getplandone, failfunc);
        },

        downloadFromServer: function (donefunc, failfunc) {

            var onresponse = function (obj) {
                var planlist = obj.healthPlanList;
                var planRecordList = obj.healthPlanRecordList;
                for (var j = 0; j < planlist.length; j++) {
                    planlist[j].uploadFlg = 1;
                    planlist[j].planDateList = $.parseJSON(planlist[j].planDateList);
                    Light.db.healthPlan.insert(
                            planlist[j],
                            null, null);
                }

                for (var j = 0; j < planRecordList.length; j++) {
                    planRecordList[j].uploadFlg = 1;
                    planRecordList[j].recordDtls = $.parseJSON(planRecordList[j].recordDtls);
                    Light.db.healthPlanRecord.insert(
                            planRecordList[j],
                            null, null);
                }

                if (donefunc) donefunc(obj);
            };

            Light.network.requestBackground("/app/member/health/getAppHealthPlanList",
                    {},
                    onresponse, failfunc, "post");
        },
        
    };
})();