﻿//action honor

(function () {
    Light.action.honor = {
        
        assess: function (continueFlag, donefunc, failfunc) {
            var done = function (items) {
                if (items && items.length > 0) {
                    for (var i = 0; i < items.length; i++) {
                        //deal one honor record
                        var name = items[i].honorName;
                        var total = items[i].honorTotal;
                        var limit = items[i].honorLimit;
                        var current = 0;
                        if (continueFlag == true) {
                            current = items[i].honorCurrent;
                        }
                        
                        if ((current + 1) >= limit) {
                            Light.db.honor.update(name, { honorCurrent: 0, honorTotal: (total + 1), uploadFlg: 0 }, null, null);
                        } else {
                            if (continueFlag == true) {
                                Light.db.honor.update(name, { honorCurrent: current + 1, uploadFlg: 0 }, null, null);
                            } else {
                                Light.db.honor.update(name, { honorCurrent: 1, uploadFlg: 0 }, null, null);
                            }
                        }
                    }
                }

                if (donefunc) donefunc();
            }

            Light.db.honor.select(null, done, failfunc);
        },

        getAll: function (donefunc, failfunc) {
            var done = function (items) {
                if (items && items.length > 0) {
                    var rts = [];
                    for (var i = 0; i < items.length; i++) {
                        //deal one honor record
                        var name = items[i].honorName;
                        var total = items[i].honorTotal;
                        var current = items[i].honorCurrent;
                        rts.push({name:name, total:total, current: current});
                    }
                    if (donefunc) donefunc(rts);
                } else {
                    if (failfunc) failfunc();
                }
            }

            Light.db.honor.select(null, done, failfunc);
        },

        uploadToServer: function (donefunc, failfunc) {

            var honorlist = [];
            var foruploadhonorlist = [];

            var onresponse = function (obj) {
                for (var j = 0; j < foruploadhonorlist.length; j++) {
                    Light.db.honor.update(
                            foruploadhonorlist[j],
                            { uploadFlg: 1 },
                            null, null);
                }

                if (donefunc) donefunc(obj);
            };

            var getplandone = function (items) {
                for (var i = 0; i < items.length; i++) {
                    honorlist.push(items[i]);
                    foruploadhonorlist.push(items[i].honorName);
                }
                if (honorlist.length == 0) {
                    if (donefunc) { donefunc(); }
                    return;
                }
                Light.network.requestBackground("/app/member/acc/syncMemberHonor",
                    { honorList: honorlist },
                    onresponse, failfunc, "post");
            }

            Light.db.honor.select(["uploadFlg", 0], getplandone, failfunc);
        },

        downloadFromServer: function (donefunc, failfunc) {

            var onresponse = function (obj) {
                var honorList = obj;
                for (var j = 0; j < honorList.length; j++) {
                    honorList[j].uploadFlg = 1;

                    Light.db.honor.insert(
                            honorList[j],
                            null, null);
                }

                if (donefunc) donefunc(obj);
            };

            Light.network.requestBackground("/app/member/acc/getMemberHonorList",
                    {},
                    onresponse, failfunc, "post");
        },
    };
})();
