﻿// application tool
(function () {

    var ACTIVITY = "ACTIVITY";
    var ALBUM = "ALBUM";
    //activityStatus: 0 - delete, 1 - created ,2 - end, 3 - for verify, 8 - deny ,9 - report

    Light.action.leancloud = Light.action.leancloud || {};

    Light.action.leancloud.activity = {
        //创建活动
        create: function (data, okfunc, errfunc) {
            var Active = AV.Object.extend(ACTIVITY);

            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var status = 3;//待审核
            if (user.id == "00000" || user.id == "") {
                status = 1;
            }

            var active = new Active();

            active.set("activityCreaterId", user.id);
            active.set("activityImg", data.activityImg);
            active.set("activityName", data.activityName);
            active.set("activityAdress", data.activityAdress);
            active.set("activityTime", data.activityTime);
            active.set("activityEndTime", data.activityEndTime);
            active.set("activityHandEndTime", data.activityEndTime);
            active.set("activityType", data.activityType);
            active.set("activityStatus", status);//创建 1 or 待审核 3
            active.set("activityContent", data.activityContent);
            active.set("activityResult", "");
            active.set("activityVerify", "");
            active.set("activityMembersCnt", 0);
            var relation = active.relation("activityMembers");
            relation.add(user);
            /*
            var relationLike = active.relation("activityLikes");
            var relationApply = active.relation("activityApplyMembers");
            var relationPermit = active.relation("activityPermitMembers");
            relationPermit.add(user);
            var relationReject = active.relation("activityRejectMembers");
            */

            active.fetchWhenSave(true);
            active.save(null, {
                success: function (active) {
                    if (okfunc) okfunc(active);
                },
                error: function (gameScore, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //审核
        verify: function (data, okfunc, errfunc) {
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);

            var status = 8;
            if (data && data.result == true) {
                status = 1;//created
            } else {
                status = 8;//审核失败
            }

            var memo = "";
            if (data && data.memo) {
                memo = data.memo;
            }

            query.get(data.id, {
                success: function (active) {
                    
                    if (active.get("activityStatus") == 3) {//待审核
                        //alert("set active status:" + active.id + "|"+ status + "|" + memo);
                        active.set('activityStatus', status);
                        active.set('activityVerify', memo);
                        active.fetchWhenSave(true);
                        active.save(null, {
                            success: function (active) {
                                if (okfunc) okfunc(active);
                            },
                            error: function () {
                                if (errfunc) errfunc();
                            }
                        }
                        );
                    } else {
                        if (errfunc) errfunc();
                    }
                },
                error: function () {
                    if (errfunc) errfunc();
                }
            });
        },

        //删除活动
        delete: function (id, okfunc, errfunc) {
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);

            query.get(id, {
                success: function (active) {
                    active.set('activityStatus', 0);//删除
                    active.fetchWhenSave(true);
                    active.save(null, {
                        success: function (active) {
                            if (okfunc) okfunc(active);
                        },
                        error: function (gameScore, error) {
                            if (errfunc) errfunc(error);
                        }
                    }
                    );
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
        },

        //更新活动状态和结果
        update: function (data, okfunc, errfunc) {
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);

            query.get(data.id, {
                success: function (active) {
                    if (data.name != null) { active.set('activityName', data.name); }
                    if (data.address != null) { active.set('activityAdress', data.address); }
                    if (data.time != null) { active.set('activityTime', data.time); }
                    if (data.endTime != null) { active.set('activityEndTime', data.endTime); }
                    if (data.handEndTime != null) { active.set('activityHandEndTime', data.handEndTime); }//no use
                    if (data.type != null) { active.set('activityType', data.type); }//no use
                    if (data.status != null) { active.set('activityStatus', data.status); }//no use
                    if (data.content != null) { active.set('activityContent', data.content); }
                    if (data.img != null) { active.set('activityImg', data.img); }
                    active.fetchWhenSave(true);
                    active.save(null, {
                        success: function (active) {
                            if (okfunc) okfunc(active);
                        },
                        error: function (gameScore, error) {
                            if (errfunc) errfunc(error);
                        }
                    }
                    );
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
        },

        //更新活动状态和结果
        end: function (data, okfunc, errfunc) {
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);

            query.get(data.id, {
                success: function (active) {
                    active.set('activityStatus', 2);//结束
                    active.set('activityHandEndTime',data.handEndTime);//结束
                    if (data.result) { active.set('activityResult', data.result); }
                    active.fetchWhenSave(true);
                    active.save(null, {
                        success: function (active) {
                            if (okfunc) okfunc(active);
                        },
                        error: function (gameScore, error) {
                            if (errfunc) errfunc(error);
                        }
                    }
                    );
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
        },

        //更新活动状态
        updateStatus: function (data, okfunc, errfunc) {
            //no use
            /*
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);

            query.get(data.id, {
                success: function (active) {
                    if (data.status != null) { active.set('activityStatus', data.status); }
                    active.fetchWhenSave(true);
                    active.save(null, {
                        success: function (active) {
                            if (okfunc) okfunc(active);
                        },
                        error: function (gameScore, error) {
                            if (errfunc) errfunc(error);
                        }
                    }
                    );
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
            */
        },

        //对活动点赞
        like: function (activeId, okfunc, errfunc) {
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);

            query.get(activeId, {
                success: function (active) {

                    var user = AV.User.current();
                    if (!user) {
                        if (errfunc) errfunc();
                        return;
                    }

                    var relation = active.relation("activityLikes");
                    relation.add(user);

                    active.fetchWhenSave(true);
                    active.save(null, {
                        success: function (active) {
                            if (okfunc) okfunc(active);
                        },
                        error: function (gameScore, error) {
                            if (errfunc) errfunc(error);
                        }
                    }
                    );
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
        },

        //参加活动
        join: function (activeId, cnt, okfunc, errfunc) {
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            query.get(activeId, {
                success: function (active) {
                    var ndate = new Date();
                    if (active.get("activityStatus") !== 1
                        || active.get("activityEndTime") <= ndate) {
                        if (okfunc) okfunc(active);
                        return;
                    }

                    var user = AV.User.current();

                    if (!user) {
                        if (errfunc) errfunc();
                        return;
                    }

                    active.set('activityMembersCnt', cnt);
                    var relation = active.relation("activityMembers");
                    relation.add(user);

                    active.fetchWhenSave(true);
                    active.save(null, {
                        success: function (active) {
                            if (okfunc) okfunc(active);
                        },
                        error: function (gameScore, error) {
                            if (errfunc) errfunc(error);
                        }
                    }
                    );
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
        },

        //退出活动
        quit: function (activeId, cnt, okfunc, errfunc) {
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            query.get(activeId, {
                success: function (active) {
                    var ndate = new Date();
                    if (active.get("activityStatus") !== 1
                        || active.get("activityEndTime") <= ndate) {
                        if (okfunc) okfunc(active);
                        return;
                    }

                    var user = AV.User.current();
                    if (!user) {
                        if (errfunc) errfunc();
                        return;
                    }

                    active.set('activityMembersCnt', cnt);
                    var relation = active.relation("activityMembers");
                    relation.remove(user);

                    active.fetchWhenSave(true);
                    active.save(null, {
                        success: function (active) {
                            if (okfunc) okfunc(active);
                        },
                        error: function (gameScore, error) {
                            if (errfunc) errfunc(error);
                        }
                    }
                    );
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
        },

        //取得活动状态
        getStatus: function (activeId, okfunc, errfunc) {
            //no use
            /*
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            query.select("activityStatus");
            query.get(activeId, {
                success: function (active) {
                    if (okfunc) okfunc(active.get("activityStatus"));
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
            */
        },

        //取得活动
        getOne: function (activeId, okfunc, errfunc) {
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            query.get(activeId, {
                success: function (active) {
                    if (okfunc) okfunc(active);
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
        },

        //取得最近创建的活动（10条）
        getRecent: function (page, okfunc, errfunc) {
            if (!page) { page = 1; }
            var ndate = new Date();

            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            query.ascending("createdAt");
            query.limit(10);
            query.equalTo("activityStatus", 1);
            query.greaterThan("activityEndTime", ndate);
            query.descending("updatedAt");
            query.skip(10 * (page - 1));
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },
        
        getRecent2: function (okfunc, errfunc) {

            var ndate = new Date();
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            query.ascending("createdAt");
            query.limit(500);
            query.equalTo("activityStatus", 1);
            query.greaterThan("activityEndTime", ndate);
            query.descending("updatedAt");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },
  
        //取得当前用户创建的所有活动
        getCreated: function (okfunc, errfunc) {
            var user = AV.User.current();
            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            query.equalTo("activityCreaterId", user.id);
            query.notEqualTo("activityStatus", 0);
            query.descending("updatedAt");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },

        //取得所有活动
        getAll: function (condition, okfunc, errfunc) {

            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            if (condition.status) {query.equalTo("activityStatus", condition.status);}
            if (condition.createrId) {query.equalTo("activityCreaterId", condition.createrId);}
            //if (condition.type) {query.equalTo("activityType", condition.type);}
            query.descending("updatedAt");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },

        //取得当前用户参加的所有活动
        getJoined: function (okfunc, errfunc) {
            var user = AV.User.current();
            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            query.equalTo("activityMembers", user);
            query.notEqualTo("activityStatus", 0);
            query.descending("updatedAt");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },

        //取得当前用户参加的所有活动(id list)
        getJoinedOnlyId: function (okfunc, errfunc) {
            var user = AV.User.current();
            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            query.select("activityStatus");
            query.equalTo("activityMembers", user);
            query.notEqualTo("activityStatus", 0);
            query.notEqualTo("activityStatus", 3);
            query.notEqualTo("activityStatus", 8);
            query.notEqualTo("activityStatus", 9);
            query.descending("updatedAt");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },

        //取得参加活动的用户
        getMembers: function (activeId, okfunc, errfunc) {
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            query.get(activeId, {
                success: function (active) {
                    var relation = active.relation("activityMembers");
                    relation.query().find({
                        success: function (results) {
                            if (okfunc) okfunc(results);
                        },
                        error: function (error) {
                            if (okfunc) okfunc([]);
                        }
                    });
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },


        //取得点赞的用户
        getLikes: function (activeId, okfunc, errfunc) {
            var Active = AV.Object.extend(ACTIVITY);
            var query = new AV.Query(Active);
            query.get(activeId, {
                success: function (active) {
                    var relation = active.relation("activityLikes");
                    relation.query().find({
                        success: function (results) {
                            if (okfunc) okfunc(results);
                        },
                        error: function (error) {
                            if (okfunc) okfunc([]);
                        }
                    });
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },

        //模糊查询名称匹配的活动
        search: function (activename, okfunc, errfunc) {
            var nickName = "%" + activename + "%";
            //AV.Query.doCloudQuery('select count(*),* from _User where nickname=? ', [nickName], {
            AV.Query.doCloudQuery('select * from ' + ACTIVITY + ' where activityName like ? and activityStatus <> 0 and activityStatus <> 3 and activityStatus <> 8 and activityStatus <> 9  order by updatedAt desc', [nickName], {
                success: function (result) {
                    var results = result.results;
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    if (errfunc) errfunc();
                }
            });
        },
    };

})();
