﻿// application tool
(function () {

    var ACTIVITYMEMBER = "ACTIVITYMEMBER";

    Light.action.leancloud = Light.action.leancloud || {};

    Light.action.leancloud.activityMember = {
        //创建活动成员
        create: function (data, okfunc, errfunc) {
            var Member = AV.Object.extend(ACTIVITYMEMBER);

            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var member = new Member();

            member.set("activityId", data.activityId);
            member.set("memberID", data.memberID);
            member.set("userName", data.userName);
            member.set("realName", data.realName);
            member.set("telphone", data.telphone);

            member.fetchWhenSave(true);
            member.save(null, {
                success: function (member) {
                    if (okfunc) okfunc(member);
                },
                error: function (gameScore, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //更新活动成员
        update: function (data, okfunc, errfunc) {
            var Member = AV.Object.extend(ACTIVITYMEMBER);
            var query = new AV.Query(Member);

            query.get(data.id, {
                success: function (member) {
                    if (data.realName != null) { member.set('realName', data.realName); }
                    if (data.telphone != null) { member.set('telphone', data.telphone); }
                    member.fetchWhenSave(true);
                    member.save(null, {
                        success: function (member) {
                            if (okfunc) okfunc(member);
                        },
                        error: function (gameScore, error) {
                            if (errfunc) errfunc(error);
                        }
                    }
                    );
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
        },

        //取得全体活动成员
        getAllMembers: function (activityId, okfunc, errfunc) {
            
            var Member = AV.Object.extend(ACTIVITYMEMBER);
            var query = new AV.Query(Member);
            query.equalTo("activityId", activityId);
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    if (errfunc) errfunc();
                }
            });
        },
    };

})();
