﻿// application tool
(function () {

    var ALBUM = "ALBUM";

    Light.action.leancloud = Light.action.leancloud || {};

    Light.action.leancloud.album = {
        //追加活动/群组照片
        //
        create: function (data, okfunc, errfunc) {
            var name = data.name;
            var imgdata = data.data;

            var done = function (result) {
                var imageid = result.id;
                var imageurl = result.url();
                var imageturl = result.thumbnailURL(150, 150);

                var Album = AV.Object.extend(ALBUM);

                var album = new Album();
                album.set("groupActivityId", data.groupActivityId);
                album.set("imageType", data.albumType);
                album.set("imageId", imageid);
                album.set("imageUrl", imageurl);
                album.set("imageThumbnail", imageturl);

                album.fetchWhenSave(true);
                album.save(null, {
                    success: function (album) {
                        if (okfunc) okfunc(album);
                    },
                    error: function (gameScore, error) {
                        if (errfunc) errfunc(error);
                    }
                });
            };

            var turldone = function (result) {
                alert("file create done...build timage:" + result.id);
                Light.action.leancloud.file.createImageT(result.id, done, errfunc);
            };
            
            //Light.action.leancloud.file.createFileB64(name, imgdata, done, errfunc);
           
            Light.action.leancloud.file.setFileB64(name, imgdata, done, errfunc);
            
        },

        //删除活动/群组照片
        delete: function (id, okfunc, errfunc) {
            var Album = AV.Object.extend(ALBUM);
            var query = new AV.Query(Album);
            query.get(id, {
                success: function (album) {
                    album.destroy({
                        success: function (myObject) {
                            if (okfunc) okfunc();
                        },
                        error: function (myObject, error) {
                            if (errfunc) errfunc(error);
                        }
                    });
                },
                error: function (object, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //取得活动/群组最新照片
        getAll: function (activitygroupid, page, okfunc, errfunc) {
            if (!page) { page = 1; }

            var Album = AV.Object.extend(ALBUM);
            var query = new AV.Query(Album);
            query.equalTo("groupActivityId", activitygroupid);
            query.limit(10);
            query.skip(10 * (page - 1));
            //query.descending("uploadTime");
            query.descending("updatedAt");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },
    };

})();
