﻿// application tool
(function () {
    Light.action.leancloud = Light.action.leancloud || {};



    Light.action.leancloud.file = {

        
        createFileB64: function (name, data, donefunc, errorfunc) {
            AV.Cloud.run('uploadImage', { name: name, data:data }, {
                success: function (result) {
                    if (result.flag == true) {
                        if (donefunc) donefunc(result);
                    } else {
                        if (errorfunc) errorfunc();
                    }
                },
                error: function (error) {
                    if (errorfunc) errorfunc(error);
                }
            });
        },

        createImageT: function(id, donefunc,errorfunc) {
            AV.Cloud.run('createImageT', { id:id }, {
                success: function (result) {
                    if (result.flag == true) {
                        if (donefunc) donefunc(result);
                    } else {
                        if (errorfunc) errorfunc();
                    }
                },
                error: function (error) {
                    if (errorfunc) errorfunc(error);
                }
            });
        },

        setFileB64: function (name, data, donefunc, errorfunc) {
            //data = "V29ya2luZyBhdCBQYXJzZSBpcyBncmVhdCE=";//base64
            var file = new AV.File(name, { base64: data });
            file.save().then(function (rt) {
                if (donefunc) donefunc(rt);
            }, function (error) {
                if (errorfunc) errorfunc(error);
            });
        },

        setFileByte: function (name, data, donefunc, errorfunc) {
            //data = [0xBE, 0xEF, 0xCA, 0xFE];
            var file = new AV.File(name, data);
            file.save().then(function (rt) {
                if (donefunc) donefunc(rt);
            }, function (error) {
                if (errorfunc) errorfunc(error);
            });
        },

        deleteFile: function (id, donefunc, errorfunc) {
            AV.Cloud.run('deleteFile', {id:id}, {
                success: function (result) {
                    if (result.delete == "ok") {
                        if (donefunc) donefunc();
                    } else {
                        if (errorfunc) errorfunc(error);
                    }
                },
                error: function (error) {
                    if (errorfunc) errorfunc(error);
                }
            });
        },
    };
})();

/*
var file = new AV.File.createWithoutData(id);

file.destroy().then(function () {
    if (donefunc) donefunc(rt);
}, function (error) {
    if (errorfunc) errorfunc(error);
});
*/

/*

getFileUrl: function (id, donefunc, errorfunc) {
    AV.Query.doCloudQuery('select key,url from _File where objectId = ?', [id], {
        success: function (result) {
            var files = result.results;
            if (files.length > 0) {
                if (donefunc) donefunc(files[0].get("url"));
            } else {
                if (errorfunc) errorfunc();
            }
        },
        error: function (error) {
            if (errorfunc) errorfunc();
        }
    });
},
*/