﻿
(function () {

    var INVITE = "INVITE";

    Light.action.leancloud = Light.action.leancloud || {};

    Light.action.leancloud.invite = {
        //create invite
        createInvite: function (toUserId, message, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }
            var userId = user.id;
            var userImage = user.get("userHeadImage");
            var userNickName = user.get("nickname");

            var Invite = AV.Object.extend(INVITE);

            var invite = new Invite();
            invite.set("toUserId", toUserId);
            invite.set("fromUserId", userId);
            invite.set("fromUserNickName", userNickName);
            invite.set("fromUserImage", userImage);
            invite.set("message", message);
            invite.set("status", 0);//0:新规 1:同意 2:不同意
            invite.fetchWhenSave(true);
            invite.save(null, {
                success: function (invite) {
                    if (okfunc) okfunc(invite);
                },
                error: function (gameScore, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //get new invite
        getNewInvite: function (okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }
            var userId = user.id;

            var Invite = AV.Object.extend(INVITE);
            var query = new AV.Query(Invite);
            query.equalTo("toUserId", userId);
            query.equalTo("status", 0);
            query.descending("updatedAt");
            query.find().then(function (list) {
                if (okfunc) okfunc(list);
            }, function (error) {
                if (errfunc) errfunc(error);
            });
        },

        //get invite
        getInviteByKey: function (fromUserId, toUserId, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var Invite = AV.Object.extend(INVITE);
            var query = new AV.Query(Invite);
            query.equalTo("toUserId", toUserId);
            query.equalTo("fromUserId", fromUserId);
            query.equalTo("status", 0);
            query.find().then(function (list) {
                if (okfunc) okfunc(list);
            }, function (error) {
                if (errfunc) errfunc(error);
            });
        },

        //update invite status
        updateInviteStatus: function (inviteId, status, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var Invite = AV.Object.extend(INVITE);
            var query = new AV.Query(Invite);
            query.get(inviteId, {
                success: function (invite) {
                    invite.set("status", status);
                    invite.fetchWhenSave(true);
                    invite.save(null, {
                        success: function (active) {
                            if (okfunc) okfunc(active);
                        },
                        error: function (gameScore, error) {
                            if (errfunc) errfunc(error);
                        }
                    }
                    );
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
        },

        //update invite message
        updateInviteMessage: function (inviteId, message, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var Invite = AV.Object.extend(INVITE);
            var query = new AV.Query(Invite);
            query.get(inviteId, {
                success: function (invite) {
                    invite.set("message", message);
                    invite.fetchWhenSave(true);
                    invite.save(null, {
                        success: function (active) {
                            if (okfunc) okfunc(active);
                        },
                        error: function (gameScore, error) {
                            if (errfunc) errfunc(error);
                        }
                    }
                    );
                },
                error: function (object, error) {
                    if (errfunc) errfunc();
                }
            });
        },
    };

})();
