﻿// application tool
(function () {
    Light.action.leancloud = Light.action.leancloud || {};

    Light.action.leancloud.push = {
        engine: null,

        init: function () {
            this.engine = AV.push({
                appId: Light.action.leancloud.config.AppId,
                appKey: Light.action.leancloud.config.AppKey,
            });
        },

        open: function(donefunc) {
            // 如果想接收推送，需要调用 open 方法，开启和服务器的连接
            this.engine.open(function() {
                //alert('连接服务器成功，可以接收推送');
                if (donefunc) donefunc();
            });
        },

        callBan: function (message, donefunc, errorfunc) {

            if (this.engine) {
                // 发送一条推送，如果不传 channels 则是给所有 channel 发送消息
                this.engine.send({
                    channels: ['ban'],
                    data: { message: message }
                }, function (result) {
                    if (result) {
                        //console.log('推送成功发送');
                        //alert('推送成功发送');
                        if (donefunc) donefunc(result);
                    } else {
                        //console.log('error');
                        //alert('推送 error');
                        if (errorfunc) errorfunc();
                    }
                });
            } else {
                if (errorfunc) errorfunc();
            }
        },

        onBan: function (callback) {
            var recieveBan = function (data) {
                alert("debug:" + data.message);
                if (callback) callback();
            };
            // 监听推送消息
            if (this.engine) {
                this.engine.subscribe(['ban'], function () {
                    alert('订阅成功！');
                });
                this.engine.on('message', recieveBan);
            }
        },

        onNetworkError: function (callback) {
            // 监听网络异常，SDK 会在底层自动重新连接服务器
            if (this.engine) {
                this.engine.on('reuse', callback);
            }
        },

    };
})();

