﻿// application tool
(function () {

    var REPORT = "REPORT";
    var ACTIVITY = "ACTIVITY";

    Light.action.leancloud = Light.action.leancloud || {};

    Light.action.leancloud.report = {
        //创建举报
        createReport: function (data, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var Report = AV.Object.extend(REPORT);

            var report = new Report();
            report.set("reportType", Number(data.type));//0:user 1:group 2:activity
            report.set("reportTargetId", data.id);
            report.set("reportTargetName", data.name);
            report.set("reportReson", data.reson);
            report.set("reportContent", data.content);
            report.set("reportUserId", user.id);
            report.set("reportUserName", user.get("nickname"));
            report.set("reportCheckUserId", "");
            report.set("reportCheckUserName", "");
            report.set("reportCheckResult", 0);//未处理
            report.set("reportCheckMemo", "");

            report.fetchWhenSave(true);
            report.save(null, {
                success: function (report) {
                    if (okfunc) okfunc(report);
                },
                error: function (gameScore, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //举报无效
        updateReport: function (id, result, memo, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var changeStatus = function (report, okfunc, errfunc) {
                report.set("reportCheckUserId", user.id);
                report.set("reportCheckUserName", user.get("nickname"));
                report.set("reportCheckDate", new Date());
                report.set("reportCheckResult", result);
                report.set("reportCheckMemo", memo);

                report.fetchWhenSave(true);
                report.save(null, {
                    success: function (report) {
                        if (okfunc) okfunc(report);
                    },
                    error: function (gameScore, error) {
                        if (errfunc) errfunc(error);
                    }
                });
            };

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            //query.equalTo("reportCheckResult", 0);
            query.get(id, {
                success: function (report) {
                    //changeStatus(report, okfunc, errfunc);
                    if (result == 2)//无罪
                    {
                        changeStatus(report, okfunc, errfunc);
                    } else if (result == 1){//有罪
                        var type = report.get("reportType");//0:user 

                        if (type == 0) {
                            AV.Cloud.run('forbidUser', { userId: report.get("reportTargetId") }, {
                                success: function (result) {
                                    if (result.flag == 0 || result.flag == 2) {//forbid user done
                                        changeStatus(report, okfunc, errfunc);
                                    } else {
                                        if (errorfunc) errorfunc(error);
                                    }
                                },
                                error: function (error) {
                                    if (errorfunc) errorfunc(error);
                                }
                            });
                        } else if (type == 1) {//1:group
                            AV.Cloud.run('forbidGroup', { groupId: report.get("reportTargetId") }, {
                                success: function (result) {
                                    if (result.flag == 0 || result.flag == 2) {//forbid group done
                                        changeStatus(report, okfunc, errfunc);
                                    } else {
                                        if (errorfunc) errorfunc(error);
                                    }
                                },
                                error: function (error) {
                                    if (errorfunc) errorfunc(error);
                                }
                            });
                        } else {// 2:activity
                            var Active = AV.Object.extend(ACTIVITY);
                            var query = new AV.Query(Active);

                            query.get(report.get("reportTargetId"), {
                                success: function (active) {
                                    active.set('activityStatus', 9);//举报
                                    active.fetchWhenSave(true);
                                    active.save(null, {
                                        success: function (active) {
                                            changeStatus(report, okfunc, errfunc);
                                        },
                                        error: function (gameScore, error) {
                                            if (errfunc) errfunc(error);
                                        }
                                    }
                                    );
                                },
                                error: function (object, error) {
                                    if (errfunc) errfunc();
                                }
                            });
                        }
                    }
                },
                error: function (object, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //查询报告
        getActiveMemo: function (id, okfunc, errfunc) {

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.equalTo("reportCheckResult", 1);//有罪
            query.equalTo("reportType", 2);//active
            query.equalTo("reportTargetId", id);
            
            query.limit(10);
            query.descending("uploadAt");
            query.find({
                success: function (results) {
                    var memo = "";
                    if (results.length > 0) {
                        for (i = 0; i < results.length; i++) {
                            if (results[i].get('reportReson') && results[i].get('reportReson') != "") {
                                memo = results[i].get('reportReson');
                            }
                        }
                    }
                    if (okfunc) okfunc(memo);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },


        //查询所有报告
        getReport: function (type, result, page, okfunc, errfunc) {
            if (!page) { page = 1; }

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            if (type != null) {
                query.equalTo("reportType", type);
            }
            if (result != null) {
                query.equalTo("reportCheckResult", result);
            }
            query.limit(50);
            query.skip(50 * (page - 1));
            //query.descending("uploadTime");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },

        //查询所有本人的举报
        getMyReport: function (okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.equalTo("reportUserId", user.id);
            //query.descending("uploadTime");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },
    };

})();

/*
        createReport: function (data, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var Report = AV.Object.extend(REPORT);

            var report = new Report();
            report.set("reportType", data.type);//0:user 1:group 2:activity
            report.set("reportTargetId", data.id);
            report.set("reportTargetName", data.name);
            report.set("reportReson", data.reson);
            report.set("reportContent", data.content);
            report.set("reportUserId", user.id);
            report.set("reportUserName", user.get("nickname"));
            report.set("reportCheckUserId", "");
            //report.set("reportCheckDate", null);
            report.set("reportCheckResult", 0);//未处理
            report.set("reportCheckMemo", "");


            report.fetchWhenSave(true);
            report.save(null, {
                success: function (report) {
                    if (okfunc) okfunc(report);
                },
                error: function (gameScore, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //举报无效
        checkGuitless: function (id, memo, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var changeStatus = function (report, okfunc, errfunc) {
                report.set("reportCheckUserId", user.id);
                report.set("reportCheckDate", new Date());
                report.set("reportCheckResult", 2);//无罪
                report.set("reportCheckMemo", memo);

                report.fetchWhenSave(true);
                report.save(null, {
                    success: function (report) {
                        if (okfunc) okfunc(report);
                    },
                    error: function (gameScore, error) {
                        if (errfunc) errfunc(error);
                    }
                });
            };

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.equalTo("reportCheckResult", 0);
            query.get(id, {
                success: function (report) {
                    changeStatus(report, okfunc, errfunc);
                },
                error: function (object, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //举报生效
        checkGuity: function (id, memo, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var changeStatus = function (report, okfunc, errfunc) {
                report.set("reportCheckUserId", user.id);
                report.set("reportCheckDate", new Date());
                report.set("reportCheckResult", 1);//有罪
                report.set("reportCheckMemo", memo);

                report.fetchWhenSave(true);
                report.save(null, {
                    success: function (report) {

                        if (okfunc) okfunc(report);
                    },
                    error: function (gameScore, error) {
                        if (errfunc) errfunc(error);
                    }
                });
            };

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.equalTo("reportType", 0);//user
            query.equalTo("reportCheckResult", 0);
            query.get(id, {
                success: function (report) {

                    var type = report.get("reportType");//0:user 

                    if (type == 0) {
                        AV.Cloud.run('forbidUser', { userId: report.get("reportTargetId") }, {
                            success: function (result) {
                                if (result.flag == 0) {//forbid user done
                                    changeStatus(report, okfunc, errfunc);
                                } else {
                                    if (errorfunc) errorfunc(error);
                                }
                            },
                            error: function (error) {
                                if (errorfunc) errorfunc(error);
                            }
                        });
                    } else if (type == 1) {//1:group
                        AV.Cloud.run('forbidGroup', { groupId: report.get("reportTargetId") }, {
                            success: function (result) {
                                if (result.flag == 0) {//forbid group done
                                    changeStatus(report, okfunc, errfunc);
                                } else {
                                    if (errorfunc) errorfunc(error);
                                }
                            },
                            error: function (error) {
                                if (errorfunc) errorfunc(error);
                            }
                        });
                    } else {// 2:activity
                        //todo:forbid Activity
                    }
                },
                error: function (object, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },


        //查询所有报告
        getAll: function (page, okfunc, errfunc) {
            if (!page) { page = 1; }

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.limit(50);
            query.skip(50 * (page - 1));
            //query.descending("uploadTime");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },

        //查询所有未审核的报告
        getUncheck: function (page, okfunc, errfunc) {
            if (!page) { page = 1; }

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.equalTo("reportCheckResult", 0);
            query.limit(50);
            query.skip(50 * (page - 1));
            //query.descending("uploadTime");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },

        //查询所有举报生效的报告
        getGuilty: function (page, okfunc, errfunc) {
            if (!page) { page = 1; }

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.equalTo("reportCheckResult", 1);//有罪
            query.limit(50);
            query.skip(50 * (page - 1));
            //query.descending("uploadTime");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },

        //查询所有举报无效的报告
        getGuiltless: function (page, okfunc, errfunc) {
            if (!page) { page = 1; }

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.equalTo("reportCheckResult", 2);//无罪
            query.limit(50);
            query.skip(50 * (page - 1));
            //query.descending("uploadTime");
            query.find({
                success: function (results) {
                    if (okfunc) okfunc(results);
                },
                error: function (error) {
                    //alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc();
                }
            });
        },

*/

/*

        createUserReport: function (data, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var Report = AV.Object.extend(REPORT);

            var report = new Report();
            report.set("reportType", 0);//user
            report.set("reportTargetId", data.id);
            report.set("reportReson", data.reson);
            report.set("reportContent", data.content);
            report.set("reportUserId", user.id);
            report.set("reportCheckUserId", "");
            //report.set("reportCheckDate", null);
            report.set("reportCheckResult", 0);//未处理
            report.set("reportCheckMemo", "");


            report.fetchWhenSave(true);
            report.save(null, {
                success: function (report) {
                    if (okfunc) okfunc(report);
                },
                error: function (gameScore, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //创建群组举报
        createGroupReport: function (data, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var Report = AV.Object.extend(REPORT);
            var report = new Report();
            report.set("reportType", 1);//group
            report.set("reportTargetId", data.id);
            report.set("reportReson", data.reson);
            report.set("reportContent", data.content);
            report.set("reportUserId", user.id);
            report.set("reportCheckUserId", "");
            //report.set("reportCheckDate", null);
            report.set("reportCheckResult", 0);//未处理
            report.set("reportCheckMemo", "");

            report.fetchWhenSave(true);
            report.save(null, {
                success: function (report) {
                    if (okfunc) okfunc(report);
                },
                error: function (gameScore, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //用户有罪
        checkUserGuity: function (id, memo, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var changeStatus = function (report, okfunc, errfunc) {
                report.set("reportCheckUserId", user.id);
                report.set("reportCheckDate", new Date());
                report.set("reportCheckResult", 1);//有罪
                report.set("reportCheckMemo", memo);

                report.fetchWhenSave(true);
                report.save(null, {
                    success: function (report) {

                        if (okfunc) okfunc(report);
                    },
                    error: function (gameScore, error) {
                        if (errfunc) errfunc(error);
                    }
                });
            };

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.equalTo("reportType", 0);//user
            query.equalTo("reportCheckResult", 0);
            query.get(id, {
                success: function (report) {
                    AV.Cloud.run('forbidUser', { userId: report.get("reportTargetId") }, {
                        success: function (result) {
                            if (result.flag == 0) {//forbid user done
                                changeStatus(report, okfunc, errfunc);
                            } else {
                                if (errorfunc) errorfunc(error);
                            }
                        },
                        error: function (error) {
                            if (errorfunc) errorfunc(error);
                        }
                    });
                    
                },
                error: function (object, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //用户无罪
        checkUserGuitless: function (id, memo, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var changeStatus = function (report, okfunc, errfunc) {
                report.set("reportCheckUserId", user.id);
                report.set("reportCheckDate", new Date());
                report.set("reportCheckResult", 2);//无罪
                report.set("reportCheckMemo", memo);

                report.fetchWhenSave(true);
                report.save(null, {
                    success: function (report) {
                        if (okfunc) okfunc(report);
                    },
                    error: function (gameScore, error) {
                        if (errfunc) errfunc(error);
                    }
                });
            };

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.equalTo("reportType", 0);
            query.equalTo("reportCheckResult", 0);
            query.get(id, {
                success: function (report) {
                    changeStatus(report, okfunc, errfunc);
                },
                error: function (object, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //群组有罪
        checkGroupGuity: function (id, memo, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var changeStatus = function (report, okfunc, errfunc) {
                report.set("reportCheckUserId", user.id);
                report.set("reportCheckDate", new Date());
                report.set("reportCheckResult", 1);//有罪
                report.set("reportCheckMemo", memo);

                report.fetchWhenSave(true);
                report.save(null, {
                    success: function (report) {

                        if (okfunc) okfunc(report);
                    },
                    error: function (gameScore, error) {
                        if (errfunc) errfunc(error);
                    }
                });
            };

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.equalTo("reportType", 1);//group
            query.equalTo("reportCheckResult", 0);
            query.get(id, {
                success: function (report) {
                    AV.Cloud.run('forbidGroup', { groupId: report.get("reportTargetId") }, {
                        success: function (result) {
                            if (result.flag == 0) {//forbid group done
                                changeStatus(report, okfunc, errfunc);
                            } else {
                                if (errorfunc) errorfunc(error);
                            }
                        },
                        error: function (error) {
                            if (errorfunc) errorfunc(error);
                        }
                    });
                },
                error: function (object, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        //群组无罪
        checkGroupGuitless: function (id, memo, okfunc, errfunc) {
            var user = AV.User.current();

            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            var changeStatus = function (report, okfunc, errfunc) {
                report.set("reportCheckUserId", user.id);
                report.set("reportCheckDate", new Date());
                report.set("reportCheckResult", 2);//无罪
                report.set("reportCheckMemo", memo);

                report.fetchWhenSave(true);
                report.save(null, {
                    success: function (report) {
                        if (okfunc) okfunc(report);
                    },
                    error: function (gameScore, error) {
                        if (errfunc) errfunc(error);
                    }
                });
            };

            var Report = AV.Object.extend(REPORT);
            var query = new AV.Query(Report);
            query.equalTo("reportType", 1);//group
            query.equalTo("reportCheckResult", 0);
            query.get(id, {
                success: function (report) {
                    changeStatus(report, okfunc, errfunc);
                },
                error: function (object, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

*/
