﻿// application tool
(function () {

    Light.action.leancloud = Light.action.leancloud || {};
    Light.action.leancloud.user = {

        //注册用户
        //signUp by server

        //登录
        signIn: function (okfunc, errfunc) {

            var userName = "" + Light.rtdata.memberId;
            /*
            var password = Light.rtdata.memberPassword;
            if (password == null || password == "") {
                password = Light.config.DEFAULT_PASSWORD;
            }
            */
            var password = Light.config.DEFAULT_PASSWORD;

            if (!userName || !password) {
                if (errfunc) errfunc();
                return;
            }

            AV.User.logIn(userName, password, {
                success: function (user) {
                    if (okfunc) okfunc(user);
                },
                error: function (user, error) {
                    if (errfunc) errfunc();
                }
            });
        },


        //登出
        signOut: function () {
            AV.User.logOut();
        },

        //获得用户详细
        getUserById: function (memberId, okfunc, errfunc) {
            var query = new AV.Query(AV.User);
            query.get(memberId, {
                success: function (user) {
                    if (okfunc) okfunc(user);
                },
                error: function (object, error) {
                    if (errfunc) errfunc(error);
                }
            });
        },

        setUserInfoById: function (
            //email, phone, nickname, birthday, sex, height, weight, address, job, disease, userHeadImage, realName, privacySex, privacyBirthday, privacyHeight, privacyWeight, privacyGroup, privacyCity, privacySick,
            okfunc, errfunc) {
            
            var user = AV.User.current();
            if (!user) {
                if (errfunc) errfunc();
                return;
            }

            user.set("phone", Light.rtdata.common_phone);
            user.set("nickname", Light.rtdata.common_userName);
            user.set("birthday", Light.rtdata.common_birth);
            user.set("sex", Light.rtdata.common_sex);
            user.set("height", Light.rtdata.common_height);
            user.set("weight", Light.rtdata.common_weight);
            user.set("address", Light.rtdata.common_city);
            user.set("job", Light.rtdata.common_job);
            user.set("disease", Light.rtdata.common_disease);
            user.set("userHeadImage", Light.rtdata.common_imgHead);

            user.set("realName", Light.rtdata.common_realName);
            user.set("privacySex", Light.rtdata.common_privacy_sex);
            user.set("privacyBirthday", Light.rtdata.common_privacy_birth);
            user.set("privacyHeight", Light.rtdata.common_privacy_height);
            user.set("privacyWeight", Light.rtdata.common_privacy_weight);
            user.set("privacyCity", Light.rtdata.common_privacy_city);
            user.set("privacyGroup", Light.rtdata.common_privacy_job);
            user.set("privacySick", Light.rtdata.common_privacy_disease);

            user.fetchWhenSave(true);
            user.save(null, {
                success: function (user) {
                    if (okfunc) okfunc(user);
                },
                error: function (object, error) {
                    if (errfunc) errfunc(error);
                }
            }
            );
        },

        //获得用户详细
        getUserByUsername: function (clientId, okfunc, errfunc) {

            AV.Query.doCloudQuery('select * from _User where username=?', [clientId], {
                success: function (result) {
                    var results = result.results;
                    if (results.length > 0) {
                        if (okfunc) okfunc(results[0]);
                    } else {
                        if (errfunc) errfunc();
                    }
                },
                error: function (error) {
                    if (errfunc) errfunc();
                }
            });
        },


        signInWithUser: function (userName, userPassword, okfunc, errfunc) {
            AV.User.logIn(userName, userPassword, {
                success: function (user) {
                    if (okfunc) okfunc(user);
                },
                error: function (user, error) {
                    if (errfunc) errfunc();
                }
            });
        },

        signUpWithUser: function (username, password, email, phone, nickname,
            birthday, sex, height, weight, address, job, disease,
            userHeadImage, okfunc, errfunc) {

            var user = new AV.User();
            user.set("username", username);
            user.set("password", password);
            user.set("email", email);
            user.set("phone", phone);
            user.set("nickname", nickname);
            user.set("birthday", birthday);
            user.set("sex", sex);
            user.set("height", height);
            user.set("weight", weight);
            user.set("address", address);
            user.set("job", job);
            user.set("disease", disease);
            user.set("userHeadImage", userHeadImage);

            user.signUp(null, {
                success: function (user) {
                    //alert("success");
                    if (okfunc) okfunc(user);
                },
                error: function (user, error) {
                    alert("Error: " + error.code + " " + error.message);
                    if (errfunc) errfunc(error);
                }
            });
        },

    };
})();
/*
signUp: function (username, password, email, phone, okfunc, errfunc) {

    var user = new AV.User();
    user.set("username", username);
    user.set("password", password);
    user.set("email", email);
    user.set("phone", phone);

    user.signUp(null, {
        success: function (user) {
            if (okfunc) okfunc(user);
        },
        error: function (user, error) {
            alert("Error: " + error.code + " " + error.message);
            if (errfunc) errfunc(error);
        }
    });
},*/