﻿//action notification
(function () {
    var hours = Light.config.notificationIntervalHours;
    var getStartTime = function (argtime) {
        var time = parseInt(argtime);
        var inttime = parseInt(time / 100);
        var rt = inttime - (inttime % hours);
        return rt * 100;
    };

    Light.action.notification = {

        renewNotification: function (donefunc, failfunc) {
            var notification_left = 64;
            var cdate = Light.tool.getDate();
            var ctime = Light.tool.getTime();
            var targetdate;
            var dateplus = 0;
            var all_item = [];

            var getNextDateData = function () { };

            var insertdb = function () {
                var items = all_item;
                var count = 0;
                for (var i = 0; i < items.length; i++) {
                    var values = {
                        notificationId: Light.tool.newGUID(),
                        content: items[i].content,
                        type: items[i].type,
                        date: items[i].date,
                        time: items[i].time,
                        status: 0
                    };
                    Light.db.notification.insert(values, null, null);
                    count = count + 1;
                    if (count >= 64) break;
                }

                if (donefunc) donefunc();
            };

            var getMedicineDone = function (items) {

                var alltime = [];
                for (var i = 0; i < items.length; i++) {
                    var list = items[i].timeList.split(",");
                    for (var j = 0; j < list.length; j++) {
                        var inttime = getStartTime(list[j]);
                        if ($.inArray(inttime, alltime) == -1) {
                            alltime.push(inttime);
                        }
                    }
                }

                for (var i = 0; i < alltime.length; i++) {
                    if (notification_left > 0 && ((targetdate == cdate && alltime[i] > ctime) || targetdate > cdate)) {
                        all_item.push({
                            type: "medicine,0",
                            date: "" + targetdate,
                            time: alltime[i],
                            content: Light.config.scheduleItemsList[0].notify[0],
                        });
                        notification_left = notification_left - 1;
                    }
                }
               
                if (notification_left > 0) {
                    dateplus = dateplus + 1;

                    if (dateplus > 14) {
                        insertdb();
                    } else {
                        getNextDateData();
                    }
                } else {
                    insertdb();
                }
            };

            var getHealthDone = function (items) {

                if (items && items.length > 0) {//has health plan
                    for (var i = 0; i < items.length; i++) {
                        if (items[i].itemType != 4) {//加餐

                            if ((targetdate == cdate && items[i].itemStartTime > ctime) || targetdate > cdate) {
                                var tmpcontent = Light.config.scheduleItemsList[items[i].itemType].notify[0];

                                var dtls = items[i].itemDtls;
                                for (var j = 0; j < dtls.length; j++) {
                                    if (dtls[j].dtlId == "999999") {
                                        tmpcontent = Light.config.scheduleItemsList[items[i].itemType].notify[1];
                                        //alert("qi pian ri.");
                                    }
                                }
                                if (notification_left > 0) {
                                    all_item.push({
                                        type: "health," + items[i].itemType + "",
                                        date: "" + targetdate,
                                        time: items[i].itemStartTime,
                                        content: tmpcontent,
                                    });
                                    notification_left = notification_left - 1;
                                }
                            }
                        }
                    }
                } else {//has not health plan
                    if (Light.rtdata.health_notification_switch == 1) {
                        for (var i = 1; i <= 7 ; i++) {
                            if (i != 4) {//加餐
                                if ((targetdate == cdate && Light.config.scheduleItemsList[i].intTime > ctime) || targetdate > cdate) {
                                    if (notification_left > 0) {
                                        all_item.push({
                                            type: "health," + i + "",
                                            date: "" + targetdate,
                                            time: Light.config.scheduleItemsList[i].intTime,
                                            content: Light.config.scheduleItemsList[i].notify[0],
                                        });
                                        notification_left = notification_left - 1;
                                    }
                                }
                            }
                        }
                    }
                }

                if (Light.rtdata.medicine_notification_switch == 1) {
                    Light.action.customMedicinePlan.getPlanByDate(
                        targetdate,
                        getMedicineDone,
                        failfunc);
                } else {
                    if (notification_left > 0) {
                        dateplus = dateplus + 1;

                        if (dateplus > 14) {
                            insertdb();
                        } else {
                            getNextDateData();
                        }
                    } else {
                        insertdb();
                    }
                }
            };

            getNextDateData = function () {
                targetdate = Light.tool.addDate(cdate, dateplus);

                if (Light.rtdata.health_notification_switch == 1) {
                    Light.action.healthPlan.getPlanByDate(
                    targetdate,
                    getHealthDone,
                    failfunc);
                } else {
                    getHealthDone([]);
                }
            }

            Light.db.notification.reset();

            getNextDateData();
        },

        testNotificationNow: function (donefunc) {
            var items = [];
            var cdate = Light.tool.getDate();
            var ctime = Light.tool.getTime();
            //for test start
            //alert("debug:"+ Light.config.scheduleItemsList[2].notify[0]);
            items.push({
                type: "health,1",
                date: "" + cdate,
                time: Light.tool.getTime() + 1,
                content: Light.config.scheduleItemsList[1].notify[0],
            });
            items.push({
                type: "medicine,0",
                date: "" + cdate,
                time: Light.tool.getTime() + 2,
                content: Light.config.scheduleItemsList[0].notify[0],
            });
            //for test end

            for (var i = 0; i < items.length; i++) {
                var values = {
                    notificationId: Light.tool.newGUID(),
                    content: items[i].content,
                    type: items[i].type,
                    date: items[i].date,
                    time: items[i].time,
                    status: 0
                };
                Light.db.notification.insert(values, null, null);
            }
            if (donefunc) donefunc();
        },

        renewSystemNotification: function (donefunc, failfunc) {

            var getNotificationdone = function (items) {

                for (var i = 0; i < items.length; i++) {
                    var datetime = "";
                    if (items[i].time >= 1000) {
                        datetime = items[i].date + "" + items[i].time;
                    } else {
                        datetime = items[i].date + "0" + items[i].time;
                    }

                    //alert("regist notification:[" + datetime + "|" + items[i].type + "" + "]");
                    if (window.plugins && window.plugins.NativePush) {
                        window.plugins.NativePush.addNativePush(datetime, items[i].type + "," + datetime, items[i].content);
                    }
                    Light.db.notification.update(
                        items[i].notificationId,
                        {
                            status: 1,//1:scheduled
                        },
                        null, null);
                }

                if (donefunc) { donefunc(); }
            };

            if (window.plugins && window.plugins.NativePush) {
                //alert("delete all notification:");
                window.plugins.NativePush.resetNativePush();
            }

            Light.db.notification.select(
                ["status", 0],
                getNotificationdone,
                failfunc);
        },

        /*

        getUnReadCount: function (donefunc, failfunc) {

            var getNotificationdone = function (items) {
                var rt = 0;
                if (items) { rt = items.length;}
                if (donefunc) { donefunc(rt); }
            };

            Light.db.notification.getAll(
                [
                    [
                        ["notificationDate", "<", Light.tool.getDate()],
                        "or",
                        [
                            ["notificationDate", Light.tool.getDate()],
                            "and",
                            ["startTime", "<=", Light.tool.getTime()],
                        ]
                    ],
                    "and",
                    ["status", "<>", 2]// unread notification
                ],
                getNotificationdone,
                failfunc);
        },

        */
    };

})();