﻿//action pedometer
(function () {

    var groupSum = function (items) {
        var rt = [];

        var sumdate = "";
        var sumtime = 0;
        var sumstep = 0;
        var sumcalorie = 0;
        var sumcourse = 0;
        var summinute = 0;

        for (var i = 0; i < items.length; i++) {
            var item = items[i];

            if (item.surveyDate != sumdate) {
                if (sumdate != "") {
                    rt.push({
                        surveyDate: sumdate,
                        step: sumstep,
                        calorie: sumcalorie,
                        course: sumcourse,
                        minute: summinute
                    });
                }
                sumdate = item.surveyDate;
                sumtime = item.surveyTime;
                sumstep = item.step;
                sumcalorie = item.calorie;
                sumcourse = item.course;
                summinute = item.minute;
            } else {
                if (item.surveyTime > sumtime) {
                    sumtime = item.surveyTime;
                    sumstep = item.step;
                    sumcalorie = item.calorie;
                    sumcourse = item.course;
                    summinute = item.minute;
                }
            }
        }
        if (sumdate != "") {
            rt.push({
                surveyDate: sumdate,
                step: sumstep,
                calorie: sumcalorie,
                course: sumcourse,
                minute: summinute
            });
        }
        return rt;
    }

    var hasSumDate = function (date, list) {
        for (var i = 0; i < list.length; i++) {
            if (list[i].surveyDate == date) {
                return list[i].pedometerSumId;
            }
        }
        return null;
    }

    Light.action.pedometer = {

        addRecord: function (date, time, step, calorie, course, minute) {

            var ongetall = function (items) {
                if (items && items.length > 0) {
                    var record = items[0];
                    var values = {
                        step: step,
                        calorie: calorie,
                        course: course,
                        minute: minute,
                        uploadFlg: 0
                    };
                    Light.db.pedometer.update(record.pedometerId, values, null, null);
                } else {
                    var values = {
                        pedometerId: Light.tool.newGUID(),
                        surveyDate: date,
                        surveyTime: time,
                        step: step,
                        calorie: calorie,
                        course: course,
                        minute: minute,
                        uploadFlg: 0,
                        timestamp:"",
                    };
                    Light.db.pedometer.insert(values, null, null);

                    //for test only
                    /*
                    for (var i = 0; i < 80; i++) {
                        values.pedometerId = Light.tool.newGUID();
                        values.surveyDate = Light.tool.addDate("20141210", i);
                        Light.db.pedometer.insert(values, null, null)
                    }*/
                }
            };

            Light.db.pedometer.select([["surveyDate", date], "and", ["surveyTime", time]], ongetall, null);
        },
        
        getRecordByDate: function (date, donefunc) {
            var ongetall = function (items) {
                var rt = [];
                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    rt.push({
                        surveyDate: item.surveyDate,
                        surveyTime: item.surveyTime,
                        step: item.step,
                        calorie: item.calorie,
                        course: item.course,
                        minute: item.minute
                    });
                }

                if (donefunc) { donefunc(rt); }
            };
            Light.db.pedometer.select(["surveyDate", date], ongetall, null);
        },

        getWeekRecord: function (startdate, enddate, donefunc) {

            var ongetall = function (items) {
                var rt = [];
                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    rt.push({
                        surveyDate: item.surveyDate,
                        step: item.step,
                        calorie: item.calorie,
                        course: item.course,
                        minute: item.minute
                    });
                }
                if (donefunc) { donefunc(rt); }
            };
            Light.db.pedometerSum.selectColumnsSort(null, [["surveyDate", ">=", startdate], "and", ["surveyDate", "<=", enddate]], "surveyDate", ongetall);
        },

        getMonthRecord: function (month, donefunc) {
            var rt = Light.tool.getMonthStartEnd(month);
            var startdate = rt.startDate;
            var enddate = rt.endDate;
            var ongetall = function (items) {
                var rt = [];
                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    rt.push({
                        surveyDate: item.surveyDate,
                        step: item.step,
                        calorie: item.calorie,
                        course: item.course,
                        minute: item.minute
                    });
                }
                if (donefunc) { donefunc(rt); }
            };
            Light.db.pedometerSum.selectColumnsSort(null, [["surveyDate", ">=", startdate], "and", ["surveyDate", "<=", enddate]], "surveyDate", ongetall);
        },

        getYearRecord: function (year, donefunc) {
            var rtdate = Light.tool.getYearStartEnd(year);
            var startdate = rtdate.startDate;
            var enddate = rtdate.endDate;
            var ongetall = function (items) {
                var rt = [];

                var summonth = "";
                var sumstep = 0;
                var sumcalorie = 0;
                var sumcourse = 0;
                var summinute = 0;

                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    if (item.surveyDate.substring(0, 6) != summonth) {
                        if (summonth != "") {
                            rt.push({
                                surveyDate: summonth,
                                step: sumstep,
                                calorie: sumcalorie,
                                course: sumcourse,
                                minute: summinute
                            });
                        }
                        summonth = item.surveyDate.substring(0, 6);
                        sumstep = item.step;
                        sumcalorie = item.calorie;
                        sumcourse = item.course;
                        summinute = item.minute;
                    } else {
                        sumstep = sumstep + item.step;
                        sumcalorie = sumcalorie + item.calorie;
                        sumcourse = sumcourse + item.course;
                        summinute = summinute + item.minute;
                    }
                }
                if (summonth != "") {
                    rt.push({
                        surveyDate: summonth,
                        step: sumstep,
                        calorie: sumcalorie,
                        course: sumcourse,
                        minute: summinute
                    });
                }

                if (donefunc) { donefunc(rt); }
            };
            Light.db.pedometerSum.selectColumnsSort(null, [["surveyDate", ">=", startdate], "and", ["surveyDate", "<=", enddate]], "surveyDate", ongetall);
        },

        renewSum: function (donefunc) {
            var today = Light.tool.getDate();
            var yestoday = Light.tool.addDate(today, -1);
            var sumIdlist = [];

            var renewSumStore = function (items) {
                var groupitems = groupSum(items);
                //alert("storePedometer insert update start:" + groupitems.length);
                for (var i = 0; i < groupitems.length; i++) {
                    var item = groupitems[i];

                    var tid = hasSumDate(item.surveyDate, sumIdlist);
                    if (tid) {
                        var values = {
                            step: item.step,
                            calorie: item.calorie,
                            course: item.course,
                            minute: item.minute,
                            uploadFlg: 0
                        };
                        Light.db.pedometerSum.update(tid, values, null, null);
                    } else {
                        var newrecord = {
                            pedometerSumId: Light.tool.newGUID(),
                            surveyDate: item.surveyDate,
                            step: item.step,
                            calorie: item.calorie,
                            course: item.course,
                            minute: item.minute,
                            uploadFlg: 0
                        };
                        Light.db.pedometerSum.insert(newrecord, null, null);
                    }
                    
                }
                //alert("storePedometer insert update end:");
                if (donefunc) donefunc();
            };

            var onsumgetall = function (items) {
                //alert("storePedometerSum get done")
                sumIdlist = [];
                for (var i = 0; i < items.length; i++) {
                    sumIdlist.push({
                        surveyDate: items[i].surveyDate,
                        pedometerSumId: items[i].pedometerSumId
                    });
                }

                if (items && items.length > 0) {
                    var lastdate = items[items.length - 1].surveyDate;
                    Light.db.pedometer.selectColumnsSort(null, [["surveyDate", ">=", lastdate], "and", ["surveyDate", "<=", today]], "surveyDate", renewSumStore, null);
                    //alert("storePedometer select all start" + lastdate + "|" + today);
                } else {
                    Light.db.pedometer.selectColumnsSort(null, null, "surveyDate", renewSumStore, null);
                    //alert("storePedometer select all start");
                }
            };

            Light.db.pedometerSum.selectColumnsSort(null, null, "surveyDate", onsumgetall, null);
        },

        uploadToServer: function (donefunc, failfunc) {
            if (Light.rtdata.memberAcc == Light.config.TRIAL_USER_KEY) {
                if (donefunc) donefunc();
                return;
            }
            var fortimelist = [];
            var forupdatetimelist = [];
            var fordatelist = [];
            var forupdatedatelist = [];
            var onresponse = function (obj) {
                //var items = obj.list;
                for (var i = 0; i < forupdatetimelist.length; i++) {
                    var item = forupdatetimelist[i];
                    Light.db.pedometer.update(item, { uploadFlg: 1}, null, null);
                }

                for (var i = 0; i < forupdatedatelist.length; i++) {
                    var item = forupdatedatelist[i];
                    Light.db.pedometerSum.update(item, { uploadFlg: 1 }, null, null);
                }
                if (donefunc) { donefunc(); }
            };

            var getdatedone = function (items) {
                for (var i = 0; i < items.length; i++) {

                    fordatelist.push(items[i]);
                    forupdatedatelist.push(items[i].pedometerSumId);
                }
                if (fortimelist.length == 0 && fordatelist.length == 0) {
                    if (donefunc) { donefunc(); }
                    return;
                }
                Light.network.requestBackground("/app/member/health/uploadPedometerList", { pedometerList: fortimelist, pedometerDayList: fordatelist }, onresponse, failfunc, "post");
            }

            var gettimedone = function (items) {
                for (var i = 0; i < items.length && i < 200; i++) {
                    fortimelist.push(items[i]);
                    forupdatetimelist.push(items[i].pedometerId);
                }
                Light.db.pedometerSum.select(["uploadFlg", 0], getdatedone, failfunc);
            }

            var done = function (rt) {
                //alert("healthSync:" + rt.healthSyncSwitch);
                if (rt.healthSyncSwitch == 1) {
                    Light.db.pedometer.select(["uploadFlg", 0], gettimedone, failfunc);
                } else {
                    if (donefunc) { donefunc(); }
                }
            };
            Light.action.setting.getHealthSetting(done);
        },

        downloadFromServer: function (donefunc, failfunc) {
            var onresponse = function (obj) {
                var timeslist = obj.pedometerList;
                var dateslist = obj.pedometerDayList;
                for (var i = 0; i < timeslist.length; i++) {
                    timeslist[i].uploadFlg = 1;

                    Light.db.pedometer.insert(timeslist[i], null, null);
                }
                for (var i = 0; i < dateslist.length; i++) {
                    dateslist[i].uploadFlg = 1;

                    Light.db.pedometerSum.insert(dateslist[i], null, null);
                }

                if (donefunc) { donefunc(); }
            };

            Light.network.requestBackground("/app/member/health/getPedometerList", {}, onresponse, failfunc, "post");
        },
    };

})();