﻿//action coin
(function () {

    Light.action.research = {
        /*
        ——参数命名——
        项目ID：【ProjID】
        项目名称：【ProjName】
        项目状态：【ProjStatusID/ProjStatusName】
        项目角色：【ProjRole】
        项目图标：【ProjIcon】
        所属类型：【QuestionnaireType】
        参与者姓名：【PatientName】
        参与者性别：【PatientSex】
        参与者年龄：【PatientAge】
        参与者手机号：【MobilePhone】
        上传者手机号：【UploadPhone】
        图片列表：【ImgList】
        参与者列表：【PatientList】
        */
        //Light.action.research.UploadImg("2", "13911111111","0","13922222222",upimg.files[0],function () { alert("done") }, function () { alert("error"); });
        //Light.action.research.GetProjList("12345678901", function () { alert("done"); }, function () { alert("error"); });
        //Light.action.research.GetProjData("pro01","12345678901", function () { alert("done"); }, function () { alert("error"); });
        //Light.action.research.GetImgList("pro01","12345678901", 1, function () { alert("done"); }, function () { alert("error"); });
        //Light.action.research.GetPatientList("pro01", function () { alert("done"); }, function () { alert("error"); });

        /*
        1，获取项目列表【GetProjList】
        提供参数：手机号（第三方可能没有？）
        返回参数：项目ID，项目名称，项目状态（ID/名称）。
        疑问：用户在项目中的角色，项目图标。
        */
        GetProjList: function (telephone, donefunc, failfunc) {

            var onresponse = function (obj) {
                var list = [];
                
                if (obj && obj.length > 0) {
                    for (var j = 0; j < obj.length; j++) {
                        var item = {};
                        item.projectId = obj[j].projID;
                        item.projectName = obj[j].projName;
                        item.projectState = obj[j].projStatus;
                        //item.projectIcon = obj[j].projIcon;
                        item.projectIcon = "./resource/img/project_icon.png";
                        item.userType = obj[j].projRole;
                        list.push(item);
                    }
                }

                if (donefunc) donefunc(list);
            };
            var data = {
                MobilePhone: telephone,
            };
            Light.network.requestResearch("GetProjList",
                    data,
                    onresponse, failfunc, "post");
        },

        /*
        2，获取项目全部参与信息【GetProjData】
        提供参数：项目ID，手机号
        返回参数：姓名，性别，年龄，图片列表（基线+随访）。
        图片列表参数：图片ID，图片URL，缩略图URL，状态，上传日期。
        */
        GetProjData: function (projectid, telephone, donefunc, failfunc) {

            var onresponse = function (obj) {
                var rt = {};
                rt.name = "";
                rt.sex = "";
                rt.age = "";
                rt.telephone = "";
                rt.stage1 = false;
                rt.stage2 = false;
                rt.stage3 = false;
                rt.stage4 = false;
                rt.stage5 = false;
                rt.stage6 = false;
                rt.stage7 = false;

                rt.list0 = [];
                rt.list1 = [];
                rt.list2 = [];
                rt.list3 = [];
                rt.list4 = [];
                rt.list5 = [];
                rt.list6 = [];

                if (obj) {
                    rt.name = obj.patientName;
                    rt.sex = obj.patientSex;
                    rt.age = obj.patientAge;
                    rt.telephone = obj.mobilePhone;
                    if (obj.stage1 == 1) { rt.stage1 = true; }
                    if (obj.stage2 == 1) { rt.stage2 = true; }
                    if (obj.stage3 == 1) { rt.stage3 = true; }
                    if (obj.stage4 == 1) { rt.stage4 = true; }
                    if (obj.stage5 == 1) { rt.stage5 = true; }
                    if (obj.stage6 == 1) { rt.stage6 = true; }
                    if (obj.stage7 == 1) { rt.stage7 = true; }

                    var list0 = obj.imgList.list0;
                    var list1 = obj.imgList.list1;
                    var list2 = obj.imgList.list2;
                    var list3 = obj.imgList.list3;
                    var list4 = obj.imgList.list4;
                    var list5 = obj.imgList.list5;
                    var list6 = obj.imgList.list6;

                    if (list0 && list0.length > 0) {
                        for (var j = 0; j < list0.length; j++) {
                            var item = {};
                            item.id = list0[j].imgID;
                            item.url = list0[j].imgUrl;
                            item.turl = list0[j].minImgUrl;
                            item.state = list0[j].status;
                            item.date = list0[j].date;
                            rt.list0.push(item);
                        }
                    }

                    if (list1 && list1.length > 0) {
                        for (var j = 0; j < list1.length; j++) {
                            var item = {};

                            item.id = list1[j].imgID;
                            item.url = list1[j].imgUrl;
                            item.turl = list1[j].minImgUrl;
                            item.state = list1[j].status;
                            item.date = list1[j].date;
                            rt.list1.push(item);
                        }
                    }
                    if (list3 && list3.length > 0) {
                        for (var j = 0; j < list3.length; j++) {
                            var item = {};

                            item.id = list3[j].imgID;
                            item.url = list3[j].imgUrl;
                            item.turl = list3[j].minImgUrl;
                            item.state = list3[j].status;
                            item.date = list3[j].date;
                            rt.list3.push(item);
                        }
                    }
                    if (list2 && list2.length > 0) {
                        for (var j = 0; j < list2.length; j++) {
                            var item = {};

                            item.id = list2[j].imgID;
                            item.url = list2[j].imgUrl;
                            item.turl = list2[j].minImgUrl;
                            item.state = list2[j].status;
                            item.date = list2[j].date;
                            rt.list2.push(item);
                        }
                    }
                    if (list4 && list4.length > 0) {
                        for (var j = 0; j < list4.length; j++) {
                            var item = {};

                            item.id = list4[j].imgID;
                            item.url = list4[j].imgUrl;
                            item.turl = list4[j].minImgUrl;
                            item.state = list4[j].status;
                            item.date = list4[j].date;
                            rt.list4.push(item);
                        }
                    }
                    if (list5 && list5.length > 0) {
                        for (var j = 0; j < list5.length; j++) {
                            var item = {};

                            item.id = list5[j].imgID;
                            item.url = list5[j].imgUrl;
                            item.turl = list5[j].minImgUrl;
                            item.state = list5[j].status;
                            item.date = list5[j].date;
                            rt.list5.push(item);
                        }
                    }
                    if (list6 && list6.length > 0) {
                        for (var j = 0; j < list6.length; j++) {
                            var item = {};

                            item.id = list6[j].imgID;
                            item.url = list6[j].imgUrl;
                            item.turl = list6[j].minImgUrl;
                            item.state = list6[j].status;
                            item.date = list6[j].date;
                            rt.list6.push(item);
                        }
                    }
                }

                if (donefunc) donefunc(rt);
            };
            var data = {
                MobilePhone: telephone,
                ProjID: projectid,
            };
            Light.network.requestResearch("GetProjData",
                    data,
                    onresponse, failfunc, "post");
        },

        /*
        3，上传图片【UploadImg】
        提供参数：项目ID，参与者手机号，所属类型（0~6），图片本体，上传者手机号。
        返回参数：成功/失败。
        */
        
        UploadImg: function (projectid, telephone, type, utelephone, file, donefunc, failfunc) {

            var data = new FormData();
            data.append('file', file);
            data.append('MobilePhone', telephone);
            data.append('UploadPhone', utelephone);
            data.append('ProjID', projectid);
            data.append('QuestionnaireType', type);

            $.ajax({
                url: Light.config.RESEARCH_SERVER_URL + Light.config.RESEARCH_UPLOAD_FILE,
                data: data,
                cache: false,
                contentType: false,
                processData: false,
                type: 'POST',
                success: function (data) {
                    if (data && data.result == 0) {
                        if (donefunc) donefunc(data);
                    } else {
                        if (failfunc) failfunc();
                    }
                },
                error: function () {
                    if (failfunc) failfunc();
                }
            });
        },
        
        /*
        4，获取单列表图片信息【GetImgList】
        提供参数：项目ID，手机号，所属类型（0~6）。
        返回参数：图片ID，图片URL，缩略图URL，状态，上传日期。
        */
        GetImgList: function (projectid, telephone, type, donefunc, failfunc) {
            var onresponse = function (obj) {
                var list = [];
                if (obj && obj.length > 0) {
                    for (var j = 0; j < obj.length; j++) {
                        var item = {};
                        item.id = obj[j].imgID;
                        item.url = obj[j].imgUrl;
                        item.turl = obj[j].minImgUrl;
                        item.state = obj[j].status;
                        item.date = obj[j].date;
                        list.push(item);
                    }
                }

                if (donefunc) donefunc(list);
            };
            var data = {
                MobilePhone: telephone,
                ProjID: projectid,
                QuestionnaireType: "" + type,
            };
            Light.network.requestResearch("GetImgList",
                    data,
                    onresponse, failfunc, "post");
        },

        /*
        5，获取项目参与者列表【GetPatientList】
        提供参数：项目ID
        返回参数：参与者列表（姓名，手机号，性别）
        */
        GetPatientList: function (projectid, donefunc, failfunc) {
            var onresponse = function (obj) {
                var rt = {};

                rt.projName = "";
                rt.projDate = "";
                rt.instituteName = "";
                rt.contacter = "";
                rt.mobile = "";

                rt.list = [];

                if (obj) {
                    rt.projName = obj.projName;
                    rt.projDate = obj.projDate;
                    rt.instituteName = obj.instituteName;
                    rt.contacter = obj.contacter;
                    rt.mobile = obj.mobile;

                    if (obj.patientList && obj.patientList.length > 0) {
                        for (var j = 0; j < obj.patientList.length; j++) {
                            var item = {};
                            item.index = (j + 1) + "";
                            item.userId = obj.patientList[j].mobilePhone;
                            item.userName = obj.patientList[j].patientName;
                            item.userTelephone = obj.patientList[j].patienPhone;
                            item.userSex = obj.patientList[j].patientSex;
                            rt.list.push(item);
                        }
                    }
                }
 
                if (donefunc) donefunc(rt);
            };
            var data = {
                ProjID: projectid,
            };
            Light.network.requestResearch("GetPatientList",
                    data,
                    onresponse, failfunc, "post");
        },
    };
})();
