﻿//action setting
(function () {

    Light.action.setting = {

        reset: function(done, fail) {
            Light.db.setting.reset(done,fail);
        },

        //******************** set **********************
        getHealthCoinDesc: function (param, donefunc, failfunc) {
            var onresponse = function (data) {
                if (donefunc) { donefunc(data); }
            };
            Light.network.request("/app/sys/getHealthCoinDesc", param, onresponse, failfunc, "post");
        },

        editMemberPrivacy: function (param, donefunc, failfunc) {
            var onresponse = function (data) {
                if (donefunc) { donefunc(data); }
            };
            Light.network.request("/app/member/acc/editMemberPrivacy", { privacy: param }, onresponse, failfunc, "post");
        },

        saveLastEquipmentIndex: function (index) {
            Light.rtdata.health_last_equipment = index;
            Light.db.setting.set("healthLastEquipment", index, null, null);
        },

        saveLastWeight: function (weight, bmi, bfr, waterContent, mus, boneQuality, metabolism, sfat, infat, bodyage) {
            Light.rtdata.health_last_weight_weight = weight;
            Light.rtdata.health_last_weight_bmi = bmi;
            Light.rtdata.health_last_weight_bfr = bfr;
            Light.rtdata.health_last_weight_water = waterContent;
            Light.rtdata.health_last_weight_mus = mus;
            Light.rtdata.health_last_weight_bone = boneQuality;
            Light.rtdata.health_last_weight_bmr = metabolism;
            Light.rtdata.health_last_weight_sfat = sfat;
            Light.rtdata.health_last_weight_infat = infat;
            Light.rtdata.health_last_weight_bodyage = bodyage;
            var data = "" + Light.tool.RoundFloat(weight, 2) + "," +
                Light.tool.RoundFloat(bmi,2 ) + "," +
                Light.tool.RoundFloat(bfr,2) + "," +
                Light.tool.RoundFloat(waterContent, 2) + "," +
                Light.tool.RoundFloat(mus, 2) + "," +
                Light.tool.RoundFloat(boneQuality, 2) + "," +
                Light.tool.RoundFloat(metabolism, 2) + "," +
                Light.tool.RoundFloat(sfat, 2) + "," +
                Light.tool.RoundFloat(infat, 2) + "," +
                bodyage + "";
            Light.db.setting.set("healthLastWeightData", data, null, null);

        },

        saveLastPedometer: function (step, calorie, course, minute, date, time) {
            Light.rtdata.health_last_pedometer_step = Light.tool.RoundFloat(step, 2);
            Light.rtdata.health_last_pedometer_calorie = Light.tool.RoundFloat(calorie, 2);
            Light.rtdata.health_last_pedometer_course = Light.tool.RoundFloat(course, 2);
            Light.rtdata.health_last_pedometer_minute = Light.tool.RoundFloat(minute, 2);
            Light.rtdata.health_last_pedometer_date = date;
            Light.rtdata.health_last_pedometer_time = time;

            var data = "" + Light.tool.RoundFloat(step, 2) + "," +
                Light.tool.RoundFloat(calorie, 2) + "," +
                Light.tool.RoundFloat(course, 2) + "," +
                Light.tool.RoundFloat(minute, 2) + "," +
                date + "," + time;
            Light.db.setting.set("healthLastPedometerData", data, null, null);
        },

        saveUDID: function (udid) {
            Light.db.setting.set("UDID", udid, null, null);
        },

        saveAccPassword: function (user, password) {
            Light.db.setting.setValues(
                {
                    memberLoginFlg: 1,
                    memberAcc: user,
                    memberPassword: password,
                }, null, null);
        },

        setPassword: function (password) {
            Light.db.setting.set("memberPassword", password, null, null);
        },

        setPrivacy: function (sex, birthday, height, weight, city, group, sick) {
            Light.db.setting.setValues(
                {
                    privacySex: sex,
                    privacyBirthday: birthday,
                    privacyHeight: height,
                    privacyWeight: weight,
                    privacyCity: city,
                    privacyGroup: group,
                    privacySick: sick,
                }, null, null);
        },

        setRealName: function (name) {
            Light.db.setting.set("realName", name, null, null);
        },

        setThirdPartyType: function (thirdPartyType) {
            Light.db.setting.set("thirdPartyType", thirdPartyType, null, null);
        },

        setTelephoneEmail: function (telephone, email) {
            if (telephone != null) { Light.db.setting.set("memberTelephone", telephone, null, null); }
            if (email != null) { Light.db.setting.set("memberEmail", email, null, null); }
        },

        setLeanCloud: function (leanCloudSocialId, leanCloudUDOId) {
            if (leanCloudSocialId != null) { Light.db.setting.set("leanCloudSocialId", leanCloudSocialId, null, null); }
            if (leanCloudUDOId != null) { Light.db.setting.set("leanCloudUDOId", leanCloudUDOId, null, null); }
        },

        setMemberId: function (memberId) {
            if (memberId != null) { Light.db.setting.set("memberId", memberId, null, null); }
        },

        setLastActivyDate: function(date) {
            if (date != null) { Light.db.setting.set("lastActivyDate", date, null, null); }
        },

        setUserInfo: function (userIconIndex, userName, userSex, userBirthday, userHeight, userWeight, userJob, userAddress) {
            Light.db.setting.setValues(
                {
                    userIconIndex: userIconIndex,
                    userName: userName,
                    userSex: userSex,
                    userBirthday: userBirthday,
                    userHeight: userHeight,
                    userWeight: userWeight,
                    userJob: userJob,
                    userAddress: userAddress,
                }, null, null);
        },

        setUserInfoUserName: function (userName) {
            Light.db.setting.set("userName", userName, null, null);
        },

        setUserInfoSex: function (userSex) {
            Light.db.setting.set("userSex", userSex, null, null);
        },

        setUserInfoBirthday: function (userBirthday) {
            Light.db.setting.set("userBirthday", userBirthday, null, null);
        },

        setUserInfoHeight: function (userHeight) {
            Light.db.setting.set("userHeight", userHeight, null, null);
        },

        setUserInfoWeight: function (userWeight) {
            Light.db.setting.set("userWeight", userWeight, null, null);
        },

        setUserInfoJob: function (userJob) {
            Light.db.setting.set("userJob", userJob, null, null);
        },

        setUserInfoAddress: function (userAddress) {
            Light.db.setting.set("userAddress", userAddress, null, null);
        },

        setUserHeadImg: function (userheadimg) {
            Light.db.setting.set("userHeadImg", userheadimg, null, null);
        },

        setDisease: function (list) {
            var value = "";
            for (var i = 0; i < list.length; i++) {
                if (value != "") {
                    value += ","; 
                }
                value += "" + list[i] + "";
            }
            Light.db.setting.set("disease", value, null, null);
        },

        setPlanNotificationSwitch: function (medicineSwitchFlg, healthSwitchFlg, notificationSoundIndex, notificationVibrationFlg) {
            if (medicineSwitchFlg != null) {
                Light.db.setting.set("medicineNotificationSwitch", medicineSwitchFlg, null, null);
            }
            if (healthSwitchFlg != null) {
                Light.db.setting.set("healthNotificationSwitch", healthSwitchFlg, null, null);
            }
            if (notificationSoundIndex != null) { Light.db.setting.set("planNotificationSoundIndex", notificationSoundIndex, null, null); }
            if (notificationVibrationFlg != null) { Light.db.setting.set("planNotificationVibrationFlg", notificationVibrationFlg, null, null); }
        },

        setHealthSwitch: function (yunyueWeightSwitch, lexinWeightSwitch, lexinPedometerSwitch, healthSyncSwitch) {
            Light.db.setting.setValues({
                yunyueWeightSwitch: yunyueWeightSwitch,
                lexinWeightSwitch: lexinWeightSwitch,
                lexinPedometerSwitch: lexinPedometerSwitch,
                healthSyncSwitch: healthSyncSwitch
            }, null, null);
        },

        setLexinWeightEquipmentId: function (id) {
            Light.db.setting.set("lexinWeightEquipmentId", id, null, null);
        },

        setLexinPedometerEquipmentId: function (id) {
            Light.db.setting.set("lexinPedometerEquipmentId", id, null, null);
        },

        setAppTip: function (index) {
            Light.db.setting.set("appTip", index, null, null);
        },

        //******************** get **********************

        getAccount: function (donefunc, failfunc) {
            Light.db.setting.getValues(donefunc, failfunc);
        },

        getUserInfo: function (donefunc) {
            var done = function (record) {
                var rt = {};
                rt.userIconIndex = record.userIconIndex;
                rt.userName = record.userName;
                rt.userSex = record.userSex;
                rt.userBirthday = record.userBirthday;
                rt.userHeight = record.userHeight;
                rt.userWeight = record.userWeight;
                rt.userJob = record.userJob;
                rt.userAddress = record.userAddress;
                rt.memberAcc = record.memberAcc;
                rt.memberPassword = record.memberPassword;
                rt.disease = record.disease.split(",");
                rt.userHeadImg = record.userHeadImg;
                rt.appTip = record.appTip;
                rt.memberTelephone = record.memberTelephone;

                rt.realName = record.realName;
                rt.privacySex = record.privacySex;
                rt.privacyBirthday = record.privacyBirthday;
                rt.privacyHeight = record.privacyHeight;
                rt.privacyWeight = record.privacyWeight;
                rt.privacyGroup = record.privacyGroup;
                rt.privacyCity = record.privacyCity;
                rt.privacySick = record.privacySick;
                
                donefunc(rt);
            };
            Light.db.setting.getValues( done, null);
        },

        getPlanNotificationSwitch: function (donefunc) {
            var done = function (record) {
                var rt = {};
                rt.medicineNotificationSwitch = record.medicineNotificationSwitch;
                rt.healthNotificationSwitch = record.healthNotificationSwitch;
                rt.planNotificationSoundIndex = record.planNotificationSoundIndex;
                rt.planNotificationVibrationFlg = record.planNotificationVibrationFlg;

                rt.realName = record.realName;
                rt.privacySex = record.privacySex;
                rt.privacyBirthday = record.privacyBirthday;
                rt.privacyHeight = record.privacyHeight;
                rt.privacyWeight = record.privacyWeight;
                rt.privacyGroup = record.privacyGroup;
                rt.privacyCity = record.privacyCity;
                rt.privacySick = record.privacySick;

                donefunc(rt);
            };
            Light.db.setting.getValues(done, null);
        },

        getHealthSetting: function (donefunc) {
            var done = function (record) {
                var rt = {};
                rt.yunyueWeightSwitch = record.yunyueWeightSwitch;
                rt.lexinWeightSwitch = record.lexinWeightSwitch;
                rt.lexinPedometerSwitch = record.lexinPedometerSwitch;
                rt.healthSyncSwitch = record.healthSyncSwitch;
                rt.lexinWeightEquipmentId = record.lexinWeightEquipmentId;
                rt.lexinPedometerEquipmentId = record.lexinPedometerEquipmentId;
                donefunc(rt);
            };
            Light.db.setting.getValues(done, null);
        },

        getDisease: function (donefunc) {
            var done = function (value) {
                var valuelist = value.split(",");
                donefunc(valuelist);
            };
            Light.db.setting.get("disease", done, null);
        },

        initRtdata: function () {
            var done = function (record) {
                Light.rtdata.UDID = record.UDID;
                Light.rtdata.memberId = record.memberId;
                Light.rtdata.memberAcc = record.memberAcc;
                Light.rtdata.memberPassword = record.memberPassword;
                Light.rtdata.thirdPartyType = record.thirdPartyType;

                Light.rtdata.health_last_equipment = record.healthLastEquipment;

                Light.rtdata.medicine_notification_switch = record.medicineNotificationSwitch;
                Light.rtdata.health_notification_switch = record.healthNotificationSwitch;
                

                var weightdata = (record.healthLastWeightData).split(",");
                if (weightdata) {
                    if (weightdata.length == 7) {
                        Light.rtdata.health_last_weight_weight = Globalize.parseFloat(weightdata[0]);
                        Light.rtdata.health_last_weight_bmi = Globalize.parseFloat(weightdata[1]);
                        Light.rtdata.health_last_weight_bfr = Globalize.parseFloat(weightdata[2]);
                        Light.rtdata.health_last_weight_water = Globalize.parseFloat(weightdata[3]);
                        Light.rtdata.health_last_weight_mus = Globalize.parseFloat(weightdata[4]);
                        Light.rtdata.health_last_weight_bone = Globalize.parseFloat(weightdata[5]);
                        Light.rtdata.health_last_weight_bmr = Globalize.parseFloat(weightdata[6]);
                        Light.rtdata.health_last_weight_sfat = 0;
                        Light.rtdata.health_last_weight_infat = 0;
                        Light.rtdata.health_last_weight_bodyage = 0;
                    } else if (weightdata.length == 10) {
                        Light.rtdata.health_last_weight_weight = Globalize.parseFloat(weightdata[0]);
                        Light.rtdata.health_last_weight_bmi = Globalize.parseFloat(weightdata[1]);
                        Light.rtdata.health_last_weight_bfr = Globalize.parseFloat(weightdata[2]);
                        Light.rtdata.health_last_weight_water = Globalize.parseFloat(weightdata[3]);
                        Light.rtdata.health_last_weight_mus = Globalize.parseFloat(weightdata[4]);
                        Light.rtdata.health_last_weight_bone = Globalize.parseFloat(weightdata[5]);
                        Light.rtdata.health_last_weight_bmr = Globalize.parseFloat(weightdata[6]);
                        Light.rtdata.health_last_weight_sfat = Globalize.parseFloat(weightdata[7]);
                        Light.rtdata.health_last_weight_infat = Globalize.parseFloat(weightdata[8]);
                        Light.rtdata.health_last_weight_bodyage = Globalize.parseFloat(weightdata[9]);
                    }
                }
                var pedometerdata = (record.healthLastPedometerData).split(",");
                if (pedometerdata && pedometerdata.length == 5) {
                    Light.rtdata.health_last_pedometer_step = Globalize.parseFloat(pedometerdata[0]);
                    Light.rtdata.health_last_pedometer_calorie = Globalize.parseFloat(pedometerdata[1]);
                    Light.rtdata.health_last_pedometer_course = Globalize.parseFloat(pedometerdata[2]);
                    Light.rtdata.health_last_pedometer_minute = Globalize.parseFloat(pedometerdata[3]);
                    Light.rtdata.health_last_pedometer_date = Globalize.parseFloat(pedometerdata[4]);
                }

                Light.rtdata.common_userName = record.userName;
                Light.rtdata.common_imgHead = record.userHeadImg;

                Light.rtdata.leanCloudUDOId = record.leanCloudUDOId;
                Light.rtdata.leanCloudSocialId = record.leanCloudSocialId;

                Light.rtdata.lastActivyDate = record.lastActivyDate;

                Light.rtdata.common_realName = record.realName;
                Light.rtdata.common_phone = record.memberTelephone;
                Light.rtdata.common_sex = record.userSex;
                Light.rtdata.common_height = record.userHeight;
                Light.rtdata.common_weight = record.userWeight;
                Light.rtdata.common_birth = record.userBirthday;
                Light.rtdata.common_age = Light.tool.getAge(record.userBirthday);
                Light.rtdata.common_job = record.userJob;
                Light.rtdata.common_city = record.userAddress;
                Light.rtdata.common_disease = record.disease;
                
                Light.rtdata.common_privacy_sex = record.privacySex;
                Light.rtdata.common_privacy_height = record.privacyHeight;
                Light.rtdata.common_privacy_weight = record.privacyWeight;
                Light.rtdata.common_privacy_birth = record.privacyBirthday;
                Light.rtdata.common_privacy_city = record.privacyCity;
                Light.rtdata.common_privacy_job = record.privacyGroup;
                Light.rtdata.common_privacy_disease = record.privacySick;

            };
            Light.db.setting.getValues(done, null);
        },

        //********************* server request **************************
        uploadToServer: function (donefunc, failfunc) {
            if (Light.rtdata.memberAcc == Light.config.TRIAL_USER_KEY) {
                if (donefunc) donefunc();
                return;
            }

            var toServerData = function (record) {
                var rt = {}
                var healthSwitch = [];
                var healthId = [];
                rt.memberAcc = record.memberAcc;
                rt.password = record.memberPassword;
                rt.mobile = record.memberTelephone;
                rt.email = record.memberEmail;
                rt.loginFlg = record.memberLoginFlg;
                rt.userIconIndex = record.userIconIndex;
                rt.userName = record.userName;
                rt.sex = record.userSex;
                rt.birthday = record.userBirthday;
                rt.userHeight = record.userHeight;
                rt.userWeight = record.userWeight;
                rt.userJob = record.userJob;
                rt.address = record.userAddress;
                rt.userHeadImg = record.userHeadImg;
                rt.healthDataSyncSwitch = record.healthDataSyncSwitch;
                rt.medicineNotificationSwitch = record.medicineNotificationSwitch;
                rt.healthNotificationSwitch = record.healthNotificationSwitch;
                rt.healthSyncSwitch = record.healthSyncSwitch;
                rt.healthLastWeightData = record.healthLastWeightData;
                rt.healthLastPedometerData = record.healthLastPedometerData;
                rt.disease = record.disease;

                rt.realName = record.realName;
                rt.privacySex = record.privacySex;
                rt.privacyBirthday = record.privacyBirthday;
                rt.privacyHeight = record.privacyHeight;
                rt.privacyWeight = record.privacyWeight;
                rt.privacyGroup = record.privacyGroup;
                rt.privacyCity = record.privacyCity;
                rt.privacySick = record.privacySick;

                rt.leanCloudSocialId = record.leanCloudSocialId;
                rt.leanCloudUDOId = record.leanCloudUDOId;

                rt.healthSetSwitch = JSON.stringify(healthSwitch);
                rt.healthSetId = JSON.stringify(healthId);

                rt.lastActivyDate = record.lastActivyDate;
                return rt;
            };

            var onresponse = function (obj) {
                if (donefunc) { donefunc(); }
            };

            var getlocaldone = function (record) {
                var data = { member: toServerData(record) };
                Light.network.requestBackground("/app/member/acc/uploadProfile", data, onresponse, failfunc, "post");
            }

            Light.db.setting.getValues(getlocaldone, failfunc);
        },

        downloadFromServer: function (donefunc, failfunc) {

            var onresponse = function (obj) {

                Light.db.setting.setValues({
                    memberId: obj.memberId,
                    memberAcc: obj.memberAcc,
                    memberPassword: obj.password,
                    memberTelephone: obj.mobile,
                    memberEmail: obj.email,
                    userIconIndex: obj.userIconIndex,
                    userName: obj.userName,
                    userSex: obj.sex,
                    userBirthday: obj.birthday,
                    userHeight: obj.userHeight,
                    userWeight: obj.userWeight,
                    userJob: obj.userJob,
                    userAddress: obj.address,
                    userHeadImg: obj.userHeadImg,

                    realName: obj.realName,
                    privacySex: obj.privacySex,
                    privacyBirthday: obj.privacyBirthday,
                    privacyHeight: obj.privacyHeight,
                    privacyWeight: obj.privacyWeight,
                    privacyGroup: obj.privacyGroup,
                    privacyCity: obj.privacyCity,
                    privacySick: obj.privacySick,

                    medicineNotificationSwitch: obj.medicineNotificationSwitch,
                    healthNotificationSwitch: obj.healthNotificationSwitch,
                    healthDataSyncSwitch: obj.healthDataSyncSwitch,
                    healthSyncSwitch: obj.healthSyncSwitch,
                    healthLastWeightData: obj.healthLastWeightData,
                    healthLastPedometerData: obj.healthLastPedometerData,
                    disease: obj.disease,

                    leanCloudSocialId: obj.leanCloudSocialId,
                    leanCloudUDOId: obj.leanCloudUDOId,
                    
                    lastActivyDate: obj.lastActivyDate,
                }, null, null);

                //init rtdata
                var weightdata = (obj.healthLastWeightData).split(",");
                Light.rtdata.health_last_weight_weight = Globalize.parseFloat(weightdata[0]);
                Light.rtdata.health_last_weight_bmi = Globalize.parseFloat(weightdata[1]);
                Light.rtdata.health_last_weight_bfr = Globalize.parseFloat(weightdata[2]);
                Light.rtdata.health_last_weight_water = Globalize.parseFloat(weightdata[3]);
                Light.rtdata.health_last_weight_mus = Globalize.parseFloat(weightdata[4]);
                Light.rtdata.health_last_weight_bone = Globalize.parseFloat(weightdata[5]);
                Light.rtdata.health_last_weight_bmr = Globalize.parseFloat(weightdata[6]);

                var pedometerdata = (obj.healthLastPedometerData).split(",");
                Light.rtdata.health_last_pedometer_step = Globalize.parseFloat(pedometerdata[0]);
                Light.rtdata.health_last_pedometer_calorie = Globalize.parseFloat(pedometerdata[1]);
                Light.rtdata.health_last_pedometer_course = Globalize.parseFloat(pedometerdata[2]);
                Light.rtdata.health_last_pedometer_minute = Globalize.parseFloat(pedometerdata[3]);
                Light.rtdata.health_last_pedometer_date = pedometerdata[4];
                Light.rtdata.health_last_pedometer_time = Globalize.parseInt(pedometerdata[5]);

                if (donefunc) { donefunc(); }
            };

            Light.network.requestBackground("/app/member/acc/getProfile", {}, onresponse, failfunc, "post");
        }
        
    };

})();
