﻿//action surveys

(function () {

    Light.action.surveys = {
        addRecord: function (type, result, memo, donefunc, failfunc) {

            var values = {
                surveysId: Light.tool.newGUID(),
                type:type,
                date: Light.tool.getDate(),
                time: Light.tool.getTime(),
                result: result,
                memo: memo,
                uploadFlg: 0,
                timestamp: "",
            };
            Light.db.surveys.insert(values, donefunc, failfunc);
        },

        getByType: function (type, donefunc, failfunc) {
            var done = function (items) {
                if (items && items.length > 0) {
                    donefunc(items);
                } else {
                    donefunc([]);
                }
            }
            Light.db.surveys.selectColumnsSort(null, ["type", type], ["date", "time"], done, failfunc);
        },

        getLast: function (donefunc, failfunc) {
            var rt = []
            var done = function (records) {
                var type = "";
                var first;
                for (var i = 0; i < records.length; i++) {
                    var record = records[i];
                    if (record.type != type) {
                        if (type != "") {
                            rt.push(first);
                        }
                        type = record.type;
                        first = record;
                    }
                }
                if (type != "") {
                    rt.push(first);
                }
                
                donefunc(rt);
            };
            Light.db.surveys.selectColumnsSort(null, null,
                [{ getter: "type", desc: false },
                    { getter: "date", desc: true },
                    { getter: "time", desc: true }]
                , done, failfunc);
        },

        uploadToServer: function (donefunc, failfunc) {
            if (Light.rtdata.memberAcc == Light.config.TRIAL_USER_KEY) {
                if (donefunc) donefunc();
                return;
            }

            var uploadlist = [];
            var forupdatelist = [];

            var onresponse = function (obj) {
                for (var i = 0; i < forupdatelist.length; i++) {
                    var id = forupdatelist[i];
                    Light.db.surveys.update(id, { uploadFlg: 1 }, null, null);
                }
                if (donefunc) { donefunc(); }
            };

            var getdatedone = function (items) {

                for (var i = 0; i < items.length; i++) {
                    var uploaditem = {
                        surveysId: items[i].surveysId,
                        type: items[i].type,
                        date: items[i].date,
                        time: items[i].time,
                        memo: items[i].memo,
                        result: JSON.stringify(items[i].result),
                    };

                    uploadlist.push(uploaditem);
                    forupdatelist.push(items[i].surveysId);
                }
                if (uploadlist.length == 0) {
                    if (donefunc) donefunc();
                    return;
                }
                Light.network.requestBackground("/app/member/health/uploadSurveys", { surveysList: uploadlist }, onresponse, failfunc, "post");//todo
            }

            Light.db.surveys.select(["uploadFlg", 0], getdatedone, failfunc);

        },

        downloadFromServer: function (donefunc, failfunc) {
            var onresponse = function (obj) {
                var surveys = obj;
                for (var i = 0; i < surveys.length; i++) {
                    surveys[i].uploadFlg = 1;
                    surveys[i].result = $.parseJSON(surveys[i].result);
                    Light.db.surveys.insert(surveys[i], null, null);
                }

                if (donefunc) { donefunc(); }
            };

            Light.network.requestBackground("/app/member/health/getSurveys", {}, onresponse, failfunc, "post");
        },
    };
})();
