﻿//action wealth
(function () {

    Light.action.wealth = {

        //取得我的健康币总数
        getMyCoinCount: function (userid, donefunc, failfunc) {
            var data = {
                userid: userid,
            };
            $.ajax({
                url: Light.config.APP_SERVER_URL + Light.config.REST_ROOT + "/app/jk/getJKB",
                data: data,
                type: 'GET',
                success: function (result) {
                    var obj = $.parseJSON(result);
                    if (obj.status == 1) {
                        if (donefunc) donefunc(obj.jkb);
                    }
                },
                error: function () {
                    if (failfunc) failfunc(0);
                }
            });
        },

        //取得所有可兑换优惠券
        getAllCoupons: function (donefunc, failfunc) {//0:饮食1:用药2:刷牙3:运动4:称体重
            data = {};
            $.ajax({
                url: Light.config.CC_51JK.SERVICE_URL + "?app=zhounian&act=getAllCoupons&callback=?",
                dataType: 'jsonp',
                data: data,
                type: 'POST',
                jsonp: 'callback',
                success: function (result) {
                    if (result.ReturnCode == 0) {
                        coupons = [];
                        var data = result.Data;
                        for (var i = 0; i < data.length; i++) {
                            var obj = {};
                            obj.id = data[i].health_coupon_id;
                            obj.url = "./resource/img/coupons/" + data[i].coupon_value + "_coupon.png";
                            obj.value = data[i].coupon_value;
                            obj.jkb = data[i].health_money;
                            obj.desc = data[i].detail;
                            if (data[i].end_time) {
                                var ymd = data[i].end_time.split("-");
                                obj.y = ymd[0];
                                obj.m = ymd[1];
                                obj.d = ymd[2];
                            }
                            coupons.push(obj);
                        }
                        if (donefunc) donefunc(coupons);
                    } else {
                        if (donefunc) donefunc([]);
                    }
                },
                error: function () {
                    if (failfunc) failfunc([]);
                }
            });
        },

        //取得我的优惠券
        getMyCoupons: function (userid, donefunc, failfunc) {//0:饮食1:用药2:刷牙3:运动4:称体重
            var data = {
                userid: userid,
            };

            $.ajax({
                url: Light.config.CC_51JK.SERVICE_URL + "?app=zhounian&act=getMyCoupons&callback=?",
                dataType: 'jsonp',
                data: data,
                type: 'POST',
                jsonp: 'callback',
                success: function (result) {
                    coupons = [];
                    for (var i = 0; i < result.length; i++) {
                        var obj = {};
                        obj.id = result[i].coupon_id;
                        obj.url = "./resource/img/coupons/" + result[i].coupon_value + "_mcoupon.png";
                        obj.valid = result[i].valid_flag;
                        obj.start_time = result[i].start_time;
                        obj.end_time = result[i].end_time;
                        obj.coupon_sn = result[i].coupon_sn;
                        obj.min_amount = result[i].min_amount;
                        /*
                        if (result[i].end_time) {
                            var ymd = result[i].end_time.split("-");
                            obj.y = ymd[0];
                            obj.m = ymd[1];
                            obj.d = ymd[2];
                        }*/
                        if (result[i].coupon_url) {
                            obj.coupon_url = result[i].coupon_url;
                        } else {
                            obj.coupon_url = "m_index.php";
                        }
                        
                        coupons.push(obj);
                    }
                    if (donefunc) donefunc(coupons);
                },
                error: function () {
                    if (failfunc) failfunc([]);
                }
            });
        },

        //兑换优惠券
        exchange: function (userid,jkb,couponid, donefunc, failfunc) {
            var data = {
                userid: userid,
                jkb: jkb,
                couponid: couponid,
            };
            $.ajax({
                url: Light.config.APP_SERVER_URL + Light.config.REST_ROOT + "/app/jk/exchange",
                data: data,
                type: 'GET',
                success: function (result) {
                    var obj = $.parseJSON(result);
                    if (donefunc) donefunc(obj);
                },
                error: function () {
                    if (failfunc) failfunc();
                }
            });
        },
    };
})();
