﻿//action weight Weight
(function () {

    var groupAvg = function (items) {
        var rt = [];

        var avgdate = "";
        var avgweight = 0;
        var avgCount = 0;
        var avgbmi = 0;
        var avgbfr = 0;
        var avgwaterContent = 0;
        var avgmus = 0;
        var avgboneQuality = 0;
        var avgmetabolism = 0;
        var avgsfat = 0;
        var avginfat = 0;
        var avgbodyage = 0;

        for (var i = 0; i < items.length; i++) {
            var item = items[i];

            if (item.surveyDate != avgdate) {
                if (avgdate != "") {
                    rt.push({
                        surveyDate: avgdate,
                        weight: avgweight / avgCount,
                        bmi: avgbmi / avgCount,
                        bfr: avgbfr / avgCount,
                        waterContent: avgwaterContent / avgCount,
                        mus: avgmus / avgCount,
                        boneQuality: avgboneQuality / avgCount,
                        metabolism: avgmetabolism / avgCount,
                        sfat: avgsfat / avgCount,
                        infat: avginfat / avgCount,
                        bodyage: avgbodyage / avgCount,
                    });
                }
                avgdate = item.surveyDate;
                avgweight = item.weight;
                avgbmi = item.bmi;
                avgbfr = item.bfr;
                avgwaterContent = item.waterContent;
                avgmus = item.mus;
                avgboneQuality = item.boneQuality;
                avgmetabolism = item.metabolism;
                avgsfat = item.sfat;
                avginfat = item.infat;
                avgbodyage = item.bodyage;
                avgCount = 1;
            } else {
                avgweight = avgweight + item.weight;
                avgbmi = avgbmi + item.bmi;
                avgbfr = avgbfr + item.bfr;
                avgwaterContent = avgwaterContent + item.waterContent;
                avgmus = avgmus + item.mus;
                avgboneQuality = avgboneQuality + item.boneQuality;
                avgmetabolism = avgmetabolism + item.metabolism;
                avgsfat = avgsfat + item.sfat;
                avginfat = avginfat + item.infat;
                avgbodyage = avgbodyage + item.bodyage;
                avgCount = avgCount + 1;

            }
        }
        if (avgdate != "") {
            rt.push({
                surveyDate: avgdate,
                weight: avgweight / avgCount,
                bmi: avgbmi / avgCount,
                bfr: avgbfr / avgCount,
                waterContent: avgwaterContent / avgCount,
                mus: avgmus / avgCount,
                boneQuality: avgboneQuality / avgCount,
                metabolism: avgmetabolism / avgCount,
                sfat: avgsfat / avgCount,
                infat: avginfat / avgCount,
                bodyage: avgbodyage / avgCount,
            });
        }
        return rt;
    }

    var hasAvgDate = function (date, list) {
        for (var i = 0; i < list.length; i++) {
            if (list[i].surveyDate == date) {
                return list[i].weightAvgId;
            }
        }
        return null;
    }


    Light.action.weight = {

        addRecord: function (weight, bmi, bfr, waterContent, mus, boneQuality, metabolism, sfat, infat, bodyage) {
            var date = Light.tool.getDate();
            var time = Light.tool.getTime();

            var ongetall = function (items) {
                if (items && items.length > 0) {
                    var record = items[0];
                    var values = {
                        weight: weight,
                        bmi: bmi,
                        bfr: bfr,
                        waterContent: waterContent,
                        mus: mus,
                        boneQuality: boneQuality,
                        metabolism: metabolism,
                        sfat: sfat,
                        infat: infat,
                        bodyage: bodyage,
                        uploadFlg: 0
                    };
                    Light.action.setting.saveLastWeight(weight, bmi, bfr, waterContent, mus, boneQuality, metabolism, sfat, infat, bodyage);
                    Light.db.weight.update(record.weightId, values, null, null);
                } else {
                    var values = {
                        weightId: Light.tool.newGUID(),
                        surveyDate: date,
                        surveyTime: time,
                        weight: weight,
                        bmi: bmi,
                        bfr: bfr,
                        waterContent: waterContent,
                        mus: mus,
                        boneQuality: boneQuality,
                        metabolism: metabolism,
                        sfat: sfat,
                        infat: infat,
                        bodyage: bodyage,
                        uploadFlg: 0,
                        timestamp: "",
                    };
                    Light.action.setting.saveLastWeight(weight, bmi, bfr, waterContent, mus, boneQuality, metabolism, sfat, infat, bodyage);
                    Light.db.weight.insert(values, null, null);

                    //for test only
                    /*
                    for (var i = 0; i < 80; i++) {
                        values.weightId = Light.tool.newGUID();
                        values.surveyDate = Light.tool.addDate("20141210", i);
                        Light.db.weight.insert(values, null, null);
                    }*/
                }
            };

            Light.db.weight.select([["surveyDate", date], "and", ["surveyTime", time]], ongetall, null);
        },

        getRecordByDate: function (date, donefunc) {
            var ongetall = function (items) {
                var rt = [];
                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    rt.push({
                        surveyDate: item.surveyDate,
                        surveyTime: item.surveyTime,
                        weight: item.weight,
                        bmi: item.bmi,
                        bfr: item.bfr,
                        waterContent: item.waterContent,
                        mus: item.mus,
                        boneQuality: item.boneQuality,
                        metabolism: item.metabolism,
                        sfat: item.sfat,
                        infat: item.infat,
                        bodyage: item.bodyage
                    });
                }

                if (donefunc) { donefunc(rt); }
            };
            Light.db.weight.select(["surveyDate", date], ongetall, null);
        },

        getWeekRecord: function (startdate, enddate, donefunc) {

            var ongetall = function (items) {
                var rt = [];
                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    rt.push({
                        surveyDate: item.surveyDate,
                        weight: item.weight,
                        bmi: item.bmi,
                        bfr: item.bfr,
                        waterContent: item.waterContent,
                        mus: item.mus,
                        boneQuality: item.boneQuality,
                        metabolism: item.metabolism,
                        sfat: item.sfat,
                        infat: item.infat,
                        bodyage: item.bodyage
                    });
                }
                if (donefunc) { donefunc(rt); }
            };
            Light.db.weightAvg.selectColumnsSort(null, [["surveyDate", ">=", startdate], "and", ["surveyDate", "<=", enddate]], "surveyDate", ongetall);
        },

        getMonthRecord: function (month, donefunc) {
            var rt = Light.tool.getMonthStartEnd(month);
            var startdate = rt.startDate;
            var enddate = rt.endDate;
            var ongetall = function (items) {
                var rt = [];
                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    rt.push({
                        surveyDate: item.surveyDate,
                        weight: item.weight,
                        bmi: item.bmi,
                        bfr: item.bfr,
                        waterContent: item.waterContent,
                        mus: item.mus,
                        boneQuality: item.boneQuality,
                        metabolism: item.metabolism,
                        sfat: item.sfat,
                        infat: item.infat,
                        bodyage: item.bodyage
                    });
                }
                if (donefunc) { donefunc(rt); }
            };
            Light.db.weightAvg.selectColumnsSort(null, [["surveyDate", ">=", startdate], "and", ["surveyDate", "<=", enddate]], "surveyDate", ongetall);
        },

        getYearRecord: function (year, donefunc) {
            var rtdate = Light.tool.getYearStartEnd(year);
            var startdate = rtdate.startDate;
            var enddate = rtdate.endDate;
            var ongetall = function (items) {
                var rt = [];

                var summonth = "";
                var sumweight = 0;
                var sumbmi = 0;
                var sumbfr = 0;
                var sumcount = 0;
                var sumwaterContent = 0;
                var summus = 0;
                var sumboneQuality = 0;
                var summetabolism = 0;

                var sumsfat = 0;
                var suminfat = 0;
                var sumbodyage = 0;

                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    if (item.surveyDate.substring(0, 6) != summonth) {
                        if (summonth != "") {
                            rt.push({
                                surveyDate: summonth,
                                weight: sumweight / sumcount,
                                bmi: sumbmi / sumcount,
                                bfr: sumbfr / sumcount,
                                waterContent: sumwaterContent / sumcount,
                                mus: summus / sumcount,
                                boneQuality: sumboneQuality / sumcount,
                                metabolism: summetabolism / sumcount,
                                sfat: sumsfat / sumcount,
                                infat: suminfat / sumcount,
                                bodyage: sumbodyage / sumcount,
                            });
                        }
                        summonth = item.surveyDate.substring(0, 6);
                        sumweight = item.weight;
                        sumbmi = item.bmi;
                        sumbfr = item.bfr;
                        sumwaterContent = item.waterContent;
                        summus = item.mus;
                        sumboneQuality = item.boneQuality;
                        summetabolism = item.metabolism;
                        sumsfat = item.sfat;
                        suminfat = item.infat;
                        sumbodyage = item.bodyage;
                        sumcount = 1;
                    } else {
                        sumweight = sumweight + item.weight;
                        sumbmi = sumbmi + item.bmi;
                        sumbfr = sumbfr + item.bfr;
                        sumwaterContent = sumwaterContent + item.waterContent;
                        summus = summus +  item.mus;
                        sumboneQuality = sumboneQuality + item.boneQuality;
                        summetabolism = summetabolism + item.metabolism;
                        sumsfat = sumsfat + item.sfat;
                        suminfat = suminfat + item.infat;
                        sumbodyage = sumbodyage + item.bodyage;
                        sumcount = sumcount + 1;
                    }
                }
                if (summonth != "") {
                    rt.push({
                        surveyDate: summonth,
                        weight: sumweight / sumcount,
                        bmi: sumbmi / sumcount,
                        bfr: sumbfr / sumcount,
                        waterContent: sumwaterContent / sumcount,
                        mus: summus / sumcount,
                        boneQuality: sumboneQuality / sumcount,
                        metabolism: summetabolism / sumcount,
                        sfat: sumsfat / sumcount,
                        infat: suminfat / sumcount,
                        bodyage: sumbodyage / sumcount,
                    });
                }

                if (donefunc) { donefunc(rt); }
            };
            Light.db.weightAvg.selectColumnsSort(null, [["surveyDate", ">=", startdate], "and", ["surveyDate", "<=", enddate]], "surveyDate", ongetall);
        },

        renewAvg: function (donefunc) {
            var today = Light.tool.getDate();
            var yestoday = Light.tool.addDate(today, -1);
            var avgIdlist = [];

            var renewAvgStore = function (items) {
                var groupitems = groupAvg(items);
                //alert("storeWeight insert update start:" + groupitems.length);
                for (var i = 0; i < groupitems.length; i++) {
                    var item = groupitems[i];

                    var tid = hasAvgDate(item.surveyDate, avgIdlist);
                    if (tid) {
                        var values = {
                            weight: item.weight,
                            bmi: item.bmi,
                            bfr: item.bfr,
                            waterContent : item.waterContent,
                            mus : item.mus,
                            boneQuality: item.boneQuality,
                            metabolism: item.metabolism,
                            sfat: item.sfat,
                            infat: item.infat,
                            bodyage: item.bodyage,
                            uploadFlg: 0
                        };
                        Light.db.weightAvg.update(tid, values, null, null);
                    } else {
                        var newrecord = {
                            weightAvgId: Light.tool.newGUID(),
                            surveyDate: item.surveyDate,
                            weight: item.weight,
                            bmi: item.bmi,
                            bfr: item.bfr,
                            waterContent: item.waterContent,
                            mus: item.mus,
                            boneQuality: item.boneQuality,
                            metabolism: item.metabolism,
                            sfat: item.sfat,
                            infat: item.infat,
                            bodyage: item.bodyage,
                            uploadFlg: 0
                        };
                        Light.db.weightAvg.insert(newrecord, null, null);
                    }

                }
                //alert("storeWeight insert update end:");
                if (donefunc) donefunc();
            };

            var onavggetall = function (items) {
                //alert("storeWeightAvg get done")
                avgIdlist = [];
                for (var i = 0; i < items.length; i++) {
                    avgIdlist.push({
                        surveyDate: items[i].surveyDate,
                        weightAvgId: items[i].weightAvgId
                    });
                }

                if (items && items.length > 0) {
                    var lastdate = items[items.length - 1].surveyDate;
                    Light.db.weight.selectColumnsSort(null, [["surveyDate", ">=", lastdate], "and", ["surveyDate", "<=", today]], "surveyDate", renewAvgStore, null);
                    //alert("storeWeight select all start" + lastdate + "|" + today);
                } else {
                    Light.db.weight.selectColumnsSort(null, null, "surveyDate", renewAvgStore, null);
                    //alert("storeWeight select all start");
                }
            };

            Light.db.weightAvg.selectColumnsSort(null, null, "surveyDate", onavggetall, null);
        },

        uploadToServer: function (donefunc, failfunc) {
            if (Light.rtdata.memberAcc == Light.config.TRIAL_USER_KEY) {
                if (donefunc) donefunc();
                return;
            }

            var fortimelist = [];
            var forupdatetimelist = [];
            var fordatelist = [];
            var forupdatedatelist = [];
            var onresponse = function (obj) {
                //var items = obj.list;
                for (var i = 0; i < forupdatetimelist.length; i++) {
                    var item = forupdatetimelist[i];
                    Light.db.weight.update(item, { uploadFlg: 1 }, null, null);
                }

                for (var i = 0; i < forupdatedatelist.length; i++) {
                    var item = forupdatedatelist[i];
                    Light.db.weightAvg.update(item, { uploadFlg: 1 }, null, null);
                }
                if (donefunc) { donefunc(); }
            };

            var getdatedone = function (items) {
                for (var i = 0; i < items.length; i++) {

                    fordatelist.push(items[i]);
                    forupdatedatelist.push(items[i].weightAvgId);
                }
                if (fortimelist.length == 0 && fordatelist.length == 0) {
                    if (donefunc) { donefunc(); }
                    return;
                }
                Light.network.requestBackground("/app/member/health/uploadWeightList", { weightList: fortimelist, weightDayList: fordatelist }, onresponse, failfunc, "post");
            }

            var gettimedone = function (items) {
                for (var i = 0; i < items.length && i < 200; i++) {

                    fortimelist.push(items[i]);
                    forupdatetimelist.push(items[i].weightId);
                }
                Light.db.weightAvg.select(["uploadFlg", 0], getdatedone, failfunc);
            }
            var done = function (rt) {
                //alert("healthSync:" + rt.healthSyncSwitch);
                if (rt.healthSyncSwitch == 1) {
                    Light.db.weight.select(["uploadFlg", 0], gettimedone, failfunc);
                } else {
                    if (donefunc) { donefunc(); }
                }
            };
            Light.action.setting.getHealthSetting(done);
        },
        
        downloadFromServer: function (donefunc, failfunc) {
            var onresponse = function (obj) {
                var timeslist = obj.weightList;
                var dateslist = obj.weightDayList;
                for (var i = 0; i < timeslist.length; i++) {
                    timeslist[i].uploadFlg = 1;

                    Light.db.weight.insert(timeslist[i], null, null);
                }
                for (var i = 0; i < dateslist.length; i++) {
                    dateslist[i].uploadFlg = 1;

                    Light.db.weightAvg.insert(dateslist[i], null, null);
                }

                if (donefunc) { donefunc(); }
            };

            Light.network.requestBackground("/app/member/health/getWeightList", {}, onresponse, failfunc, "post");
        },
    };
})();
