﻿
Light.db.addressBook = {
    name: "addressBook",
    store: null,
    scheme: [
        { name: "username", type: "string", default: "" },
        { name: "email", type: "string", default: "" },
        { name: "phone", type: "string", default: "" },
        { name: "nickname", type: "string", default: "" },
        { name: "birthday", type: "string", default: "" },
        { name: "sex", type: "int", default: 0 },
        { name: "height", type: "int", default: 0 },
        { name: "weight", type: "float", default: 0 },
        { name: "address", type: "string", default: 0 },
        { name: "job", type: "int", default: 0 },
        { name: "disease", type: "obj", default: [] },
        { name: "userHeadImage", type: "string", default: "" },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "addressBook",
            key: "username",
            immediate: true,
            loaded: function () {
                Light.db.log("addressBook data has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
};

Light.db.addressBook.init();