﻿
Light.db.coin = {
    name: "coin",
    store: null,
    scheme: [
        { name: "coinId", type: "string", default: "" },
        { name: "coinType", type: "int", default: 0 },//0:饮食1:用药2:刷牙3:运动4:称体重
        { name: "coinDate", type: "string", default: "" },
        { name: "coinCount", type: "int", default: 0 },
        { name: "uploadFlg", type: "int", default: 0 },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "coin",
            key: "coinId",
            immediate: true,
            loaded: function () {
                Light.db.log("coin has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    update: function (id, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, id, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.coin.init();