﻿
Light.db.customMedicine = {
    name: "customMedicine",
    store: null,
    scheme: [
        { name: "customMedicineId", type: "string", default: "" },
        { name: "medicineName", type: "string", default: "" },
        { name: "medicineMemo", type: "string", default: "" },
        { name: "eatFrequency", type: "int", default: 3 },
        { name: "dosage", type: "float", default: 0 },
        { name: "unit", type: "int", default: 0 },
        { name: "uploadFlg", type: "int", default: 0 },
        { name: "timestamp", type: "string", default: "" },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "customMedicine",
            key: "customMedicineId",
            immediate: true,
            loaded: function () {
                Light.db.log("customMedicine has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    update: function (id, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, id, values, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
    selectColumns: function (columns, condition, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, null, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.customMedicine.init();