﻿
Light.db.customMedicinePlan = {
    name: "customMedicinePlan",
    store: null,
    scheme: [
        { name: "medicinePlanId", type: "string", default: "" },
        { name: "medicineId", type: "string", default: "" },
        { name: "medicineName", type: "string", default: "" },
        { name: "planType", type: "int", default: 1 },//1:everday, 2:intervalday, 3:week, 4:once
        { name: "planMetadata", type: "obj", default: [] },
        { name: "dateList", type: "string", default: "" },//20141001,20141002
        { name: "timeList", type: "string", default: "" },//900,1800
        { name: "instruction", type: "string", default: "" },
        { name: "memo", type: "string", default: "" },
        { name: "createDate", type: "string", default: "" },
        { name: "startDate", type: "string", default: "" },
        { name: "endDate", type: "string", default: "" },
        { name: "status", type: "int", default: 0},//0:normal 1:delete 2:end
        { name: "uploadFlg", type: "int", default: 0 },
        { name: "timestamp", type: "string", default: "" },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "customMedicinePlan",
            key: "medicinePlanId",
            immediate: true,
            loaded: function () {
                Light.db.log("A data item has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    update: function (id, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, id, values, donefunc, failfunc);
    },
    getOne: function (key, donefunc, failfunc) {
        Light.db.getOne(this.store, key, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
    selectColumns: function (columns, condition, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, null, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.customMedicinePlan.init();