﻿/*
mediceineList
[
    {medicinePlanId:"xxxxxx",
        medicineId: "xxxxx"},
    {medicinePlanId:"xxxxxx",
        medicineId: "xxxxx"}
]
*/
Light.db.customMedicinePlanRecord = {
    name: "customMedicinePlanRecord",
    store: null,
    scheme: [
        { name: "customMedicinePlanRecordId", type: "string", default: "" },
        { name: "customMedicinePlanRecordDate", type: "string", default: "" },
        { name: "timeStart", type: "int", default: 0 },
        { name: "timeEnd", type: "int", default: 0 },
        { name: "takenTime", type: "int", default: 0 },
        { name: "takenStatus", type: "int", default: 0 },
        { name: "takenMemo", type: "string", default: "" },
        { name: "mediceineList", type: "obj", default: [] },
        { name: "uploadFlg", type: "int", default: 0 },
        { name: "timestamp", type: "string", default: "" },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "customMedicinePlanRecord",
            key: "customMedicinePlanRecordId",
            immediate: true,
            loaded: function () {
                Light.db.log("customMedicinePlanRecord has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },

    set: function (date, timestart, timeend, takentime, takenstatus, memo, medicinelist, donefunc, failfunc) {
        var storerf = this.store;
        var schemeref = this.scheme;
        var getone = function (items) {
            if (items && items.length > 0) {
                var item = items[0];
                Light.db.updateWithCheck(storerf, schemeref,
                    item.customMedicinePlanRecordId,
                    {
                        takenTime: takentime,
                        takenStatus: takenstatus,
                        takenMemo: memo,
                        mediceineList: medicinelist,
                        uploadFlg: 0,
                    }, donefunc, failfunc);
            } else {
                var values = {
                    customMedicinePlanRecordId: Light.tool.newGUID(),
                    customMedicinePlanRecordDate: date,
                    timeStart: timestart,
                    timeEnd: timeend,
                    takenTime: takentime,
                    takenStatus: takenstatus,
                    takenMemo: memo,
                    mediceineList: medicinelist,
                    uploadFlg: 0,
                    timestamp: ""
                };
                Light.db.insertWithCheck(storerf, schemeref, values, donefunc, failfunc);
            }
        };

        Light.db.getAll(this.store, null,
            [
                ["customMedicinePlanRecordDate", date]
                ,"and"
                ,["timeStart", timestart ]
            ],
            null,
            getone, failfunc);
    },

    getOneDate: function (date, donefunc, failfunc) {

        var getdone = function (items) {
            if (items) {
                if (donefunc) donefunc(items);
            } else {
                if (donefunc) donefunc([]);
            }
        }
        Light.db.getAll(this.store, null, [ "customMedicinePlanRecordDate", date ], ["timeStart"], getdone, failfunc);
    },

    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
    update: function (id, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, id, values, donefunc, failfunc);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
};

Light.db.customMedicinePlanRecord.init();