﻿//store base class
(function () {

    var showScheme = function (store) {


    };

    Light.db = {
        version: "0.0.1",
        log: function (text) {
            if (Light.config.IS_DEBUG_MODE) {
                //console.log(text);
            }
        },
        errorlog: function (text) {
            if (Light.config.is_debug_mode) {
                //console.log(text);
            }
        },

        reset: function (store) {
            if (store) {
                this.log(store.name + " clear");
                store.clear();
            }
        },
        /*
        insert: function (store, values, donefunc, failfunc) {
            var thisref = this;

            if (store) {
                store.insert(values).done(function (values, key) {
                    thisref.log(store.name + " insert done[" + key + "]");
                    if (donefunc) donefunc(values);
                }).fail(function (error) {
                    thisref.errorlog(store.name + " insert fail" + error);
                    if (failfunc) failfunc(error);
                });
            }
        },
        */
        insertWithCheck: function (store, scheme, values, donefunc, failfunc) {
            var thisref = this;

            var insertValues = {};
            for (var i = 0; i < scheme.length ; i++) {
                var column = scheme[i];
                insertValues[column.name] = column.default;//set default

                if (values[column.name] != undefined) {
                    var value = values[column.name];

                    if (column.type == "string") {
                        insertValues[column.name] = "" + value + "";
                    } else if (column.type == "int") {
                        if (Light.tool.isInt(value)) {
                            insertValues[column.name] = value;
                        }
                    } else if (column.type == "float") {
                        if (Light.tool.isNumber(value)) {
                            if (column.round != undefined) {
                                insertValues[column.name] = Light.tool.RoundFloat(value, 2);
                            } else {
                                insertValues[column.name] = value;
                            }
                        }
                    } else {//obj
                        insertValues[column.name] = value;
                    }
                } else {
                    //do nothing
                }
            }

            if (store) {
                store.insert(insertValues).done(function (values, key) {
                    thisref.log(store.name + " insert done[" + key + "]");
                    if (donefunc) donefunc(values);
                }).fail(function (error) {
                    thisref.errorlog(store.name + " insert fail" + error);
                    if (failfunc) failfunc(error);
                });
            }
        },
        remove: function (store, key, donefunc, failfunc) {
            var thisref = this;
            if (store) {
                store.remove(key).done(function () {
                    thisref.log(store.name + " remove done[" + key + "]");
                    if (donefunc) donefunc(key);
                }).fail(function (error) {
                    thisref.errorlog(store.name + " remove fail" + error);
                    if (failfunc) failfunc(error);
                });
            }
        },
        getOne: function (store, key, donefunc, failfunc) {
            var thisref = this;

            if (store != null) {
                store.byKey(key).done(function (dataItem) {
                    thisref.log(store.name + " getone done[" + key + "]");
                    if (donefunc) donefunc(dataItem);
                }).fail(function (error) {
                    thisref.errorlog(store.name + " getone fail" + error);
                    if (failfunc) failfunc(error)
                });
            }
        },
        /*
        update: function (store, key, values, donefunc, failfunc) {
            var thisref = this;
            if (store) {
                store.update(key, values).done(function (result) {
                    thisref.log(store.name + " update done[" + key + "]");
                    if (donefunc) donefunc(result);
                }).fail(function (error) {
                    thisref.errorlog(store.name + " update fail" + error);
                    if (failfunc) failfunc(error)
                });
            }
        },
        */
        updateWithCheck: function (store, scheme, key, values, donefunc, failfunc) {
            var thisref = this;

            var updateValues = {};
            for (var i = 0; i < scheme.length ; i++) {
                var column = scheme[i];

                if (values[column.name] != undefined) {
                    var value = values[column.name];

                    if (column.type == "string") {
                        updateValues[column.name] = "" + value + "";
                    } else if (column.type == "int") {
                        if (Light.tool.isInt(value)) {
                            updateValues[column.name] = value;
                        }
                    } else if (column.type == "float") {
                        if (Light.tool.isNumber(value)) {
                            if (column.round != undefined) {
                                updateValues[column.name] = Light.tool.RoundFloat(value, column.round);
                            } else {
                                updateValues[column.name] = value;
                            }
                            
                        }
                    } else {//obj
                        updateValues[column.name] = value;
                    }
                } else {
                    //do nothing
                }
            }
            if (store) {
                store.update(key, updateValues).done(function (result) {
                    thisref.log(store.name + " update done[" + key + "]");
                    if (donefunc) donefunc(result);
                }).fail(function (error) {
                    thisref.errorlog(store.name + " update fail" + error);
                    if (failfunc) failfunc(error)
                });
            }
        },
        getAll: function (store, columns, condition, sort, donefunc, failfunc) {
            var thisref = this;
            if (store) {
                var dt = new DevExpress.data.DataSource({
                    store: store,
                    paginate: false
                });

                if (condition) { dt.filter(condition); }
                if (columns) { dt.select(columns);}
                if (sort) { dt.sort(sort); }

                dt.load().done(function (result) {
                    thisref.log(store.name + " getall done[" + result.length + "]");
                    if (donefunc) donefunc(result);
                }).fail(function (error) {
                    thisref.errorlog(store.name + " getall fail" + error);
                    if (failfunc) failfunc(error);
                });
            }
        },

        debugShowRecord: function (store, condition, columns) {
            var showall = function (result) {
                var str = "[" + store.name + ":" + result.length + "]";

                for (var i = 0; i < result.length ; i++) {
                    var record = result[i];
                    var line = "\n ************";
                    for (var j = 0; j < store.scheme.length; j++) {
                        var name = store.scheme[j].name;
                        if (columns) {
                            if ($.inArray(name, columns) != -1) {
                                line = line + "\n" + name + ":" + record[name];
                            }
                        } else {
                            line = line + "\n" + name + ":" + record[name];
                        }
                    }
                    str = str + line;
                }
                alert(str);
            };

            this.getAll(store.store, null, condition, null, showall, null);
        },

        debugShowScheme: function (store, condition, columns) {
            var str = "[" + store.name + " :scheme]";
            for (var j = 0; j < store.scheme.length; j++) {
                var column = store.scheme[j];
                str = str + " \n" + column.name + " (" + column.type + ") " + column.default;
            }

            alert(str);
        },
    }

})();