﻿
Light.db.favorite = {
    name: "favorite",
    store: null,
    scheme: [
        { name: "favoriteId", type: "string", default: "" },
        { name: "favoriteTitle", type: "string", default: "" },
        { name: "favoriteUrl", type: "string", default: "" },
        { name: "favoriteDate", type: "string", default: "" },
        { name: "uploadFlg", type: "int", default: 0 },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "favorite",
            key: "favoriteId",
            immediate: true,
            loaded: function () {
                Light.db.log("favorite has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },

    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    update: function (id, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, id, values, donefunc, failfunc);
    },

    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },

    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.favorite.init();
