﻿
Light.db.food = {
    name: "food",
    store: null,
    scheme: [
        { name: "foodId", type: "int", default: 0 },
        { name: "foodName", type: "string", default: "" },
        { name: "foodType", type: "int", default: 0 },
        { name: "foodTypeName", type: "string", default: "" },
        { name: "quantity", type: "float", default: 0 },
        { name: "quantityUnit", type: "int", default: 0 },
        { name: "quantityUnitName", type: "string", default: "" },
        { name: "dosage", type: "float", default: 0 },
        { name: "dosageUnit", type: "int", default: 0 },
        { name: "dosageUnitName", type: "string", default: "" },
        { name: "calorie", type: "int", default: 0 }
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "food",
            key: "foodId",
            immediate: true,
            loaded: function () {
                Light.db.log("food data has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.food.init();