﻿
Light.db.group = {
    name: "group",
    store: null,
    scheme: [
        { name: "groupId", type: "int", default: 0 },
        { name: "groupName", type: "string", default: ""},
        { name: "groupDesc", type: "string", default: "" },
        { name: "groupOwnerId", type: "int", default: 0 },
        { name: "groupCreateTime", type: "string", default: "" },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "group",
            key: "groupId",
            immediate: true,
            loaded: function () {
                Light.db.log("group has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.group.init();