﻿
Light.db.groupActivity = {
    name: "groupActivity",
    store: null,
    scheme: [
        { name: "activityId", type: "int", default: 0 },
        { name: "groupId", type: "int", default: 0 },
        { name: "activityCreateId", type: "int", default: 0 },
        { name: "activityImg", type: "string", default: "" },
        { name: "activityName", type: "string", default: "" },
        { name: "activityAddress", type: "string", default: "" },
        { name: "activityTime", type: "string", default: "" },
        { name: "activityCreaterTime", type: "string", default: "" },
        { name: "activitySignupStartTime", type: "string", default: "" },
        { name: "activitySignupEndTime", type: "string", default: "" },
        { name: "activityType", type: "string", default: "" },
        { name: "activityPeopleNum", type: "int", default: 0 },
        { name: "activityStatus", type: "int", default: 0 },
        { name: "activityContent", type: "string", default: "" },
        { name: "activityResult", type: "string", default: "" },
        { name: "timestamp", type: "string", default: 0 },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "groupActivity",
            key: "activityId",
            immediate: true,
            loaded: function () {
                Light.db.log("groupActivity has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.groupActivity.init();