﻿
Light.db.groupAlbum = {
    name: "groupAlbum",
    store: null,
    scheme: [
        { name: "imageId", type: "int", default: 0 },
        { name: "groupActivityId", type: "int", default: 0 },
        { name: "imageType", type: "int", default: 0 },
        { name: "imageUrl", type: "string", default: 0 },
        { name: "uploadTime", type: "string", default: "" },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "groupAlbum",
            key: "imageId",
            immediate: true,
            loaded: function () {
                Light.db.log("groupAlbum has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.groupAlbum.init();