﻿/*
planDateList:
[
{date:"20141011",solutionIndex:1},
{date:"20141012",solutionIndex:2},
{date:"20141013",solutionIndex:3},
]
*/
Light.db.healthPlan = {
    name: "healthPlan",
    store: null,
    scheme: [
        { name: "healthPlanId", type: "string", default: "" },
        { name: "healthSolutionId", type: "int", default: 0 },
        { name: "planCreateDate", type: "string", default: "" },
        { name: "planStartDate", type: "string", default: "" },
        { name: "planEndDate", type: "string", default: "" },
        { name: "planDateList", type: "obj", default: [] },
        { name: "planSuspendCount", type: "int", default: 0 },
        { name: "status", type: "int", default: 0 }, //0:normal 1:delete 2:end 3:suspend
        { name: "uploadFlg", type: "int", default: 0 },
        { name: "timestamp", type: "string", default: "" },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "healthPlan",
            key: "healthPlanId",
            immediate: true,
            loaded: function () {
                Light.db.log("healthPlan has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    update: function (id, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, id, values, donefunc, failfunc);
    },
    getOne: function (key, donefunc, failfunc) {
        Light.db.getOne(this.store, key, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
    selectColumns: function (columns, condition, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, null, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.healthPlan.init();