﻿/*
recordDtls:
[
{
    extraKbn:0,
    dtlKbn:1,
    dtlId:123,
    dtlNumber:1,
    calorie:120,
 },
]
*/
Light.db.healthPlanRecord = {
    name: "healthPlanRecord",
    store: null,
    scheme: [
        { name: "healthPlanRecordId", type: "string", default: "" },
        { name: "healthPlanRecordDate", type: "string", default: "" },
        { name: "healthPlanId", type: "string", default: "" },//"":no-plan-record
        { name: "itemId", type: "int", default: 0 },
        { name: "recordDtls", type: "obj", default: [] },
        { name: "uploadFlg", type: "int", default: 0 },
        { name: "timestamp", type: "string", default: "" },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "healthPlanRecord",
            key: "healthPlanRecordId",
            immediate: true,
            loaded: function () {
                Light.db.log("healthPlanRecord has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },

    set: function (date, planid, itemid, recordlist, donefunc, failfunc) {
        var storeref = this.store;
        var schemeref = this.scheme;
        var getone = function (items) {
            
            if (items && items.length > 0) {
                var item = items[0];
                Light.db.updateWithCheck(storeref, schemeref,
                    item.healthPlanRecordId,
                    {
                        recordDtls: recordlist,
                        uploadFlg: 0,
                    }, donefunc, failfunc);
            } else {
                Light.db.insertWithCheck(storeref, schemeref, {
                    healthPlanRecordId: Light.tool.newGUID(),
                    healthPlanRecordDate: date,
                    healthPlanId: planid,
                    itemId: itemid,
                    recordDtls: recordlist,
                    uploadFlg: 0,
                }, donefunc, failfunc);
            }
        }
        Light.db.getAll(this.store,
            null,
            [
                ["healthPlanRecordDate", date],
                "and",
                ["healthPlanId", planid],
                "and",
                ["itemId", itemid]
            ],
            null, getone, failfunc);
    },

    getOneDate: function (date, donefunc, failfunc) {
        var getdone = function (items) {
            if (items && items.length > 0) {
                donefunc(items);
            } else {
                donefunc([]);
            }
        }

        Light.db.getAll(this.store, null,
            ["healthPlanRecordDate", date],
            ["healthPlanId", "itemID"], getdone, failfunc);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    update: function (id, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, id, values, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
};

Light.db.healthPlanRecord.init();