﻿
Light.db.healthSolution = {
    name: "healthSolution",
    store: null,
    scheme: [
        { name: "healthSolutionId", type: "int", default: 0 },
        { name: "healthSolutionName", type: "string", default: "" },
        { name: "sex", type: "string", default: "" },
        { name: "solutionStatus", type: "int", default: 0},
        { name: "endDate", type: "string", default: "" },
        { name: "movementDays", type: "int", default: 0 },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "healthSolution",
            key: "healthSolutionId",
            immediate: true,
            loaded: function () {
                Light.db.log("healthSolution has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    getOne: function (key, donefunc, failfunc) {
        Light.db.getOne(this.store, key, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    }
};

Light.db.healthSolution.init();