﻿
Light.db.honor = {
    name: "honor",
    store: null,
    scheme: [
        { name: "honorName", type: "string", default: "" },
        { name: "honorDesc", type: "string", default: "" },
        { name: "honorTotal", type: "int", default: 0 },
        { name: "honorLimit", type: "int", default: 1 },
        { name: "honorCurrent", type: "int", default: 0 },
        { name: "uploadFlg", type: "int", default: 0 },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "honor",
            key: "honorName",
            immediate: true,
            loaded: function () {
                Light.db.log("honor has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
        /*
        var honors = [
            { "honorName": "yinxing", "honorDesc": "", "honorTotal": 0, "honorLimit": 1, "honorCurrent":0, "uploadFlg": 0 },
            { "honorName": "jinxing", "honorDesc": "", "honorTotal": 0, "honorLimit": 7, "honorCurrent": 0, "uploadFlg": 0 },
            { "honorName": "taiyang", "honorDesc": "", "honorTotal": 0, "honorLimit": 14, "honorCurrent": 0, "uploadFlg": 0 },
            { "honorName": "yueliang", "honorDesc": "", "honorTotal": 0, "honorLimit": 28, "honorCurrent": 0, "uploadFlg": 0 },
        ];
        for (var i = 0; i < honors.length; i++) {
            Light.db.insertWithCheck(this.store, this.scheme, honors[i], null, null);
        }*/
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    update: function (name, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, name, values, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
};

Light.db.honor.init();