﻿
Light.db.invite = {
    name: "invite",
    store: null,
    scheme: [
        { name: "inviteId", type: "int", default: 0 },
        { name: "inviteUserId", type: "string", default: "" },
        { name: "inviteUserName", type: "string", default: "" },
        { name: "inviteUserImage", type: "string", default: "" },
        { name: "inviteMessage", type: "object", default: [] },
        { name: "inviteStatus", type: "int", default: 0 },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "invite",
            key: "inviteId",
            immediate: true,
            loaded: function () {
                Light.db.log("invite has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    update: function (name, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, name, values, donefunc, failfunc);
    },
    getOne: function (key, donefunc, failfunc) {
        Light.db.getOne(this.store, key, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
};

Light.db.invite.init();