﻿
Light.db.memberPrivacy = {
    name: "memberPrivacy",
    store: null,
    scheme: [
        { name: "memberId", type: "int", default: 0 },
        { name: "agePrivacy", type: "int", default: 0},
        { name: "weightPrivacy", type: "int", default: 0 },
        { name: "heightPrivacy", type: "int", default: 0 },
        { name: "userJobPrivacy", type: "int", default: 0 },
        { name: "diseasePrivacy", type: "int", default: 0 },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "memberPrivacy",
            key: "memberId",
            immediate: true,
            loaded: function () {
                Light.db.log("memberPrivacy has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.memberPrivacy.init();