﻿
Light.db.movement = {
    name: "movement",
    store: null,
    scheme: [
        { name: "movementId", type: "int", default: 0 },
        { name: "movementName", type: "string", default: ""},
        { name: "movementTime", type: "int", default: 0 },
        { name: "unit", type: "int", default: 0 },
        { name: "step", type: "string", default: "" },
        { name: "calorie", type: "string", default: "" },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "movement",
            key: "movementId",
            immediate: true,
            loaded: function () {
                Light.db.log("movement has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.movement.init();