﻿Light.db.notification = {
    name: "notification",
    store: null,
    scheme: [
        { name: "notificationId", type: "string", default: "" },
        { name: "content", type: "string", default: "" },
        { name: "type", type: "string", default: "" },//medicine,health
        { name: "date", type: "string", default: "" },
        { name: "time", type: "int", default: 0 },
        { name: "status", type: "int", default: 0 },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "notification",
            key: "notificationId",
            immediate: true,
            loaded: function () {
                Light.db.log("notification has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    update: function (id, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, id, values, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.notification.init();