﻿Light.db.pedometerSum = {
    name: "pedometerSum",
    store: null,
    scheme: [
        { name: "pedometerSumId", type: "string", default: "" },
        { name: "surveyDate", type: "string", default: "" },
        { name: "step", type: "int", default: 0 },
        { name: "calorie", type: "float", default: 0 },
        { name: "course", type: "float", default: 0 },
        { name: "minute", type: "int", default: 0 },
        { name: "uploadFlg", type: "int", default: 0 },
        { name: "timestamp", type: "string", default: "" },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "pedometerSum",
            key: "pedometerSumId",
            immediate: true,
            loaded: function () {
                Light.db.log("pedometerSum has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    update: function (id, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, id, values, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
    selectColumns: function (columns, condition, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, null, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.pedometerSum.init();