﻿var DEFAULT_SETTING_KEY = "default";

Light.db.setting = {
    name: "setting",
    store: null,
    scheme: [
        { name: "key", type: "string", default: DEFAULT_SETTING_KEY },
        { name: "UDID", type: "string", default: "" },
        { name: "appTip", type: "int", default: 0 },
        { name: "memberId", type: "int", default: 0 },
        { name: "memberLoginFlg", type: "int", default: 0 },
        { name: "memberAcc", type: "string", default: "" },
        { name: "memberPassword", type: "string", default: "" },
        { name: "memberTelephone", type: "string", default: "" },
        { name: "memberEmail", type: "string", default: "" },
        { name: "thirdPartyType", type: "int", default: 0 },
        
        { name: "realName", type: "string", default: "" },
        { name: "privacySex", type: "int", default: 0 },
        { name: "privacyBirthday", type: "int", default: 0 },
        { name: "privacyHeight", type: "int", default: 0 },
        { name: "privacyWeight", type: "int", default: 0 },
        { name: "privacyGroup", type: "int", default: 0 },
        { name: "privacyCity", type: "int", default: 0 },
        { name: "privacySick", type: "int", default: 0 },

        { name: "userIconIndex", type: "int", default: 0 },
        { name: "userName", type: "string", default: "" },
        { name: "userSex", type: "int", default: 0 },//0:man 1:women
        { name: "userBirthday", type: "string", default: "19800101" },
        { name: "userHeight", type: "int", default: 170 },
        { name: "userWeight", type: "float", default: 80.5 },
        { name: "userJob", type: "int", default: 0 },
        { name: "userAddress", type: "string", default: "" },
        { name: "userHeadImg", type: "string", default: "" },

        { name: "healthLastEquipment", type: "int", default: 0 },//native only
        { name: "healthLastWeightData", type: "string", default: "" },
        { name: "healthLastPedometerData", type: "string", default: "0,0,0,0,,0" },

        { name: "disease", type: "string", default: "0,0,0,0,0,0,0,0,0,0" },

        { name: "medicineNotificationSwitch", type: "int", default: 1 },
        { name: "healthNotificationSwitch", type: "int", default: 1 },
        { name: "planNotificationSoundIndex", type: "int", default: 0 },
        { name: "planNotificationVibrationFlg", type: "int", default: 0 },

        { name: "healthSyncSwitch", type: "int", default: 1 },
        { name: "yunyueWeightSwitch", type: "int", default: 0 },//native only
        { name: "lexinWeightSwitch", type: "int", default: 0 },//native only
        { name: "lexinPedometerSwitch", type: "int", default: 0 },//native only
        { name: "lexinWeightEquipmentId", type: "string", default: "" },//native only
        { name: "lexinPedometerEquipmentId", type: "string", default: "" },//native only

        { name: "leanCloudSocialId", type: "string", default: "" },
        { name: "leanCloudUDOId", type: "string", default: "" },

        { name: "lastActivyDate", type: "string", default: "" },
    ],
    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "setting",
            key: "key",
            immediate: true,
            loaded: function () {
                Light.db.log("setting has been loaded");
            },
        });
    },

    reset: function (done, fail) {
        Light.db.reset(this.store);
        var setting = {
            key: DEFAULT_SETTING_KEY,
            UDID: "",
            appTip: 0,
            memberId: 0,
            memberLoginFlg: 0,
            memberAcc: "",
            memberPassword: "",
            memberTelephone: "",
            memberEmail: "",
            thirdPartyType: 0,

            realName: "",
            privacySex: 0,
            privacyBirthday: 0,
            privacyHeight: 0,
            privacyWeight: 0,
            privacyGroup: 0,
            privacyCity: 0,
            privacySick: 0,

            userIconIndex: 0,
            userName: "",
            userSex: 0,
            userBirthday: "19800101",
            userHeight: 170,
            userWeight: 80.5,
            userJob: 0,
            userAddress: "",
            userHeadImg: "",

            healthLastEquipment: 0,//native only
            healthLastWeightData: "0,0,0,0,0,0,0,0,0,0",
            healthLastPedometerData: "0,0,0,0,,0",

            disease: "0,0,0,0,0,0,0,0,0,0",

            medicineNotificationSwitch: 1,
            healthNotificationSwitch: 1,
            planNotificationSoundIndex: 0,
            planNotificationVibrationFlg: 0,
            
            healthSyncSwitch: 1,
            yunyueWeightSwitch: 0,//native only
            lexinWeightSwitch: 0,//native only
            lexinPedometerSwitch: 0,//native only
            lexinWeightEquipmentId: "",//native only
            lexinPedometerEquipmentId: "",//native only

            leanCloudSocialId: "",
            leanCloudUDOId: "",

            lastActivyDate:"",

            //list1: [{kk1:"kkv"}, {kk2:"kkv2"}]
        };
        Light.db.insertWithCheck(this.store,this.scheme, setting, done, fail);
    },

    get: function (key, donefunc, failfunc) {
        var getone = function(item){
            if (item) {
                if (donefunc) { donefunc(item[key]); }
            } else {
                if (failfunc) failfunc();
            }
        }
        Light.db.getOne(this.store, DEFAULT_SETTING_KEY, getone, failfunc);
    },

    set: function (key, value, donefunc, failfunc) {
        var newvalue = {};
        newvalue[key] = value;
        Light.db.updateWithCheck(this.store,this.scheme, DEFAULT_SETTING_KEY, newvalue, donefunc, failfunc);
    },

    getValues: function (donefunc, failfunc) {
        var getone = function (item) {
            if (item) {
                if (donefunc) { donefunc(item); }
            } else {
                if (failfunc) failfunc();
            }
        }
        Light.db.getOne(this.store, DEFAULT_SETTING_KEY, getone, failfunc);
    },

    setValues: function (values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store,this.scheme, DEFAULT_SETTING_KEY, values, donefunc, failfunc);
    },

    getAll: function (donefunc, failfunc) {
        var getone = function (item) {
            if (item) {
                if (donefunc) { donefunc(item); }
            } else {
                if (failfunc) failfunc();
            }
        }
        Light.db.getOne(this.store, DEFAULT_SETTING_KEY, getone, failfunc);
    },
};

Light.db.setting.init();