﻿
Light.db.surveys = {
    name: "surveys",
    store: null,
    scheme: [
        { name: "surveysId", type: "string", default: "" },
        { name: "type", type: "string", default: "" },
        { name: "date", type: "string", default: "" },
        { name: "time", type: "int", default: 0 },
        { name: "result", type: "obj", default: {} },
        { name: "memo", type: "string", default: "" },
        { name: "uploadFlg", type: "int", default: 0 },
        { name: "timestamp", type: "string", default: "" },
    ],

    init: function () {
        this.store = new DevExpress.data.LocalStore({
            name: "surveys",
            key: "surveysId",
            immediate: true,
            loaded: function () {
                Light.db.log("surveys has been loaded");
            },
        });
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    update: function (id, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, id, values, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.surveys.init();