﻿Light.db.weightAvg = {
    name: "weightAvg",
    store: null,
    scheme: [
    { name: "weightAvgId", type: "string", default: "" },
    { name: "surveyDate", type: "string", default: "" },
    { name: "weight", type: "float", default: 0 },
    { name: "bmi", type: "float", default: 0 },
    { name: "bfr", type: "float", default: 0 },
    { name: "waterContent", type: "float", default: 0 },
    { name: "mus", type: "float", default: 0 },
    { name: "boneQuality", type: "float", default: 0 },
    { name: "metabolism", type: "float", default: 0 },
    { name: "sfat", type: "float", default: 0 },
    { name: "infat", type: "float", default: 0 },
    { name: "bodyage", type: "int", default: 0 },
    { name: "uploadFlg", type: "int", default: 0 },
    { name: "timestamp", type: "string", default: "" },
    ],

    init: function () {
        if (this.store == null) {
            this.store = new DevExpress.data.LocalStore({
                name: "weightAvg",
                key: "weightAvgId",
                immediate: true,
                loaded: function () {
                    Light.db.log("weightAvg has been loaded");
                },
            });
        }
    },

    reset: function () {
        Light.db.reset(this.store);
    },
    insert: function (values, donefunc, failfunc) {
        Light.db.insertWithCheck(this.store, this.scheme, values, donefunc, failfunc);
    },
    remove: function (id, donefunc, failfunc) {
        Light.db.remove(this.store, id, donefunc, failfunc);
    },
    update: function (id, values, donefunc, failfunc) {
        Light.db.updateWithCheck(this.store, this.scheme, id, values, donefunc, failfunc);
    },
    select: function (condition, donefunc, failfunc) {
        Light.db.getAll(this.store, null, condition, null, donefunc, failfunc);
    },
    selectColumns: function (columns, condition, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, null, donefunc, failfunc);
    },
    selectColumnsSort: function (columns, condition, sort, donefunc, failfunc) {
        Light.db.getAll(this.store, columns, condition, sort, donefunc, failfunc);
    },
};

Light.db.weightAvg.init();