﻿window.Light = window.Light || {};

$(function() {
    // Uncomment the line below to disable platform-specific look and feel and to use the Generic theme for all devices
    // DevExpress.devices.current({ platform: "generic" });

    document.addEventListener("deviceready", onDeviceReady, false);

    function onDeviceReady() {
        document.addEventListener("backbutton", onBackButton, false);
    }

    function onBackButton() {
        DevExpress.hardwareBackButton.fire();
    }

    function onNavigatingBack(e) {
        if (e.isHardwareButton && !Light.app.canBack()) {
            /*
            e.cancel = true;
            exitApp();
            */
            var url = Light.app.navigationManager._currentItem.uri;
            if (DevExpress.devices.real().platform == "android"
                && url == "Shop") {
                //var url = Light.app.navigationManager._currentItem.uri;
                document.getElementById('showframe').contentWindow.history.back();
            } else {
                e.cancel = true;
                exitApp();
            }
        }
    }

    function exitApp() {
        switch (DevExpress.devices.real().platform) {
            case "tizen":
                window["tizen"].application.getCurrentApplication().exit();
                break;
            case "android":
                navigator["app"].exitApp();
                break;
            case "win8":
                window.external.Notify("DevExpress.ExitApp");
                break;
        }
    }

    function findController(name, controllers) {
        var result = $.grep(controllers, function (item, index) {
            return item.controller.name == name;
        });
        return result.length ? result[0].controller : null;
    }

    //define layout set
    var layoutSet = [];
    layoutSet.push.apply(layoutSet, DevExpress.framework.html.layoutSets["slideout"]);
    layoutSet.push.apply(layoutSet, DevExpress.framework.html.layoutSets["empty"]);
    layoutSet.push.apply(layoutSet, DevExpress.framework.html.layoutSets["simple"]);
    layoutSet.push.apply(layoutSet, DevExpress.framework.html.layoutSets["navbar"]);

    Light.app = new DevExpress.framework.html.HtmlApplication({
        namespace: Light,
        layoutSet: layoutSet, 
        navigation: Light.config.navigation,
        commandMapping: Light.config.commandMapping,
    });

    //define view layout controller
    Light.app.resolveLayoutController.add(function (args) {
        args.layoutController = findController('simple', args.availableLayoutControllers);

        if (args.viewInfo.viewName === 'initApp'
            || args.viewInfo.viewName === 'Welcome'
            || args.viewInfo.viewName === 'Schedule'
            || args.viewInfo.viewName === 'ScheduleMonth'
            || args.viewInfo.viewName === 'FoodRecord'
            || args.viewInfo.viewName === 'SportsRecord'
            || args.viewInfo.viewName === 'MedicineRecord'
            || args.viewInfo.viewName === 'MedicinePlan'
            || args.viewInfo.viewName === 'MedicinePlanCreate'
            || args.viewInfo.viewName === 'MedicineSearch'
            || args.viewInfo.viewName === 'MedicineCreate'
            || args.viewInfo.viewName === 'Health'
            || args.viewInfo.viewName === 'acceResult'
            || args.viewInfo.viewName === 'acce'
            || args.viewInfo.viewName === 'lifeStyleResult'
            || args.viewInfo.viewName === 'lifeStyle'
            || args.viewInfo.viewName === 'obesityCausesResult'
            || args.viewInfo.viewName === 'obesityCauses'
            || args.viewInfo.viewName === 'traditionalChineseMedicineResult'
            || args.viewInfo.viewName === 'traditionalChineseMedicine'
            || args.viewInfo.viewName === 'traditionalChineseMedicine_2'
            || args.viewInfo.viewName === 'traditionalChineseMedicine_3'
            || args.viewInfo.viewName === 'traditionalChineseMedicine_4'
            || args.viewInfo.viewName === 'traditionalChineseMedicine_5'
            || args.viewInfo.viewName === 'traditionalChineseMedicine_6'
            || args.viewInfo.viewName === 'traditionalChineseMedicine_7'
            || args.viewInfo.viewName === 'traditionalChineseMedicine_8'
            || args.viewInfo.viewName === 'traditionalChineseMedicine_9'
            || args.viewInfo.viewName === 'SelSolution'
            || args.viewInfo.viewName === 'Profile'
            || args.viewInfo.viewName === 'MyWealth'
            || args.viewInfo.viewName === 'TodayHC'
            || args.viewInfo.viewName === 'PartnerSearch'
            || args.viewInfo.viewName === 'ActivityCreate'
            || args.viewInfo.viewName === 'ActivityMemberList'
            || args.viewInfo.viewName === 'GroupSetting'
            || args.viewInfo.viewName === 'Activity'
            || args.viewInfo.viewName === 'FriendList'
            || args.viewInfo.viewName === 'GroupCreate'
            || args.viewInfo.viewName === 'GroupShareSetting'
            || args.viewInfo.viewName === 'GroupShare'
            || args.viewInfo.viewName === 'Login') {
            args.layoutController = findController('empty', args.availableLayoutControllers);

        }else if (args.viewInfo.viewName === 'Home'
            || args.viewInfo.viewName === 'HealthIndex'
            || args.viewInfo.viewName === 'Partner'
            || args.viewInfo.viewName === 'test') {
            args.layoutController = findController('navbar', args.availableLayoutControllers);
        }
    });

    //define navigating
    Light.app.navigatingBack.add(onNavigatingBack);
    var navigation = Light.app.navigation;

    Light.app.router.register(":view", { view: "initApp" });
    Light.app.navigate();
});
