cordova.define("com.seiosoft.phonegap.LeanChat.LeanChat", function(require, exports, module) { var LeanChat = function(){
};

LeanChat.prototype.isPlatformIOS = function(){
	return device.platform == "iPhone" || device.platform == "iPad" || device.platform == "iPod touch" || device.platform == "iOS"
}

LeanChat.prototype.error_callback = function(msg){
	console.log("Javascript Callback Error: " + msg)
}

LeanChat.prototype.call_native = function(name, args, callback){

	ret = cordova.exec(callback,this.error_callback,'LeanChat',name,args);
	return ret;
}

LeanChat.prototype.registStatusCallback = function(callback){
	try{
	    var data=[];
		this.call_native("registStatusCallback",data,callback);
	}
	catch(exception){
		console.log(exception);
	}
}

LeanChat.prototype.groupList = function(userId, callback){
    try{
        var data=[userId];
        this.call_native("groupList",data,callback);
    }
    catch(exception){
        console.log(exception);
    }
}

LeanChat.prototype.addGroupMembers = function(userId, convId, members, pic, callback){
    try{
        var data=[userId, convId, members, pic];
        this.call_native("addGroupMembers",data,callback);
    }
    catch(exception){
        console.log(exception);
    }
}
               
LeanChat.prototype.fetchGroupByMembers = function(userId, members, desc, pic, callback){
    try{
        var data=[userId, members, desc, pic];
        this.call_native("fetchGroupByMembers",data,callback);
    }
    catch(exception){
        console.log(exception);
    }
}
      
LeanChat.prototype.removeGroupMembers = function(userId, convId, members, pic, callback){
    try{
        var data=[userId, convId, members, pic];
        this.call_native("removeGroupMembers",data,callback);
    }
    catch(exception){
        console.log(exception);
    }
}

LeanChat.prototype.quitGroup = function(userId, convId, pic, callback){
    try{
        var data=[userId, convId, pic];
        this.call_native("quitGroup",data,callback);
    }
    catch(exception){
        console.log(exception);
    }
}
               
LeanChat.prototype.editGroupName = function(userId, convId, groupName , callback){
    try{
        var data=[userId, convId, groupName];
        this.call_native("editGroupName",data,callback);
    }
    catch(exception){
        console.log(exception);
    }
}
               
LeanChat.prototype.editGroupDesc = function(userId, convId, groupDesc , callback){
    try{
        var data=[userId, convId, groupDesc];
        this.call_native("editGroupDesc",data,callback);
    }
    catch(exception){
        console.log(exception);
    }
}
               
LeanChat.prototype.createGroup = function(userId, members, desc, pic, callback){
    try{
        var data=[userId, members, desc, pic];
        this.call_native("createGroup",data,callback);
    }
    catch(exception){
        console.log(exception);
    }
}

LeanChat.prototype.fetchGroupById = function(userId, convId, callback){
    try{
        var data=[userId, convId];
        this.call_native("fetchGroupById",data,callback);
    }
    catch(exception){
        console.log(exception);
    }
}

if(!window.plugins){
	window.plugins = {};
}

if(!window.plugins.LeanChat){
	window.plugins.LeanChat = new LeanChat();
}

module.exports = new LeanChat();

});
