cordova.define("com.seiosoft.phonegap.NativePush.NativePush", function(require, exports, module) { var NativePush = function(){
};

NativePush.prototype.isPlatformIOS = function(){
	return device.platform == "iPhone" || device.platform == "iPad" || device.platform == "iPod touch" || device.platform == "iOS"
}

NativePush.prototype.error_callback = function(msg){
	console.log("Javascript Callback Error: " + msg)
}

NativePush.prototype.call_native = function(name, args, callback){

	ret = cordova.exec(callback,this.error_callback,'NativePush',name,args);
	return ret;
}

NativePush.prototype.registPushCallback = function(callback){
	try{
	    var data=[];
		this.call_native("registPushCallback",[data],callback);
	}
	catch(exception){
		console.log(exception);
	}
}

NativePush.prototype.getPushOnStart = function(callback){
	try{
	    var data=[];
		this.call_native("getPushOnStart",[data],callback);
	}
	catch(exception){
		console.log(exception);
	}
}

NativePush.prototype.resetNativePush = function(callback){
	try{
	    var data=[];
		this.call_native("resetNativePush",data,callback);
	}
	catch(exception){
		console.log(exception);
	}
}

NativePush.prototype.addNativePush = function(datetime, id, content, callback){
	try{
        var data=[datetime, id, content];
		this.call_native("addNativePush",data,callback);
	}
	catch(exception){
		console.log(exception);
	}
}
               
//android single

NativePush.prototype.saveNativePush = function (callback) {
 if(device.platform == "Android") {
   data=[];
 	this.call_native("saveNativePush",data,callback);
 }
}

//ios  single

if(!window.plugins){
	window.plugins = {};
}

if(!window.plugins.NativePush){
	window.plugins.NativePush = new NativePush();
}

module.exports = new NativePush();

});
