﻿// application tool
(function () {

    var getDateStr = function(d) {
        var yyyy = d.getFullYear().toString();
        var mm = (d.getMonth() + 1).toString(); // getMonth() is zero-based
        var dd = d.getDate().toString();
        return yyyy + (mm[1] ? mm : "0" + mm[0]) + (dd[1] ? dd : "0" + dd[0]); // padding
    }

    Light.tool = {
        isInt: function(n){
            return Number(n)===n && n%1===0;
        },
        isNumber: function (n) {
            return Number(n) === n;
        },
        RoundFloat: function (value, length) {
            var p = Math.pow(10, length);
            var roundvalue = (Math.round(value * p)) / p;
            return roundvalue;
        },
        getDate: function () {
            var d = new Date();
            return getDateStr(d);
        },
        getDateToStr: function (d) {
            return getDateStr(d);
        },
        addDate: function(datestr, numDays) {
            //alert(datestr.substring(0, 4) + datestr.substring(4, 6) + datestr.substring(6, 8));
            var date = new Date(datestr.substring(0, 4), datestr.substring(4, 6) -1, datestr.substring(6, 8));
            date.setDate(date.getDate() + numDays);

            return getDateStr(date);
        },
        dateDiff: function (lastdate, basedate) {
            var ldate = new Date(lastdate.substring(0, 4), lastdate.substring(4, 6) - 1, lastdate.substring(6, 8));
            var bdate = new Date(basedate.substring(0, 4), basedate.substring(4, 6) - 1, basedate.substring(6, 8));
            var one_day = 1000 * 60 * 60 * 24;
            var lms = ldate.getTime();
            var bms = bdate.getTime();
            var difference_ms = lms - bms;
            return Math.round(difference_ms / one_day);
        },
        getTime: function () {
            //return 900;

            var d = new Date();
            var h = d.getHours() * 100;
            var m = d.getMinutes();
            return h + m;
        },
        getWeekStartEnd: function (datestr) {

            /*
            var d = new Date(datestr.substring(0, 4), datestr.substring(4, 6) - 1, datestr.substring(6, 8));
            var dayindex = d.getDay();
            var rt = {};
            rt.startDate = Light.tool.addDate(datestr, -dayindex);
            rt.endDate = Light.tool.addDate(datestr, -dayindex + 6);
            return rt;
            */

            var d = new Date(datestr.substring(0, 4), datestr.substring(4, 6) - 1, datestr.substring(6, 8));
            var dayindex = d.getDay();
            var rt = {};
            if (dayindex == 0) {
                rt.startDate = Light.tool.addDate(datestr, -5);
                rt.endDate = Light.tool.addDate(datestr, 1);
            } else {
                rt.startDate = Light.tool.addDate(datestr, -dayindex + 1);
                rt.endDate = Light.tool.addDate(datestr, -dayindex + 7);
            }
            return rt;
        
            //return Light.tool.addDate(datestr, -6);
        },
        getDateIndex: function (datestr) {
            var d = new Date(datestr.substring(0, 4), datestr.substring(4, 6) - 1, datestr.substring(6, 8));
            var dayindex = d.getDay();
            var rt = {};
            if (dayindex == 0) {
                return 7;
            } else {
                return dayindex;
            }
        },
        getMonthStartEnd: function (monthstr) {
            var d = new Date(monthstr.substring(0, 4), monthstr.substring(4, 6) - 1, "01");
            var d2 = new Date(monthstr.substring(0, 4), monthstr.substring(4, 6), "01");
            d2.setDate(0);
            var rt = {};
            rt.startDate = getDateStr(d);
            rt.endDate = getDateStr(d2);
            return rt;
        },
        getYearStartEnd: function (monthstr) {
            var d = new Date(monthstr.substring(0, 4), 0, 1);
            var d2 = new Date(monthstr.substring(0, 4), 11, 31);
            var rt = {};
            rt.startDate = getDateStr(d);
            rt.endDate = getDateStr(d2);
            return rt;
        },
        getTakenTimes: function (frequency) {
            var times = [];
            if (frequency == 2) {
                times = Light.config.takenList.time2;
            } else if (frequency == 3) {
                times = Light.config.takenList.time3;
            } else if (frequency == 4) {
                times = Light.config.takenList.time4;
            } else if (frequency == 5) {
                times = Light.config.takenList.time5;
            } else {
                times = Light.config.takenList.time1;
            }
            return times;
        },
        newGUID: (function () {
            function s4() {
                return Math.floor((1 + Math.random()) * 0x10000)
                           .toString(16)
                           .substring(1);
            }

            return function () {
                return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
                       s4() + '-' + s4() + s4() + s4();
            };
        })(),
        getStandardDate: function (date) {
            //return 2014/12/01;
            var sDate = date;
            if (date.length == 8) {
                sDate = Globalize.format(new Date(sDate.substring(0, 4), sDate.substring(4, 6) - 1, sDate.substring(6, 8)), 'yyyy/MM/dd');
            } else if (date.length == 7) {
                sDate = Globalize.format(new Date(sDate.substring(0, 4), sDate.substring(4, 6) - 1, sDate.substring(6, 7)), 'yyyy/MM/dd');
            } else if (date.length == 6) {
                sDate = Globalize.format(new Date(sDate.substring(0, 4), sDate.substring(4, 6) - 1, 01), 'yyyy/MM/dd');
            }
            return sDate;
        },
        getAge: function (date) {
            var age = 0;
            var nowYear = Globalize.format(new Date(), 'yyyy');
            var userYear = Globalize.format(new Date(Light.tool.getStandardDate(date)), 'yyyy');
            age = nowYear - userYear;

            if (age < 0) {
                age = 0;
            }

            return age;
        },
        getDisplayTime: function (time) {
            //return 9:00;
            var h = Globalize.format(time / 100, "d2");
            var m = Globalize.format(time % 100, "d2");
            return h + ":" + m;
        },
        getCity: function (lat, lng, gpslist) {
            function toRad(d) { return d * Math.PI / 180; }
            function getDisance(lat1, lng1, lat2, lng2) {
                var dis = 0;
                var radLat1 = toRad(lat1);
                var radLat2 = toRad(lat2);
                var deltaLat = radLat1 - radLat2;
                var deltaLng = toRad(lng1) - toRad(lng2);
                var dis = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(deltaLat / 2), 2) + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(deltaLng / 2), 2)));
                return dis * 6378137;
            }

            var city = null;
            var long = 0;

            for (var i = 0; i < gpslist.length; i++) {
                var tmplong = getDisance(lat, lng, gpslist[i].latitude, gpslist[i].longitude);
                if (city == null) {
                    city = gpslist[i];
                    long = tmplong;
                } else {
                    if (tmplong < long) {
                        city = gpslist[i];
                        long = tmplong;
                    }
                }
            }

            return city;
        },

        trim: function (str) {
            return str.replace(/(^\s*)|(\s*$)/g, "");
        },

        getActivityDate: function (start, end) {
            var disdate = '';
            var year = new Date().getFullYear();

            if (Globalize.format(start, 'yyyyMMdd') == Globalize.format(end, 'yyyyMMdd')) {
                if (start.getFullYear() == year) {
                    disdate = Globalize.format(start, 'M月d日 H:mm') + ' ～ ' + Globalize.format(end, 'H:mm')
                } else {
                    disdate = Globalize.format(start, 'yyyy年M月d日 H:mm') + ' ～ ' + Globalize.format(end, 'H:mm')
                }
            } else {
                if ((start.getFullYear() == year) && (end.getFullYear() == year)) {
                    disdate = Globalize.format(start, 'M月d日 H:mm') + ' ～ ' + Globalize.format(end, 'M月d日 H:mm')
                } else {
                    disdate = Globalize.format(start, 'yyyy年M月d日 H:mm') + ' ～ ' + Globalize.format(end, 'yyyy年M月d日 H:mm')
                }
            }

            return disdate;
        },

        arrSortByGroup: function (arr) {
            var tmp = arr;
            if (tmp.length > 0) {
                //list 排序
                tmp.sort(function (a, b) {
                    if (a.key > b.key) {
                        return 1;
                    }
                    return -1;
                });

                for (i = 0; i < tmp.length; i++) {
                    if ((i == 0) || (tmp[i].key !== tmp[i - 1].key)) {
                        tmp[i].keyFlg(true);
                    }
                }
            }
            return tmp
        },

        toPartnerMessageList: function () {

            Light.action.leancloud.user.signIn(
                function () {
                    if (window.plugins && window.plugins.LeanChat) {
                        window.plugins.LeanChat.registStatusCallback(Light.PartnerPluginData.group_all_onState);
                        window.plugins.LeanChat.groupList(Light.rtdata.leanCloudSocialId);
                    } else {
                        //for debug
                        Light.app.navigate('Partner', { root: true });
                    }
                 }, 
                function () {
                    // DevExpress.ui.notify("网络或数据原因，请退出应用，重新登录。", "error", 2000);
                    DevExpress.ui.notify("咦？网络不见了，请检查网络连接", "error", 2000);
                });

                //
            /*
            Light.action.leancloud.user.signIn(function () { }, function () { });

            if (window.plugins && window.plugins.LeanChat) {
                window.plugins.LeanChat.registStatusCallback(Light.PartnerPluginData.group_all_onState);
                window.plugins.LeanChat.groupList(Light.rtdata.leanCloudSocialId);
            }

            Light.app.navigate('Partner', { root: true });
            */
        },

    };
})();