﻿Light.HealthChart = function (params) {

    var chartDataSource = [];
    var bathroomScaleData = [];
    var pedometerData = [];
    var calorieData = [];
    var chartType = "";
    var chartTypeName = "";
    //var chart = $("#chartBathroomScale").dxChart("instance");

    //日期计算
    function setDate(date, value, type) {
        var rtDate;
        switch (type) {
            case "day":
                rtDate = new Date(date);
                rtDate.setDate(rtDate.getDate() + value);
                break;
            case "month":
                rtDate = new Date(date + '/01');
                rtDate.setMonth(rtDate.getMonth() + value);
                break;
            case "year":
                rtDate = new Date(date + '/01/01');
                rtDate.setFullYear(rtDate.getFullYear() + value);
        }
        
        return rtDate;
    };

    //图表数据模型
    function chartDataMode(type) {
        bathroomScaleData = [];
        pedometerData = [];
        calorieData = [];
        switch (type) {
            case "day":
                //天
                break;

            case "week":
                //周
                for (i = 0; i < 7; i++) {
                    bathroomScaleData.push({
                        date: Light.config.weekList[i].name,
                        weight: 0,
                        bmi: 0,
                        bfr: 0,
                        waterContent: 0,
                        mus: 0,
                        boneQuality: 0,
                        metabolism: 0,
                        sfat: 0,
                        infat: 0,
                        bodyage: 0
                    });

                    pedometerData.push({
                        date: Light.config.weekList[i].name,
                        step: 0,
                        calorie: 0,
                        course: 0
                    });

                    calorieData.push({
                        date: Light.config.weekList[i].name,
                        input: 0,
                        output: 0,
                        outputMovement: 0,
                        outputBase: 0
                    });
                }
                break;

            case "month":
                //月
                var monthDay = viewModel.txt_month();
                var temp = setDate(monthDay, 1, "month");
                var maxDay = new Date(temp.getFullYear(), temp.getMonth(), 0).getDate();
                monthDay = monthDay + '/01';

                for (i = 0; i < maxDay; i++) {
                    bathroomScaleData.push({
                        date: i + 1,
                        weight: 0,
                        bmi: 0,
                        bfr: 0,
                        waterContent: 0,
                        mus: 0,
                        boneQuality: 0,
                        metabolism: 0,
                        sfat: 0,
                        infat: 0,
                        bodyage: 0
                    });

                    pedometerData.push({
                        date: i + 1,
                        step: 0,
                        calorie: 0,
                        course: 0
                    });

                    calorieData.push({
                        date: i + 1,
                        input: 0,
                        output: 0,
                        outputMovement: 0,
                        outputBase: 0
                    });
                }
                break;

            case "year":
                //年
                var yearMonth = viewModel.txt_year();
                yearMonth = yearMonth + '/01';

                for (i = 0; i < 12; i++) {
                    bathroomScaleData.push({
                        date: i + 1,
                        weight: 0,
                        bmi: 0,
                        bfr: 0,
                        waterContent: 0,
                        mus: 0,
                        boneQuality: 0,
                        metabolism: 0,
                        sfat: 0,
                        infat: 0,
                        bodyage: 0
                    });

                    pedometerData.push({
                        date: i + 1,
                        step: 0,
                        calorie: 0,
                        course: 0
                    });

                    calorieData.push({
                        date: i + 1,
                        input: 0,
                        output: 0,
                        outputMovement: 0,
                        outputBase: 0
                    });
                }
                break;
        }
    };

    //图表数据取得
    function getDataByPeriod() {
        //$("#chartBathroomScale").dxChart();
        //alert("selectedPeriodType="+viewModel.selectedPeriodType());
        //alert("dispChartDtlType=" + viewModel.dispChartDtlType());
        var inDate = '';
        var item = '';
        var key = 0;
        bathroomScaleData = [];
        pedometerData = [];
        calorieData = [];
        switch (viewModel.selectedPeriodType()) {
            case 0:
                //天
                inDate = Globalize.format(new Date(viewModel.txt_day()), "yyyyMMdd");
                var hour;
                var minter;
                if (viewModel.dispChartType() == 0) {
                    var done_weight = function (items) {
                        items.sort(function (a, b) { return a.surveyTime - b.surveyTime; });
                        for (i = 0; i < items.length; i++) {
                            item = items[i];
                            hour = Globalize.format(item.surveyTime / 100, "d2");
                            minter = Globalize.format(item.surveyTime % 100, "d2");
                            bathroomScaleData.push({
                                date: hour + ":" + minter,
                                weight: Globalize.parseFloat(Globalize.format(item.weight, "n2")),
                                bmi: Globalize.parseFloat(Globalize.format(item.bmi, "n2")),
                                bfr: Globalize.parseFloat(Globalize.format(item.bfr, "n2")),
                                waterContent: Globalize.parseFloat(Globalize.format(item.waterContent, "n2")),
                                mus: Globalize.parseFloat(Globalize.format(item.mus, "n2")),
                                boneQuality: Globalize.parseFloat(Globalize.format(item.boneQuality, "n2")),
                                metabolism: Globalize.parseFloat(Globalize.format(item.metabolism, "n2")),
                                sfat: Globalize.parseFloat(Globalize.format(item.sfat, "n2")),
                                infat: Globalize.parseFloat(Globalize.format(item.infat, "n2")),
                                bodyage: Globalize.parseFloat(Globalize.format(item.bodyage, "n2"))
                            });
                        }

                        reDrawBathroomScale();
                    };
                    Light.action.weight.getRecordByDate(inDate, done_weight);
                } else if (viewModel.dispChartType() == 1) {
                    //alert(viewModel.dispChartType());
                    var done_calorie = function (items) {

                        if (items != null) {
                            //hour = Globalize.format(inDate / 100, "d2");
                            //minter = Globalize.format(inDate % 100, "d2");
                            var outputMov = items.outputMovement + items.outputPedometer;
                            calorieData.push({
                                date: "",
                                input: Globalize.parseFloat(Globalize.format(items.input, "n2")),
                                output: Globalize.parseFloat(Globalize.format(items.output, "n2")),
                                outputMovement: Globalize.parseFloat(Globalize.format(outputMov, "n2")),
                                outputBase: Globalize.parseFloat(Globalize.format(items.outputBase, "n2"))
                            });
                        }

                        //图表绘制
                        reDrawBathroomScale();
                    };
                    Light.action.calorie.getByDate(inDate, done_calorie);


                } else if (viewModel.dispChartType() == 2) {
                    var done_pedometer = function (items) {
                        items.sort(function (a, b) { return a.surveyTime - b.surveyTime; });
                        for (i = 0; i < items.length; i++) {
                            item = items[i];
                            hour = Globalize.format(item.surveyTime / 100, "d2");
                            minter = Globalize.format(item.surveyTime % 100, "d2");
                            pedometerData.push({
                                date: hour + ":" + minter,
                                step: item.step,
                                calorie: Globalize.parseFloat(Globalize.format(item.calorie, "n2")),
                                course: Globalize.parseFloat(Globalize.format(item.course, "n2"))
                            });
                        }
                        
                        //图表绘制
                        reDrawBathroomScale();
                    };
                    Light.action.pedometer.getRecordByDate(inDate, done_pedometer);
                }
                
                break;

            case 1:
                //周
                chartDataMode("week");
                var startDate = Globalize.format(new Date(viewModel.txt_weekStart()), "yyyyMMdd");
                var endDate = Globalize.format(new Date(viewModel.txt_weekEnd()), "yyyyMMdd");
                if (viewModel.dispChartType() == 0) {
                    //体重
                    var done_weight = function (items) {

                        for (i = 0; i < items.length; i++) {
                            item = items[i];
                            key = new Date(item.surveyDate.substring(0, 4) + "/" + item.surveyDate.substring(4, 6) + "/" + item.surveyDate.substring(6, 8)).getDay();

                            if (key == 0) {
                                //周日
                                bathroomScaleData[6].weight = Globalize.parseFloat(Globalize.format(item.weight, "n2"));
                                bathroomScaleData[6].bmi = Globalize.parseFloat(Globalize.format(item.bmi, "n2"));
                                bathroomScaleData[6].bfr = Globalize.parseFloat(Globalize.format(item.bfr, "n2"));
                                bathroomScaleData[6].waterContent = Globalize.parseFloat(Globalize.format(item.waterContent, "n2"));
                                bathroomScaleData[6].mus = Globalize.parseFloat(Globalize.format(item.mus, "n2"));
                                bathroomScaleData[6].boneQuality = Globalize.parseFloat(Globalize.format(item.boneQuality, "n2"));
                                bathroomScaleData[6].metabolism = Globalize.parseFloat(Globalize.format(item.metabolism, "n2"));
                                bathroomScaleData[6].sfat = Globalize.parseFloat(Globalize.format(item.sfat, "n2"));
                                bathroomScaleData[6].infat = Globalize.parseFloat(Globalize.format(item.infat, "n2"));
                                bathroomScaleData[6].bodyage = Globalize.parseFloat(Globalize.format(item.bodyage, "n2"));
                            } else {
                                bathroomScaleData[key - 1].weight = Globalize.parseFloat(Globalize.format(item.weight, "n2"));
                                bathroomScaleData[key - 1].bmi = Globalize.parseFloat(Globalize.format(item.bmi, "n2"));
                                bathroomScaleData[key - 1].bfr = Globalize.parseFloat(Globalize.format(item.bfr, "n2"));
                                bathroomScaleData[key - 1].waterContent = Globalize.parseFloat(Globalize.format(item.waterContent, "n2"));
                                bathroomScaleData[key - 1].mus = Globalize.parseFloat(Globalize.format(item.mus, "n2"));
                                bathroomScaleData[key - 1].boneQuality = Globalize.parseFloat(Globalize.format(item.boneQuality, "n2"));
                                bathroomScaleData[key - 1].metabolism = Globalize.parseFloat(Globalize.format(item.metabolism, "n2"));
                                bathroomScaleData[key - 1].sfat = Globalize.parseFloat(Globalize.format(item.sfat, "n2"));
                                bathroomScaleData[key - 1].infat = Globalize.parseFloat(Globalize.format(item.infat, "n2"));
                                bathroomScaleData[key - 1].bodyage = Globalize.parseFloat(Globalize.format(item.bodyage, "n2"));
                            }
                        }

                        //图表绘制
                        reDrawBathroomScale();
                    };
                    Light.action.weight.getWeekRecord(startDate, endDate, done_weight);

                } else if (viewModel.dispChartType() == 1) {
                    //摄入
                    var done_calorie = function (items) {
                        for (i = 0; i < items.length; i++) {
                            item = items[i];
                            var outputMov = item.outputMovement + item.outputPedometer;
                            key = new Date(item.date.substring(0, 4) + "/" + item.date.substring(4, 6) + "/" + item.date.substring(6, 8)).getDay();

                            if (key == 0) {
                                //周日
                                calorieData[6].input = Globalize.parseFloat(Globalize.format(item.input, "n2"));
                                calorieData[6].output = Globalize.parseFloat(Globalize.format(item.output, "n2"));
                                calorieData[6].outputMovement = Globalize.parseFloat(Globalize.format(outputMov, "n2"));
                                calorieData[6].outputBase = Globalize.parseFloat(Globalize.format(item.outputBase, "n2"));
                            } else {
                                calorieData[key - 1].input = Globalize.parseFloat(Globalize.format(item.input, "n2"));
                                calorieData[key - 1].output = Globalize.parseFloat(Globalize.format(item.output, "n2"));
                                calorieData[key - 1].outputMovement = Globalize.parseFloat(Globalize.format(outputMov, "n2"));
                                calorieData[key - 1].outputBase = Globalize.parseFloat(Globalize.format(item.outputBase, "n2"));
                            }
                        }

                        //图表绘制
                        reDrawBathroomScale();
                    };
                    Light.action.calorie.getWeekRecord(startDate, endDate, done_calorie);

                } else if (viewModel.dispChartType() == 2) {
                    //运动
                    var done_pedometer = function (items) {
                        for (i = 0; i < items.length; i++) {
                            item = items[i];
                            key = new Date(item.surveyDate.substring(0, 4) + "/" + item.surveyDate.substring(4, 6) + "/" + item.surveyDate.substring(6, 8)).getDay();

                            if (key == 0) {
                                //周日
                                pedometerData[6].step = item.step;
                                pedometerData[6].calorie = Globalize.parseFloat(Globalize.format(item.calorie, "n2"));
                                pedometerData[6].course = Globalize.parseFloat(Globalize.format(item.course, "n2"));
                            } else {
                                pedometerData[key - 1].step = item.step;
                                pedometerData[key - 1].calorie = Globalize.parseFloat(Globalize.format(item.calorie, "n2"));
                                pedometerData[key - 1].course = Globalize.parseFloat(Globalize.format(item.course, "n2"));
                            }
                        }

                        //图表绘制
                        reDrawBathroomScale();
                    };
                    Light.action.pedometer.getWeekRecord(startDate, endDate, done_pedometer);
                }
                break;

            case 2:
                //月
                chartDataMode("month");
                inDate = viewModel.txt_month().replace("/", "");
                if (viewModel.dispChartType() == 0) {

                    var done_weight = function (items) {
                        for (i = 0; i < items.length; i++) {
                            item = items[i];
                            key = Globalize.parseInt(item.surveyDate.substring(6, 8));
                            bathroomScaleData[key - 1].weight = Globalize.parseFloat(Globalize.format(item.weight, "n2"));
                            bathroomScaleData[key - 1].bmi = Globalize.parseFloat(Globalize.format(item.bmi, "n2"));
                            bathroomScaleData[key - 1].bfr = Globalize.parseFloat(Globalize.format(item.bfr, "n2"));
                            bathroomScaleData[key - 1].waterContent = Globalize.parseFloat(Globalize.format(item.waterContent, "n2"));
                            bathroomScaleData[key - 1].mus = Globalize.parseFloat(Globalize.format(item.mus, "n2"));
                            bathroomScaleData[key - 1].boneQuality = Globalize.parseFloat(Globalize.format(item.boneQuality, "n2"));
                            bathroomScaleData[key - 1].metabolism = Globalize.parseFloat(Globalize.format(item.metabolism, "n2"));
                            bathroomScaleData[key - 1].sfat = Globalize.parseFloat(Globalize.format(item.sfat, "n2"));
                            bathroomScaleData[key - 1].infat = Globalize.parseFloat(Globalize.format(item.infat, "n2"));
                            bathroomScaleData[key - 1].bodyage = Globalize.parseFloat(Globalize.format(item.bodyage, "n2"));
                        }
                        //图表绘制
                        reDrawBathroomScale();
                    };
                    Light.action.weight.getMonthRecord(inDate, done_weight);

                } else if (viewModel.dispChartType() == 1) {
                    var done_calorie = function (items) {
                        for (i = 0; i < items.length; i++) {
                            item = items[i];
                            var outputMov = item.outputMovement + item.outputPedometer;
                            key = Globalize.parseInt(item.date.substring(6, 8));
                            calorieData[key - 1].input = Globalize.parseFloat(Globalize.format(item.input, "n2"));
                            calorieData[key - 1].output = Globalize.parseFloat(Globalize.format(item.output, "n2"));
                            calorieData[key - 1].outputMovement = Globalize.parseFloat(Globalize.format(outputMov, "n2"));
                            calorieData[key - 1].outputBase = Globalize.parseFloat(Globalize.format(item.outputBase, "n2"));
                        }

                        //图表绘制
                        reDrawBathroomScale();
                    };
                    Light.action.calorie.getMonthRecord(inDate, done_calorie);

                } else if (viewModel.dispChartType() == 2) {
                    var done_pedometer = function (items) {
                        for (i = 0; i < items.length; i++) {
                            item = items[i];
                            key = Globalize.parseInt(item.surveyDate.substring(6, 8));
                            pedometerData[key - 1].step = item.step;
                            pedometerData[key - 1].calorie = Globalize.parseFloat(Globalize.format(item.calorie, "n2"));
                            pedometerData[key - 1].course = Globalize.parseFloat(Globalize.format(item.course, "n2"));
                        }

                        //图表绘制
                        reDrawBathroomScale();
                    };
                    Light.action.pedometer.getMonthRecord(inDate, done_pedometer);
                }
                break;

            case 3:
                //年
                chartDataMode("year");
                inDate = viewModel.txt_year();

                if (viewModel.dispChartType() == 0) {
                    var done_weight = function (items) {
                        for (i = 0; i < items.length; i++) {
                            item = items[i];
                            key = Globalize.parseInt(item.surveyDate.substring(4, 6));

                            bathroomScaleData[key - 1].weight = Globalize.parseFloat(Globalize.format(item.weight, "n2"));
                            bathroomScaleData[key - 1].bmi = Globalize.parseFloat(Globalize.format(item.bmi, "n2"));
                            bathroomScaleData[key - 1].bfr = Globalize.parseFloat(Globalize.format(item.bfr, "n2"));
                            bathroomScaleData[key - 1].waterContent = Globalize.parseFloat(Globalize.format(item.waterContent, "n2"));
                            bathroomScaleData[key - 1].mus = Globalize.parseFloat(Globalize.format(item.mus, "n2"));
                            bathroomScaleData[key - 1].boneQuality = Globalize.parseFloat(Globalize.format(item.boneQuality, "n2"));
                            bathroomScaleData[key - 1].metabolism = Globalize.parseFloat(Globalize.format(item.metabolism, "n2"));
                            bathroomScaleData[key - 1].sfat = Globalize.parseFloat(Globalize.format(item.sfat, "n2"));
                            bathroomScaleData[key - 1].infat = Globalize.parseFloat(Globalize.format(item.infat, "n2"));
                            bathroomScaleData[key - 1].bodyage = Globalize.parseFloat(Globalize.format(item.bodyage, "n2"));
                        }
                        //图表绘制
                        reDrawBathroomScale();
                    };
                    Light.action.weight.getYearRecord(inDate, done_weight);
                } else if (viewModel.dispChartType() == 1) {
                    var done_calorie = function (items) {
                        for (i = 0; i < items.length; i++) {
                            item = items[i];
                            var outputMov = item.outputMovement + item.outputPedometer;
                            key = Globalize.parseInt(item.date.substring(4, 6));
                            calorieData[key - 1].input = Globalize.parseFloat(Globalize.format(item.input, "n2"));
                            calorieData[key - 1].output = Globalize.parseFloat(Globalize.format(item.output, "n2"));
                            calorieData[key - 1].outputMovement = Globalize.parseFloat(Globalize.format(outputMov, "n2"));
                            calorieData[key - 1].outputBase = Globalize.parseFloat(Globalize.format(item.outputBase, "n2"));
                        }

                        //图表绘制
                        reDrawBathroomScale();
                    };
                    Light.action.calorie.getYearRecord(inDate, done_calorie);
                } else if (viewModel.dispChartType() == 2) {
                    var done_pedometer = function (items) {
                        for (i = 0; i < items.length; i++) {
                            item = items[i];
                            key = Globalize.parseInt(item.surveyDate.substring(4, 6));

                            pedometerData[key - 1].step = item.step;
                            pedometerData[key - 1].calorie = Globalize.parseFloat(Globalize.format(item.calorie, "n2"));
                            pedometerData[key - 1].course = Globalize.parseFloat(Globalize.format(item.course, "n2"));
                        }

                        //图表绘制
                        reDrawBathroomScale();
                    };

                    Light.action.pedometer.getYearRecord(inDate, done_pedometer);
                }
                break;
        }


    };

    //体重秤 数据图表绘制
    function reDrawBathroomScale() {

        //var time0 = new Date().getTime();
        //console.log('reDrawBathroomScale begin:' + time0);

        var barWidth = 2;

        var valueLow = 0;
        var valueNormal = 0;
        var valueHigh = 0;

        var normWeight = [];
        var normBMI = [];
        var normBFR = [];

        //水分
        var normMOISTURE = [];
        //骨骼
        var normSKELETON = [];
        //肌肉
        var normMUSCLE = [];
        //基础代谢率
        var normBMR = [];

        normWeight = Light.action.health.getNormWeight();
        normBMI = Light.action.health.getNormBMI();
        normBFR = Light.action.health.getNormBFR();

        switch (viewModel.selectedPeriodType()) {
            case 0:
                //天
                barWidth = 5;
                break;
            case 1:
                //周
                barWidth = 15;
                break;
            case 2:
                //月
                barWidth = 2;
                break;
            case 3:
                //年
                barWidth = 10;
                break;
        }
        if (viewModel.dispChartType() == 0) {
            chartDataSource = bathroomScaleData;
            switch (viewModel.dispChartDtlType()) {
                case 0:
                    //体重
                    chartType = "weight";
                    chartTypeName = "体重";
                    break;
                case 1:
                    //体脂率
                    chartType = "bfr";
                    chartTypeName = "体脂率";
                    break;
                case 2:
                    //BMI
                    chartType = "bmi";
                    chartTypeName = "BMI";
                    break;
                case 3:
                    //水分
                    chartType = "waterContent";
                    chartTypeName = "水分";
                    break;
                case 4:
                    //骨骼
                    chartType = "boneQuality";
                    chartTypeName = "骨骼";
                    break;
                case 5:
                    //肌肉
                    chartType = "mus";
                    chartTypeName = "肌肉";
                    break;
                case 6:
                    //基础代谢率
                    chartType = "metabolism";
                    chartTypeName = "基础代谢率";
                    break;
                case 7:
                    //皮下脂肪
                    chartType = "sfat";
                    chartTypeName = "皮下脂肪";
                    break;
                case 8:
                    //内脏脂肪
                    chartType = "infat";
                    chartTypeName = "内脏脂肪";
                    break;
                case 9:
                    //身体年龄
                    chartType = "bodyage";
                    chartTypeName = "身体年龄";
                    break;
            }
        } if (viewModel.dispChartType() == 1) {
            chartDataSource = calorieData;
            switch (viewModel.dispChartDtlType()) {
                case 0:
                    //总摄入
                    chartType = "input";
                    chartTypeName = "总摄入";
                    break;
                case 1:
                    //总消耗
                    chartType = "output";
                    chartTypeName = "总消耗";
                    break;
                case 2:
                    //运动消耗
                    chartType = "outputMovement";
                    chartTypeName = "运动消耗";
                    break;
                case 3:
                    //基础代谢
                    chartType = "outputBase";
                    chartTypeName = "基础代谢";
                    break;
            }
        } if (viewModel.dispChartType() == 2) {
            chartDataSource = pedometerData;
            switch (viewModel.dispChartDtlType()) {
                case 0:
                    //步数
                    chartType = "step";
                    chartTypeName = "步数";
                    break;
                case 1:
                    //里程
                    chartType = "course";
                    chartTypeName = "里程";
                    break;
                case 2:
                    //卡路里
                    chartType = "calorie";
                    chartTypeName = "卡路里";
                    break;
            }
        }

        var types = ["line", "stackedLine", "fullStackedLine"];
        //spline
        //ignoreEmptyPoints:true,
        //label: { visible: true },
        var chartOptions = {
            dataSource: chartDataSource,
            commonSeriesSettings: {
                argumentField: "date",
                type: "spline",
                hoverMode: "includePoints",
                point: {
                    hoverMode: "none"
                }
            },
            commonAxisSettings: {
                grid: {
                    visible: true
                }
            },
            tooltip: {
                enabled: false
            },
            margin: {
                bottom: 30
            },
            series: [
                {
                    valueField: chartType, name: chartTypeName,
                    label: {
                        visible: true,
                        backgroundColor: "transparent",
                        font: {
                            color: "#000000",
                        },
                    }
                }
            ],
            legend: {
                verticalAlignment: "top",
                horizontalAlignment: "right",
                visible: false
            },
            title: "",
            commonPaneSettings: {
                border: {
                    visible: true
                }
            },
        };
        var chart = $("#chartBathroomScale").dxChart(chartOptions).dxChart("instance");
        //chart.onPointClick = test();
        //chart.option("commonSeriesSettings.type", "line");
        var renderOptions = {
            force: true,
            animate: false,
            asyncSeriesRendering: true
        }
        chart.render(renderOptions); 
    };

    function showDate(type) {
        var rtDate;
        var value_1 = 1;
        var value_7 = 7;

        if (type == '-') {
            value_1 = -1;
            value_7 = -7;
        }

        switch (viewModel.selectedPeriodType()) {
            case 0:
                //天
                rtDate = setDate(viewModel.txt_day(), value_1, "day")
                viewModel.txt_day(Globalize.format(rtDate, 'yyyy/MM/dd'));
                break;
            case 1:
                //周
                rtDate = setDate(viewModel.txt_weekStart(), value_7, "day")
                viewModel.txt_weekStart(Globalize.format(rtDate, 'yyyy/MM/dd'));

                rtDate = setDate(viewModel.txt_weekEnd(), value_7, "day")
                viewModel.txt_weekEnd(Globalize.format(rtDate, 'yyyy/MM/dd'));
                break;
            case 2:
                //月
                rtDate = setDate(viewModel.txt_month(), value_1, "month")
                viewModel.txt_month(Globalize.format(rtDate, 'yyyy/MM'));
                break;
            case 3:
                //年
                rtDate = setDate(viewModel.txt_year(), value_1, "year")
                viewModel.txt_year(Globalize.format(rtDate, 'yyyy'));
                break;
        }
    };

    //页面初期化
    function init() {
        viewModel.selectedPeriodType(1);
        viewModel.dispChartType(0);
        viewModel.dispChartDtlType(0);
        viewModel.txt_day(Globalize.format(new Date(), 'yyyy/MM/dd'));
        viewModel.txt_weekStart('');
        viewModel.txt_weekEnd('');
        viewModel.txt_month(Globalize.format(new Date(), 'yyyy/MM'));
        viewModel.txt_year(Globalize.format(new Date(), 'yyyy'));
        viewModel.bathroomScaleValue(0);
        viewModel.pedometerValue(0);
    };
    //设定为选中
    function setSelected(itemId) {
        $('.dtlBar .dx-button').removeClass("selected");
        $("#" + itemId).addClass("selected");
    };

    var viewModel = {
        pageVisible: ko.observable(false),
        popupPageVisible: ko.observable(false),

        chartDataSourceTest: ko.observableArray(),
        chartSeries: ko.observableArray(),
        selectedPeriodType: ko.observable(1),
        dispChartType: ko.observable(0),
        dispChartDtlType: ko.observable(0),
        txt_day: ko.observable(Globalize.format(new Date(), 'yyyy/MM/dd')),
        txt_weekStart: ko.observable(''),
        txt_weekEnd: ko.observable(''),
        txt_month: ko.observable(Globalize.format(new Date(), 'yyyy/MM')),
        txt_year: ko.observable(Globalize.format(new Date(), 'yyyy')),

        bathroomScaleValue: ko.observable(0),
        pedometerValue: ko.observable(0),

        periodTypeSource: Light.config.periodTypeList,
        bathroomScaleParamSource: Light.config.bathroomScaleParamList,
        pedometerParamSource: Light.config.pedometerParamList,
        //tab按下
        periodTypeSelectClick: function (e) {
            getDataByPeriod();
        },
        chartTabs: [
        { id: 1, text: "体成分", dispChartType: 0 },
        { id: 2, text: "卡路里", dispChartType: 1 },
        { id: 3, text: "运动", dispChartType: 2 }
        ],
        //tab按下
        chartTabsClicked: function (e) {
            dispChartType = e.itemData.dispChartType;
            if (dispChartType == 0) {
                $("#bodyComposition").css("display", "block");
                $("#taken").css("display", "none");
                $("#sport").css("display", "none");
                if ($("#bodyComposition .selected").length == 0) {
                    $("#dxButton01").addClass("selected");
                }
            } else if (dispChartType == 1) {
                $("#bodyComposition").css("display", "none");
                $("#taken").css("display", "block");
                $("#sport").css("display", "none");
                if ($("#taken .selected").length == 0) {
                    $("#dxButton11").addClass("selected");
                }
            } else if (dispChartType == 2) {
                $("#bodyComposition").css("display", "none");
                $("#taken").css("display", "none");
                $("#sport").css("display", "block");
                if ($("#sport .selected").length == 0) {
                    $("#dxButton21").addClass("selected");
                }
            }
            //viewModel.dispChartDtlType(0);
            getDataByPeriod();
        },
        //体重按下
        chartDtl0Clicked: function (e) {
            if (viewModel.dispChartType() == 0) {
                setSelected("dxButton01");
            } else if (viewModel.dispChartType() == 1) {
                setSelected("dxButton11");
            } else if (viewModel.dispChartType() == 2) {
                setSelected("dxButton21");
            }
            viewModel.dispChartDtlType(0);
            getDataByPeriod();
        },
        //体脂率按下
        chartDtl1Clicked: function (e) {
            if (viewModel.dispChartType() == 0) {
                setSelected("dxButton02");
            } else if (viewModel.dispChartType() == 1) {
                setSelected("dxButton12");
            } else if (viewModel.dispChartType() == 2) {
                setSelected("dxButton22");
            }
            viewModel.dispChartDtlType(1);
            getDataByPeriod();
        },


        //BMI按下
        chartDtl2Clicked: function (e) {
            if (viewModel.dispChartType() == 0) {
                setSelected("dxButton03");
            } else if (viewModel.dispChartType() == 1) {
                setSelected("dxButton13");
            }
            viewModel.dispChartDtlType(2);
            getDataByPeriod();
        },
        //水分按下
        chartDtl3Clicked: function (e) {
            if (viewModel.dispChartType() == 0) {
                setSelected("dxButton04");
            } else if (viewModel.dispChartType() == 1) {
                setSelected("dxButton14");
            }
            viewModel.dispChartDtlType(3);
            getDataByPeriod();
        },
        //骨骼按下
        chartDtl4Clicked: function (e) {
            setSelected("dxButton05");
            viewModel.dispChartDtlType(4);
            getDataByPeriod();
        },
        //肌肉按下
        chartDtl5Clicked: function (e) {
            setSelected("dxButton06");
            viewModel.dispChartDtlType(5);
            getDataByPeriod();
        },
        //BFI按下
        chartDtl6Clicked: function (e) {
            setSelected("dxButton07");
            viewModel.dispChartDtlType(6);
            getDataByPeriod();
        },

        //皮下脂肪按下
        chartDtl7Clicked: function (e) {
            setSelected("dxButton08");
            viewModel.dispChartDtlType(7);
            getDataByPeriod();
        },
        //内脏脂肪按下
        chartDtl8Clicked: function (e) {
            setSelected("dxButton09");
            viewModel.dispChartDtlType(8);
            getDataByPeriod();
        },
        //身体年龄按下
        chartDtl9Clicked: function (e) {
            setSelected("dxButton10");
            viewModel.dispChartDtlType(9);
            getDataByPeriod();
        },

        //上一步按钮
        previousButton: function () {
            showDate('-');
            getDataByPeriod();
        },

        //下一步按钮
        nextButton: function () {
            showDate();
            getDataByPeriod();
        },

        //体重秤（体重,BMI..）选择
        bathroomScaleChangeClick: function (e) {
            reDrawBathroomScale();
        },

        //返回按钮
        backClick: function () {
            Light.action.weight.uploadToServer(null, null);
            Light.action.pedometer.uploadToServer(null, null);
            DevExpress.hardwareBackButton.fire();
        },

        //画面 init
        viewShown: function () {
            viewModel.popupPageVisible(true);

            init();
            var startDay = new Date();
            //var endDay = new Date();
            for (i = 0; i < 7; i++) {
                if (startDay.getDay() == 1) {
                    break;
                }
                startDay.setDate(startDay.getDate() - 1);
            }
            var endDay = new Date(startDay.getTime() + 6 * 24 * 60 * 60 * 1000);

            //endDay.setDate(startDay.getDate() + 6);
            viewModel.txt_weekStart(Globalize.format(startDay, 'yyyy/MM/dd'));
            viewModel.txt_weekEnd(Globalize.format(endDay, 'yyyy/MM/dd'));

            var done_weight = function () {

                var done_pedometer = function () {
                    getDataByPeriod();

                    viewModel.popupPageVisible(false);
                    viewModel.pageVisible(true);
                };
                Light.action.pedometer.renewSum(done_pedometer);
            };
            Light.action.weight.renewAvg(done_weight);
            //if ($("#bodyComposition .selected").length == 0) {
            //    $("#dxButton01").addClass("selected");
            // }
            for (var j = 1; j < 10; j++) {
                if ($("#dxButton0"+j)) {
                    $("#dxButton0" + j).removeClass("selected");
                }
            }
            if ($("#dxButton10")) {
                $("#dxButton10").removeClass("selected");
            }
            $("#dxButton01").addClass("selected");
        },
        viewHidden: function () {
            viewModel.pageVisible(false);
            var chartOptions = {
                dataSource: null
            };
            var chart = $("#chartBathroomScale").dxChart(chartOptions).dxChart("instance");
        }

    };

    return viewModel;
};