﻿Light.HealthIndex = function (params) {

    var isAdd = false;
    var planId = "";
    var iStatus = 0;
    var iStart = "";
    var iCount = 0;
    var flg = true;

    var viewModel = {
        reportVisible: ko.observable(true),

        healthPlanVisible: ko.observable(true),
        visible_28: ko.observable(false),
        day_28: ko.observable(0),

        addText: ko.observable(""),

        //评估报告
        reportViewInClick: function () {
            viewModel.reportVisible(!viewModel.reportVisible());
        },

        //
        lifeStyleClick: function () {
            //取得最新的记录
            var done = function (items) {
                var hasResult = false;
                if (0 == items.length) {
                    hasResult = true;
                }
                for (var i = 0; i < items.length; i++) {
                    var qType = items[i].type;
                    if (Light.rtdata.q_life == qType) {
                        Light.app.navigate(
                        {
                            view: "lifeStyleResult",
                            foodScore: items[i].result.foodScore,
                            waterScore: items[i].result.waterScore,
                            sportScore: items[i].result.sportScore
                        });
                        break;
                    } else {
                        if (i == (items.length - 1)) {
                            hasResult = true;
                        }
                    }
                }
                if (hasResult) {
                    Light.app.navigate('lifeStyle');
                }
             
            }
            Light.action.surveys.getLast(done);
        },

        //
        ACCEClick: function () {
            Light.rtdata.accefrom = 0; //健康入口设定

            //取得最新的记录
            var done = function (items) {
                var hasResult = false;
                if (0 == items.length) {
                    hasResult = true;
                }
                for (var i = 0; i < items.length; i++) {
                    var qType = items[i].type;
                    if (Light.rtdata.q_acce == qType) {
                        Light.app.navigate(
                            {
                                view: "acceResult",
                                bmi: items[i].result.bmi,
                                age: items[i].result.age,
                                weight: items[i].result.weight,
                                complication_0_count: items[i].result.complication_0_count,
                                complication_1_count: items[i].result.complication_1_count,
                                complication_2_count: items[i].result.complication_2_count
                            });
                        break;
                    } else {
                        if (i == (items.length - 1)) {
                            hasResult = true;
                        }
                    }
                }
                if (hasResult) {
                    Light.app.navigate('acce');
                }
            }
            Light.action.surveys.getLast(done);
        },

        //
        traditionalChineseMedicineClick: function () {
            //取得最新的记录
            var done = function (items) {
                var hasResult = false;
                if (0 == items.length) {
                    hasResult = true;
                }
                for (var i = 0; i < items.length; i++) {
                    var qType = items[i].type;
                    if (Light.rtdata.q_chinese == qType) {
                        Light.app.navigate(
                        {
                            view: "traditionalChineseMedicineResult",
                            aScore: items[i].result.aScore,
                            bScore: items[i].result.bScore,
                            cScore: items[i].result.cScore,
                            dScore: items[i].result.dScore,
                            eScore: items[i].result.eScore,
                            fScore: items[i].result.fScore,
                            gScore: items[i].result.gScore,
                            hScore: items[i].result.hScore,
                            iScore: items[i].result.iScore,
                            constitutionalType: items[i].result.constitutionalType,
                            details: items[i].result.details,
                        });
                        break;
                    } else {
                        if (i == (items.length - 1)) {
                            hasResult = true;
                        }

                    }
                }
                if (hasResult) {
                    Light.app.navigate('traditionalChineseMedicine');
                }
            }
            Light.action.surveys.getLast(done);
        },

        //
        obesityCausesClick: function () {
            //取得最新的记录
            var done = function (items) {
                var hasResult = false;
                if (0 == items.length) {
                    hasResult = true;
                }
                for (var i = 0; i < items.length; i++) {
                    var qType = items[i].type;
                    if (Light.rtdata.q_fat == qType) {
                        Light.app.navigate(
                            {
                                view: "obesityCausesResult",
                                aScore: items[i].result.aScore,
                                bScore: items[i].result.bScore,
                                cScore: items[i].result.cScore,
                                dScore: items[i].result.dScore,
                                eScore: items[i].result.eScore,
                                fScore: items[i].result.fScore,
                                suggest1: items[i].result.suggest1,
                                suggest2: items[i].result.suggest2,
                            });
                        break;
                    } else {
                        if (i == (items.length - 1)) {
                            hasResult = true;
                        }
                    }
                }
                if (hasResult) {
                    Light.app.navigate('obesityCauses');
                }
            }
            Light.action.surveys.getLast(done);
        },

        //健康计划
        viewInClick: function () {
            viewModel.healthPlanVisible(!viewModel.healthPlanVisible());
        },

        //28天健康方案
        solution28Click: function () {
            Light.app.navigate({ view: "SelSolution", plan: true, planId: planId, status: iStatus, start: iStart, count: iCount, day: viewModel.day_28() });
        },

        //画面init
        viewShown: function () {
            viewModel.healthPlanVisible(true);

            var date = Globalize.format(new Date(), "yyyyMMdd");
            var done = function (plan) {
                $("#btnShow").show();
                if (plan) {
                    planId = plan.healthPlanId;
                    iStatus = plan.status;
                    iStart = plan.planStartDate;
                    iCount = plan.planSuspendCount;
                    viewModel.addText(Globalize.localize('common-view'));
                    var count = 0
                    for (var i = 0; i < plan.planDateList.length; i++) {
                        if (plan.planDateList[i].date > date) break;
                        count++;
                    }
                    viewModel.day_28(count);
                    viewModel.visible_28(true);
                } else {
                    planId = "";
                    viewModel.addText(Globalize.localize('common-add'));
                    viewModel.day_28(0);
                    viewModel.visible_28(false);
                }
            }
            var fail = function () {
                $("#btnShow").hide();
            }

            Light.action.healthPlan.getValidPlan(done, fail);

            //重排通知
            Light.action.checkNotification();
        },
    };

    return viewModel;
};