﻿
Light.FoodRecord = function (params) {
    //返回 按钮
    backClick = function (e) {
        saveData();
    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: params.title + Globalize.localize('home-record') },
    ];

    var date;
    var planId;
    var itemId;
    var randomFood = [];
    var baseFood = [];

    //卡路里数据计算
    function saveCalorieData(date) {
        Light.action.calorie.renewCalorieOneDate(
            date,
            function () { },
            function () { });
    }

    //数据保存
    function saveData() {
        //date, planid, itemid, recordlist,
        var recordList = [];
        var healthFoodList = viewModel.healthFoodSource();
        var otherFoodList = viewModel.otherFoodSource();
        for (var i = 0; i < healthFoodList.length; i++) {
            if (healthFoodList[i].okCheck) {
                recordList.push({
                    itemType: viewModel.itemType(),
                    id: healthFoodList[i].no,
                    name: healthFoodList[i].name,
                    detail: '',
                    count: 1,
                    dtlType: 1,
                    dtlKbn: 1,
                    dtlNum: 1,
                    calorie: healthFoodList[i].calorie,
                });
            }
        }

        for (var i = 0; i < otherFoodList.length; i++) {
            recordList.push({
                itemType: viewModel.itemType(),
                id: otherFoodList[i].id,
                name: otherFoodList[i].name,
                detail: otherFoodList[i].detail,
                count: otherFoodList[i].count,
                dtlType: 2,
                dtlKbn: 1,
                dtlNum: 1,
                calorie: otherFoodList[i].calorie,
            });
        }

        Light.action.healthPlan.record(date, planId, itemId, recordList,
                function () {
                    Light.action.coin.record(0, function () { }, function () { });
                    Light.action.recordActivyDate();
                    saveCalorieData(date);
                    Light.app.navigate({ view: 'Schedule', scheduleBackFlg: params.scheduleBackFlg, date: date });
                },
                function () { });
    };

    //随机食品选择
    function randomValue(arr) {     
        var n1 = Math.floor(Math.random() * arr.length);
        var n2 = 0;
        var flg = true;

        while (flg) {
            n2 = Math.floor(Math.random() * arr.length);
            if (n1 !== n2) {
                flg = false;
            }
        }
        randomFood.push(arr[n1]);
        randomFood.push(arr[n2]);
    };

    //添加其他食品
    function addOtherFood(arr) {
        var tempList = viewModel.otherFoodSource();
        var repeatFlg = false;
        for (var i = 0; i < arr.length; i++) {
            //重复check
            for (var k = 0; k < tempList.length; k++) {
                if (tempList[k].id == arr[i].foodId) {
                    tempList[k].count += arr[i].count;
                    tempList[k].calorie += arr[i].calorie;
                    repeatFlg = true;
                    break;
                }
            }

            if (!repeatFlg) {
                tempList.push({
                    id: arr[i].foodId,
                    name: arr[i].name,
                    detail: arr[i].detail,
                    count: arr[i].count,
                    calorie: arr[i].calorie,
                }); 
            }
        }
        viewModel.otherFoodSource([]);
        viewModel.otherFoodSource(tempList);
    };

    function filterFood(str) {
        for (var i = 0; i < baseFood.length; i++) {
            var items = baseFood[i].detailItems;
            baseFood[i].showtype = false;

            for (var j = 0; j < items.length; j++) {
                if (items[j].foodName.indexOf(str) != -1) {
                    items[j].showflg = true;
                    baseFood[i].showtype = true;
                } else {
                    items[j].showflg = false;
                }
            }
        }
        return baseFood;
    }

    //食品库数据取得
    function setAllFood() {
        var done = function (items) {
            var allFood = [];
            var type = 0;
            var typeName = '';
            var detail = [];
            var n = 0;
            for (var i = 0; i < items.length; i++) {

                if (type !== items[i].foodType) {
                    if (type !== 0){
                        //食品记录
                        allFood.push({
                            id: n,
                            flg: 1,
                            foodType: type,
                            typeName: typeName,
                            detailVisible: ko.observable(false),
                            detailItems: detail,
                        });
                        n += 1;
                    }
                    
                    //食品详细记录
                    detail = [];
                    detail.push({
                        flg: 2,
                        foodId: items[i].foodId,
                        foodType: items[i].foodType,
                        foodName: items[i].foodName,
                        detail: items[i].quantity + items[i].quantityUnitName + "(" + items[i].dosage + items[i].dosageUnitName + "," + items[i].calorie + Globalize.localize('common-unit-calorie') + ")",
                        calorie: items[i].calorie,
                    });
                } else {
                    //食品详细记录
                    detail.push({
                        flg: 2,
                        foodId: items[i].foodId,
                        foodType: items[i].foodType,
                        foodName: items[i].foodName,
                        detail: items[i].quantity + items[i].quantityUnitName + "(" + items[i].dosage + items[i].dosageUnitName + "," + items[i].calorie + Globalize.localize('common-unit-calorie') + ")",
                        calorie: items[i].calorie,
                    });
                }

                type = items[i].foodType;
                typeName = items[i].foodTypeName;
            }
            //食品记录
            allFood.push({
                id: n,
                flg: 1,
                foodType: type,
                typeName: typeName,
                detailVisible: ko.observable(false),
                detailItems: detail,
            });

            baseFood = allFood;

            filterFood("");
            viewModel.popupFoodStoreSource(baseFood);

        }

        Light.action.food.getFoodList(done, function () { });
    };

    var viewModel = {
        pageVisible: ko.observable(false),
        popupPageVisible: ko.observable(false),

        day: ko.observable(''),
        info: ko.observable(''),
        itemType: ko.observable(),

        stapleTitle: ko.observable(''),
        stapleName1: ko.observable(''),
        stapleName2: ko.observable(''),
        foodTitle: ko.observable(''),
        foodName1: ko.observable(''),
        foodName2: ko.observable(''),
        soupTitle: ko.observable(''),
        soupName1: ko.observable(''),
        soupName2: ko.observable(''),

        healthFoodSource: ko.observable([]),
        otherFoodSource: ko.observable([]),

        //popup食品库
        popupTitleVisible: ko.observable(false),
        popupFoodStoreVisible: ko.observable(false),
        popupFoodStoreSource: ko.observable([]),
        popupSelectFoodSource: ko.observable([]),

        ssearch: ko.observable('搜索'),
        input_search: ko.observable(''),
        searchPlaceholder: ko.observable(''),

        searchClick: function () {
            var str = Light.tool.trim(viewModel.input_search());
            if (str == '') {
                //DevExpress.ui.notify(Globalize.localize('partner-searchCondition') + Globalize.localize('message-notNull'), "error", 2000);
                viewModel.popupFoodStoreSource([]);
                filterFood("");
                viewModel.popupFoodStoreSource(baseFood);
            } else {
                viewModel.popupFoodStoreSource([]);
                filterFood(str);
                viewModel.popupFoodStoreSource(baseFood);
            }
        },

        //popup食品库 详细表示
        popupDetailVisibleClick: function (object) {
            if (object.model.flg == 1) {
                if (object.model.detailVisible()) {
                    object.model.detailVisible(false);
                } else {
                    object.model.detailVisible(true);
                }
            }
        },

        //popup食品库 选择食品
        popupSelectFoodClick: function (object) {
            var tempList = viewModel.popupSelectFoodSource();

            var repeatFlg = false;
            //重复check
            for (var i = 0; i < tempList.length; i++) {
                if (tempList[i].foodId == object.model.foodId) {
                    repeatFlg = true;
                    tempList[i].count += 1;
                    tempList[i].calorie += object.model.calorie;
                    tempList[i].display = tempList[i].name + " × " + tempList[i].count;
                    break;
                }
            }

            if (!repeatFlg) {
                tempList.push({
                    foodId: object.model.foodId,
                    name: object.model.foodName,
                    detail: object.model.detail,
                    count: 1,
                    calorie: object.model.calorie,
                    display: object.model.foodName + " × " + 1,
                });
            }
            viewModel.popupSelectFoodSource([]);
            viewModel.popupSelectFoodSource(tempList);

        },

        //popup食品库 选择食品删除
        popupFoodDeleteClick: function (object) {
            var tempList = viewModel.popupSelectFoodSource();
            for (i = 0; i < tempList.length; i++) {
                if (tempList[i].foodId == object.model.foodId) {
                    tempList.splice(i, 1);
                    viewModel.popupSelectFoodSource(tempList);
                    break;
                }
            }
        },

        //popup食品库 取消
        popupCancelClick: function () {
            var arr = viewModel.popupSelectFoodSource();
            addOtherFood(arr);
            viewModel.popupFoodStoreVisible(false);
            viewModel.popupSelectFoodSource([]);
            var arr = viewModel.popupFoodStoreSource();
            for (var i = 0; i < arr.length; i++) {
                arr[i].detailVisible(false);
            }
            viewModel.popupFoodStoreSource(arr);
        },

        //记录食品list 选择
        selectHealthFoodClick: function (object) {
            var tempList = viewModel.healthFoodSource();
            if (tempList[object.model.id].okCheck) {
                tempList[object.model.id].okCheck = "";
            } else {
                tempList[object.model.id].okCheck = "icon-light-ok";
            }
            viewModel.healthFoodSource([]);
            viewModel.healthFoodSource(tempList);
        },

        //其他食品list 删除
        foodItemDeleteClick: function (object) {
            var tempList = viewModel.otherFoodSource();
            for (i = 0; i < tempList.length; i++) {
                if (tempList[i].id == object.model.id) {
                    tempList.splice(i, 1);
                    viewModel.otherFoodSource(tempList);
                    break;
                }
            }
        },

        //选择食品 按钮
        selectClick: function () {
            viewModel.popupFoodStoreVisible(true);
        },

        //添加食品 按钮
        addOtherFoodClick1: function () {
            var arr = [];
            arr.push(randomFood[0]);
            addOtherFood(arr);
        },
        addOtherFoodClick2: function () {
            var arr = [];
            arr.push(randomFood[1]);
            addOtherFood(arr);
        },
        addOtherFoodClick3: function () {
            var arr = [];
            arr.push(randomFood[2]);
            addOtherFood(arr);
        },
        addOtherFoodClick4: function () {
            var arr = [];
            arr.push(randomFood[3]);
            addOtherFood(arr);
        },
        addOtherFoodClick5: function () {
            var arr = [];
            arr.push(randomFood[4]);
            addOtherFood(arr);
        },
        addOtherFoodClick6: function () {
            var arr = [];
            arr.push(randomFood[5]);
            addOtherFood(arr);
        },

        //画面init
        viewShown: function () {
            viewModel.popupPageVisible(true);

            if (params.record) {
                var recordData = $.parseJSON(params.record.replace('json:', ''));
                date = recordData.date;
                planId = recordData.planId;
                itemId = recordData.itemId;
                viewModel.day(Light.tool.getStandardDate(date));
                viewModel.itemType(recordData.itemType);
                viewModel.info(recordData.info);
                //健康食品list表示
                viewModel.healthFoodSource(recordData.healthList);
                //其他食品list表示
                viewModel.otherFoodSource(recordData.otherList);
                //随机食品表示
                randomFood = [];
                if (recordData.itemType !== 4) {
                    var tempFood = Light.config.randomFoodList[recordData.itemType - 1].food;
                    randomValue(tempFood[0].content);
                    randomValue(tempFood[1].content);
                    randomValue(tempFood[2].content);

                    viewModel.stapleTitle(tempFood[0].title);
                    viewModel.stapleName1(randomFood[0].name);
                    viewModel.stapleName2(randomFood[1].name);
                    viewModel.foodTitle(tempFood[1].title);
                    viewModel.foodName1(randomFood[2].name);
                    viewModel.foodName2(randomFood[3].name);
                    viewModel.soupTitle(tempFood[2].title);
                    viewModel.soupName1(randomFood[4].name);
                    viewModel.soupName2(randomFood[5].name);
                }

                //食品库取得
                setAllFood();

                viewModel.popupPageVisible(false);
                viewModel.pageVisible(true);

                switch (DevExpress.devices.real().platform) {
                    case "ios":
                        viewModel.popupTitleVisible(true);
                        break;
                    case "android":
                        viewModel.popupTitleVisible(false);
                        break;
                }

            }
        },
        viewHidden: function () {
            viewModel.pageVisible(false);
            Light.action.healthPlan.uploadToServer();
            Light.action.calorie.uploadToServer();
            Light.action.coin.uploadToServer();
        }

    };

    return viewModel;
};