﻿Light.Schedule = function (params) {

    //返回 按钮
    backClick = function (e) {
        if (params.scheduleBackFlg == 'TodayHC') {
            Light.app.navigate({ view: 'TodayHC' });
        } else {
            Light.app.navigate('Home', { root: true });
        }
    };

    scheduleClick = function (e) {
        var dateList = viewModel.dateSource();
        Light.app.navigate({ view: 'ScheduleMonth', scheduleBackFlg: params.scheduleBackFlg, date: dateList[3].date });
    }

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: Globalize.localize('home-schedule') },
            { location: 'after', widget: 'button', options: { icon: 'light-timeline', clickAction: scheduleClick } },
    ];

    //
    Light.Schedule.shown = function () {
        viewModel.popupPageVisible(true);
        var intDate = Light.rtdata.notification_onstart_datetime.substring(0, 8);
        var date = Light.tool.getStandardDate(intDate);
        setDate(Globalize.format(date, "yyyy/MM/dd"));
        setScheduleData(date);
    };

    //数据保存
    function saveData(reList, dataFlg) {
        //date, planid, itemid, recordlist,
        var recordList = [];
        if (dataFlg) {
            recordList.push({
                itemType: reList.itemType,
                id: '',
                name: '',
                detail: '',
                dtlType: 1,
                dtlKbn: 1,
                dtlNum: 1,
                calorie: 0,
            });
        }

        Light.action.healthPlan.record(reList.date, reList.planId, reList.itemId, recordList,
                function () { Light.action.recordActivyDate(); },
                function () { });
    };

    //时间轴数据取得
    function setScheduleData(date) {
        var inDate = Globalize.format(new Date(date), 'yyyyMMdd');

        var done = function (rt) {
            viewModel.popupPageVisible(false);
            viewModel.pageVisible(true);

            if (rt == 1) {
                viewModel.scheduleSource(Light.ScheduleData.scheduleList);
            }


            //提醒显示
            if (Light.rtdata.notification_onstart_flag == 1) {
                Light.rtdata.notification_onstart_flag = 0;
                var time = Light.rtdata.notification_onstart_datetime.substring(8, 12);
                var notifyId = '';
                if (Light.rtdata.notification_onstart_type == 'health') {
                    notifyId = 'notify' + Globalize.parseInt(time + '') + Light.rtdata.notification_onstart_type_detail;
                } else {
                    notifyId = 'notify' + Globalize.parseInt(time + '') + 0;
                }
                $(".schedule #" + notifyId).css("color", 'red');
            }
           
            setTimeout(setScrollView(), 500);
            
        }
        Light.ScheduleData.getPlanList(inDate, done);

    };

    //调整scroll视区大小.
    function setScrollView() {
        //调整scroll视区大小.
        function getTop(e) {
            var offset = e.offsetTop;
            if (e.offsetParent != null) offset += getTop(e.offsetParent);
            return offset;
        }
        var clientHeight = parseInt($(window).height());
        $(".schedule .dx-scrollable").each(function () {
            $(this).css("height", parseInt(-getTop(this)) % clientHeight + clientHeight + "px");
        });
    }

    //日期表示
    function setDate(date) {
        var week;
        var day;
        var dateList = [];
        for (var i = 0; i < 7; i++) {
            var tmpDate = new Date(date);
            tmpDate.setDate(tmpDate.getDate() + i - 3);
            week = Light.config.weekAbbList[tmpDate.getDay()].name;
            day = tmpDate.getDate();

            dateList.push({
                id: i,
                week: week,
                day: day,
                dotCss: "",
                month: Globalize.format(tmpDate, "yyyy年MM月"),
                date: Globalize.format(tmpDate, "yyyy/MM/dd"),
                abbrDate: Globalize.format(tmpDate, "yyyyMMdd"),
            });
        }

        var currentDate = Globalize.format(new Date(), "yyyyMMdd");
        var done = function (items) {
            for (var i = 0; i < 7; i++) {
                for (var k = 0; k < items.length; k++) {
                    if ((dateList[i].abbrDate >= items[k].planStartDate) && (dateList[i].abbrDate <= items[k].planEndDate)) {
                        if (dateList[i].abbrDate < currentDate) {
                            dateList[i].dotCss = "dot gray";
                        } else {
                            dateList[i].dotCss = "dot";
                        }
                        break;
                    }
                }
            }
            viewModel.dateSource(dateList);
            setTimeout(setScrollView(), 500);
        }
        Light.action.healthPlan.getPlanByPeriod(dateList[0].abbrDate, dateList[6].abbrDate, done, function () { });
     
    };

    var viewModel = {
        pageVisible: ko.observable(false),
        popupPageVisible: ko.observable(false),

        dateSource: ko.observable([]),
        scheduleSource: ko.observable([]),
        completeTooltipVisible: ko.observable(false),
        isViewShown: ko.observable(false),
        isCompleteDate: ko.observable(false),
        isCompleteData: ko.observable(false),

        //日期 按钮
        dateClick: function (object) {
            if (object.model.id !== 3) {
                viewModel.popupPageVisible(true);

                setDate(object.model.date);
                setScheduleData(object.model.date);
            }
        },

        //list行 记录编辑
        selectRecordClick: function (object) {
            var today = Globalize.format(new Date(), "yyyyMMdd");
            var dateList = viewModel.dateSource();
            switch (object.model.itemType) {
                case 0:
                    //吃药
                    if (dateList[3].abbrDate <= today) {
                        Light.app.navigate({ view: "MedicineRecord", record: Light.ScheduleData.medicineRecordList[object.model.recordId], title: object.model.title, scheduleBackFlg: params.scheduleBackFlg });
                    }
                    break;

                case 1:
                case 2:
                case 3:
                case 4:
                    //吃饭
                    if (dateList[3].abbrDate <= today) {
                        Light.app.navigate({ view: "FoodRecord", record: Light.ScheduleData.healthRecordList[object.model.recordId], title: object.model.title, scheduleBackFlg: params.scheduleBackFlg });
                    }
                    break;

                case 5:
                    //运动
                    if (dateList[3].abbrDate <= today) {
                        Light.app.navigate({ view: "SportsRecord", record: Light.ScheduleData.healthRecordList[object.model.recordId], title: object.model.title, scheduleBackFlg: params.scheduleBackFlg });
                    }
                    break;

                case 6:
                case 7:
                    //健康记录
                    if (dateList[3].abbrDate == today) {
                        //Light.action.coin.record(4, function () { }, function () { });//move to health savedata
                        saveData(Light.ScheduleData.healthRecordList[object.model.recordId], true);
                        Light.app.navigate({ view: "Health", actionKbn: 'weight', healthBackFlg: 'Schedule', scheduleBackFlg: params.scheduleBackFlg });
                    } else if(dateList[3].abbrDate < today){
                        DevExpress.ui.notify("以前的称重记录不能更改。", "info", 1500);
                    }
                    break;
                case 12:
                    //轻盈小点
                    if (dateList[3].abbrDate <= today) {
                        var flg = false;
                        if (object.model.recordFlg() == 0) {
                            object.model.recordFlg(1);
                            object.model.typeImg(object.model.ImgSource[1]);
                            flg = true;
                        } else {
                            object.model.recordFlg(0);
                            object.model.typeImg(object.model.ImgSource[0]);
                            flg = false;
                        }
                        saveData(Light.ScheduleData.healthRecordList[object.model.recordId], flg);
                    }
                    break;
                case 20:
                case 21:
                case 22:
                case 23:
                case 24:
                    //喝水,刷牙
                    if (dateList[3].abbrDate <= today) {
                        var flg = false;
                        if (object.model.recordFlg() == 0) {
                            object.model.recordFlg(1);
                            object.model.typeImg(object.model.ImgSource[1]);
                            flg = true;
                        } else {
                            object.model.recordFlg(0);
                            object.model.typeImg(object.model.ImgSource[0]);
                            flg = false;
                        }
                        if (object.model.itemType == 24) {
                            Light.action.coin.record(2, function () { }, function () { });
                        }
                        saveData(Light.ScheduleData.healthRecordList[object.model.recordId], flg);
                    }
                    break;
            }
        },

        //完整信息显示
        completeTooltip: function (object) {
            object.model.completeTooltipVisible(true);
            setTimeout(function () { object.model.completeTooltipVisible(false) }, 4000);
        },

        //画面init
        viewShown: function () {
            viewModel.popupPageVisible(true);

            if (Light.rtdata.notification_onstart_flag == 1) {
                //提醒显示
                var intDate = Light.rtdata.notification_onstart_datetime.substring(0, 8);
                var date = Light.tool.getStandardDate(intDate);
                setDate(Globalize.format(date, "yyyy/MM/dd"));
                setScheduleData(date);

            } else {
                //正常显示
                Light.rtdata.notification_onstart_flag = 0;
                if (params.date) {
                    var date = Light.tool.getStandardDate(params.date);
                    setDate(Globalize.format(date, "yyyy/MM/dd"));
                    setScheduleData(date);
                } else {
                    var date = new Date();
                    setDate(Globalize.format(date, "yyyy/MM/dd"));
                    setScheduleData(date);
                }
            }
            setTimeout(setScrollView(), 500);
        },

        viewHidden: function () {
            viewModel.pageVisible(false);
            Light.action.healthPlan.uploadToServer();
            Light.action.coin.uploadToServer();
        }
    };


    return viewModel;
};