﻿Light.ScheduleMonth = function (params) {

    //返回 按钮
    backClick = function (e) {
        if (params.scheduleBackFlg == 'TodayHC') {
            Light.app.navigate({ view: 'TodayHC' });
        } else {
            Light.app.navigate('Home', { root: true });
        }
    };

    scheduleClick = function (e) {
        Light.app.navigate({ view: 'Schedule', scheduleBackFlg: params.scheduleBackFlg, date: Globalize.format(defaultDate, "yyyy/MM/dd") });
    }

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: Globalize.localize('home-schedule') },
            { location: 'after', widget: 'button', options: { icon: 'light-timeline1', clickAction: scheduleClick } },
    ];

    //
    var selectYear = 0;
    var defaultDate = new Date();
    var today = Globalize.format(new Date(), "yyyyMMdd");

    //数据保存
    function saveData(reList, dataFlg) {
        //date, planid, itemid, recordlist,
        var recordList = [];
        if (dataFlg) {
            recordList.push({
                itemType: reList.itemType,
                id: '',
                name: '',
                detail: '',
                dtlType: 1,
                dtlKbn: 1,
                dtlNum: 1,
                calorie: 0,
            });
        }

        Light.action.healthPlan.record(reList.date, reList.planId, reList.itemId, recordList,
                function () { Light.action.recordActivyDate(); },
                function () { });
    };

    //时间轴数据取得
    function setScheduleData() {
        date = Globalize.format(defaultDate, 'yyyyMMdd');

        var done = function (rt) {
            viewModel.popupPageVisible(false);
            viewModel.pageVisible(true);

            if (rt == 1) {    
                viewModel.scheduleSource(Light.ScheduleData.scheduleList);
            }

            setTimeout(setScrollView(), 500);

        }
        Light.ScheduleData.getPlanList(date, done);
    };

    function setScrollView() {
        //调整scroll视区大小.
        function getTop(e) {
            var offset = e.offsetTop;
            if (e.offsetParent != null) offset += getTop(e.offsetParent);
            return offset;
        }
        var clientHeight = parseInt($(window).height());
        $(".scheduleMonth .dx-scrollable").each(function () {
            $(this).css("height", parseInt(-getTop(this)) % clientHeight + clientHeight + "px");
        });
    }
   

    var viewModel = {
        pageVisible: ko.observable(false),
        popupPageVisible: ko.observable(false),

        scheduleSource: ko.observable([]),
        completeTooltipVisible: ko.observable(false),

        //月变化
        monthClick: function (year, month, inst) {

            if (selectYear != 0) {
                //日历第一次绑定 以外的场合
                defaultDate = new Date(year, month, 1);
                inst.setVal(defaultDate);
            }
            setScheduleData();

            //marked 设置
            if (selectYear != year) {
                selectYear = year;
                var startDate = Globalize.format(new Date(year, 0, 1), "yyyyMMdd");
                var endDate = Globalize.format(new Date(year + 1, 0, 1), "yyyyMMdd");

                var done = function (items) {
                    var marked = [];

                    for (var i = 0; i < items.length; i++) {
                        var date = items[i].planStartDate;

                        while (date <= items[i].planEndDate) {
                            if (date < today) {
                                marked.push({
                                    d: new Date(Light.tool.getStandardDate(date)),
                                    color: 'gray',
                                });
                            } else {
                                marked.push({
                                    d: new Date(Light.tool.getStandardDate(date)),
                                    color: '#8CF0E5',
                                });
                            }

                            var standardDate = new Date(Light.tool.getStandardDate(date));
                            standardDate.setDate(standardDate.getDate() + 1);
                            date = Globalize.format(standardDate, "yyyyMMdd");
                        }
                        setTimeout(setScrollView(), 500);
                    }

                    inst.settings.marked = [];
                    inst.settings.marked = marked;
                    inst.refresh();
                }
                Light.action.healthPlan.getPlanByPeriod(startDate, endDate, done, function () { });
            }
            
        },

        //日期选择
        dayClick: function (day, inst) {
            defaultDate = day.date;
            viewModel.popupPageVisible(true);

            setScheduleData();
        },

        //list行 记录编辑
        selectRecordClick: function (object) {
            var tempDate = Globalize.format(new Date(defaultDate), "yyyyMMdd");
            switch (object.model.itemType) {
                case 0:
                    //吃药
                    if (tempDate <= today) {
                        Light.app.navigate({ view: "MedicineRecord", record: Light.ScheduleData.medicineRecordList[object.model.recordId], title: object.model.title, scheduleBackFlg: params.scheduleBackFlg });
                    }
                    break;

                case 1:
                case 2:
                case 3:
                case 4:
                    //吃饭
                    if (tempDate <= today) {
                        Light.app.navigate({ view: "FoodRecord", record: Light.ScheduleData.healthRecordList[object.model.recordId], title: object.model.title, scheduleBackFlg: params.scheduleBackFlg });
                    }
                    break;

                case 5:
                    //运动
                    if (tempDate <= today) {
                        Light.app.navigate({ view: "SportsRecord", record: Light.ScheduleData.healthRecordList[object.model.recordId], title: object.model.title, scheduleBackFlg: params.scheduleBackFlg });
                    }
                    break;

                case 6:
                case 7:
                    //健康记录
                    if (tempDate == today) {
                        //Light.action.coin.record(4, function () { }, function () { });//move to health savedata
                        saveData(Light.ScheduleData.healthRecordList[object.model.recordId], true);
                        Light.app.navigate({ view: "Health", actionKbn: 'weight', healthBackFlg: 'Schedule', scheduleBackFlg: params.scheduleBackFlg });
                    } else if (tempDate < today) {
                        DevExpress.ui.notify("以前的称重记录不能更改。", "info", 1500);
                    }
                    break;
                case 12:
                    //轻盈小点
                    if (tempDate <= today) {
                        var flg = false;
                        if (object.model.recordFlg() == 0) {
                            object.model.recordFlg(1);
                            object.model.typeImg(object.model.ImgSource[1]);
                            flg = true;
                        } else {
                            object.model.recordFlg(0);
                            object.model.typeImg(object.model.ImgSource[0]);
                            flg = false;
                        }
                        saveData(Light.ScheduleData.healthRecordList[object.model.recordId], flg);
                    }
                    break;
                case 20:
                case 21:
                case 22:
                case 23:
                case 24:
                    //喝水,刷牙
                    if (tempDate <= today) {
                        var flg = false;
                        if (object.model.recordFlg() == 0) {
                            object.model.recordFlg(1);
                            object.model.typeImg(object.model.ImgSource[1]);
                            flg = true;
                        } else {
                            object.model.recordFlg(0);
                            object.model.typeImg(object.model.ImgSource[0]);
                            flg = false;
                        }

                        if (object.model.itemType == 24) {
                            Light.action.coin.record(2, function () { }, function () { });
                        }
                        saveData(Light.ScheduleData.healthRecordList[object.model.recordId], flg);
                    }
                    break;
            }
        },

        //完整信息显示
        completeTooltip: function (object) {
            object.model.completeTooltipVisible(true);
            setTimeout(function () { object.model.completeTooltipVisible(false) }, 4000);
        },

        //画面init
        viewShown: function () {
            viewModel.popupPageVisible(true);

            viewModel.scheduleSource([]);
            $('.scheduleMonth #calendar').mobiscroll().calendar({});

            defaultDate = new Date();
            if (params.date) {
                defaultDate = new Date(params.date);
            }

            selectYear = 0;
            $('.scheduleMonth #calendar').mobiscroll().calendar({
                theme: 'mobiscroll',
                display: 'inline',
                layout: 'liquid',
                lang: 'zh',
                firstDay: 0,
                quickNav: false,
                defaultValue: defaultDate,
                markedText: true,
                calendarHeight: 182,
                monthNamesShort: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
                marked: [],
                onMonthLoaded: viewModel.monthClick,
                onDayChange: viewModel.dayClick,
            });
            setTimeout(setScrollView(), 500);
        },

        viewHidden: function () {
            viewModel.pageVisible(false);
            Light.action.healthPlan.uploadToServer();
            Light.action.coin.uploadToServer();
        }

    };

    return viewModel;
};