﻿Light.SportsRecord = function (params) {

    //返回 按钮
    backClick = function (e) {
        saveData(1);
    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: params.title + Globalize.localize('home-record') },
    ];

    var date;
    var planId;
    var itemId;
    var itemType;

    //卡路里数据计算
    function saveCalorieData(date) {
        Light.action.calorie.renewCalorieOneDate(
            date,
            function () { },
            function () { });
    }
    
    //数据保存
    function saveData(flg) {
        //date, planid, itemid, recordlist,
        var recordList = [];
        var otherSportsList = viewModel.otherSportsSource();

        for (var i = 0; i < otherSportsList.length; i++) {
            recordList.push({
                itemType: itemType,
                id: otherSportsList[i].id,
                name: otherSportsList[i].name,
                detail: otherSportsList[i].detail,
                count: 1,
                dtlType: 2,
                dtlKbn: 2,
                dtlNum: 1,
                calorie: otherSportsList[i].calorie,
            });
        }

        Light.action.healthPlan.record(date, planId, itemId, recordList,
                function () {
                    Light.action.coin.record(3, function () { }, function () { });
                    Light.action.recordActivyDate();
                    saveCalorieData(date);

                    if (flg == 1) {
                        Light.app.navigate({ view: 'Schedule', scheduleBackFlg: params.scheduleBackFlg, date: date });
                    } else if (flg == 2) {
                        if (viewModel.healthSportsVisible()) {
                            Light.app.navigate({ view: 'Health', actionKbn: 'sports', recordList: otherSportsList, record: params.record, title: params.title, healthBackFlg: 'SportsRecord', scheduleBackFlg: params.scheduleBackFlg });
                        }
                    }
                },
                function () { });
    };

    //运动项目取得
    function setAllSports() {
        var done = function (items) {
            if (items.length > 0) {
                viewModel.popupSelectSportsTypeSource = items;
            }
        }

        Light.action.movement.getMovementList(done, function () { });
    };

    //
    var viewModel = {
        pageVisible: ko.observable(false),
        popupPageVisible: ko.observable(false),

        day: ko.observable(''),
        healthSportsName: ko.observable(''),
        healthSportsListVisible: ko.observable(true),
        healthSportsVisible: ko.observable(false),
        otherSportsSource: ko.observable([]), 

        popupSportAddVisible: ko.observable(false),
        popupSportsTypeSelector: ko.observable(),
        popupSportMinuteSelector: ko.observable(),
        popupSelectSportsTypeSource: [],
        popupSelectMinuteSource: Light.config.sportTimeList,
    
        //健康数据 画面跳转
        healthClick: function () {
            saveData(2);
        },

        //添加运动按钮
        sportAddClick: function () {
            viewModel.popupSportsTypeSelector(1);
            viewModel.popupSportMinuteSelector(1);
            viewModel.popupSportAddVisible(true);
        },

        //添加运动popup 确定按钮
        popupSprotConfirmClick:function(){
            var id = Globalize.parseInt(viewModel.popupSportsTypeSelector() + '');
            var minuteId = Globalize.parseInt(viewModel.popupSportMinuteSelector() + '');

            var tempList = viewModel.otherSportsSource();
            var len = tempList.length;
            var temp = {
                rowNO: len,
                id: id, //运动ID
                name: viewModel.popupSelectSportsTypeSource[id - 1].movementName, //运动名称
                detail: viewModel.popupSelectMinuteSource[minuteId - 1].text, //运动详细时间
                calorie: viewModel.popupSelectSportsTypeSource[id - 1].calorie * minuteId,
            };
            tempList.push(temp);
            viewModel.otherSportsSource(tempList);
            viewModel.popupSportAddVisible(false);
        },

        //popup 取消按钮
        popupCancelClick:function(){
            viewModel.popupSportAddVisible(false);
        },

        //自定义运动list 删除
        sportItemDeleteClick: function (object) {
            var tempList = viewModel.otherSportsSource();
            var no = object.model.rowNO;
            //删除
            tempList.splice(no, 1);
            
            //排序
            for (i = no; i < tempList.length; i++) {
                tempList[i].rowNO = i;
            }

            viewModel.otherSportsSource(tempList);
        },

        //画面init
        viewShown: function () {
            viewModel.popupPageVisible(true);

            if (params.record) {
                var recordData = $.parseJSON(params.record.replace('json:', ''));
                date = recordData.date;
                planId = recordData.planId;
                itemId = recordData.itemId;
                itemType = recordData.itemType;
                viewModel.day(Light.tool.getStandardDate(date));

                var now = Globalize.format(new Date(), "yyyyMMdd");
                if (now == date) {
                    viewModel.healthSportsVisible(true);
                } else {
                    viewModel.healthSportsVisible(false);
                }
                
                //方案运动list表示
                viewModel.healthSportsListVisible(true);
                if (recordData.healthList.length > 0) {
                    viewModel.healthSportsName("目标：" + recordData.healthList[0].name);
                } else {
                    if (now == date) {
                        viewModel.healthSportsName("运动数据同步");
                    } else {
                        viewModel.healthSportsListVisible(false);
                    }
                    
                }
                
                //其他运动list表示
                viewModel.otherSportsSource(recordData.otherList);
            }

            if (params.recordList) {
                var recordList = $.parseJSON(params.recordList.replace('json:', ''));
                //其他运动list表示
                viewModel.otherSportsSource(recordList);
            }

            //选择运动项目取得
            setAllSports();

            viewModel.popupPageVisible(false);
            viewModel.pageVisible(true);

        },
        viewHidden: function () {
            viewModel.pageVisible(false);
            Light.action.healthPlan.uploadToServer();
            Light.action.calorie.uploadToServer();
            Light.action.coin.uploadToServer();
        }
    };

    return viewModel;
};