﻿Light.Shake = function (params) {

    var pages = [];
    var ibeacons = '';
    var uuid = '';

    var shakeFlg = true;
    var audio = new Audio('resource/sound/shake.mp3');

    //摇动动画
    var tagheight = 25;
    var height = 0;
    var flg = true;
    var MyMar;
    function Marquee() {
        if (flg) {
            if (tagheight > height) {
                height += 1;
                $("#top").css("height", (100 - height * 2) + '%');
                $("#bottom").css("margin-top",height + '%');

            } else {
                setTimeout(function () {
                    tagheight = 0;
                    flg = false;
                }, 300);
            }
        } else {
            if (tagheight < height) {
                height -= 1;
                $("#top").css("height", (100 - height * 2) + '%');
                $("#bottom").css("margin-top", height + '%');

            } else {

                clearInterval(MyMar);
                flg = true;
                shakeFlg = true;

                //声音
                switch (DevExpress.devices.real().platform) {
                    case "ios":
                        if (!audio.paused) {
                            audio.pause();
                        }
                        break;
                    case "android":
                        if (window.plugins && window.plugins.Func) {
                            window.plugins.Func.stopSound();
                        }
                        break
                }

                //随机页面
                var n1 = Math.floor(Math.random() * pages.length);
                var record = [];
                record.push(pages[n1]);
                viewModel.popupPageSource(record);
                viewModel.popupPageVisible(true);
               
            }
        }
        
    };

    //Shake plugin
    function onShake() {
        if (shakeFlg) {
            if (pages.length > 0) {
                shakeFlg = false;
                //初期值设定
                tagheight = 25;
                height = 0;
                flg = true;

                viewModel.popupPageVisible(false);
                MyMar = setInterval(Marquee, 5);

                //声音
                switch (DevExpress.devices.real().platform) {
                    case "ios":
                        if (!audio.paused) {
                            audio.pause();
                        }
                        audio.play();
                        break;
                    case "android":
                        if (window.plugins && window.plugins.Func) {
                            window.plugins.Func.playSound();
                        }
                        break
                }

            } else {
                var vis = viewModel.roundVisible();
                if (!vis) {
                    DevExpress.ui.notify('周边未找到ibeacon设备', "info", 2000);
                }              
            }
        }
        
    };

    //page data
    function setPagesData(rt) {
        var record = {
            uuid: rt.UUID,
            major: rt.Major,
            minor: rt.Minor,
        };
        
        var done = function (items) {
            for (i = 0; i < items.length; i++) {
                pages.push({
                    uuid: items[i].uuid,
                    major: items[i].major,
                    minor: items[i].minor,
                    title: items[i].mainTitle,
                    subtitle: items[i].subHead,
                    img_picture: Light.config.APP_SERVER_URL + items[i].thumbnailUrl,
                    openURL: items[i].jumpUrl,
                    comments: items[i].comments,
                });
            }
        }

        Light.action.ibeacon.serverGetIbeacon(record, done, function () { });
    };

    //ibeaocn plugin
    function onRangingIbeacon(data) {
        viewModel.roundVisible(true);
        viewModel.round_icon('./resource/icon/round_w.png');
        $(".shake .icon .text").css("color", '#FFF');

        for (i = 0; i < data.length; i++) {
            var str = ',' + data[i].UUID + data[i].Major + data[i].Minor;
            if (ibeacons.indexOf(str) == -1) {
                ibeacons += str;
                setPagesData(data[i]);
            }
        }
    };

    //ibeaocn plugin
    function onSetData(data) {
        window.plugins.ibeacon.startRangingIbeaconsInRegion(onRangingIbeacon);
    };

    var viewModel = {
        roundVisible: ko.observable(false),
        round_icon: ko.observable('./resource/icon/round_g.png'),

        popupPageVisible: ko.observable(false),
        popupPageSource: ko.observable([]),

        //popup 商品选择
        popupPageSelectClick: function (object) {
            viewModel.popupPageVisible(false);

            if (object.model.openURL.indexOf("51jk.cc") != -1) {
                var url = object.model.openURL;
                Light.action.favoriteAndToShop(url);

                /* move to action.favoriteAndshow
                switch (DevExpress.devices.real().platform) {
                    case "ios":
                        Light.action.serverTo51jkIos(Light.rtdata.memberAcc, url);
                        break;
                    case "android":
                        var fullurl = Light.action.serverTo51jkAndroid(Light.rtdata.memberAcc, url);
                        Light.app.navigate({view:'Shop', url:fullurl}, { root: true });
                        break;
                    default :
                        if (window.plugins && window.plugins.seioinappbrowser) {
                            window.plugins.seioinappbrowser(url, "_system", "location=no");
                        } else if (window.open) {
                            window.open(url, "_system", 'location=no');
                        }
                        break;
                }
                */
            } else {
                switch (DevExpress.devices.real().platform) {
                    case "ios":
                        Light.app.navigate({ view: "IbeaconPage_ios", openURL: object.model.openURL, title: object.model.title });
                        break;
                    case "android":
                        Light.app.navigate({ view: "IbeaconPage_android", openURL: object.model.openURL, title: object.model.title });
                        break
                }
            }
        },

        //画面init
        viewShown: function () {
            viewModel.roundVisible(false);
            viewModel.round_icon('./resource/icon/round_g.png');
            $(".shake .icon .text").css("color", '#98F1EF');

            pages = [];
            ibeacons = '';
            shakeFlg = true;
            uuid = '';
            if (window.plugins) {
                shake.startWatch(onShake, 30);
            }

            /* popup test
            var tmp = [];
            tmp.push({
                title: 'fsafsafafas',
                subtitle: 'erwerwqreqwrq',
                img_picture: Light.config.imgHeadList[0].src,
            });
            viewModel.popupPageSource(tmp);
            viewModel.popupPageVisible(true);
            */

            var done = function (items) {
                var arrUUID = [];
                for (i = 0; i < items.length; i++) {
                    if (i > 4) break;
                    arrUUID.push(items[i].uuid);
                }
                if (arrUUID.length > 0) {
                    if (window.plugins && window.plugins.ibeacon) {
                        window.plugins.ibeacon.setData(arrUUID, onSetData);
                    }
                }
            }
            Light.action.ibeacon.serverGetIbeaconUUID('', done, function () { });
        },

        viewHidden: function () {
            viewModel.popupPageVisible(false);
            viewModel.roundVisible(false);
            viewModel.round_icon('./resource/icon/round_g.png');
            $(".shake .icon .text").css("color", '#97F1F0');

            if (window.plugins) {
                shake.stopWatch();
            }
            if (window.plugins && window.plugins.ibeacon) {
                window.plugins.ibeacon.stopRangingIbeaconsInRegion();  
            }
        }

    };

    return viewModel;
};