﻿Light.Activity = function (params) {
    //返回按钮
    backClick = function (e) {
        Light.tool.toPartnerMessageList();
    };

    //menu按钮
    menuClick = function (e) {
        viewModel.contextMenuVisible(true);
    },

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: Globalize.localize('partner-activity') },
            { location: 'after', widget: 'button', options: { icon: 'light-plus', clickAction: menuClick } },
    ];

    var activityStateCss = ['deleted', 'onrun', 'ended', 'verify', '', '', '', '', 'deny', 'report', ];
    var joinStateCss = [
        { joinStateText: '', joinState: 'flg' },
        { joinStateText: '已报名', joinState: 'flg joined' },
        { joinStateText: '我要参加', joinState: 'flg join' },
    ]

    //活动 取得
    function setActivityData() {

        viewModel.activityNoDataText('');
        viewModel.activitySource.store().clear();
        viewModel.activitySource.pageIndex(0);
        viewModel.activitySource.load();

        var activityDone = function (data) {

            viewModel.popupPageVisible(true);

            //参加的活动
            var strJoinId = '';
            for (var i = 0; i < data.length; i++){
                strJoinId += data[i].id + ',';
            }

            var activityAllDone = function (data) {
                //全部活动
                var flg = 0;// 0 自己 1 参加 2 未参加
                var start = new Date();
                var end = new Date();
                var disdate = '';

                if (data.length > 0) {
                    for (i = 0; i < data.length; i++) {

                        if (data[i].get('activityCreaterId') == Light.rtdata.leanCloudSocialId) {
                            //发布的活动
                            flg = 0;
                        } else {
                            //1：活动参加者  2：活动未参加者
                            flg = 1;
                            if (strJoinId.indexOf(data[i].id + ',') == -1) {
                                flg = 2;
                            }
                        }

                        start = data[i].get('activityTime');
                        end = data[i].get('activityEndTime');
                        disdate = Light.tool.getActivityDate(start, end);

                        var state = activityStateCss[data[i].get('activityStatus')];
                        if ((data[i].get('activityStatus') == 1) && (end < new Date())) {
                            state = activityStateCss[2];
                        }

                        viewModel.activitySource.store().insert({
                            id: i,
                            createrId: data[i].get('activityCreaterId'),
                            activityId: data[i].id,
                            img_picture: data[i].get('activityImg'),
                            name: data[i].get('activityName'),
                            addr: data[i].get('activityAdress'),
                            startDate: start,
                            endDate: end,
                            display_date: disdate,
                            state: state,
                            membersCnt: data[i].get('activityMembersCnt') + '人已参加',
                            content: data[i].get('activityContent'),
                            joinStateText: joinStateCss[flg].joinStateText,
                            joinState: joinStateCss[flg].joinState,
                        });
                    }

                    viewModel.popupPageVisible(false);
                    viewModel.activitySource.pageIndex(0);
                    viewModel.activitySource.load();

                } else {

                    viewModel.popupPageVisible(false);
                    viewModel.activityNoDataText(Globalize.localize('partner-activityMessage-noData_onrun'));
                }
            }

            Light.action.leancloud.activity.getRecent2(activityAllDone, function () { viewModel.activityNoDataText(Globalize.localize('partner-activityMessage-noData_onrun')); });
        }

        Light.action.leancloud.activity.getJoinedOnlyId(activityDone, function () { viewModel.activityNoDataText(Globalize.localize('partner-activityMessage-noData_onrun')); });
    };
    function checkNetState() {
        viewModel.img_info('');
        viewModel.infoText('');

        //网络check
        if (Light.network.checkConnection()) {
            viewModel.networkFlg(true);
        } else {
            viewModel.networkFlg(false);
        }

        if (viewModel.networkFlg()) {
            //有网络
            viewModel.networkFlg(true);
            viewModel.img_info('');
            viewModel.infoText('');
            setActivityData();
        } else {
            //无网络
            viewModel.img_info('./resource/img/noNetwork.gif');
            viewModel.infoText(Globalize.localize('profile-network-disconnect'));
            return;
        }
    }
    var viewModel = {
        menuItems: Light.config.activityMenuList,
        contextMenuVisible: ko.observable(false),

        popupPageVisible: ko.observable(false),
        networkFlg: ko.observable(true),
        img_info: ko.observable(''),
        infoText: ko.observable(''),
        //页面刷新
        refreshClick: function () {
            checkNetState();
        },
        activityNoDataText: ko.observable(''),
        activitySource: new DevExpress.data.DataSource({
            store: [],
            pageSize: 10
        }),

        //menu 详细
        menuItemClicked: function (e) {
            switch (e.itemData.text) {
                case Globalize.localize('partner-activityCreate'):
                    //创建活动
                    Light.app.navigate({ view: 'ActivityCreate', viewFlg: 0 });
                    break;

                case Globalize.localize('partner-activityMyself'):
                    //我的活动
                    Light.rtdata.activityPage = 'Activity';
                    Light.app.navigate('ActivityMyself');
                    break;
            }
        },

        //活动 item
        activitySelectClick: function (e) {
            Light.app.navigate({ view: 'ActivityDetail', activityId: e.itemData.activityId });
        },

        //活动 下拉更新
        updataActivityListClick: function () {
            setActivityData();
        },

        //画面init
        viewShown: function (params) {
            checkNetState();
            // if (Light.rtdata.activityPage == 'Partner') {
            // }
            //setActivityData();
        },

    };
    return viewModel;
};