﻿Light.ActivityCreate = function (params) {

    //返回 按钮
    backClick = function (e) {
        if (params.viewFlg == 0) {
            //创建活动
            DevExpress.hardwareBackButton.fire();
        } else if (params.viewFlg == 1) {
            //编辑活动
            saveData();
        }
        
    };

    //删除 按钮
    deleteClick = function (e) {
        viewModel.popupDeleteVisible(true);
    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', visible: params.viewFlg == 0, text: Globalize.localize('partner-activityCreate') },
            { location: 'center', visible: params.viewFlg == 1, text: Globalize.localize('partner-activityEdit') },
            { location: 'after', widget: 'button', options: { icon: 'light-remove', visible: params.viewFlg == 1, clickAction: deleteClick } },
    ];

    var activityId = '';
    var saveFlg = true;

    //数据保存
    function saveData() {

        if (Light.tool.trim(viewModel.input_name()) == '') {
            DevExpress.ui.notify(Globalize.localize('partner-activityName') + Globalize.localize('message-notNull'), "error", 2000);

        } else if (Light.tool.trim(viewModel.input_addr()) == '') {
            DevExpress.ui.notify(Globalize.localize('partner-activityAddr') + Globalize.localize('message-notNull'), "error", 2000);

        } else if (viewModel.input_startDate() == '') {
            DevExpress.ui.notify(Globalize.localize('partner-activityStartDate') + Globalize.localize('message-notNull'), "error", 2000);

        } else if (viewModel.input_endDate() == '') {
            DevExpress.ui.notify(Globalize.localize('partner-activityEndDate') + Globalize.localize('message-notNull'), "error", 2000);

        } else if (Light.tool.trim(viewModel.input_content()) == '') {
            DevExpress.ui.notify(Globalize.localize('partner-activityContent') + Globalize.localize('message-notNull'), "error", 2000);

        } else if ((params.viewFlg == 0) && (viewModel.input_startDate() < new Date())) {
            DevExpress.ui.notify(Globalize.localize('partner-activityMessage-startDate_error'), "error", 2000);

        } else if (viewModel.input_startDate() >= viewModel.input_endDate()) {
            DevExpress.ui.notify(Globalize.localize('message-dateCompare'), "error", 2000);

        } else {
            //保存
            var record = '';
            if (params.viewFlg == 0) {
                //新建
                record = {
                    activityImg: viewModel.img_picture(),
                    activityName: viewModel.input_name(),
                    activityAdress: viewModel.input_addr(),
                    activityTime: viewModel.input_startDate(),
                    activityEndTime: viewModel.input_endDate(),
                    activityType: 0,
                    activityContent: viewModel.input_content(),
                };
                //仅保存一次
                if (saveFlg) {
                    saveFlg = false;
                    Light.action.leancloud.activity.create(record,
                                        function (data) { DevExpress.hardwareBackButton.fire(); }, function () { });
                }
                

            } else if (params.viewFlg == 1) {
                //更新
                record = {
                    id: activityId,
                    img: viewModel.img_picture(),
                    name: viewModel.input_name(),
                    address: viewModel.input_addr(),
                    time: viewModel.input_startDate(),
                    endTime: viewModel.input_endDate(),
                    content: viewModel.input_content(),
                };
                //仅保存一次
                if (saveFlg) {
                    saveFlg = false;
                    Light.action.leancloud.activity.update(record,
                        function (data) { DevExpress.hardwareBackButton.fire(); }, function () { });
                }
                
            }
        }
    };

    var viewModel = {
        now: new Date(),
        releaseVisible: ko.observable(false),
        img_picture: ko.observable(''),
        input_name: ko.observable(''),
        input_addr: ko.observable(''),
        input_startDate: ko.observable(''),
        display_startDate: ko.observable(''),
        input_endDate: ko.observable(''),
        display_endDate: ko.observable(''),
        input_content: ko.observable(''),
        startOrEnd:ko.observable(''),
        popupSheetData: Light.config.pictureMenuList,
        popupSheetVisible: ko.observable(false),

        popupDateVisible: ko.observable(false),
        popupDateSelector: ko.observable(),
        popupDeleteVisible: ko.observable(false),

        //
        focusInClick: function () {
            if (DevExpress.devices.real().platform == "android") {
                setTimeout(function () {
                    $("#activityCreateScrollView").dxScrollView("instance").scrollTo(5000);
                }, 500);
            }
        },

        //图片变更
        imageChangeClick: function () {
            viewModel.popupSheetVisible(true);
        },

        //图片选择 
        popupSheetClick: function (clickOptions) {

            //图片保存
            var onSuccess = function(imageURI) {
                viewModel.img_picture("data:image/jpeg;base64," + imageURI);
            }

            switch (clickOptions.itemData.id) {
                case 0:
                    //拍照
                    if (navigator.camera) {
                        navigator.camera.getPicture(onSuccess, function (message) { }, {
                            quality: 100,
                            destinationType: Camera.DestinationType.DATA_URL,
                            sourceType: Camera.PictureSourceType.CAMERA,
                            allowEdit: true,
                            encodingType: Camera.EncodingType.JPEG,
                            targetWidth: 440,
                            targetHeight: 360,
                            saveToPhotoAlbum: false
                        });
                    }
                    break;

                case 1:
                    //照片选择
                    if (navigator.camera) {
                        navigator.camera.getPicture(onSuccess, function (message) { }, {
                            quality: 100,
                            destinationType: Camera.DestinationType.DATA_URL,
                            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                            allowEdit: true,
                            encodingType: Camera.EncodingType.JPEG,
                            targetWidth: 440,
                            targetHeight: 360,
                            saveToPhotoAlbum: false
                        });
                    }
                    break;
            }
        },

        //活动时间
        activityDateClick: function (e) {
            if (e.element.attr('id') == 'startDate') {
                $('.pop').mobiscroll('setActiveDate', 'start')
            } else {
                $('.pop').mobiscroll('setActiveDate', 'end')
            }
            var date = ['', ''];
            if (viewModel.input_startDate()) {
                date[0] = viewModel.input_startDate();
            } else {
                date[0] = new Date(viewModel.now.getFullYear(), viewModel.now.getMonth(), viewModel.now.getDate(), viewModel.now.getHours() + 1, 0);
            }

            if (viewModel.input_endDate()) {
                date[1] = viewModel.input_endDate();
            } else {
                date[1] = new Date(viewModel.now.getFullYear(), viewModel.now.getMonth(), viewModel.now.getDate(), viewModel.now.getHours() + 1, 0);
            }

            viewModel.popupDateSelector(date);
            console.log(viewModel.popupDateSelector());
            viewModel.popupDateVisible(true);
        },

        //popup 日期选择
        popupDateConfirmClick: function () {
            var date = viewModel.popupDateSelector();
            date[0] = new Date(date[0].getFullYear(), date[0].getMonth(), date[0].getDate(), date[0].getHours());
            date[1] = new Date(date[1].getFullYear(), date[1].getMonth(), date[1].getDate(), date[1].getHours());
            if (date[0] >= date[1]) {
                DevExpress.ui.notify(Globalize.localize('message-dateCompare'), "error", 2000);
                return;
            }

            viewModel.input_startDate(date[0]);
            viewModel.display_startDate(Globalize.format(date[0], 'yyyy年MM月dd日 H:mm'));
            viewModel.input_endDate(date[1]);
            viewModel.display_endDate(Globalize.format(date[1], 'yyyy年MM月dd日 H:mm'));

            viewModel.popupDateVisible(false);
        },

        //popup 活动删除
        popupDeleteConfirmClick: function () {

            viewModel.popupDeleteVisible(false);

            Light.action.leancloud.activity.delete(activityId,
                function () {
                    Light.app.navigate('ActivityMyself');
                },
                function () { });
        },

        //popup 取消
        popupCancelClick: function () {
            viewModel.popupDateVisible(false);
            viewModel.popupDeleteVisible(false);
        },

        //发布 按钮
        releaseClick: function () {
            saveData();
        },

        //画面Shown
        viewShown: function () {

            saveFlg = true;

            if (params.viewFlg == 0) {
                //创建活动
                activityId = '';

                viewModel.img_picture('./resource/img/active.jpg');
                viewModel.input_name('');
                viewModel.input_addr('');
                viewModel.input_startDate('');
                viewModel.display_startDate('');
                viewModel.input_endDate('');
                viewModel.display_endDate('');
                viewModel.input_content('');
                viewModel.releaseVisible(true);

            } else if (params.viewFlg == 1) {
                //编辑活动
                if (params.record) {
                    var record = $.parseJSON(params.record.replace('json:', ''));
                    activityId = record.activityId;

                    viewModel.img_picture(record.img_picture);
                    viewModel.input_name(record.name);
                    viewModel.input_addr(record.addr);
                    viewModel.input_startDate(new Date(record.startDate));
                    viewModel.display_startDate(Globalize.format(viewModel.input_startDate(), 'yyyy年MM月dd日 H:mm'));
                    viewModel.input_endDate(new Date(record.endDate));
                    viewModel.display_endDate(Globalize.format(viewModel.input_endDate(), 'yyyy年MM月dd日 H:mm'));
                    viewModel.input_content(record.content);
                    viewModel.releaseVisible(false);
                }
            }
        },

        viewHidden: function () {
            activityId = '';

            viewModel.img_picture('./resource/img/active.jpg');
            viewModel.input_name('');
            viewModel.input_addr('');
            viewModel.input_startDate('');
            viewModel.display_startDate('');
            viewModel.input_endDate('');
            viewModel.display_endDate('');
            viewModel.input_content('');
            viewModel.releaseVisible(true);
        }
    };

    return viewModel;
};