﻿Light.ActivityDetail = function (params) {

    var createrId = '';
    //0:删除 1:进行 2:结束 9:举报
    var activityStatus = 1;
    //1:未参加 2：参加者 3：创建者
    var userFlg = 1;
    var picturePage = 1;

    var activityStateCss = ['deleted', 'onrun', 'ended', 'verify', '', '', '', '', 'deny', 'report', ];

    //参加/退出活动
    function joinOrExitActive() {
        var onSuccess = function (data) {

            activityStatus = data.get('activityStatus');
            //活动状态
            if ((activityStatus == 1) && (data.get("activityEndTime") < new Date())) {
                activityStatus = 2;
            }

            if (activityStatus == 0) {
                popupMessageVisible(true);

            } else if (activityStatus == 9) {
                DevExpress.ui.notify(Globalize.localize('partner-activityMessage-tipoff'), "error", 2000);
                viewModel.userBtnVisible(false);

            } else if (activityStatus == 8) {
                DevExpress.ui.notify(Globalize.localize('partner-activityMessage-deny'), "error", 2000);
                viewModel.userBtnVisible(false);

            } else if (activityStatus == 3) {
                DevExpress.ui.notify(Globalize.localize('partner-activityMessage-verify'), "error", 2000);
                viewModel.userBtnVisible(false);

            } else if (activityStatus == 2) {
                DevExpress.ui.notify(Globalize.localize('partner-activityMessage-statusEnd'), "error", 2000);
                viewModel.userBtnVisible(false);

            } else {
                setMemberData(data.relation("activityMembers"));
            }
        }

        var cnt = viewModel.memberSource().length;
        if (userFlg == 1) {
            //参加
            Light.action.leancloud.activity.join(params.activityId, cnt + 1, onSuccess, function () { });

        } else if (userFlg == 2) {
            //退出
            Light.action.leancloud.activity.quit(params.activityId, cnt - 1, onSuccess, function () { });
        }
    };

    //活动图片添加/删除
    function setPictureIcon(record) {
        if ((activityStatus == 1) || (activityStatus == 2)) {
            if (userFlg !== 1) {
                //参加者/创建者 +
                record.push({
                    flg: 'add',
                    pictureId: '',
                    img_picture: './resource/icon/plus-active.png',
                    picture: '',
                    deleteIcon: false,
                });
            }
           

            if ((record.length > 1) && (userFlg == 3)) {
                //创建者-
                record.push({
                    flg: 'delete',
                    pictureId: '',
                    img_picture: './resource/icon/minus-active.png',
                    picture: '',
                    deleteIcon: false,
                });
            }
        }
        if (record.length > 0) {
            viewModel.pictureSource(record);
            viewModel.pictureNoDataText('');
        } else {
            viewModel.pictureSource([]);
            viewModel.pictureNoDataText('无图片');
        }
        
    };

    //取得活动图片
    function setPictureData() {
        var record = [];
        var onSuccess = function (data) {
            for (var i = 0; i < data.length; i++) {
                record.push({
                    flg: '',
                    pictureId: data[i].id,
                    img_picture: data[i].get('imageThumbnail'),
                    picture: data[i].get('imageUrl'),
                    deleteIcon: true,
                });
            }

            setPictureIcon(record);
        }

        Light.action.leancloud.album.getAll(params.activityId, picturePage, onSuccess, function () { setPictureIcon(record); });
    };

    function setCreaterData(userid) {
            var onSuccess = function (data) {
                viewModel.img_creater(data.get('userHeadImage'));
                viewModel.createrName(data.get('nickname'));
            }

            Light.action.leancloud.user.getUserById(userid, onSuccess, function () { });
    };

    //取得参加成员
    function setMemberData(members, activityFlg) {
        userFlg = 1;

        members.query().find({
            success: function (data) {
                var record = [];
                for (var i = 0; i < data.length; i++) {
                    //成员状态
                    if (Light.rtdata.leanCloudSocialId == data[i].id) {
                        userFlg = 2;
                    }

                    //成员详细
                    if (createrId == data[i].id) {
                        viewModel.img_creater(data[i].get('userHeadImage'));
                        viewModel.createrName(data[i].get('nickname'));
                    } else {
                        record.push({
                            userId: data[i].id,
                            img_head: data[i].get('userHeadImage'),
                            userName: data[i].get('nickname'),
                        });
                    }
                }

                //成员状态
                if (Light.rtdata.leanCloudSocialId == createrId) {
                    userFlg = 3;
                }

                switch (userFlg) {
                    case 1:
                        //未参加者
                        if (activityStatus == 1) {
                            //进行中
                            viewModel.menuItems(Light.config.activityDetailMenuList1);
                            viewModel.userBtnVisible(true);
                            viewModel.txt_submit(Globalize.localize('partner-activity_enter'));
                            $(".activityDetail .dx-scrollable").css("height", '90%');

                        } else if (activityStatus == 2) {
                            //已结束
                            $(".activityDetail .dx-scrollable").css("height", '100%');

                        } else if (activityStatus == 9) {
                            //被举报
                            viewModel.menuVisible(false);
                            viewModel.userBtnVisible(false);
                            viewModel.createrBtnVisible(false);
                            viewModel.createrBtnVisible3(false);
                            $(".activityDetail .dx-scrollable").css("height", '100%');
                        } else if (activityStatus == 8) {
                            //未通过
                            viewModel.menuVisible(false);
                            viewModel.userBtnVisible(false);
                            viewModel.createrBtnVisible(false);
                            viewModel.createrBtnVisible3(false);
                            $(".activityDetail .dx-scrollable").css("height", '100%');
                        } else if (activityStatus == 3) {
                            //待审核
                            viewModel.menuVisible(false);
                            viewModel.userBtnVisible(false);
                            viewModel.createrBtnVisible(false);
                            viewModel.createrBtnVisible3(false);
                            $(".activityDetail .dx-scrollable").css("height", '100%');
                        }
                        break;
                    case 2:
                        //参加者
                        $(".activityDetail .dx-scrollable").css("height", '100%');
                        if (activityStatus == 1) {
                            //进行中
                            viewModel.menuItems(Light.config.activityDetailMenuList2);
                            viewModel.userBtnVisible(false);

                        } else if (activityStatus == 2) {
                            //已结束

                        } else if (activityStatus == 9) {
                            //被举报
                            viewModel.menuVisible(false);
                            viewModel.userBtnVisible(false);
                            viewModel.createrBtnVisible(false);
                            viewModel.createrBtnVisible3(false);
                        } else if (activityStatus == 8) {
                            //未通过
                            viewModel.menuVisible(false);
                            viewModel.userBtnVisible(false);
                            viewModel.createrBtnVisible(false);
                            viewModel.createrBtnVisible3(false);
                        } else if (activityStatus == 3) {
                            //待审核
                            viewModel.menuVisible(false);
                            viewModel.userBtnVisible(false);
                            viewModel.createrBtnVisible(false);
                            viewModel.createrBtnVisible3(false);
                        }
                        break;
                    case 3:
                        //创建者
                        if (activityStatus == 1) {
                            //进行中
                            viewModel.createrBtnVisible(true);
                            $(".activityDetail .dx-scrollable").css("height", '90%');

                        } else if (activityStatus == 2) {
                            //已结束
                            viewModel.createrBtnVisible3(true);
                            $(".activityDetail .dx-scrollable").css("height", '90%');

                        } else if (activityStatus == 9) {
                            //被举报
                            viewModel.menuVisible(false);
                            viewModel.userBtnVisible(false);
                            viewModel.createrBtnVisible(false);
                            viewModel.createrBtnVisible3(false);
                            $(".activityDetail .dx-scrollable").css("height", '100%');
                        } else if (activityStatus == 8) {
                            //未通过
                            viewModel.menuVisible(false);
                            viewModel.userBtnVisible(false);
                            viewModel.createrBtnVisible(false);
                            viewModel.createrBtnVisible3(false);
                            $(".activityDetail .dx-scrollable").css("height", '100%');
                        } else if (activityStatus == 3) {
                            //待审核
                            viewModel.menuVisible(false);
                            viewModel.userBtnVisible(false);
                            viewModel.createrBtnVisible(false);
                            viewModel.createrBtnVisible3(false);
                            $(".activityDetail .dx-scrollable").css("height", '100%');
                        }

                        break;
                }

                viewModel.memberCount(record.length + '人');
                viewModel.memberSource(record);
                if (record == 0) {
                    viewModel.memberSourceVisible(false);
                }

                //图片取得
                setPictureData(); 
            }
        });
    };

    //取得活动
    function setActivityDetailData() {

        var onSuccess = function (data) {

            createrId = data.get('activityCreaterId');

            //dingwei 20160518 add
            setCreaterData(createrId);

            activityStatus = data.get('activityStatus');
            //活动状态
            if ((activityStatus == 1) && (data.get("activityEndTime") < new Date())) {
                activityStatus = 2;
            }

            viewModel.img_picture(data.get('activityImg'));
            viewModel.state(activityStateCss[activityStatus]);
            viewModel.name(data.get('activityName'));
            viewModel.addr(data.get('activityAdress'));
            viewModel.content(data.get('activityContent'));

            viewModel.startDate(data.get('activityTime'));
            viewModel.display_startDate(Globalize.format(data.get('activityTime'), 'yyyy年M月d日 H:mm'));
            viewModel.endDate(data.get('activityEndTime'));
            viewModel.display_endDate(Globalize.format(data.get('activityEndTime'), 'yyyy年M月d日 H:mm'));

            if (activityStatus == 0) {
                //删除活动
                viewModel.popupMessageVisible(true);
            } else if (activityStatus == 9) {
                //被举报
                Light.action.leancloud.report.getActiveMemo(
                    data.id,
                    function (memo) {
                        DevExpress.ui.notify("活动被举报。" + "(" + memo + ")", "error", 3000);
                        myDialog.show();
                    }, function () {
                        DevExpress.ui.notify("活动被举报。", "error", 3000);
                    });
            } else if (activityStatus == 8) {
                //未通过
                var memo = "";
                if (data.get('activityVerify')) {
                    memo = data.get('activityVerify');
                }
                var desc = "";
                if (memo && memo != "") {
                    desc = "(" + memo + ")";
                }
                DevExpress.ui.notify("活动未通过审核。" + desc, "error", 3000);
            } else if (activityStatus == 3) {
                //待审核
                DevExpress.ui.notify("活动等待审核中。", "info", 3000);
            } else {
                //有效活动
                setMemberData(data.relation("activityMembers"));
            }
        }

        Light.action.leancloud.activity.getOne(params.activityId, onSuccess, function () { });
    };

    var viewModel = {
        menuVisible: ko.observable(true),
        menuItems: ko.observable(Light.config.activityDetailMenuList1),
        contextMenuVisible: ko.observable(false),

        img_picture: ko.observable(''),
        name: ko.observable(''),
        state: ko.observable(''),
        startDate: ko.observable(''),
        endDate: ko.observable(''),
        display_startDate: ko.observable(''),
        display_endDate: ko.observable(''),
        addr: ko.observable(''),
        img_creater: ko.observable(''),
        createrName: ko.observable(''),
        memberCount: ko.observable(''),
        memberSource: ko.observable([]),
        memberSourceVisible: ko.observable(true),
        content: ko.observable(''),
        contentVisible: ko.observable(true),
        pictureSource: ko.observable([]),
        pictureNoDataText: ko.observable(''),
        pictureDeleteFlg: ko.observable(false),

        userBtnVisible: ko.observable(false),
        createrBtnVisible: ko.observable(false),
        createrBtnVisible3: ko.observable(false),
        txt_submit: ko.observable(''),

        popupSheetData: Light.config.pictureMenuList,
        popupSheetVisible: ko.observable(false),

        popupMessageVisible: ko.observable(false),

        //menu按钮
        menuClick: function () {
            viewModel.contextMenuVisible(true);
        },

        //menu 详细
        menuItemClicked: function (e) {
            switch (e.itemData.text) {
                case Globalize.localize('partner-tipOff'):
                    //举报
                    Light.app.navigate({ view: 'TipOff', id: params.activityId, type: 2 });
                    break;

                case Globalize.localize('partner-activity_exit'):
                    //退出
                    joinOrExitActive();
                    break;

            }
        },

        //举报 按钮
        tipOffClick: function(){
            Light.app.navigate({ view: 'TipOff', id: params.activityId, type: 2 });
        },

        //活动创建者
        createrClick: function () {
            if (Light.rtdata.partner_friendList.indexOf(createrId) == -1) {
                //不是好友
                Light.app.navigate({ view: 'FriendAdd', userId: createrId });
            } else {
                //不是好友
                Light.app.navigate({ view: 'FriendDetail', userId: createrId });
            }
        },

        //活动成员
        memberClick: function (object) {
            if (Light.rtdata.partner_friendList.indexOf(object.model.userId) == -1) {
                //不是好友
                Light.app.navigate({ view: 'FriendAdd', userId: object.model.userId });
            } else {
                //不是好友
                Light.app.navigate({ view: 'FriendDetail', userId: object.model.userId });
            }
        },

        //活动成员 展开
        memberSourceClick: function () {
            var record = viewModel.memberSource();
            if ( record.length > 0 ) {
                viewModel.memberSourceVisible(!viewModel.memberSourceVisible());
            }
        },

        //活动详细 展开
        contentClick: function () {
            viewModel.contentVisible(!viewModel.contentVisible());
        },

        //活动图片选择 
        popupSheetClick: function (clickOptions) {

            var onSuccess = function (imageURI){
                var record = '';
                var name = params.activityId + '_' + Globalize.format(new Date(), 'yyyyMMdd_HHmm') + '.jpge';

                var onPictureDone = function (data) {
                    var tmp = viewModel.pictureSource();
                    tmp.splice(0, 0, {
                        flg: '',
                        pictureId: data.id,
                        img_picture: data.get('imageThumbnail'),
                        picture: data.get('imageUrl'),
                        deleteIcon: true,
                    });
                    var len = tmp.length;
                    if (tmp[len-2].flg) {
                        tmp.splice(len - 2, 2);
                    } else {
                        tmp.splice(len - 1, 1);
                    }
                    setPictureIcon(tmp);
                }

                record = {
                    name: name,
                    groupActivityId: params.activityId,
                    albumType: 0,
                    data: imageURI,
                };

                Light.action.leancloud.album.create( record, onPictureDone, function () { });
            }

            switch (clickOptions.itemData.id) {
                case 0:
                    //拍照
                    if (navigator.camera) {
                        navigator.camera.getPicture(onSuccess, function (message) { }, {
                            quality: 100,
                            destinationType: Camera.DestinationType.DATA_URL,
                            sourceType: Camera.PictureSourceType.CAMERA,
                            allowEdit: true,
                            encodingType: Camera.EncodingType.JPEG,
                            targetWidth: 500,
                            targetHeight: 500,
                            saveToPhotoAlbum: false
                        });
                    }
                    break;

                case 1:
                    //照片选择
                    if (navigator.camera) {
                        navigator.camera.getPicture(onSuccess, function (message) { }, {
                            quality: 100,
                            destinationType: Camera.DestinationType.DATA_URL,
                            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                            allowEdit: true,
                            encodingType: Camera.EncodingType.JPEG,
                            targetWidth: 500,
                            targetHeight: 500,
                            saveToPhotoAlbum: false
                        });
                    }
                    break;
            }
        },

        //图片详细
        pictureClick: function (object) {
            if (!viewModel.pictureDeleteFlg()) {
                if (object.model.flg == 'add') {
                    //图片添加
                    viewModel.popupSheetVisible(true);

                } else if (object.model.flg == 'delete') {
                    //图片删除
                    viewModel.pictureDeleteFlg(true);
                } else {
                    //图片详细
                    Light.app.navigate({ view: 'PictureShow', pictureId: object.model.pictureId, record: viewModel.pictureSource() });
                }
            } else {
                //图片删除取消
                var onPictureDone = function (data) {
                    setPictureData();
                }
                Light.action.leancloud.album.delete(object.model.pictureId, onPictureDone, function () { });
            }
        },


        //图片删除取消
        pictureDeleteCancelClick: function () {
            viewModel.pictureDeleteFlg(false);
        },

        //参加/退出 按钮
        submitClick: function () {
            joinOrExitActive();
        },

        //编辑活动
        editClick: function () {
            var record = {
                activityId: params.activityId,
                img_picture: viewModel.img_picture(),
                name: viewModel.name(),
                addr: viewModel.addr(),
                startDate: viewModel.startDate(),
                endDate: viewModel.endDate(),
                content: viewModel.content(),
            };
            Light.app.navigate({ view: 'ActivityCreate', viewFlg: 1, record: record });
        },

        //活动结束
        endClick: function () {
            var endrecord = {
                id: params.activityId,
                handEndTime: new Date(),
            };

            Light.action.leancloud.activity.end(endrecord,
                function () {
                    viewModel.createrBtnVisible(false);
                    viewModel.createrBtnVisible3(true);
                },
                function () { });
        },

        //活动成员详细
        memberListClick: function () {
            Light.app.navigate({ view: 'ActivityMemberList', activityId: params.activityId });
        },

        //popup message确认
        popupConfirmClick: function () {
            viewModel.popupMessageVisible(false);
            Light.app.navigate('Partner', { root: true });
        },

        //画面Shown
        viewShown: function () {
            Light.rtdata.activityPage = 'ActivityDetail';
            setActivityDetailData();
        },

        //画面Hidden
        viewHidden: function () {
            viewModel.menuVisible(true);
            viewModel.pictureSource([]);
            viewModel.pictureNoDataText('');
            viewModel.memberSourceVisible(true);
            viewModel.contentVisible(true);

            viewModel.userBtnVisible(false);
            viewModel.createrBtnVisible(false);
            viewModel.createrBtnVisible3(false);

            viewModel.pictureDeleteFlg(false);
        }
    };

    return viewModel;
};