﻿Light.ActivityMemberList = function (params) {

    //返回 按钮
    backClick = function (e) {
        saveData();
        DevExpress.hardwareBackButton.fire();
    };


    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: Globalize.localize('partner-activityMemberList') },
    ];

    //数据保存
    function saveData() {
        var members = viewModel.memberSource()
        for (var i = 0; i < members.length; i++) {

            if (members[i].activityMemberId) {
                //更新
                var data = {
                    id: members[i].activityMemberId,
                    realName: members[i].realName(),
                    telphone: members[i].telphone(),
                };
                Light.action.leancloud.activityMember.update(data, function () { }, function () { });
            } else {
                //新规
                var data = {
                    activityId: params.activityId,
                    memberID: members[i].userId,
                    userName: members[i].userName,
                    realName: members[i].realName(),
                    telphone: members[i].telphone(),
                };
                Light.action.leancloud.activityMember.create(data, function () { }, function () { });
            }
            
        }
    };

    //成员表示
    function setMemberData(rt) {
        var onMembersDone = function (data) {

            var record = [];
            var flg = true;
            for (var i = 0; i < data.length; i++) {
                if (Light.rtdata.leanCloudSocialId !== data[i].id) {
                    flg = true;
                    for (var k = 0; k < rt.length; k++) {
                        if (data[i].id == rt[k].get("memberID")) {
                            record.push({
                                userId: data[i].id,
                                activityMemberId: rt[k].id,
                                userName: data[i].get('username'),
                                img_head: data[i].get('userHeadImage'),
                                nickName: data[i].get('nickname'),
                                sex: Light.config.sexList[data[i].get('sex')].icon,
                                age: Light.tool.getAge(data[i].get('birthday')) + '岁',
                                realName_ps: data[i].get('realName'),
                                telphone_ps: data[i].get('phone'),
                                realName: ko.observable(rt[k].get("realName")),
                                telphone: ko.observable(rt[k].get("telphone")),
                            });
                            flg = false;
                            break;
                        }

                    }

                    if (flg) {
                        record.push({
                            userId: data[i].id,
                            activityMemberId: '',
                            userName: data[i].get('username'),
                            img_head: data[i].get('userHeadImage'),
                            nickName: data[i].get('nickname'),
                            sex: Light.config.sexList[data[i].get('sex')].icon,
                            age: Light.tool.getAge(data[i].get('birthday')) + '岁',
                            realName_ps: data[i].get('realName'),
                            telphone_ps: data[i].get('phone'),
                            realName: ko.observable(data[i].get('realName')),
                            telphone: ko.observable(data[i].get('phone')),
                        });
                    }
                }
            }

            viewModel.memberSource(record);
        }

        Light.action.leancloud.activity.getMembers(params.activityId, onMembersDone, function () { });
    };

    var viewModel = {
        memberSource: ko.observable([]),

        //check
        focusOutClick:function(e){
            if (!e.model.realName()) {
                e.model.realName(e.model.realName_ps);
            }
            if (!e.model.telphone()) {
                e.model.telphone(e.model.telphone_ps);
            }
        },

        //画面Shown
        viewShown: function () {
            //取得参加成员
            Light.action.leancloud.activityMember.getAllMembers(params.activityId, function (rt) { setMemberData(rt); }, function () { setMemberData([]); });
        },
    };

    return viewModel;
};