﻿Light.ActivityMyself = function (params) {

    var activityStateCss = ['deleted', 'onrun', 'ended', 'verify', '', '', '', '', 'deny', 'report', ]

    //我的活动 取得
    function setMyActivityData() {
        var start = new Date();
        var end = new Date();
        var disdate = '';

        viewModel.joinSource.store().clear();
        viewModel.joinSource.pageIndex(0);
        viewModel.joinSource.load();
        viewModel.joinNoDataText('');

        viewModel.createSource.store().clear();
        viewModel.createSource.pageIndex(0);
        viewModel.createSource.load();
        viewModel.createNoDataText('');

        var onSuccess = function (data) {

            if (data.length > 0) {

                var joinSourceFlg = true;
                var createSourceFlg = true;

                for (i = 0; i < data.length; i++) {

                    //日期显示
                    start = data[i].get('activityTime');
                    end = data[i].get('activityEndTime');
                    disdate = Light.tool.getActivityDate(start, end);

                    var state = activityStateCss[data[i].get('activityStatus')];
                    if ((data[i].get('activityStatus') == 1) && (end < new Date())) {
                        state = activityStateCss[2];
                    }

                    if (data[i].get('activityCreaterId') == Light.rtdata.leanCloudSocialId) {
                        //发布的活动
                        viewModel.createSource.store().insert({
                            id: i,
                            createrId: data[i].get('activityCreaterId'),
                            activityId: data[i].id,
                            state: state,
                            img_picture: data[i].get('activityImg'),
                            name: data[i].get('activityName'),
                            addr: data[i].get('activityAdress'),
                            startDate: data[i].get('activityTime'),
                            endDate: data[i].get('activityEndTime'),
                            display_date: disdate,
                            membersCnt: data[i].get('activityMembersCnt') + '人已参加',
                            content: data[i].get('activityContent'),
                        });
                        createSourceFlg = false;

                    } else {
                        //参加的活动
                        viewModel.joinSource.store().insert({
                            id: i,
                            createrId: data[i].get('activityCreaterId'),
                            activityId: data[i].id,
                            state: state,
                            img_picture: data[i].get('activityImg'),
                            name: data[i].get('activityName'),
                            addr: data[i].get('activityAdress'),
                            startDate: data[i].get('activityTime'),
                            endDate: data[i].get('activityEndTime'),
                            display_date: disdate,
                            membersCnt: data[i].get('activityMembersCnt') + '人已参加',
                            content: data[i].get('activityContent'),
                        });
                        joinSourceFlg = false;
                    }
                }

                viewModel.popupPageVisible(false);

                viewModel.createSource.pageIndex(0);
                viewModel.createSource.load();
                if (createSourceFlg) {
                    viewModel.createNoDataText(Globalize.localize('partner-activityMessage-nodata_create'));
                }

                viewModel.joinSource.pageIndex(0);
                viewModel.joinSource.load();
                if (joinSourceFlg) {
                    viewModel.joinNoDataText(Globalize.localize('partner-activityMessage-nodata_join'));
                }

            } else {
                viewModel.popupPageVisible(false);
                viewModel.joinNoDataText(Globalize.localize('partner-activityMessage-nodata_join'));
                viewModel.createNoDataText(Globalize.localize('partner-activityMessage-nodata_create'));
            }

        }

        var onFail = function () {
            viewModel.joinNoDataText(Globalize.localize('partner-activityMessage-nodata_join'));
            viewModel.createNoDataText(Globalize.localize('partner-activityMessage-nodata_create'));
        }

        Light.action.leancloud.activity.getJoined(onSuccess, onFail);
    };

    var viewModel = {
        selectedContent: ko.observable(0),
        contentTabsSource: Light.config.activityMyselfTypeList,
        contentSource: [
            { template: 'joinList' },
            { template: 'createList' },
        ],

        joinNoDataText: ko.observable(''),
        joinSource: new DevExpress.data.DataSource({
            store: [],
            pageSize: 10
        }),
        createNoDataText: ko.observable(''),
        createSource: new DevExpress.data.DataSource({
            store: [],
            pageSize: 10
        }),

        popupPageVisible: ko.observable(true),

        //活动 下拉更新
        updataActivityListClick:function(){
            setMyActivityData();
        },

        //参加的活动 item
        joinSelectClick: function (e) {
            Light.app.navigate({ view: 'ActivityDetail', activityId: e.itemData.activityId });
        },

        //发布的活动 item
        createSelectClick: function (e) {
            Light.app.navigate({ view: 'ActivityDetail', activityId: e.itemData.activityId });
        },


        //创建活动
        addClick:function(){
            Light.app.navigate({ view: 'ActivityCreate', viewFlg: 0 });
        },

        //画面init
        viewShown: function () {
            //if (Light.rtdata.activityPage == 'Activity') {
                setMyActivityData();
            //}
        },

    };

    return viewModel;
};