﻿Light.FriendAdd = function (params) {
    
    var inviteId = '';

    var viewModel = {
        img_head: ko.observable(''),
        nickName: ko.observable(''),
        message: ko.observable(''),

        popupMessage: ko.observable(''),
        popupMessageVisible: ko.observable(false),

        //添加通讯录
        addFriendListClick: function () {
            var onFollow = function () {

                var onSuccess = function (data) {
                    var flg = false;
                    Light.rtdata.partner_friendList = Light.rtdata.leanCloudSocialId;

                    for (i = 0; i < data.length; i++) {
                        Light.rtdata.partner_friendList += ',' + data[i].objectId;
                        if (data[i].objectId == params.userId) {
                            flg = true;
                        }
                    }

                    if (flg) {
                        //是好友
                        Light.app.navigate({ view: 'FriendDetail', userId: params.userId });
                    } else {
                        //不是好友
                        viewModel.popupMessageVisible(true);
                    }
                }
                //通讯录 判断
                Light.action.leancloud.share.getAddressBook(onSuccess, function () { });

                //消息 clear
                if (inviteId) {
                    Light.action.leancloud.invite.updateInviteStatus(inviteId, 1, function () { }, function () { });
                }
                
            }
            Light.action.leancloud.share.follow(params.userId, onFollow, function () { });
        },

        //popup 发消息
        popupMessageSendClick: function () {
            var message = [];
            var onSuccess = function (data) {
                if (data.length > 0) {
                    //存在，更新
                    message = data[0].get("message");
                    var inviteId = data[0].id;
                    if (viewModel.popupMessage()) {
                        message.splice(0, 0, viewModel.popupMessage());
                    }
                    Light.action.leancloud.invite.updateInviteMessage(inviteId, message, function () { }, function () { });

                } else {
                    //不存在，新规
                    if (viewModel.popupMessage()) {
                        message.splice(0, 0, viewModel.popupMessage());
                    }
                    Light.action.leancloud.invite.createInvite(params.userId, message, function () { }, function () { });
                }
            }

            var onFail = function () {
                //不存在，新规
                if (viewModel.popupMessage()) {
                    message.splice(0, 0, viewModel.popupMessage());
                }
                Light.action.leancloud.invite.createInvite(params.userId, message, function () { }, function () { });
            }

            Light.action.leancloud.invite.getInviteByKey(Light.rtdata.leanCloudSocialId , params.userId, onSuccess, onFail);
            
            viewModel.popupMessageVisible(false);
        },

        //popup 取消
        popupCancelClick: function () {
            viewModel.popupMessageVisible(false);
        },

        //画面init
        viewShown: function () {
            inviteId = '';
            var onSuccess = function (recordData) {
                viewModel.img_head(recordData.get("userHeadImage"));
                viewModel.nickName(recordData.get("nickname"));
                viewModel.popupMessage("我是" + Light.rtdata.common_userName);

                var onInviteSuccess = function (data) {
                    inviteId = data[0].id;
                    var title = viewModel.nickName() + ' 留言：';
                    var text = title + data[0].get('message').join("\r\n" + title);
                    viewModel.message(text);
                }

                var onInviteFail = function () {
                    viewModel.message('');
                }

                Light.action.leancloud.invite.getInviteByKey(params.userId, Light.rtdata.leanCloudSocialId, onInviteSuccess, onInviteFail);
            }

            Light.action.leancloud.user.getUserById(params.userId, onSuccess, function () { });
        },
    };

    return viewModel;
};