﻿Light.FriendDetail = function (params) {
    
    var notSee = '***';
    var groupImgHeadData = '';
    var sickList = [];

    //群头像
    function createImg() {
        var groupHead, cxt;
        var img = new Image();
        var canvas_length = 113;
        var canvas_blank = 5;

        groupHead = document.getElementById("myCanvas");
        groupHead.width = canvas_length;
        groupHead.height = canvas_length;
        cxt = groupHead.getContext("2d");
        cxt.clearRect(0, 0, canvas_length, canvas_length);
        cxt.fillStyle = '#E2E2E2';
        cxt.fillRect(0, 0, canvas_length, canvas_length);

        //1排2列
        var img_length = (canvas_length - canvas_blank * 3) / 2;
        var img_x = canvas_blank;
        var img_y = (canvas_length - img_length) / 2;
        var img_2x = img_length + canvas_blank * 2;

        img.src = viewModel.img_head();
        cxt.drawImage(img, img_x, img_y, img_length, img_length);
        img.src = Light.rtdata.common_imgHead;
        cxt.drawImage(img, img_2x, img_y, img_length, img_length);

        groupImgHeadData = groupHead.toDataURL('png');
    };

    var viewModel = {
        menuVisible: ko.observable(true),
        menuItems: Light.config.friendMenuList,
        contextMenuVisible: ko.observable(false),

        img_head: ko.observable(''),
        nickName: ko.observable(''),

        personalSource: [
            { id: 0, title: Globalize.localize('profile-sex'), displayValue: ko.observable("") },
            { id: 1, title: Globalize.localize('profile-age'), displayValue: ko.observable("") },
            { id: 2, title: Globalize.localize('profile-height'), displayValue: ko.observable("") },
            { id: 3, title: Globalize.localize('profile-weight'), displayValue: ko.observable("") },
            { id: 4, title: Globalize.localize('profile-city'), displayValue: ko.observable("") },
            { id: 5, title: Globalize.localize('profile-group'), displayValue: ko.observable("") },
            { id: 6, title: Globalize.localize('profile-sick'), displayValue: ko.observable("") },
        ],
        btnVisible: ko.observable(false),

        popupSickSource: ko.observable([]),
        popupSickVisible: ko.observable(false),

        //menu按钮
        menuClick: function () {
            viewModel.contextMenuVisible(true);
        },

        //menu 详细
        menuItemClicked: function (e) {
            switch (e.itemData.text) {
                case Globalize.localize('common-delete'):
                    //删除
                    var onSuccess = function () {
                        DevExpress.hardwareBackButton.fire();
                        DevExpress.hardwareBackButton.fire();
                    }
                    Light.action.leancloud.share.unfollow(params.userId, onSuccess, function () { });
                    break;

                case Globalize.localize('partner-tipOff'):
                    //举报
                    Light.app.navigate({ view: 'TipOff', id: params.userId, type: 0 });
                    break;
            }
        },

        selectPersonalClick:function(e){
            if (e.itemData.id == 6) {
                //疾病
                var tmp = [];
                for (var i = 0; i < sickList.length; i++) {
                    if (sickList[i] == 1) {
                        tmp.push({
                            name: Light.config.diseaseWomenList[i].text,
                        });
                    }
                }

                if (tmp.length > 0) {
                    viewModel.popupSickSource(tmp);
                    viewModel.popupSickVisible(true);
                }
            }
        },

        //发消息
        sendMessageClick: function () {
            createImg();
            if (window.plugins && window.plugins.LeanChat) {
                window.plugins.LeanChat.registStatusCallback(Light.PartnerPluginData.group_all_onState);
                window.plugins.LeanChat.fetchGroupByMembers(Light.rtdata.leanCloudSocialId, params.userId, '', groupImgHeadData);
            }
        },

        //popup 疾病显示
        popupSickConfirmClick: function () {
            viewModel.popupSickVisible(false);
        },

        //画面init
        viewShown: function () {
            sickList = [];
            viewModel.menuVisible(true);
            viewModel.btnVisible(true);
            if (params.userId == Light.rtdata.leanCloudSocialId) {
                viewModel.menuVisible(false);
                viewModel.btnVisible(false);
            }

            var onSuccess = function (recordData) {

                viewModel.img_head(recordData.get("userHeadImage"));
                viewModel.nickName(recordData.get("nickname"));

                //性别
                if ((recordData.get("privacySex") == 1) || !viewModel.menuVisible()) {
                    //允许
                    viewModel.personalSource[0].displayValue(Light.config.sexList[recordData.get("sex")].text);
                } else {
                    viewModel.personalSource[0].displayValue(notSee);
                }

                //出生年月
                if ((recordData.get("privacyBirthday") == 1) || !viewModel.menuVisible()) {
                    //允许
                    var age = Light.tool.getAge(recordData.get("birthday")) + Globalize.localize('common-unit-age');
                    viewModel.personalSource[1].displayValue(age);
                } else {
                    viewModel.personalSource[1].displayValue(notSee);
                }

                //身高
                if ((recordData.get("privacyHeight") == 1) || !viewModel.menuVisible()) {
                    //允许
                    viewModel.personalSource[2].displayValue(recordData.get("height") + Globalize.localize('common-unit-cm'));
                } else {
                    viewModel.personalSource[2].displayValue(notSee);
                }

                //体重
                if ((recordData.get("privacyWeight") == 1) || !viewModel.menuVisible()) {
                    //允许
                    viewModel.personalSource[3].displayValue(recordData.get("weight") + Globalize.localize('common-unit-kg'));
                } else {
                    viewModel.personalSource[3].displayValue(notSee);
                }

                //城市
                if ((recordData.get("privacyCity") == 1) || !viewModel.menuVisible()) {
                    //允许
                    var cityId = Globalize.parseInt(recordData.get("address") + '');
                    if (Light.config.cityGPSList[cityId].state == Light.config.cityGPSList[cityId].city) {
                        viewModel.personalSource[4].displayValue(Light.config.cityGPSList[cityId].city);
                    } else {
                        viewModel.personalSource[4].displayValue(Light.config.cityGPSList[cityId].state + ' ' + Light.config.cityGPSList[cityId].city);
                    }
                } else {
                    viewModel.personalSource[4].displayValue(notSee);
                }

                //人群
                if ((recordData.get("privacyGroup") == 1) || !viewModel.menuVisible()) {
                    //允许
                    viewModel.personalSource[5].displayValue(Light.config.groupList[recordData.get("job")].name);
                } else {
                    viewModel.personalSource[5].displayValue(notSee);
                }

                //疾病史
                if ((recordData.get("privacySick") == 1) || !viewModel.menuVisible()) {
                    //允许
                    var disease = "无";
                    sickList = recordData.get("disease").split(",");
                    for (var i = 0; i < sickList.length; i++) {
                        if (sickList[i] == 1) {
                            disease = "有";
                        }
                    }
                    viewModel.personalSource[6].displayValue(disease);
                } else {
                    viewModel.personalSource[6].displayValue(notSee);
                }
 
            }

            Light.action.leancloud.user.getUserById(params.userId, onSuccess, function () { });
        },

    };

    return viewModel;
};