﻿Light.FriendList = function (params) {

    //返回按钮
    backClick = function (e) {
        Light.tool.toPartnerMessageList();
    };

    //好友添加
    friendAddClick = function (e) {
        Light.app.navigate({ view: 'PartnerSearch', flg: 'add', back: 'FriendList' });
    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: Globalize.localize('partner-friendList') },
            { location: 'after', widget: 'button', options: { icon: 'light-friendAdd', clickAction: friendAddClick } },
    ];

    //新的朋友 消息是否存在
    function newFriendMessage() {
        var onSuccess = function (data) {
            if (data.length > 0) {
                viewModel.pageSource[0].newFriendIcon(data[0].get("fromUserImage"));
                viewModel.pageSource[0].newVisible(true);
            } else {
                viewModel.pageSource[0].newFriendIcon('');
                viewModel.pageSource[0].newVisible(false);
            }
        }

        var onFail = function () {
            viewModel.pageSource[0].newFriendIcon('');
            viewModel.pageSource[0].newVisible(false);
        }

        Light.action.leancloud.invite.getNewInvite(onSuccess, onFail);
    };

    //好友list 
    function setFriendList() {
        var onSuccess = function (data) {
            var tmp = [];
            Light.rtdata.partner_friendList = Light.rtdata.leanCloudSocialId;

            for (i = 0; i < data.length; i++) {
                Light.rtdata.partner_friendList += ',' + data[i].objectId;

                var py = codefans_net_CC2PY(data[i].nickname);
                tmp.push({
                    userId: data[i].objectId,
                    userHeadImage: data[i].userHeadImage,
                    name: data[i].nickname,
                    name_py: py,
                    key: py.substr(0, 1).toUpperCase(), //排序key
                    keyFlg: ko.observable(false), //排序group 显示flg
                })
            }

            viewModel.friendSource(Light.tool.arrSortByGroup(tmp));
            viewModel.memberCnt(tmp.length + '位同伴');
        }

        var onFail = function () {
            viewModel.networkFlg(true);
            viewModel.img_info('./resource/img/noNetwork.gif');
            viewModel.infoText(Globalize.localize('profile-network-disconnect'));
            viewModel.friendSource([]);
            viewModel.memberCnt('0位同伴');
        }

        Light.action.leancloud.share.getAddressBook(onSuccess, onFail);
    };
    function checkNetState() {
        viewModel.img_info('');
        viewModel.infoText('');

        //网络check
        if (Light.network.checkConnection()) {
            viewModel.networkFlg(true);
        } else {
            viewModel.networkFlg(false);
        }

        if (viewModel.networkFlg()) {
            //有网络
            viewModel.networkFlg(true);
            viewModel.img_info('');
            viewModel.infoText('');
            setFriendList();
            newFriendMessage();
        } else {
            //无网络
            viewModel.img_info('./resource/img/noNetwork.gif');
            viewModel.infoText(Globalize.localize('profile-network-disconnect'));
            console.log(viewModel);
        }
    }
    var viewModel = {
        pageSource: [
            { color: 'yellow', icon: './resource/icon/newFriend.png', name: Globalize.localize('partner-friendNew'), itemClick: '#FriendNew', newVisible: ko.observable(false), newFriendIcon: ko.observable('') },
            { color: 'green', icon: './resource/icon/group.png', name: Globalize.localize('partner-group'), itemClick: '#GroupList', newVisible: ko.observable(false), newFriendIcon: ko.observable('') },
        ],

        friendSource: ko.observable([]),
        memberCnt: ko.observable(''),
        networkFlg: ko.observable(false),
        img_info: ko.observable(''),
        infoText: ko.observable(''),
        //页面刷新
        refreshClick: function () {
            checkNetState();
        },
        //好友 list选择
        selectFriendClick: function (object) {
            Light.app.navigate({ view: 'FriendDetail', userId: object.model.userId });
        },

        //画面init
        viewShown: function () {
            checkNetState();
            //setFriendList();
            //newFriendMessage();
        },

    };

    return viewModel;
};