﻿Light.FriendNew = function (params) {

    //消息list
    function setMessageList() {

        var onSuccess = function (data) {
            if (data.length > 0) {
                var tmp = [];
                for (i = 0; i < data.length; i++) {
                    var messageList = data[i].get("message");
                    var message = '';
                    if (messageList.length > 0) {
                        message = messageList[0];
                    }
                    tmp.push({
                        id: i,
                        inviteId: data[i].id,
                        userId: data[i].get("fromUserId"),
                        img_head: data[i].get("fromUserImage"),
                        name: data[i].get("fromUserNickName"),
                        message: message,
                    });
                }
                viewModel.messageSource(tmp);
                viewModel.infoText('');

            } else {
                viewModel.messageSource([]);
                viewModel.infoText(Globalize.localize('partner-friend-noData'));
            }
        }

        var onFail = function () {
            viewModel.messageSource([]);
            viewModel.infoText(Globalize.localize('partner-friend-noData'));
        }

        Light.action.leancloud.invite.getNewInvite(onSuccess, onFail);
    };

    var viewModel = {
        infoText: ko.observable(''),
        messageSource: ko.observable([]),

        //好友添加
        friendAddClick: function (e) {
            Light.app.navigate({ view: 'PartnerSearch', flg: 'add', back: 'FriendNew' });
        },

        //消息选择 list
        messageSelectClick: function (object) {
            Light.app.navigate({ view: 'FriendAdd', userId: object.model.userId });
        },

        //接受 按钮
        acceptClick: function (object) {
            var onSuccess = function () {
                setMessageList();
                Light.action.leancloud.share.follow(object.model.userId, function () { }, function () { });
            }
            Light.action.leancloud.invite.updateInviteStatus(object.model.inviteId, 1, onSuccess, function () { });
        },

        //画面init
        viewShown: function () {
            setMessageList();
        },

        viewHidden: function () {
            viewModel.infoText('');
            viewModel.messageSource([]);
        },
    };

    return viewModel;
};