﻿Light.GroupCreate = function (params) {
    //返回按钮
    backClick = function (e) {
        if (params.groupId) {
            DevExpress.hardwareBackButton.fire();
        } else {
            Light.tool.toPartnerMessageList();
        }
    };

    //确定 按钮
    groupCreateClick = function (e) {
        var list = viewModel.memberSource();
        memberList = '';
        memberHeadList = [];
        if (params.memberHeadList) {
            memberHeadList = $.parseJSON(params.memberHeadList.replace('json:', ''));
        }

        for (var i = 0; i < list.length; i++) {
            if (list[i].displayFlg() && list[i].selectFlg) {
                if (memberList) {
                    memberList += ',' + list[i].userId;
                } else {
                    memberList = list[i].userId;
                }

                memberHeadList.push(list[i].userHeadImage)
            }
        }

        if (memberList) {
            //头像
            createImg();
            //保存
            saveGroup();
        } else {
            DevExpress.ui.notify(Globalize.localize('partner-groupCreate-message'), "info", 2000);
        }

    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: Globalize.localize('partner-memberSelect') },
            { location: 'after', widget: 'button', options: { text: Globalize.localize('common-confirm'), clickAction: groupCreateClick } },
    ];

    var selectWidth = 10;

    var memberList = '';
    var memberHeadList = [];
    var groupImgHeadData = '';

    //群头像
    function createImg() {
        var groupHead, cxt;
        var img = new Image();
        var canvas_length = 113;
        var canvas_blank = 5;

        groupHead = document.getElementById("myCanvas");
        groupHead.width = canvas_length;
        groupHead.height = canvas_length;
        cxt = groupHead.getContext("2d");
        cxt.clearRect(0, 0, canvas_length, canvas_length);
        cxt.fillStyle = '#E2E2E2';
        cxt.fillRect(0, 0, canvas_length, canvas_length);

        if (memberHeadList.length == 1) {
            //1排2列
            var img_length = (canvas_length - canvas_blank * 3) / 2;
            var img_x = canvas_blank;
            var img_y = (canvas_length - img_length) / 2;
            var img_2x = img_length + canvas_blank * 2;

            img.src = memberHeadList[0];
            cxt.drawImage(img, img_x, img_y, img_length, img_length);
            img.src = Light.rtdata.common_imgHead;
            cxt.drawImage(img, img_2x, img_y, img_length, img_length);

        } else if ((memberHeadList.length >= 2) && (memberHeadList.length < 4)) {
            //2排2列
            var img_length = (canvas_length - canvas_blank * 3) / 2;
            var img_x = canvas_blank;
            var img_y = canvas_blank;
            var img_2x = img_length + canvas_blank * 2;
            var img_2y = img_length + canvas_blank * 2;
            //第2排
            img.src = memberHeadList[0];
            cxt.drawImage(img, img_x, img_2y, img_length, img_length);
            img.src = memberHeadList[1];
            cxt.drawImage(img, img_2x, img_2y, img_length, img_length);

            if (memberHeadList.length == 2) {
                //第1排
                var img_x_center = (canvas_length - img_length) / 2;
                img.src = Light.rtdata.common_imgHead;
                cxt.drawImage(img, img_x_center, img_y, img_length, img_length);

            } else if (memberHeadList.length == 3) {
                //第1排
                img.src = memberHeadList[2];
                cxt.drawImage(img, img_x, img_y, img_length, img_length);
                img.src = Light.rtdata.common_imgHead;
                cxt.drawImage(img, img_2x, img_y, img_length, img_length);
            }

        } else if ((memberHeadList.length >= 4) && (memberHeadList.length < 6)) {
            //2排3列
            var img_length = (canvas_length - canvas_blank * 4) / 3;
            var img_x = canvas_blank;
            var img_y = (canvas_length - img_length * 2 - canvas_blank) / 2;
            var img_2x = img_length + canvas_blank * 2;
            var img_2y = img_length + img_y + canvas_blank;
            var img_3x = img_length * 2 + canvas_blank * 3;
            //第2排
            img.src = memberHeadList[0];
            cxt.drawImage(img, img_x, img_2y, img_length, img_length);
            img.src = memberHeadList[1];
            cxt.drawImage(img, img_2x, img_2y, img_length, img_length);
            img.src = memberHeadList[2];
            cxt.drawImage(img, img_3x, img_2y, img_length, img_length);

            if (memberHeadList.length == 4) {
                //第1排
                var img_x_center = (canvas_length - img_length * 2 - canvas_blank) / 2;
                var img_2x_center = img_length + img_x_center + canvas_blank;
                img.src = memberHeadList[3];
                cxt.drawImage(img, img_x_center, img_y, img_length, img_length);
                img.src = Light.rtdata.common_imgHead;
                cxt.drawImage(img, img_2x_center, img_y, img_length, img_length);

            } else if (memberHeadList.length == 5) {
                //第1排
                img.src = memberHeadList[3];
                cxt.drawImage(img, img_x, img_y, img_length, img_length);
                img.src = memberHeadList[4];
                cxt.drawImage(img, img_2x, img_y, img_length, img_length);
                img.src = Light.rtdata.common_imgHead;
                cxt.drawImage(img, img_3x, img_y, img_length, img_length);
            }

        } else if (memberHeadList.length >= 6) {
            //3排3列
            var img_length = (canvas_length - canvas_blank * 4) / 3;
            var img_x = canvas_blank;
            var img_y = canvas_blank;
            var img_2x = img_length + canvas_blank * 2;
            var img_2y = img_length + canvas_blank * 2;
            var img_3x = img_length * 2 + canvas_blank * 3;
            var img_3y = img_length * 2 + canvas_blank * 3;

            //第2排
            img.src = memberHeadList[0];
            cxt.drawImage(img, img_x, img_2y, img_length, img_length);
            img.src = memberHeadList[1];
            cxt.drawImage(img, img_2x, img_2y, img_length, img_length);
            img.src = memberHeadList[2];
            cxt.drawImage(img, img_3x, img_2y, img_length, img_length);
            //第3排
            img.src = memberHeadList[3];
            cxt.drawImage(img, img_x, img_3y, img_length, img_length);
            img.src = memberHeadList[4];
            cxt.drawImage(img, img_2x, img_3y, img_length, img_length);
            img.src = memberHeadList[5];
            cxt.drawImage(img, img_3x, img_3y, img_length, img_length);

            if (memberHeadList.length == 6) {
                //第1排
                img.src = Light.rtdata.common_imgHead;
                cxt.drawImage(img, img_2x, img_y, img_length, img_length);

            } else if (memberHeadList.length == 7) {
                //第1排
                var img_x_center = (canvas_length - img_length * 2 - canvas_blank) / 2;
                var img_2x_center = img_length + img_x_center + canvas_blank;
                img.src = memberHeadList[6];
                cxt.drawImage(img, img_x_center, img_y, img_length, img_length);
                img.src = Light.rtdata.common_imgHead;
                cxt.drawImage(img, img_2x_center, img_y, img_length, img_length);

            } else if (memberHeadList.length >= 8) {
                //第1排
                img.src = memberHeadList[6];
                cxt.drawImage(img, img_x, img_y, img_length, img_length);
                img.src = memberHeadList[7];
                cxt.drawImage(img, img_2x, img_y, img_length, img_length);
                img.src = Light.rtdata.common_imgHead;
                cxt.drawImage(img, img_3x, img_y, img_length, img_length);
            }
        }
        groupImgHeadData = groupHead.toDataURL('png');
    };

    //群保存
    function saveGroup() {

        if (params.groupId) {
            //群成员添加
            if (window.plugins && window.plugins.LeanChat) {
                window.plugins.LeanChat.registStatusCallback(Light.PartnerPluginData.groupData_onState);
                window.plugins.LeanChat.addGroupMembers(Light.rtdata.leanCloudSocialId, params.groupId, memberList, groupImgHeadData);
            }

        } else {
            //群创建
            if (window.plugins && window.plugins.LeanChat) {
                window.plugins.LeanChat.registStatusCallback(Light.PartnerPluginData.group_all_onState);
                window.plugins.LeanChat.createGroup(Light.rtdata.leanCloudSocialId, memberList, '', groupImgHeadData);
            }
        }

    };
    function checkNetState() {
        viewModel.img_info('');
        viewModel.infoText('');

        //网络check
        if (Light.network.checkConnection()) {
            viewModel.networkFlg(true);
        } else {
            viewModel.networkFlg(false);
        }

        if (viewModel.networkFlg()) {
            //有网络
            viewModel.networkFlg(true);
            viewModel.img_info('');
            viewModel.infoText('');
            getAddressBook();
        } else {
            //无网络
            viewModel.img_info('./resource/img/noNetwork.gif');
            viewModel.infoText(Globalize.localize('profile-network-disconnect'));
            return;
        }
    }
    var viewModel = {
        groupListVisible: ko.observable(false),
        memberSource: ko.observable([]),
        networkFlg: ko.observable(true),
        img_info: ko.observable(''),
        infoText: ko.observable(''),
        //页面刷新
        refreshClick: function () {
            checkNetState();
        },
        //删除好友
        delectMemberClick: function (object) {
            if (object.model.displayFlg()) {
                object.model.okCheck('');
                object.model.displayFlg(false);
            }
        },

        //选择好友
        selectMemberClick: function (object) {
            if (object.model.selectFlg) {
                if (object.model.displayFlg()) {
                    object.model.okCheck('');
                    object.model.displayFlg(false);
                    //
                    selectWidth -= 40;
                    $(".groupCreate .selectDiv .dx-scrollable-content").css("width", selectWidth + 'px');
                } else {
                    object.model.okCheck("icon-light-ok");
                    object.model.displayFlg(true);
                    //
                    selectWidth += 40;
                    $(".groupCreate .selectDiv .dx-scrollable-content").css("width", selectWidth + 'px');
                }
            }
        },

        //画面init
        viewShown: function () {
            selectWidth = 10;
            checkNetState()
           // getAddressBook();
        },

        viewHidden: function () {
            viewModel.memberSource([]);
        }
    };

    function getAddressBook() {
        console.log("getAddressBook")
        if (params.memberList) {
            viewModel.groupListVisible(false);
        } else {
            viewModel.groupListVisible(true);
        }
        var onSuccess = function (data) {
            var tmp = [];
            Light.rtdata.partner_friendList = Light.rtdata.leanCloudSocialId;

            for (i = 0; i < data.length; i++) {
                Light.rtdata.partner_friendList += ',' + data[i].objectId;

                var py = codefans_net_CC2PY(data[i].nickname);
                if (params.memberList) {
                    if (params.memberList.indexOf(data[i].objectId + ',') == -1) {
                        //不是群成员
                        tmp.push({
                            userId: data[i].objectId,
                            userHeadImage: data[i].userHeadImage,
                            name: data[i].nickname,
                            name_py: py,
                            key: py.substr(0, 1).toUpperCase(), //排序key
                            keyFlg: ko.observable(false), //排序group 显示flg
                            displayFlg: ko.observable(false), // 选择区域的显示
                            okCheck: ko.observable(''),  //checkbox 显示
                            selectFlg: true, //成员是否能选择
                        })
                    } else {
                        //是群成员
                        tmp.push({
                            userId: data[i].objectId,
                            userHeadImage: data[i].userHeadImage,
                            name: data[i].nickname,
                            name_py: py,
                            key: py.substr(0, 1).toUpperCase(),
                            keyFlg: ko.observable(false),
                            displayFlg: ko.observable(false),
                            okCheck: ko.observable('icon-light-ok-unselect'),
                            selectFlg: false,
                        })

                    }
                } else {
                    tmp.push({
                        userId: data[i].objectId,
                        userHeadImage: data[i].userHeadImage,
                        name: data[i].nickname,
                        name_py: py,
                        key: py.substr(0, 1).toUpperCase(),
                        keyFlg: ko.observable(false),
                        displayFlg: ko.observable(false),
                        okCheck: ko.observable(''),
                        selectFlg: true,
                    })
                }
            }

            viewModel.memberSource(Light.tool.arrSortByGroup(tmp));
        }

        var onFail = function () {
            viewModel.memberSource([]);
        }

        Light.action.leancloud.share.getAddressBook(onSuccess, onFail);
    }

    return viewModel;
};