﻿Light.GroupList = function (params) {

    var viewModel = {
        groupNoDataText: ko.observable(''),
        groupSource: ko.observable([]),

        //选择群
        groupSelectClick:function(e){
            if (window.plugins && window.plugins.LeanChat) {
                window.plugins.LeanChat.registStatusCallback(Light.PartnerPluginData.group_all_onState);
                window.plugins.LeanChat.fetchGroupById(Light.rtdata.leanCloudSocialId, e.itemData.groupId);
            }
        },

        //画面init
        viewShown: function () {
            viewModel.groupSource([]);
            viewModel.groupNoDataText('');

            var onSuccess = function (data) {
                var list = [];
                for (i = 0; i < data.length; i++) {
                    if (data[i].get('m').length > 2) {
                        list.push({
                            groupId: data[i].id,
                            groupHeadImage: data[i].get('attr').icon,
                            name: data[i].get('name'),
                            memberCnt: "（" + data[i].get('m').length + "人）",
                        });
                    }
                    
                }
                if (list.length > 0) {
                    viewModel.groupSource(list);
                    viewModel.groupNoDataText('');
                } else {
                    viewModel.groupSource([]);
                    viewModel.groupNoDataText(Globalize.localize('partner-groupList-nodata'));
                }
            }

            var onFail = function (data) {
                viewModel.groupSource([]);
                viewModel.groupNoDataText(Globalize.localize('partner-groupList-nodata'));
            }

            Light.action.leancloud.realtime.searchMyGroup(Light.rtdata.leanCloudSocialId, onSuccess, onFail);
        },

    };

    return viewModel;
};