﻿Light.GroupShareData = function (params) {

    var inDate = new Date();
    var weightData = [];
    var weightType = 'weight';

    //日期计算
    function showDate(type) {
        var rtDate;
        var value = 1;

        if (type == '-') {
            value = -1;
        }

        rtDate = new Date(viewModel.day());
        rtDate.setDate(rtDate.getDate() + value);

        if ((rtDate < viewModel.popupMinDate) || (rtDate > viewModel.popupMaxDate)){
            DevExpress.ui.notify(Globalize.localize('partner-groupShare-message-date_error'), "error", 2000);
            return 0;
        } else {
            inDate = rtDate;
            viewModel.day(Globalize.format(rtDate, 'yyyy/MM/dd'));
            return 1;
        }
        
    };

    //体重数据 图表绘制
    function reDrawChart() {

        var chartOptions = {
            dataSource: weightData,
            commonSeriesSettings: {
                argumentField: "date",
                type: "spline",
                hoverMode: "includePoints",
                point: {
                    hoverMode: "none"
                }
            },
            commonAxisSettings: {
                grid: {
                    visible: true
                }
            },
            tooltip: {
                enabled: false
            },
            margin: {
                bottom: 30
            },
            series: [
                {
                    valueField: weightType,
                    label: {
                        visible: true,
                        backgroundColor: "transparent",
                        font: {
                            color: "#000000",
                        },
                    }
                }
            ],
            legend: {
                verticalAlignment: "top",
                horizontalAlignment: "right",
                visible: false
            },
            size: {
                height: 250,
            },
            title: "",
            commonPaneSettings: {
                border: {
                    visible: true
                }
            },
        };
        var chart = $("#weightChart").dxChart(chartOptions).dxChart("instance");

        var renderOptions = {
            force: true,
            animate: false,
            asyncSeriesRendering: true
        }
        chart.render(renderOptions);
    };

    //体重数据 表示
    function setWeightData(sdate, data) {

        weightData = [];
        for (i = 0; i < 7; i++) {
            var rtDate = new Date(sdate);
            rtDate.setDate(rtDate.getDate() + i);

            weightData.push({
                date: Globalize.format(rtDate, "MM/dd"),
                weight: 0,
                bmi: 0,
                bfr: 0,
                waterContent: 0,
                mus: 0,
                boneQuality: 0,
                metabolism: 0,
                sfat: 0,
                infat: 0,
                bodyage: 0
            });

            if (rtDate >= viewModel.popupMinDate && rtDate <= viewModel.popupMaxDate) {
                for (j = 0; j < data.length; j++) {
                    var key = Globalize.format(rtDate, "yyyyMMdd");
                    if (key == data[j].surveyDate) {
                        weightData[i].weight = Globalize.parseFloat(Globalize.format(data[j].weight, "n2"));
                        weightData[i].bmi = Globalize.parseFloat(Globalize.format(data[j].bmi, "n2"));
                        weightData[i].bfr = Globalize.parseFloat(Globalize.format(data[j].bfr, "n2"));
                        weightData[i].waterContent = Globalize.parseFloat(Globalize.format(data[j].waterContent, "n2"));
                        weightData[i].mus = Globalize.parseFloat(Globalize.format(data[j].mus, "n2"));
                        weightData[i].boneQuality = Globalize.parseFloat(Globalize.format(data[j].boneQuality, "n2"));
                        weightData[i].metabolism = Globalize.parseFloat(Globalize.format(data[j].metabolism, "n2"));
                        weightData[i].sfat = Globalize.parseFloat(Globalize.format(data[j].sfat, "n2"));
                        weightData[i].infat = Globalize.parseFloat(Globalize.format(data[j].infat, "n2"));
                        weightData[i].bodyage = Globalize.parseFloat(Globalize.format(data[j].bodyage, "n2"));
                        break;
                    }
                }
            }
        }

        //图表绘制
        reDrawChart();
    };

    //运动计步器数据 表示
    function setPedometerData(data) {
        data.sort(function (a, b) { return a.surveyTime - b.surveyTime; });
        var len = data.length - 1;
        var steps = 0;
        var calorie = 0;

        if (len >= 0) {
            steps = data[len].step;
            calorie = Globalize.parseFloat(Globalize.format(data[len].calorie, "n2"));
        }

        viewModel.sportsPedometerSteps(steps);
        viewModel.sportsPedometerCal(calorie);

    }

    //运动，饮食数据 表示
    function setHealthData(recordData) {

        var sportsItemTmp = [];
        var sportsItemCal = 0;
        var foodSumCal = 0;

        for (var i = 0; i < 4; i++) {
            viewModel.foodSource[i].cal(0);
            viewModel.foodSource[i].foodItemSource([]);
        }

        for (var i = 0; i < recordData.length; i++) {
            var dtl = $.parseJSON(recordData[i].recordDtls);
            if (dtl.length > 0) {
                var type = dtl[0].itemType;
                switch (type) {
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                        //吃饭
                        var foodItemTmp = [];
                        var foodItemCal = 0;
                        for (var j = 0; j < dtl.length; j++) {
                            if (dtl[j].dtlType == 1) {
                                foodItemTmp.push({
                                    foodName: dtl[j].name + ' × 1',
                                });
                                foodItemCal += dtl[j].calorie;
                            } else {
                                foodItemTmp.push({
                                    foodName: dtl[j].name + dtl[j].detail + ' × ' + dtl[j].count,
                                });
                                foodItemCal += dtl[j].calorie;
                            }
                        }
                        //
                        viewModel.foodSource[type - 1].cal(foodItemCal);
                        viewModel.foodSource[type - 1].foodItemSource(foodItemTmp);
                        foodSumCal += foodItemCal;
                        break;

                    case 5:
                        //运动
                        for (j = 0; j < dtl.length; j++) {
                            sportsItemTmp.push({
                                sportsName: dtl[j].name + ' ' + dtl[j].detail,
                            });
                            sportsItemCal += dtl[j].calorie;
                        }
                        break;
                }
            }

        }

        viewModel.sportsItemCal(sportsItemCal);
        viewModel.sportsItemSource(sportsItemTmp);
        viewModel.foodSumCal('+ ' + foodSumCal);
        var sportsSumCal = viewModel.sportsPedometerCal() + viewModel.sportsItemCal();
        viewModel.sportsSumCal('- ' + sportsSumCal);
    }

    //服药数据 表示
    function setMedicineData(planData, recordData) {

        var medicineTmp = [];

        for (var i = 0; i < planData.length; i++) {
            //时间list 取得
            var time = planData[i].timeList.split(",");
            for (var k = 0; k < time.length; k++) {
                medicineTmp.push({
                    medicinePlanId: planData[i].medicinePlanId,
                    medicineName: planData[i].medicineName,
                    intTime: Globalize.parseInt(time[k]),
                    time: Light.tool.getDisplayTime(Globalize.parseInt(time[k])),
                    instruction: planData[i].instruction,
                    statusVisible: false,
                });
            }
        }

        //药品list 排序
        medicineTmp.sort(function (a, b) { return a.intTime - b.intTime; });

        for (var i = 0; i < recordData.length; i++) {
            for (var k = 0; k < medicineTmp.length; k++) {
                if ((medicineTmp[k].intTime >= recordData[i].timeStart) && (medicineTmp[k].intTime <= recordData[i].timeEnd)) {
                    if (recordData[i].takenStatus == 1) {
                        medicineTmp[k].statusVisible = true;
                    }
                } else if (medicineTmp[k].intTime > recordData[i].timeEnd) {
                    break;
                }
            }
        }
        viewModel.medicineItemSource(medicineTmp);
    }

    //显示分享内容
    function showShareData(date) {

        if ((viewModel.weightVisible) || (viewModel.sportsVisible) || (viewModel.foodVisible) || (viewModel.medicineVisible)) {
            viewModel.noDataVisible(false);

            var rtDate = new Date(date);
            rtDate.setDate(rtDate.getDate() - 6);
            var startDate = Globalize.format(rtDate, "yyyyMMdd");
            var endDate = Globalize.format(date, "yyyyMMdd");

            var onShareSuccess = function (data) {
                //体重
                if (viewModel.weightVisible) {
                    setWeightData(rtDate, data.weightDayList);
                }

                //运动,饮食
                if ((viewModel.sportsVisible) || (viewModel.foodVisible)) {
                    setPedometerData(data.pedometerList);
                    setHealthData(data.healthPlanRecordList);
                }

                //服药
                if (viewModel.medicineVisible) {
                    setMedicineData(data.medicinePlanList, data.medicinePlanRecordList);
                }

            }
            Light.action.datashare.getDataForMe(Globalize.parseInt(params.userId), startDate, endDate, endDate, onShareSuccess, function () { });

        } else {
            viewModel.noDataVisible(true);
        }
    };

    var viewModel = {
        title: params.name,
        weightVisible: Globalize.parseInt(params.weightFlg),
        sportsVisible: Globalize.parseInt(params.sportsFlg),
        foodVisible: Globalize.parseInt(params.foodFlg),
        medicineVisible: Globalize.parseInt(params.medicineFlg),
        noDataVisible: ko.observable(false),

        day: ko.observable(''),

        //体重
        weightTitle: ko.observable(Globalize.localize('health-weight') + '(kg)'),
        weightBtnSource:[
            { type: 'weight', name: Globalize.localize('health-weight'), title: Globalize.localize('health-weight') + '(kg)' },
            { type: 'bfr', name: Globalize.localize('health-BFR'), title:  Globalize.localize('health-BFR') + '(%)' },
            { type: 'bmi', name: Globalize.localize('health-BMI'), title: Globalize.localize('health-BMI') },
            { type: 'waterContent', name: Globalize.localize('health-water'), title: Globalize.localize('health-water') + '(%)' },
            { type: 'boneQuality', name: Globalize.localize('health-bone'), title: Globalize.localize('health-bone') + '(%)' },
            { type: 'mus', name: Globalize.localize('health-muscle'), title: Globalize.localize('health-muscle') + '(%)' },
            { type: 'metabolism', name: Globalize.localize('health-BMR'), title: Globalize.localize('health-BMR') + '(千卡/天)' },
            { type: 'sfat', name: Globalize.localize('health-sfat'), title: Globalize.localize('health-sfat') + '(%)' },
            { type: 'infat', name: Globalize.localize('health-infat'), title: Globalize.localize('health-infat') },
        ],

        //运动
        sportsSumCal: ko.observable(0),
        sportsPedometerSteps: ko.observable(0),
        sportsPedometerCal: ko.observable(0),
        sportsItemCal: ko.observable(0),
        sportsItemSource: ko.observable([]),

        //服药
        medicineItemSource: ko.observable([]),

        //饮食
        foodSumCal: ko.observable(0),
        foodSource: [
            { name: Light.config.scheduleItemsList[1].title, cal: ko.observable(0), foodItemSource: ko.observable([]) },
            { name: Light.config.scheduleItemsList[2].title, cal: ko.observable(0), foodItemSource: ko.observable([]) },
            { name: Light.config.scheduleItemsList[3].title, cal: ko.observable(0), foodItemSource: ko.observable([]) },
            { name: Light.config.scheduleItemsList[4].title, cal: ko.observable(0), foodItemSource: ko.observable([]) },
        ],

        //popup 日期
        popupDateVisible: ko.observable(false),
        popupDateSelector: ko.observable(),
        popupMinDate: new Date(params.startDate),
        popupMaxDate: new Date(params.endDate),

        //日期往前 按钮
        previousDateClick: function () {
            if (showDate('-') == 1) {
                showShareData(inDate);
            }
        },

        //日期往后 按钮
        nextDateClick: function () {
            if (showDate() == 1) {
                showShareData(inDate);
            }
        },

        //日期选择
        dayClick: function () {
            viewModel.popupDateSelector(inDate);
            viewModel.popupDateVisible(true);
        },

        //体重 按钮
        weightClick: function (object) {
            weightType = object.model.type;
            viewModel.weightTitle(object.model.title);
            reDrawChart();
        },

        //popup 日期选择
        popupDateConfirmClick: function () {
            inDate = viewModel.popupDateSelector();
            viewModel.day(Globalize.format(inDate, 'yyyy/MM/dd'));
            showShareData(inDate);
            viewModel.popupDateVisible(false);
        },

        //popup 取消
        popupCancelClick: function () {
            viewModel.popupDateVisible(false);
        },

        //画面init
        viewShown: function () {
            var sDate = viewModel.popupMinDate;
            var eDate = viewModel.popupMaxDate;
            if ((sDate <= new Date()) && (eDate >= new Date())) {
                inDate = new Date();
            } else {
                if (sDate > new Date()) {
                    inDate = sDate;
                } else {
                    inDate = eDate;
                }
            }

            viewModel.day(Globalize.format(inDate, 'yyyy/MM/dd'));

            //显示
            showShareData(inDate);
        },

        viewHidden: function () {
            viewModel.noDataVisible(false);

            var chartOptions = {
                dataSource: null
            };
            var chart = $("#weightChart").dxChart(chartOptions).dxChart("instance");
        }
    };

    return viewModel;
};