﻿Light.GroupShareSetting = function (params) {

    //返回按钮
    backClick = function (e) {
        saveData();
        DevExpress.hardwareBackButton.fire();
    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: Globalize.localize('partner-groupShareSetting') },
    ];

    var index = 0;
    var selShare = ['未选择', '已选择'];

    //false-->0  ture-->1
    function bool(flg) {
        var rt = 0;
        if (flg) {
            rt = 1;
        }
        return rt;
    };

    //数据保存
    function saveData() {
        var tmp = viewModel.memberSource();
        for (i = 0; i < tmp.length; i++) {
            var flg = [bool(tmp[i].weightFlg()), bool(tmp[i].sportsFlg()), bool(tmp[i].foodFlg()), bool(tmp[i].medicineFlg()), 0];

            var start = Globalize.format(tmp[i].input_startDate(), 'yyyyMMdd');
            var end = Globalize.format(tmp[i].input_endDate(), 'yyyyMMdd');

            if (tmp[i].shareId) {
                //update
                Light.action.datashare.updateDefine(tmp[i].shareId, start, end, flg, function () { }, function () { });

            } else {
                //create
                Light.action.datashare.createDefine(Light.rtdata.memberId, params.groupId, tmp[i].userName, start, end, flg, function () { }, function () { });
            }
        }
    };

    var viewModel = {
        memberSource: ko.observable([]),
        
        //日期
        popupDateVisible: ko.observable(false),
        popupDateSelector: ko.observable(),

        //分享设置
        popupTypeSettingVisible: ko.observable(false),
        popupWeightVisible: ko.observable(false),
        popupSportsVisible: ko.observable(false),
        popupFoodVisible: ko.observable(false),
        popupMedicineVisible: ko.observable(false),

        //画面选择成员
        selectMemberClick: function(object){
            object.model.settingVisible(!object.model.settingVisible());
        },
        
        //分享日期
        groupShareDateClick: function (object) {
            var date = ['', ''];
            date[0] = object.model.input_startDate();
            date[1] = object.model.input_endDate();

            viewModel.popupDateSelector(date);
            index = object.model.id;
            viewModel.popupDateVisible(true);
        },

        //分享类型选择
        shareTypeClick: function (object) {
            viewModel.popupWeightVisible(object.model.weightFlg());
            viewModel.popupSportsVisible(object.model.sportsFlg());
            viewModel.popupFoodVisible(object.model.foodFlg());
            viewModel.popupMedicineVisible(object.model.medicineFlg());
            index = object.model.id;
            viewModel.popupTypeSettingVisible(true);
        },

        //popup 分享项目选择
        popupWeightClick: function () {
            viewModel.popupWeightVisible(!viewModel.popupWeightVisible());
        },
        popupSportsClick: function () {
            viewModel.popupSportsVisible(!viewModel.popupSportsVisible());
        },
        popupFoodClick: function () {
            viewModel.popupFoodVisible(!viewModel.popupFoodVisible());
        },
        popupMedicineClick: function () {
            viewModel.popupMedicineVisible(!viewModel.popupMedicineVisible());
        },

        //popup 日期选择
        popupDateConfirmClick: function (e) {
            var date = viewModel.popupDateSelector();
            var tmp = viewModel.memberSource();
            if (e.element.attr('id') == 'startDate') {
                $('.pop').mobiscroll('setActiveDate', 'start')
            } else {
                $('.pop').mobiscroll('setActiveDate', 'end')
            }
            tmp[index].input_startDate(date[0]);
            tmp[index].display_startDate(Globalize.format(date[0], 'yyyy-MM-dd'));
            tmp[index].input_endDate(date[1]);
            tmp[index].display_endDate(Globalize.format(date[1], 'yyyy-MM-dd'));
            viewModel.memberSource(tmp);

            viewModel.popupDateVisible(false);
        },

        //popup 分享项目确定
        popupShareTypeConfirmClick: function () {
            var tmp = viewModel.memberSource();
            
            tmp[index].weightFlg(viewModel.popupWeightVisible());
            tmp[index].sportsFlg(viewModel.popupSportsVisible());
            tmp[index].foodFlg(viewModel.popupFoodVisible());
            tmp[index].medicineFlg(viewModel.popupMedicineVisible());
            if (viewModel.popupWeightVisible() || viewModel.popupSportsVisible() || viewModel.popupFoodVisible() || viewModel.popupMedicineVisible()) {
                tmp[index].shareResult(selShare[1]);
            } else {
                tmp[index].shareResult(selShare[0]);
            }
            
            viewModel.popupTypeSettingVisible(false);
        },

        //popup 取消
        popupCancelClick: function () {
            viewModel.popupDateVisible(false);
            viewModel.popupTypeSettingVisible(false);
        },

        //画面init
        viewShown: function () {
            //群成员
            var onGroupMemberSuccess = function (rt) {

                var onShareSuccess = function (data) {
                    var tmp = [];
                    var shareFlg = true;
                    var idx = 0;
                    for (i = 0; i < rt.length; i++) {
                        //群成员
                        if (rt[i].id !== Light.rtdata.leanCloudSocialId) {
                            for (j = 0; j < data.length; j++) {
                                //分享设置
                                if (Globalize.parseInt(rt[i].get("username")) == data[j].userIdTo) {
                                    var sDate = Light.tool.getStandardDate(data[j].dateStart);
                                    var eDate = Light.tool.getStandardDate(data[j].dateEnd);
                                    tmp.push({
                                        id: idx,
                                        userId: rt[i].id,
                                        userName: Globalize.parseInt(rt[i].get("username")),
                                        userHeadImage: rt[i].get("userHeadImage"),
                                        name: rt[i].get("nickname"),
                                        shareId: data[j].shareId,
                                        display_startDate: ko.observable(Globalize.format(new Date(sDate), 'yyyy-MM-dd')),
                                        input_startDate: ko.observable(new Date(sDate)),
                                        display_endDate: ko.observable(Globalize.format(new Date(eDate), 'yyyy-MM-dd')),
                                        input_endDate: ko.observable(new Date(eDate)),
                                        weightFlg: ko.observable(data[j].flag1),
                                        sportsFlg: ko.observable(data[j].flag2),
                                        foodFlg: ko.observable(data[j].flag3),
                                        medicineFlg: ko.observable(data[j].flag4),
                                        shareResult: ko.observable(selShare[data[j].flag1 || data[j].flag2 || data[j].flag3 || data[j].flag4]),
                                        settingVisible: ko.observable(false),
                                    });
                                    idx++;
                                    shareFlg = false;
                                    break;
                                }
                            }

                            if (shareFlg) {
                                tmp.push({
                                    id: idx,
                                    userId: rt[i].id,
                                    userName: Globalize.parseInt(rt[i].get("username")),
                                    userHeadImage: rt[i].get("userHeadImage"),
                                    name: rt[i].get("nickname"),
                                    shareId: '',
                                    display_startDate: ko.observable(Globalize.format(new Date(), 'yyyy-MM-dd')),
                                    input_startDate: ko.observable(new Date()),
                                    display_endDate: ko.observable(Globalize.format(new Date(), 'yyyy-MM-dd')),
                                    input_endDate: ko.observable(new Date()),
                                    weightFlg: ko.observable(false),
                                    sportsFlg: ko.observable(false),
                                    foodFlg: ko.observable(false),
                                    medicineFlg: ko.observable(false),
                                    shareResult: ko.observable(selShare[0]),
                                    settingVisible: ko.observable(false),
                                });
                                idx++;
                            }
                            shareFlg = true;
                        }
                    }
                    viewModel.memberSource(tmp);
                }

                Light.action.datashare.getMyDefine(Light.rtdata.memberId, params.groupId, onShareSuccess, function () { });
            }

            var data = {
                clientId: Light.rtdata.leanCloudSocialId,
                groupId: params.groupId,
            };
            Light.action.leancloud.realtime.listGroupMember(data, onGroupMemberSuccess, function () { });
        },

        viewHidden: function () {
            viewModel.memberSource([]);
        }
    };

    return viewModel;
};