﻿Light.Partner = function (params) {

    var groupId = "57303b78f38c840067cb07f8";
    function checkNetState() {
        viewModel.img_info('');
        viewModel.infoText('');
        viewModel.popupPageVisible(true);

        //网络check
        if (Light.network.checkConnection()) {
            viewModel.networkFlg(true);
        } else {
            viewModel.networkFlg(false);
        }

        viewModel.popupPageVisible(false);

        if (viewModel.networkFlg()) {
            //有网络
            viewModel.networkFlg(true);
            viewModel.img_info('');
            viewModel.infoText('');
            Light.tool.toPartnerMessageList();
        } else {
            //无网络
            viewModel.img_info('./resource/img/noNetwork.gif');
            viewModel.infoText(Globalize.localize('profile-network-disconnect'));
        }
    }


    var viewModel = {
        menuItems: Light.config.partnerMenuList,
        contextMenuVisible: ko.observable(false),

        popupPageVisible: ko.observable(false),
        networkFlg: ko.observable(true),
        img_info: ko.observable(''),
        infoText: ko.observable(''),
        //menu按钮
        menuClick: function () {
            if (!viewModel.networkFlg()) return;
            viewModel.contextMenuVisible(true);
        },
        //页面刷新
        refreshClick: function () {
            checkNetState();
        },
        //menu 详细
        menuItemClicked: function (e) {
            if (!viewModel.networkFlg()) return;
            switch (e.itemData.text) {
                case Globalize.localize('partner-groupCreate'):
                    //发起群组
                    Light.app.navigate('GroupCreate');
                    break;
                case Globalize.localize('partner-friendAdd'):
                    //添加同伴
                    Light.app.navigate({ view: 'PartnerSearch', flg: 'add', back: 'Partner' });
                    break;
                case Globalize.localize('partner-activity'):
                    //活动
                    Light.rtdata.activityPage = 'Partner';
                    Light.app.navigate('Activity');
                    break;
                case Globalize.localize('partner-friendList'):
                    //通讯录
                    Light.app.navigate('FriendList');
                    break;
                case Globalize.localize('partner-groupSetting'):
                    //群设置
                    Light.app.navigate({ view: 'GroupSetting', groupId: groupId });
                    break;
                case Globalize.localize('partner-groupShare'):
                    //群分享
                    Light.app.navigate({ view: 'GroupShare', groupId: groupId });
                    break;
            }
        },

        partnerSearchClick: function () {
            if (!viewModel.networkFlg()) return;
            Light.app.navigate({ view: 'PartnerSearch', flg: 'all', back: 'Partner' });
        },

        //画面init
        viewShown: function () {
            if (window.plugins && window.plugins.LeanChat) {
              //  viewModel.popupPageVisible(true);
            }
            checkNetState();
           
        },

        viewHidden: function () {
            viewModel.popupPageVisible(false);
        }
    };

    return viewModel;
};