﻿Light.PartnerSearch = function (params) {

    var activityStateCss = ['deleted', 'onrun', 'ended', '', '', '', '', '', '', 'report', ]

    //tab 变更
    function typeSelect() {
        switch (viewModel.selectedContent()) {
            case 0:
                //好友检索成功
                var list = viewModel.friendSource();
                if (list.length == 0) {
                    var onFriendSuccess = function (data) {
                        viewModel.popupPageVisible(true);

                        Light.rtdata.partner_friendList = Light.rtdata.leanCloudSocialId;

                        for (i = 0; i < data.length; i++) {
                            Light.rtdata.partner_friendList += ',' + data[i].objectId;

                            if (data[i].nickname.indexOf(viewModel.input_search()) > -1) {
                                list.push(data[i]);
                            }
                        }
                        viewModel.friendSource(list);
                        viewModel.popupPageVisible(false);
                    }

                    Light.action.leancloud.share.getAddressBook(onFriendSuccess, function () { });

                }
                break;

            case 1:
                //群
                var list = viewModel.groupSource();
                if (list.length == 0) {
                    //群检索成功
                    var onGroupSuccess = function (data) {
                        viewModel.popupPageVisible(true);

                        for (i = 0; i < data.length; i++) {
                            list.push({
                                groupId: data[i].id,
                                img_head: data[i].get('attr').icon,
                                name: data[i].get('name'),
                            });
                        }
                        viewModel.groupSource(list);
                        viewModel.popupPageVisible(false);
                    };

                    var data = {
                        name: viewModel.input_search(),
                        clientId: Light.rtdata.leanCloudSocialId,
                    };
                    Light.action.leancloud.realtime.searchGroup(data, onGroupSuccess, function () { });

                } 
                break;

            case 2:
                //活动
                var list = viewModel.activitySource();
                if (list.length == 0) {
                    //活动检索成功
                    var activityDone = function (data) {
                        viewModel.popupPageVisible(true);

                        //参加的活动
                        var strJoinId = '';
                        for (var i = 0; i < data.length; i++){
                            strJoinId += data[i].id + ',';
                        }

                        var onActivitySuccess = function (data) {
                            //检索的活动
                            var flg = false;
                            var start = new Date();
                            var end = new Date();
                            var disdate = '';

                            for (i = 0; i < data.length; i++) {
                                flg = false;
                                if (strJoinId.indexOf(data[i].id + ',') == -1) {
                                    flg = true;
                                }

                                start = data[i].get('activityTime');
                                end = data[i].get('activityEndTime');
                                disdate = Light.tool.getActivityDate(start, end);

                                var state = activityStateCss[data[i].get('activityStatus')];
                                if ((data[i].get('activityStatus') == 1) && (end < new Date())) {
                                    state = activityStateCss[2];
                                }

                                list.push({
                                    id: i,
                                    createrId: data[i].get('activityCreaterId'),
                                    activityId: data[i].id,
                                    state: state,
                                    img_picture: data[i].get('activityImg'),
                                    name: data[i].get('activityName'),
                                    addr: data[i].get('activityAdress'),
                                    startDate: start,
                                    endDate: end,
                                    display_date: disdate,
                                    membersCnt: data[i].get('activityMembersCnt') + '人已参加',
                                    content: data[i].get('activityContent'),
                                    enterVisible: flg,
                                });
                            }
                            viewModel.activitySource(list);
                            viewModel.popupPageVisible(false);
                        };

                        Light.action.leancloud.activity.search(viewModel.input_search(), onActivitySuccess, function () { })
                    }

                    Light.action.leancloud.activity.getJoinedOnlyId(activityDone, function () { });
                } 
                break;
        }
    };

    //搜索陌生好友
    function searchFriend() {
        var onFriendSuccess = function (data) {
            var list = [];
            for (i = 0; i < data.length; i++) {
                if (Light.rtdata.leanCloudSocialId !== data[i].id) {
                    //if (Light.rtdata.partner_friendList.indexOf(data[i].id) == -1) {
                        //陌生人和在通讯录的人都显示
                        list.push({
                            objectId: data[i].id,
                            nickname: data[i].get('nickname'),
                            userHeadImage: data[i].get('userHeadImage'),
                        });
                    //}
                }
            }
            if (list.length > 0) {
                viewModel.friendNoDataText('');
                viewModel.friendSource(list);
            } else {
                viewModel.friendNoDataText(Globalize.localize('partner-searchFriend-nodata'));
                viewModel.friendSource([]);
            }
            
        };
        Light.action.leancloud.share.getFriends(viewModel.input_search(), onFriendSuccess, function () { });
    };
    function checkNetState(callbackFunc) {
        viewModel.img_info('');
        viewModel.infoText('');

        //网络check
        if (Light.network.checkConnection()) {
            viewModel.networkFlg(true);
        } else {
            viewModel.networkFlg(false);
        }
      
        if (viewModel.networkFlg()) {
            //有网络
            viewModel.networkFlg(true);
            viewModel.img_info('');
            viewModel.infoText('');
            if (callbackFunc) callbackFunc();
        } else {
            //无网络
            viewModel.img_info('./resource/img/noNetwork.gif');
            viewModel.infoText(Globalize.localize('profile-network-disconnect'));
        }
    }

    var viewModel = {
        input_search: ko.observable(''),
        searchPlaceholder: ko.observable(''),
        networkFlg: ko.observable(true),
        img_info: ko.observable(''),
        infoText: ko.observable(''),
        //页面刷新
        refreshClick: function () {
            checkNetState();
        },
        bodyFriendVisible: ko.observable(false),

        bodyAllVisible: ko.observable(false),
        selectedContent: ko.observable(0),
        contentTabsSource: Light.config.partnerSearchTypeList,
        contentSource: [
            { template: 'friendList' },
            { template: 'groupList' },
            { template: 'activityList' },
        ],

        friendNoDataText: ko.observable(''),
        friendSource: ko.observable([]),
        groupSource: ko.observable([]),
        activitySource: ko.observable([]),

        popupPageVisible: ko.observable(false),

        //返回 按钮
        backClick: function () {
            if (params.back == 'Partner') {
                Light.tool.toPartnerMessageList();
            } else {
                DevExpress.hardwareBackButton.fire();
            }
        },

        //检索 按钮/
        /*
        qrClick: function (e) {

            cordova.plugins.barcodeScanner.scan(
                  function (result) {
                      if (result.cancelled) {
                        //do nothing 
                      } else {

                        if (result.format == "QR_CODE" && result.text.indexOf(Light.config.QRCODE_MEMBERID) != -1) {
                            var content = qrtext.split("-");
                            if (content && content.length == 3) {
                                Light.app.navigate({ view: 'FriendAdd', userId: content[2] });
                            } else {
                                DevExpress.ui.notify("无法识别的二维码", "error", 2000);
                            }
                        } else {
                            DevExpress.ui.notify("无法识别的二维码", "error", 2000);
                        }
                      }
                  }, 
                  function (error) {
                      DevExpress.ui.notify("扫描二维码失败", "error", 2000);
                  }
               );

        },*/

        //检索 按钮
        searchClick: function (e) {
            if (!viewModel.networkFlg())
            {
                DevExpress.ui.notify(Globalize.localize('message-no-net'), "error", 2000);
                return;
            } 
            viewModel.bodyFriendVisible(false);
            viewModel.bodyAllVisible(false);
            viewModel.friendNoDataText('');
            viewModel.friendSource([]);
            viewModel.groupSource([]);
            viewModel.activitySource([]);

            if (Light.tool.trim(viewModel.input_search()) == '') {
                DevExpress.ui.notify(Globalize.localize('partner-searchCondition') + Globalize.localize('message-notNull'), "error", 2000);
            } else {
                if (params.flg == "add") {
                    //添加好友
                    searchFriend();
                    viewModel.bodyFriendVisible(true);

                } else {
                    //查找好友/群/活动
                    typeSelect();
                    viewModel.bodyAllVisible(true);
                }
            }
        },

        //tab 变更
        searchTypeSelectClick: function (e) {
            typeSelect();          
        },

        //好友选择
        freindSelectClick: function (e) {
            if (params.flg == "add") {
                //判断用户是否在通讯录
                if (Light.rtdata.partner_friendList.indexOf(e.itemData.objectId) != -1) {
                    Light.app.navigate({ view: 'FriendDetail', userId: e.itemData.objectId });
                    return;
                }
                //添加好友
                Light.app.navigate({ view: 'FriendAdd', userId: e.itemData.objectId });

            } else {
                //查找好友/群/活动
                Light.app.navigate({ view: 'FriendDetail', userId: e.itemData.objectId });
            }
            
        },


        //群选择
        groupSelectClick: function (e) {
            if (window.plugins && window.plugins.LeanChat) {
                window.plugins.LeanChat.registStatusCallback(Light.PartnerPluginData.group_all_onState);
                window.plugins.LeanChat.fetchGroupById(Light.rtdata.leanCloudSocialId, e.itemData.groupId);
            }
        },

        //活动选择
        activitySelectClick: function (e) {
            Light.app.navigate({ view: 'ActivityDetail', activityId: e.itemData.activityId });
        },

        //画面init
        viewShown: function () {
            checkNetState();
            viewModel.input_search('');
            viewModel.bodyFriendVisible(false);
            viewModel.bodyAllVisible(false);

            if (params.flg == "add") {
                //添加好友
                viewModel.searchPlaceholder('添加同伴 搜索 ');
            } else {
                //查找好友/群/活动
                viewModel.searchPlaceholder('搜索 同伴/群/活动');
            }
        },
    };

    return viewModel;
};