﻿Light.TipOff = function (params) {

    var selectId = -1;

    //数据保存
    function saveData() {
        var record = {
            type: params.type, //0:user 1:group 2:activity
            id: params.id, //userid, groupid, activityid
            reson: Light.config.tipOffList[selectId].name,
            content: viewModel.input_content(),
        }

        Light.action.leancloud.report.createReport(record,
            function (data) { DevExpress.hardwareBackButton.fire(); },
            function () { });
    };

    //画面表示
    function setTipOff() {
        var list = [];
        for (i = 0; i < Light.config.tipOffList.length; i++) {
            list.push({
                id: Light.config.tipOffList[i].id,
                name: Light.config.tipOffList[i].name,
                select: ko.observable(false),
            });
        }
        viewModel.tipOffSource(list);
    };

    var viewModel = {
        tipOffSource: ko.observable([]),
        input_content: ko.observable(''),

        //
        focusInClick: function () {
            if (DevExpress.devices.real().platform == "android") {
                setTimeout(function () {
                    $("#tipOffScrollView").dxScrollView("instance").scrollTo(5000);
                }, 500);
            }
        },

        //选择举报原因
        selectTipOffClick: function (object) {
            var tmp = viewModel.tipOffSource();

            if (object.model.select()) {
                //选择的场合
                selectId = -1;
            } else {
                //未选择的场合
                if (selectId !== -1) {
                    tmp[selectId].select(false);
                } 
                selectId = object.model.id;
            }
            object.model.select(!object.model.select());
        },

        //发送 按钮
        sendClick: function () {
            if (selectId == -1) {
                DevExpress.ui.notify(Globalize.localize('partner-tipOffCause'), "error", 2000);
            } else {
                //保存
                saveData();
            }
        },

        //画面Shown
        viewShown: function () {
            setTipOff();
        },

        viewHidden: function () {
            setTipOff();
            viewModel.input_content('');
        }
    };

    return viewModel;
};