﻿Light.MedicineCreate = function (params) {

    //删除按钮
    deleteClick = function (e) {
        Light.action.customMedicine.remove(
                med.id,
                function () { Light.app.navigate('MedicineSearch'); },
                function () { }
       );
    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: '#MedicineSearch' } },
            { location: 'center', visible: !(params.del == 1), text: Globalize.localize('medicine-medicineCreate') },
            { location: 'center', visible: params.del == 1, text: Globalize.localize('medicine-medicineEdit') },
            { location: 'after', widget: 'button', options: { icon: 'light-remove', visible: params.del == 1, clickAction: deleteClick } },
    ];

    var med = "";
    var height = 0;

    //数据保存
    function dataSave() {
        if (params.medicineItem) {
            //更新数据
            Light.action.customMedicine.update(
               med.id, viewModel.input_name(), viewModel.input_memo(), viewModel.viewSource[0].value(), viewModel.viewSource[1].value(), viewModel.viewSource[2].value(),
               function () { DevExpress.hardwareBackButton.fire(); },
               function () { }
               );

        } else {
            //追加数据
            Light.action.customMedicine.create(
                viewModel.input_name(), viewModel.input_memo(), viewModel.viewSource[0].value(), viewModel.viewSource[1].value(), viewModel.viewSource[2].value(),
                function () { DevExpress.hardwareBackButton.fire(); },
                function () { DevExpress.ui.notify(Globalize.localize('medicine-name') + Globalize.localize('message-repeat'), "error", 2000); }
                );
        }
    };

    //页面初期化
    function init() {
        viewModel.input_name('');
        viewModel.input_memo('');
        viewModel.viewSource[0].value(1);
        viewModel.viewSource[0].displayValue(Light.config.frequencyList[0].name);
        viewModel.viewSource[1].value(1);
        viewModel.viewSource[1].displayValue(1);
        viewModel.viewSource[2].value(6);
        viewModel.viewSource[2].displayValue(Light.config.medicineUnitList[6].name);
    };

    var viewModel = {
        input_name: ko.observable(''),
        input_memo: ko.observable(''),

        viewSource: [
            { id: 0, key: "frequency", title: Globalize.localize('medicine-frequency'), value: ko.observable(""), displayValue: ko.observable("") },
            { id: 1, key: "dosage", title: Globalize.localize('medicine-dosage'), value: ko.observable(""), displayValue: ko.observable("") },
            { id: 2, key: "unit", title: Globalize.localize('medicine-unit'), value: ko.observable(""), displayValue: ko.observable("") },
        ],

        //频率popup
        popupFrequencyVisible: ko.observable(false),
        popupFrequencySelector: ko.observable(),
        popupFrequencySource: Light.config.frequencyList,

        //剂量popup
        popupDosageVisible: ko.observable(false),
        popupDosageSelector: ko.observable(),

        //单位popup
        popupUnitsVisible: ko.observable(false),
        popupUnitsSelector: ko.observable(),
        popupUnitsSource: Light.config.medicineUnitList,

        focusInClick:function(){
            if (DevExpress.devices.real().platform == "android") {
                setTimeout(function () {
                    $("#medicineCreateScrollView").dxScrollView("instance").scrollTo( 5000);
                }, 500);
            }
        },

        //明细item
        viewItemClick:function(object){
            switch (object.model.key) {
                case "frequency":
                    //频率
                    viewModel.popupFrequencySelector(object.model.value());
                    viewModel.popupFrequencyVisible(true);
                    break;
                case "dosage":
                    //剂量
                    viewModel.popupDosageSelector(object.model.value());
                    viewModel.popupDosageVisible(true);
                    break;
                case "unit":
                    //单位
                    viewModel.popupUnitsSelector(object.model.value());
                    viewModel.popupUnitsVisible(true);
                    break;
            }
        },


        //-------popup--------------
        //频率popup 选择item
        popupFrequencyConfirmClick: function () {
            var selected = Globalize.parseInt(viewModel.popupFrequencySelector() + '');
            viewModel.viewSource[0].value(selected);
            viewModel.viewSource[0].displayValue(Light.config.frequencyList[selected-1].name);
            viewModel.popupFrequencyVisible(false);
        },

        //剂量popup 选择item
        popupDosageConfirmClick: function () {
            var selected = viewModel.popupDosageSelector();
            if (selected == 0) {
                DevExpress.ui.notify(Globalize.localize('medicine-dosage') + Globalize.localize('message-notZero'), "error", 2000);
            } else {
                viewModel.viewSource[1].value(selected);
                viewModel.viewSource[1].displayValue(selected);
                viewModel.popupDosageVisible(false);
            }
        },

        //单位popup 选择item
        popupUnitsConfirmClick: function () {
            var selected = Globalize.parseInt(viewModel.popupUnitsSelector() + '');
            viewModel.viewSource[2].value(selected);
            viewModel.viewSource[2].displayValue(Light.config.medicineUnitList[selected].name);
            viewModel.popupUnitsVisible(false);
        },

        //popup画面 取消按钮
        popupCancelClick: function () {
            viewModel.popupFrequencyVisible(false);
            viewModel.popupDosageVisible(false);
            viewModel.popupUnitsVisible(false);
        },

        //保存按钮
        dataSaveClick: function () {
            if (viewModel.input_name()) {  
                dataSave();
            } else {
                DevExpress.ui.notify(Globalize.localize('medicine-name') + Globalize.localize('message-notNull'), "error", 2000);   
            }          
        },

        //画面init
        viewShown: function () {

            Light.rtdata.mediSearch_flg = "medicineCreate";
            init();

            if (params.medicineItem) {
                //编辑 自定义药品
                med = $.parseJSON(params.medicineItem.replace('json:', ''));
                viewModel.input_name(med.name);
                viewModel.input_memo(med.memo);

                viewModel.viewSource[0].value(med.eatFrequency);
                viewModel.viewSource[0].displayValue(Light.config.frequencyList[med.eatFrequency - 1].name);
                viewModel.viewSource[1].value(med.dosage);
                viewModel.viewSource[1].displayValue(med.dosage);
                viewModel.viewSource[2].value(med.unit);
                viewModel.viewSource[2].displayValue(Light.config.medicineUnitList[med.unit].name);
            }
        },
        viewHidden: function () {
            Light.action.customMedicine.uploadToServer();
        }
    };

    return viewModel;
};