﻿
Light.MedicinePlan = function (params) {

    //返回按钮
    backClick = function (e) {
        //Light.app.navigate('Plan', { root: true });
        Light.app.navigate('HealthIndex', { root: true });
    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: Globalize.localize('medicine-medicinePlan') },
            { location: 'after', widget: 'button', options: { icon: 'light-plus', clickAction: '#MedicinePlanCreate' } },
    ];

    var delFlg = 0;
    var delPlanId = '';
    var intToday = Globalize.format(new Date(), 'yyyyMMdd');
    var popupDate = new Date();

    //药品列表显示
    function showMedicineSource() {
        var record = [];
        var date = Globalize.format(new Date(viewModel.day()), 'yyyyMMdd');
        var time = [];

        var done = function (items) {
            for (var i = 0; i < items.length; i++) {
                //时间list 获取
                time = items[i].timeList.split(",");
                for (var k = 0; k < time.length; k++) {
                    record.push({
                        medicineId: items[i].medicineId,
                        name: items[i].medicineName,
                        intTime: time[k],
                        time: Light.tool.getDisplayTime(time[k]),
                        dosage: items[i].instruction,
                    });
                } 
            }

            //排序
            record.sort(function (a, b) { return a.intTime - b.intTime; });

            viewModel.medicineSource(record);

            //调整list
            function getTop(e) {
                var offset = e.offsetTop;
                if (e.offsetParent != null) offset += getTop(e.offsetParent);
                return offset;
            }
            var clientHeight = $(window).height();
            $(".medicinePlan .medicineList .dx-list").each(function () {
                $(".medicinePlan .medicineList .dx-list").css("height", (-getTop(this)) % clientHeight + clientHeight + "px");
            });
        };
        Light.action.customMedicinePlan.getPlanByDate(
            date,
            done,
            function () { }
        );
    };

    //计划列表显示
    function showPlanSource() {
        var record = [];

        var done = function (items) {
            for (var i = 0; i < items.length; i++) {
                var item = items[i];
                var planItem = item.planMetadata;
                planItem[0].planEndDate = Light.tool.getStandardDate(item.endDate);

                record.push({
                    planId: item.medicinePlanId,
                    name: item.medicineName,
                    startDate: item.startDate,
                    planItem: planItem,
                });
            }
            viewModel.planSource(record);

            //调整list
            function getTop(e) {
                var offset = e.offsetTop;
                if (e.offsetParent != null) offset += getTop(e.offsetParent);
                return offset;
            }
            var clientHeight = $(window).height();
            $(".medicinePlan .planList .dx-list").each(function () {
                $(".medicinePlan .planList .dx-list").css("height", (-getTop(this)) % clientHeight + clientHeight + "px");
            });
        };
        Light.action.customMedicinePlan.getPlanList(
            done,
            function () { });
    };

    //日期计算
    function showDate(type) {
        var rtDate;
        var value = 1;

        if (type == '-') {
            value = -1;
        }

        rtDate = new Date(viewModel.day());
        rtDate.setDate(rtDate.getDate() + value);
        popupDate = rtDate;
        viewModel.day(Globalize.format(rtDate, 'yyyy/MM/dd'));
    };

    var viewModel = {
        selectedContent: ko.observable(0),
        day: ko.observable(Globalize.format(new Date(), 'yyyy/MM/dd')),
        medicineSource: ko.observable([]),
        planSource: ko.observable([]),

        contentTabsSource: Light.config.medicinePlanTypeList,
        contentSource: [
            { template: 'medicineList' },
            { template: 'planList' },
        ],

        popupDateVisible: ko.observable(false),
        popupDateSelector: ko.observable(),
        popupMessageVisible: ko.observable(false),
        popupMessage: ko.observable(''),
        popupAlertMessageVisible: ko.observable(false),
        popupAlertMessage: ko.observable(''),


        //日期选择
        dayClick: function () {
            viewModel.popupDateSelector(popupDate);
            viewModel.popupDateVisible(true);
        },

        //日期往前 按钮
        previousDateClick: function () {
            showDate('-');
            showMedicineSource();
        },

        //日期往后 按钮
        nextDateClick: function () {
            showDate();
            showMedicineSource();
        },

        //计划编辑 按钮
        editButton: function(object){
            Light.app.navigate({ view: "MedicinePlanCreate", planId: object.model.planId, planItem: object.model.planItem });
        },

        //计划删除 按钮
        deleteButton: function (object) {
 
            if (intToday >= object.model.startDate) {
                //已经开始的计划，终止原计划
                delFlg = 0;
                delPlanId = object.model.planId;
                viewModel.popupMessage('药品：' + object.model.name + ' 正在被执行，是否删除?');
                viewModel.popupMessageVisible(true);

            } else {
                //未开始的计划，删除原计划
                delFlg = 1;
                delPlanId = object.model.planId;
                viewModel.popupMessage('是否删除药品：' + object.model.name + ' ?');
                viewModel.popupMessageVisible(true);
            }
        },

        //popup 日期选择
        popupDateConfirmClick: function () {
            popupDate = viewModel.popupDateSelector();
            viewModel.day(Globalize.format(popupDate, 'yyyy/MM/dd'));
            viewModel.popupDateVisible(false);
            showMedicineSource();
        },

        //popup画面 确认message 确认按钮
        popupMessageConfirmClick: function () {
            viewModel.popupMessageVisible(false);
            if (delFlg == 0) {
                Light.action.customMedicinePlan.endPlan(delPlanId, intToday,
                               function () {
                                   viewModel.popupAlertMessage('（如果在【我的药品】里面依然存在，说明当天还有计划需要继续执行。）');
                                   viewModel.popupAlertMessageVisible(true);
                               },
                               function () { });

            } else {
                Light.action.customMedicinePlan.deletePlan(delPlanId,
                    function () {
                        viewModel.popupAlertMessage('');
                        viewModel.popupAlertMessageVisible(true);
                    },
                    function () { });
            }
        },

        //popup画面 Alert
        popupAlertConfirmClick: function () {
            viewModel.popupAlertMessageVisible(false);
            showMedicineSource();
            showPlanSource();
        },

        //popup画面 取消按钮
        popupCancelClick: function () {
            viewModel.popupMessageVisible(false);
            viewModel.popupAlertMessageVisible(false);
            viewModel.popupDateVisible(false);
        },

        //画面Shown
        viewShown: function () {
            if (params.planDate) {
                viewModel.day(Globalize.format(new Date(params.planDate), 'yyyy/MM/dd'));
            }
            showMedicineSource();
            showPlanSource();
        },

        //画面Hidden
        viewHidden: function () {
            viewModel.selectedContent(0);
            viewModel.day(Globalize.format(new Date(), 'yyyy/MM/dd'));
            viewModel.medicineSource([]);
            viewModel.planSource([]);
        }
    };

    return viewModel;
};