﻿Light.MedicinePlanCreate = function (params) {

    //帮助按钮
    helpClick = function(e){
        viewModel.popupIKnowVisible(true);
    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: '#MedicinePlan' } },
            { location: 'center', text: Globalize.localize('medicine-medicinePlanCreate') },
            { location: 'after', widget: 'button', options: { icon: 'light-help', clickAction: helpClick } },
    ];

    var popupWeekList = [];
    var mediId = '';
    var editPlanStartDate = '';
    var editPlanId = '';
    var intToday = Globalize.format(new Date(), 'yyyyMMdd');
    var saveDataStartDate, saveDataTimelist, saveDataDosage, saveDataDescription, saveDataPlanDetail;
    var height = 0;

    //自定义药品保存
    function saveData() {

        var mediDone = function (data) {

            var times = viewModel.timeSource().length;
            if (times > 5) {
                times = 5;
            }

            if (data.length > 0) {
                //更新数据
                Light.action.customMedicine.update(data[0].customMedicineId, viewModel.input_name(), data[0].medicineMemo, times, viewModel.input_dosage(), viewModel.input_unit(),
                    function () {
                        mediId = data[0].customMedicineId;
                        planSaveData();
                }, function () { });

            } else {
                //追加数据
                Light.action.customMedicine.create(viewModel.input_name(), '', times, viewModel.input_dosage(), viewModel.input_unit(),
                    function (rt) {
                        mediId = rt.customMedicineId;
                        planSaveData();
                }, function () { });
            }
        }

        Light.action.customMedicine.getByName(viewModel.input_name(), mediDone, function () { });
        
    }

    //计划数据保存
    function planSaveData() {
        var plandone = function () {
            //upload new plan to server
            // Light.action.plan.uploadToServer(null, null);
            //renew native notification
            Light.action.notification.renewNotification(function () { Light.action.notification.renewSystemNotification(null, null); }, null);
            Light.app.navigate({ view: 'MedicinePlan', planDate: saveDataPlanDetail[0].planStartDate });
        };

        switch (viewModel.input_interval()) {
            case 0:
                //间隔周期-- 一次性，保存数据
                //medicineId, medicineName, timelist, startDate, description, dosage + unit, planDetail
                Light.action.customMedicinePlan.createPlanCustomOnce(
                            mediId, viewModel.input_name(), saveDataTimelist, saveDataStartDate, saveDataDescription, saveDataDosage, saveDataPlanDetail,
                            plandone);
                break;

            case 1:
                //间隔周期-- 每天，保存数据
                // medicineId, medicineName, duration, timelist, startDate, description, dosage + unit, planDetail,
                //Light.action.customMedicinePlan.createPlanEveryDay(
                //           mediId, viewModel.input_name(), viewModel.input_duration(), saveDataTimelist, saveDataStartDate, saveDataDescription, saveDataDosage, saveDataPlanDetail,
                //           plandone);

                // medicineId, medicineName, timelist, startDate, endDate, description, dosage + unit, planDetail,
                Light.action.customMedicinePlan.createPlanEveryDay2(
                           mediId, viewModel.input_name(), saveDataTimelist, saveDataStartDate, viewModel.input_planEndDate(), saveDataDescription, saveDataDosage, saveDataPlanDetail,
                           plandone);
                break;

            case 2:
                //间隔周期-- 每周，保存数据
                //medicineId, medicineName, duration, weekList, timelist, startDate, description, dosage + unit, planDetail,
                //Light.action.customMedicinePlan.createPlanWeek(
                //            mediId, viewModel.input_name(), viewModel.input_duration(), viewModel.weekList(), saveDataTimelist, saveDataStartDate, saveDataDescription, saveDataDosage, saveDataPlanDetail,
                //            plandone);

                //medicineId, medicineName, weekList, timelist, startDate, endDate, description, dosage + unit, planDetail,
                Light.action.customMedicinePlan.createPlanWeek2(
                            mediId, viewModel.input_name(), viewModel.weekList(), saveDataTimelist, saveDataStartDate, viewModel.input_planEndDate(), saveDataDescription, saveDataDosage, saveDataPlanDetail,
                            plandone);
                break;

            case 3:
                //间隔周期-- 隔天，保存数据
                //medicineId, medicineName, duration, intervaldays, timelist, startDate, description, dosage + unit, planDetail,
                //Light.action.customMedicinePlan.createPlanIntervalDay(
                //            mediId, viewModel.input_name(), viewModel.input_duration(), viewModel.input_intervalDay(), saveDataTimelist, saveDataStartDate, saveDataDescription, saveDataDosage, saveDataPlanDetail,
                //            plandone);

                //medicineId, medicineName, duration, timelist, startDate, endDate, description, dosage + unit, planDetail,
                Light.action.customMedicinePlan.createPlanIntervalDay2(
                            mediId, viewModel.input_name(), viewModel.input_intervalDay(), saveDataTimelist, saveDataStartDate, viewModel.input_planEndDate(), saveDataDescription, saveDataDosage, saveDataPlanDetail,
                            plandone);
                break;
        }
    };

    //保存数据 (startDate, startTime, timelist, description, dosage + unit)作成
    function getSaveData() {
        saveDataStartDate = viewModel.input_planStartDate();//"20141030";

        //timelist
        var tempList = viewModel.timeSource();
        saveDataTimelist = [];
        for (i = 0; i < tempList.length; i++) {
            saveDataTimelist.push(tempList[i].int);
        }

        saveDataDosage = viewModel.input_dosage() + viewModel.unit();

        //description
        saveDataDescription = Globalize.localize('medicine-notify-description2');
        saveDataDescription = saveDataDescription.replace('dosage', saveDataDosage);

        if (viewModel.input_foodRemark() == 3) {
            saveDataDescription = saveDataDescription.replace('food', '');
        } else {
            saveDataDescription = saveDataDescription.replace('food', viewModel.foodRemark());
        }

        if (viewModel.input_remark()) {
            saveDataDescription = saveDataDescription + ', ' + viewModel.input_remark();
        }

        //planDetail
        saveDataPlanDetail = [];
        saveDataPlanDetail.push({
            name: viewModel.input_name(),//名称
            time: viewModel.timeSource(),//时间
            dosage: viewModel.input_dosage(),//剂量
            unit: viewModel.input_unit(),//剂量单位
            planStartDate: viewModel.display_planStartDate(),//开始时间
            planEndDate: viewModel.display_planEndDate(),//结束时间
            interval: viewModel.input_interval(),//间隔期间
            intervalDay: viewModel.input_intervalDay(),//间隔天数
            week: viewModel.weekList(),//星期间隔
            duration: viewModel.input_duration(),//持续天数
            foodRemark: viewModel.input_foodRemark(),//用餐说明
            remark: viewModel.input_remark(),//说明
        });
    };

    //页面初期化
    function init() {
        viewModel.title(Globalize.localize('medicine-medicinePlanCreate'));
        viewModel.input_name('');
        viewModel.input_dosage(1);
        viewModel.input_intervalDay(1);
        viewModel.duration(14 + Globalize.localize('common-day'));
        viewModel.input_duration(14);
        viewModel.dosageVisible(false);
        viewModel.planVisible(false);
        viewModel.remarkVisible(false);
        viewModel.timeSource([]);
        viewModel.unit(Light.config.medicineUnitList[6].name);
        viewModel.input_unit(6);
        viewModel.planStartDate(Globalize.format(new Date(), 'yyyy-MM-dd'));
        viewModel.input_planStartDate(Globalize.format(new Date(), 'yyyyMMdd'));
        viewModel.display_planStartDate(Globalize.format(new Date(), 'yyyy/MM/dd'));
        var tempDate = new Date(viewModel.display_planStartDate());
        tempDate.setDate(tempDate.getDate() + 14);
        viewModel.planEndDate(Globalize.format(new Date(tempDate), 'yyyy-MM-dd'));
        viewModel.input_planEndDate(Globalize.format(new Date(tempDate), 'yyyyMMdd'));
        viewModel.display_planEndDate(Globalize.format(new Date(tempDate), 'yyyy/MM/dd'));
        viewModel.popupMinDate = new Date();
        viewModel.interval(Light.config.notifyIntervalList[1].name);
        viewModel.input_interval(1);
        viewModel.weekList([]);
        viewModel.foodRemark(Light.config.foodRemarkList[3].name);
        viewModel.input_foodRemark(3);
        viewModel.input_remark('');
    };

    var viewModel = {
        pageVisible: ko.observable(false),
        popupPageVisible: ko.observable(false),

        title: ko.observable(''),
        input_name: ko.observable(''),
        input_intervalDay: ko.observable(1),
        duration: ko.observable(14 + Globalize.localize('common-day')),
        input_duration: ko.observable(14),

        dosageVisible: ko.observable(false),
        planVisible: ko.observable(false),
        remarkVisible: ko.observable(false),

        //时间
        timeSource: ko.observable([]),
        popupTimeVisible: ko.observable(false),
        popupTimeSelector: ko.observable(),

        //剂量
        input_dosage: ko.observable(1),
        popupDosageVisible: ko.observable(false),
        popupDosageSelector: ko.observable(),
        popupDosageDefaultValue: 50,

        //单位
        unit: ko.observable(Light.config.medicineUnitList[6].name),
        input_unit: ko.observable(6),
        popupUnitsVisible: ko.observable(false),
        popupUnitsSelector: ko.observable(),
        popupUnitsSource: Light.config.medicineUnitList,

        //开始日期
        planStartDate: ko.observable(Globalize.format(new Date(), 'yyyy-MM-dd')),
        input_planStartDate: ko.observable(Globalize.format(new Date(), 'yyyyMMdd')),
        display_planStartDate: ko.observable(Globalize.format(new Date(), 'yyyy/MM/dd')),
        //终了日期
        planEndDate: ko.observable(Globalize.format(new Date(), 'yyyy-MM-dd')),
        input_planEndDate: ko.observable(Globalize.format(new Date(), 'yyyyMMdd')),
        display_planEndDate: ko.observable(Globalize.format(new Date(), 'yyyy/MM/dd')),
        //日期
        popupDateTitle: ko.observable(''),
        popupDateVisible: ko.observable(false),
        popupDateSelector: ko.observable(),
        popupMinDate: new Date(),

        //间隔周期
        interval: ko.observable(Light.config.notifyIntervalList[1].name),
        input_interval: ko.observable(1),
        popupIntervalVisible: ko.observable(false),
        popupIntervalSelector: ko.observable(),
        popupIntervalSource: Light.config.notifyIntervalList,

        //星期
        weekList: ko.observable([]),
        popupWeekVisible: ko.observable(false),
        popupWeekSelector: ko.observable(),
        popupWeekSource: Light.config.weekList,

        //说明
        foodRemark: ko.observable(Light.config.foodRemarkList[3].name),
        input_foodRemark: ko.observable(3),
        input_remark: ko.observable(''),
        popupFoodRemarkVisible: ko.observable(false),
        popupFoodRemarkSelector: ko.observable(),
        popupFoodRemarkSource: Light.config.foodRemarkList,

        //数量
        popupNumberTitle: ko.observable(''),
        popupNumberSelector: ko.observable(),
        popupNumberVisible: ko.observable(false),

        //我知道了
        popupIKnowVisible: ko.observable(false),

        //确认message
        popupMessageVisible: ko.observable(false),

        //
        focusInClick: function () {
            if (DevExpress.devices.real().platform == "android") {
                setTimeout(function () {
                    $("#medicinePlanCreateScrollView").dxScrollView("instance").scrollTo(5000);
                }, 500);
            }
        },

        //----画面按钮------//
        //药品名称取得
        nameFocusOutClick: function () {
            var mediDone = function (data) {

                if (data.length > 0) {
                    mediId = data[0].customMedicineId;
                    var time = [];
                    if (data[0].eatFrequency) {
                        Array.prototype.push.apply(time, Light.tool.getTakenTimes(data[0].eatFrequency));
                        viewModel.timeSource(time);
                    }

                    viewModel.input_dosage(data[0].dosage);
                    viewModel.input_unit(data[0].unit);
                    viewModel.unit(Light.config.medicineUnitList[data[0].unit].name);

                } 
            }

            Light.action.customMedicine.getByName(viewModel.input_name(), mediDone, function () { });
        },

        //添加时间 +按钮
        plusTimeClick: function () {
            viewModel.popupTimeSelector(Globalize.format(new Date(), 'H:00'));
            viewModel.popupTimeVisible(true);
        },

        //时间list item删除 x按钮
        timeItemDeleteClick: function (object) { 
            var tempList = viewModel.timeSource();
            for (i = 0; i < tempList.length; i++) {
                if (tempList[i].int == object.model.int) {
                    tempList.splice(i, 1);
                    viewModel.timeSource(tempList);
                    break;
                }
            }
        },

        //剂量 >按钮 
        dosageClick: function () {
            viewModel.popupDosageSelector(viewModel.input_dosage());
            viewModel.popupDosageVisible(true);
        },

        //单位 >按钮 
        unitClick: function () {
            viewModel.popupUnitsSelector(viewModel.input_unit());
            viewModel.popupUnitsVisible(true);
        },

        //开始日期 >按钮 
        planStartDateClick: function () {
            viewModel.popupDateTitle(Globalize.localize('medicine-planStartDate'));
            viewModel.popupDateSelector(viewModel.display_planStartDate());
            viewModel.popupDateVisible(true);
        },

        //终了日期 >按钮 
        planEndDateClick: function () {
            viewModel.popupDateTitle(Globalize.localize('medicine-planEndDate'));
            viewModel.popupDateSelector(viewModel.display_planEndDate());
            viewModel.popupDateVisible(true);
        },

        //间隔周期 >按钮 
        intervalClick: function () {
            viewModel.popupIntervalSelector(viewModel.input_interval());
            viewModel.popupIntervalVisible(true);
        },

        //持续天数 >按钮 
        durationClick: function () {
            viewModel.popupNumberVisible(true);
            viewModel.popupNumberTitle(Globalize.localize('medicine-duration'));
            viewModel.popupNumberSelector(viewModel.input_duration());
        },

        //餐饮说明 >按钮 
        foodRemarkClick: function () {
            viewModel.popupFoodRemarkSelector(viewModel.input_foodRemark());
            viewModel.popupFoodRemarkVisible(true);
        },


        //----popup-------
        //添加时间popup 确认按钮
        popupTimeConfirmClick: function () {
            var tempList = viewModel.timeSource();

            var time = viewModel.popupTimeSelector();
            var intTime = Globalize.parseInt(Globalize.format(time, 'Hmm'));
            if (isNaN(intTime)) {
                var intTime = time.replace(":", "");
            }
            tempList.push({
                int: intTime,
                time: Light.tool.getDisplayTime(intTime),
            });

            //sort , delete repeatValue
            tempList.sort(function (a, b) { return a.int - b.int; });
            var sortList = [];
            for (i = 0; i < tempList.length; i++) {
                if (i == tempList.length - 1) {
                    sortList.push(tempList[i]);
                } else {
                    if (tempList[i].int !== tempList[i + 1].int) {
                        sortList.push(tempList[i]);
                    }
                }
            }

            viewModel.timeSource(sortList);
            viewModel.popupTimeVisible(false);
        },

        //剂量popup 确认按钮
        popupDosageConfirmClick: function () {
            var selected = viewModel.popupDosageSelector();
            if (selected == 0) {
                DevExpress.ui.notify(Globalize.localize('medicine-dosage') + Globalize.localize('message-notZero'), "error", 2000);
            } else {
                viewModel.input_dosage(selected);
                viewModel.popupDosageVisible(false);
            }
        },

        //单位popup 确认按钮
        popupUnitsConfirmClick: function () {
            var selected = Globalize.parseInt(viewModel.popupUnitsSelector()+'');
            viewModel.input_unit(selected);
            viewModel.unit(Light.config.medicineUnitList[selected].name);
            viewModel.popupUnitsVisible(false);
        },

        //服药时间popup 确认按钮
        popupDateConfirmClick: function () {
            var ymd = viewModel.popupDateSelector();
            var selectYMD = Globalize.format(new Date(viewModel.popupDateSelector()),"yyyyMMdd");
            switch (viewModel.popupDateTitle()) {
                case Globalize.localize('medicine-planStartDate'):
                    if ((intToday <= selectYMD) && (viewModel.input_planEndDate() >= selectYMD)) {
                        viewModel.planStartDate(Globalize.format(new Date(ymd), 'yyyy-MM-dd'));
                        viewModel.input_planStartDate(Globalize.format(new Date(ymd), 'yyyyMMdd'));
                        viewModel.display_planStartDate(Globalize.format(new Date(ymd), 'yyyy/MM/dd'));
                        viewModel.popupDateVisible(false);

                    } else {
                        if (viewModel.input_planEndDate() < selectYMD) {
                            DevExpress.ui.notify(Globalize.localize('medicine-planEndDate_error'), "error", 3000);
                        } else {
                            DevExpress.ui.notify(Globalize.localize('medicine-planStartDate_error'), "error", 3000);
                        }
                    }
                    break;

                case Globalize.localize('medicine-planEndDate'):
                    if (viewModel.input_planStartDate() <= selectYMD) {
                        viewModel.planEndDate(Globalize.format(new Date(ymd), 'yyyy-MM-dd'));
                        viewModel.input_planEndDate(Globalize.format(new Date(ymd), 'yyyyMMdd'));
                        viewModel.display_planEndDate(Globalize.format(new Date(ymd), 'yyyy/MM/dd'));
                        viewModel.popupDateVisible(false);

                    } else {
                        DevExpress.ui.notify(Globalize.localize('medicine-planEndDate_error'), "error", 3000);
                    }
                    break;
            } 
        },

        //间隔周期popup 确认按钮
        popupIntervalConfirmClick: function () {
            var selected = Globalize.parseInt(viewModel.popupIntervalSelector() + '');
            switch (selected) {
                case 0:
                    viewModel.input_interval(selected);
                    viewModel.interval(Light.config.notifyIntervalList[selected].name);
                    viewModel.weekList([]);
                    break;
                case 1:
                    viewModel.input_interval(selected);
                    viewModel.interval(Light.config.notifyIntervalList[selected].name);
                    viewModel.weekList([]);
                    viewModel.input_duration(14);
                    viewModel.duration(14 + Globalize.localize('common-day'));
                    break;
                case 2:
                    var list = viewModel.weekList();
                    var weekList = [];
                    for (var i = 0; i < list.length; i++) {
                        if (list[i] == 1) {
                            weekList.push(i);
                        }
                    }
                    viewModel.popupWeekSelector(weekList);
                    viewModel.popupWeekVisible(true);
                    break;
                case 3:
                    viewModel.popupNumberTitle(Globalize.localize('medicine-intervalDay'));
                    viewModel.popupNumberSelector(viewModel.input_intervalDay());
                    viewModel.popupNumberVisible(true);
                    break;
            }
            viewModel.popupIntervalVisible(false);     
        },

        //星期popup 确认按钮
        popupWeekConfirmClick: function () {
            var list = viewModel.popupWeekSelector();
            var tempList = [0, 0, 0, 0, 0, 0, 0];
            var tempString = '';
            if (list !== null) {
                for (var i = 0; i < list.length; i++) {
                    tempList[list[i]] = 1;
                    tempString = tempString + ' ' + Light.config.weekList[list[i]].name;
                }
            }
            if (tempString) {
                viewModel.input_interval(2);
                viewModel.interval(tempString);
                viewModel.weekList(tempList);
                viewModel.input_duration(2);
                viewModel.duration(2 + Globalize.localize('common-week'));
                viewModel.popupWeekVisible(false);
            } else {
                DevExpress.ui.notify(Globalize.localize('medicine-selectWeek') + Globalize.localize('message-notNull'), "error", 2000);
            }
        },

        //星期popup 取消按钮
        popupWeekCancelClick: function () {
            viewModel.popupWeekVisible(false);
            viewModel.popupIntervalVisible(true);
        },

        //餐饮说明popup 确认按钮
        popupFoodRemarkConfirmClick: function () {
            var selected = Globalize.parseInt(viewModel.popupFoodRemarkSelector()+'');
            viewModel.input_foodRemark(selected);
            viewModel.foodRemark(Light.config.foodRemarkList[selected].name);
            viewModel.popupFoodRemarkVisible(false);
        },

        //数量popup 确认按钮
        popupNumberConfirmClick: function () {
            var selected = viewModel.popupNumberSelector();

            switch (viewModel.popupNumberTitle()) {
                case Globalize.localize('medicine-intervalDay'):
                    //间隔天数
                    viewModel.input_intervalDay(viewModel.popupNumberSelector());
                    var str = Light.config.notifyIntervalList[3].name;
                    //ex： str = 每隔3天
                    viewModel.interval(str.substr(0, 2) + viewModel.popupNumberSelector() + str.substr(3, 1));
                    viewModel.input_interval(3);
                    viewModel.weekList([]);
                    viewModel.input_duration(14);
                    viewModel.duration(14 + Globalize.localize('common-day'));
                    break;

                case Globalize.localize('medicine-duration'):
                    //持续天数
                    viewModel.input_duration(viewModel.popupNumberSelector());
                    if (viewModel.input_interval() == 2) {
                        var str = viewModel.popupNumberSelector() + Globalize.localize('common-week');
                    } else {
                        var str = viewModel.popupNumberSelector() + Globalize.localize('common-day');
                    }
                    viewModel.duration(str);
                    break;
            }
            viewModel.popupNumberVisible(false);
        },

        //数量popup 取消按钮
        popupNumberCancelClick: function () {
            switch (viewModel.popupNumberTitle()) {
                case Globalize.localize('medicine-intervalDay'):
                    viewModel.popupIntervalVisible(true);
                    break;
            }
            viewModel.popupNumberVisible(false);
        },

        //我知道了 按钮
        popupIKnowConfirmClick: function(){
            viewModel.popupIKnowVisible(false);
        },

        //确认message 确认按钮
        popupMessageConfirmClick: function () {
            viewModel.popupMessageVisible(false);

            Light.action.customMedicinePlan.endPlan(editPlanId, intToday,
                               function () {
                                   var sDay = new Date();
                                   sDay.setDate(sDay.getDate() + 1);
                                   var detailDay = Globalize.format(sDay, 'yyyy/MM/dd');
                                   var dispDay = Globalize.format(sDay, 'yyyyMMdd');
                                   //开始日期小于第二天，已第二天为准
                                   if (dispDay > viewModel.input_planStartDate()) {
                                       saveDataStartDate = dispDay;//"20141030";
                                       saveDataPlanDetail[0].planStartDate = detailDay;//"2014/10/30";
                                   }

                                   //数据保存
                                   saveData();
                               },
                               function () { });
        },

        //popup画面 取消按钮
        popupCancelClick: function () {
            viewModel.popupTimeVisible(false);
            viewModel.popupDosageVisible(false);
            viewModel.popupUnitsVisible(false);
            viewModel.popupDateVisible(false);
            viewModel.popupIntervalVisible(false);
            viewModel.popupWeekVisible(false);
            viewModel.popupNumberVisible(false);
            viewModel.popupFoodRemarkVisible(false);
            viewModel.popupIKnowVisible(false);
            viewModel.popupMessageVisible(false);
        },



        //------栏visible-------
        //剂量栏 显示按钮
        dosageVisibleClick: function () {
            if (viewModel.dosageVisible()) {
                viewModel.dosageVisible(false);
            } else {
                viewModel.dosageVisible(true);
            }
        },

        //计划栏 显示按钮
        planVisibleClick:function(){
            if (viewModel.planVisible()) {
                viewModel.planVisible(false);
            } else {
                viewModel.planVisible(true);
            }
        },

        //说明栏 显示按钮
        remarkVisibleClick: function () {
            if (viewModel.remarkVisible()) {
                viewModel.remarkVisible(false);
            } else {
                viewModel.remarkVisible(true);
            }
        },
        
        //-------------------------
        //选择药品
        medicineSearchClick:function(){
            //保存数据作成
            getSaveData();
            Light.rtdata.mediSearch_data = [];
            Light.rtdata.mediSearch_data = saveDataPlanDetail;
            Light.app.navigate('MedicineSearch');
        },

        //保存按钮
        saveClick: function () {
            var isCorrect = 0;

            //check
            if (!viewModel.input_name()) {
                isCorrect = 1;
            } else if (!viewModel.timeSource().length) {
                isCorrect = 2;
            }

            switch (isCorrect) {
                case 1:
                    DevExpress.ui.notify(Globalize.localize('medicine-name') + Globalize.localize('message-notNull'), "error", 2000);
                    break;
                case 2:
                    DevExpress.ui.notify(Globalize.localize('medicine-time') + Globalize.localize('message-notNull'), "error", 2000);
                    break;
                default:
                    //保存数据作成
                    getSaveData();

                    if (editPlanId) {
                        //编辑的场合
                        var startYMD = Globalize.format(new Date(editPlanStartDate), 'yyyyMMdd');

                        if (intToday >= startYMD) {
                            //已经开始的计划，终止原计划
                            viewModel.popupMessageVisible(true);

                        } else {
                            //未开始的计划，删除原计划
                            Light.action.customMedicinePlan.deletePlan(editPlanId,
                                function () {
                                    //数据保存
                                    saveData();
                                },
                                function () { });

                        }
                    } else {
                        //数据保存
                        saveData();
                    }                   
            }
        },

        //画面init
        viewShown: function () {
            viewModel.popupPageVisible(true);

            init();
            Light.rtdata.mediSearch_flg = "plan";

            //药品取得
            if (params.medicineItem) {
                var medi = $.parseJSON(params.medicineItem.replace('json:', ''));
                mediId = medi.id;
                viewModel.input_name(medi.name);
                var time = [];
                if (medi.eatFrequency) {
                    Array.prototype.push.apply(time, Light.tool.getTakenTimes(medi.eatFrequency));
                    viewModel.timeSource(time);
                }

                viewModel.input_dosage(medi.dosage);
                viewModel.input_unit(medi.unit);
                viewModel.unit(Light.config.medicineUnitList[medi.unit].name);
            }

            //药品返回
            if (params.medicineBack) {
                var planSource = Light.rtdata.mediSearch_data;
                var plan = planSource[0];

                viewModel.input_name(plan.name);
                viewModel.timeSource(plan.time);

                viewModel.input_dosage(plan.dosage);
                viewModel.input_unit(plan.unit);
                viewModel.unit(Light.config.medicineUnitList[plan.unit].name);

                viewModel.planStartDate(Globalize.format(new Date(plan.planStartDate), 'yyyy-MM-dd'));
                viewModel.input_planStartDate(Globalize.format(new Date(plan.planStartDate), 'yyyyMMdd'));
                viewModel.display_planStartDate(Globalize.format(new Date(plan.planStartDate), 'yyyy/MM/dd'));
                viewModel.planEndDate(Globalize.format(new Date(plan.planEndDate), 'yyyy-MM-dd'));
                viewModel.input_planEndDate(Globalize.format(new Date(plan.planEndDate), 'yyyyMMdd'));
                viewModel.display_planEndDate(Globalize.format(new Date(plan.planEndDate), 'yyyy/MM/dd'));
                var today = Globalize.format(new Date(), 'yyyyMMdd');
                if (viewModel.input_planStartDate() <= today) {
                    viewModel.popupMinDate = new Date(plan.planStartDate);
                } else {
                    viewModel.popupMinDate = new Date();
                }

                viewModel.input_interval(plan.interval);
                if (plan.interval == 2) {
                    //每周
                    var list = plan.week;
                    var tempString = '';
                    if (list !== null) {
                        for (var i = 0; i < list.length; i++) {
                            if (list[i] == 1) {
                                tempString = tempString + ' ' + Light.config.weekList[i].name;
                            }
                        }
                    }
                    viewModel.interval(tempString);

                } else if (plan.interval == 3) {
                    //每隔X天
                    var str = Light.config.notifyIntervalList[3].name;
                    viewModel.interval(str.substr(0, 2) + plan.intervalDay + str.substr(3, 1));

                } else {
                    viewModel.interval(Light.config.notifyIntervalList[plan.interval].name);
                }

                viewModel.input_intervalDay(plan.intervalDay);
                viewModel.weekList(plan.week);
                viewModel.input_duration(plan.duration);
                if (plan.interval == 2) {
                    viewModel.duration(plan.duration + Globalize.localize('common-week'));
                } else {
                    viewModel.duration(plan.duration + Globalize.localize('common-day'));
                }

                viewModel.input_foodRemark(plan.foodRemark);
                viewModel.foodRemark(Light.config.foodRemarkList[plan.foodRemark].name);
                viewModel.input_remark(plan.remark);

            }

            //计划取得
            if (params.planItem) {
                var planSource = $.parseJSON(params.planItem.replace('json:', ''));
                var plan = planSource[0];

                editPlanId = params.planId;
                editPlanStartDate = plan.planStartDate;

                viewModel.title(Globalize.localize('medicine-medicinePlanEdit'));
                viewModel.input_name(plan.name);
                viewModel.timeSource(plan.time);

                viewModel.input_dosage(plan.dosage);
                viewModel.input_unit(plan.unit);
                viewModel.unit(Light.config.medicineUnitList[plan.unit].name);

                viewModel.planStartDate(Globalize.format(new Date(plan.planStartDate), 'yyyy-MM-dd'));
                viewModel.input_planStartDate(Globalize.format(new Date(plan.planStartDate), 'yyyyMMdd'));
                viewModel.display_planStartDate(Globalize.format(new Date(plan.planStartDate), 'yyyy/MM/dd'));
                viewModel.planEndDate(Globalize.format(new Date(plan.planEndDate), 'yyyy-MM-dd'));
                viewModel.input_planEndDate(Globalize.format(new Date(plan.planEndDate), 'yyyyMMdd'));
                viewModel.display_planEndDate(Globalize.format(new Date(plan.planEndDate), 'yyyy/MM/dd'));
                var today = Globalize.format(new Date(), 'yyyyMMdd');
                if (viewModel.input_planStartDate() <= today) {
                    viewModel.popupMinDate = new Date(plan.planStartDate);
                } else {
                    viewModel.popupMinDate = new Date();
                }

                viewModel.input_interval(plan.interval);             
                if (plan.interval == 2) {
                    //每周
                    var list = plan.week;
                    var tempString = '';
                    if (list !== null) {
                        for (var i = 0; i < list.length; i++) {
                            if (list[i] == 1) {
                                tempString = tempString + ' ' + Light.config.weekList[i].name;
                            }
                        }
                    }
                    viewModel.interval(tempString);

                } else if (plan.interval == 3) {
                    //每隔X天
                    var str = Light.config.notifyIntervalList[3].name;
                    viewModel.interval(str.substr(0, 2) + plan.intervalDay + str.substr(3, 1));

                } else {
                    viewModel.interval(Light.config.notifyIntervalList[plan.interval].name);
                }

                viewModel.input_intervalDay(plan.intervalDay);
                viewModel.weekList(plan.week);
                viewModel.input_duration(plan.duration);
                if (plan.interval == 2) {
                    viewModel.duration(plan.duration + Globalize.localize('common-week'));
                } else {
                    viewModel.duration(plan.duration + Globalize.localize('common-day'));
                }
               
                viewModel.input_foodRemark(plan.foodRemark);
                viewModel.foodRemark(Light.config.foodRemarkList[plan.foodRemark].name);
                viewModel.input_remark(plan.remark);

            }

            viewModel.popupPageVisible(false);
            viewModel.pageVisible(true);
        },
        viewHidden: function () {
            viewModel.pageVisible(false);
            Light.action.customMedicinePlan.uploadToServer();
        }
    };

    return viewModel;

};
