﻿Light.MedicineSearch = function (params) {

    //返回 按钮
    backClick = function (e) {
        Light.rtdata.mediSearch_name = viewModel.input_condition();
        Light.app.navigate({ view: "MedicinePlanCreate", medicineBack: 1 });
    };

    //添加 按钮
    plusClick = function (e) {
        Light.rtdata.mediSearch_name = viewModel.input_condition();
        Light.app.navigate({ view: "MedicineCreate", medicineItem: "", del: 0 });
    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: Globalize.localize('medicine-medicineSearch') },
            { location: 'after', widget: 'button', options: { icon: 'light-plus', clickAction: plusClick } },
    ];

    var detailFlg = false;

    //药品检索
    function medicineSearch() {

        viewModel.medicineSource.store().clear();
        viewModel.medicineSource.pageIndex(0);
        viewModel.medicineSource.load();

        var done = function (items) {
            for (var i = 0; i < items.length; i++) {
                var item = items[i];
                viewModel.medicineSource.store().insert({
                    id: item.customMedicineId,
                    name: item.medicineName,
                    memo: item.medicineMemo,
                    eatFrequency: item.eatFrequency,
                    dosage: item.dosage,
                    unit: item.unit,
                });
            }
            viewModel.medicineSource.pageIndex(0);
            viewModel.medicineSource.load();
        };
        Light.action.customMedicine.getAllLike(
            viewModel.input_condition(),
            done,
            function () { }
            );
    };

    var viewModel = {
        input_condition: ko.observable(''),
        medicineSource: new DevExpress.data.DataSource({
            store: [],
            pageSize: 5
        }),

        //检索按钮
        searchClick: function () {
            medicineSearch();
        },

        //药品list 行选择
        medicineSelectClick: function (e) {
            if (!detailFlg) {
                //选择药品
                Light.rtdata.mediSearch_name = null;
                Light.app.navigate({ view: "MedicinePlanCreate", medicineItem: e.itemData });
            }
        },

        //药品详细按钮
        medicineDetailClick: function (object) {
            detailFlg = true;
            Light.rtdata.mediSearch_name = viewModel.input_condition();
            Light.app.navigate({ view: "MedicineCreate", medicineItem: object.model, del: 1 });
        },

        //画面init
        viewShown: function () {

            detailFlg = false;
            viewModel.input_condition('');
            if (Light.rtdata.mediSearch_flg !== "plan") {
                viewModel.input_condition(Light.rtdata.mediSearch_name);
            }

            medicineSearch();

            //调整list
            function getTop(e) {
                var offset = e.offsetTop;
                if (e.offsetParent != null) offset += getTop(e.offsetParent);
                return offset;
            }
            var clientHeight = $(window).height();
            $(".medicineSearch .dx-list").each(function () {
                $(".medicineSearch .dx-list").css("height", (-getTop(this)) % clientHeight + clientHeight + "px");
            });
        }
    };

    return viewModel;
};