﻿Light.SelSolution = function (params) {

    var isPlan = false;

    //返回 按钮
    backClick = function (e) {
        if (isPlan) {
            //Light.app.navigate('Plan', { root: true });
            Light.app.navigate('HealthIndex', { root: true });
        } else {
            Light.app.navigate('Home', { root: true });
        }
    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: Globalize.localize('plan-healthPlan') },
    ];

    var iPlanId = "";
    var iStatus = 0;
    var iCount = 0;
    var flag = 0;//1:暂停，2：继续，3：删除，4：结束

    var today = Light.tool.getDate();
    var tommorrow = new Date();
    tommorrow.setDate(tommorrow.getDate() + 1);

    function displayComplete() {

        $("#containers").dxLinearGauge({
            subvalues: params.day,

            subvalueIndicator: {
                type: 'triangleMarker',
                color: '#f26d7e',
            },

            scale: {
                startValue: 0, 
                endValue: 28,
                majorTick: {
                    tickInterval: 7,
                },
            },

            rangeContainer: {
                ranges: [
                { startValue: 0, endValue: 7, color: '#2fac34' },
                { startValue: 7, endValue: 14, color: '#57c55c' },
                { startValue: 14, endValue: 21, color: '#83e087' },
                { startValue: 21, endValue: 28, color: '#b0fab3' },
                ]
            },

            size: {
                height: 40,
                width: document.body.clientWidth * 0.8,
            }
        });
    };

    var viewModel = {
        pageVisible: ko.observable(false),
        popupPageVisible: ko.observable(false),

        btnTxtSubmit: ko.observable(""),
        btnTxtOne: ko.observable(""),
        tipTxt: ko.observable(""),
        tipVisible: ko.observable(false),
        completeDay: ko.observable(params.day),
        completeVisible: ko.observable(false),
        
        popupDateVisible: ko.observable(false),
        popupDateSelector: ko.observable(Globalize.format(new Date(), 'yyyy/MM/dd')),
        popupMinDate: new Date(),

        viewShown: function () {
            viewModel.popupPageVisible(true);

            $("#btnView").hide();
            viewModel.completeVisible(false);
            viewModel.btnTxtSubmit(Globalize.localize('common-start'));

            if (params.plan == String(true)) {
                isPlan = true;
            } else {
                isPlan = false;
            }

            iPlanId = params.planId;
            iStatus = params.status;
            iCount = params.count;

            flag = 0;

            if (iPlanId != "" && iPlanId != "undefined") {

                $("#btnView").show();
                $("#btnStart").hide();

                if (iStatus == 0 && iCount == 0 && Light.tool.dateDiff(today, params.start) < 0) {//状态：未开始

                    iStatus = -1;
                    $("#btnStart").show();
                    viewModel.btnTxtSubmit(Globalize.localize('plan-status-delete'));//删除

                    $("#btnView").hide();
                    $("#btnOne").hide();

                    viewModel.btnTxtOne("");
                    viewModel.completeVisible(false);

                } else if (iStatus == 0) {//状态：正常
                    
                    if (iCount < 2) {
                        viewModel.btnTxtOne(Globalize.localize('plan-status-stop'));//暂停
                        $("#btnOne").show();
                    } else {
                        viewModel.btnTxtOne("");
                        $("#btnOne").hide();
                    }

                    viewModel.completeVisible(true);

                } else if (iStatus == 3) {//状态：暂停

                    viewModel.btnTxtOne(Globalize.localize('plan-status-regain'));//恢复
                    viewModel.popupMinDate = tommorrow;
                    $("#btnOne").show();

                    viewModel.completeVisible(true);

                } else {//状态：异常

                    viewModel.btnTxtOne("");
                    $("#btnOne").hide();
                    $("#btnView").hide();

                    //计划结束
                    viewModel.completeVisible(true);
                }
            } else {
                $("#btnView").hide();
                $("#btnStart").show();
                viewModel.completeVisible(false);

            }

            viewModel.popupPageVisible(false);
            viewModel.pageVisible(true);
            displayComplete();
        },

        viewHidden: function () {
            viewModel.pageVisible(false);
            Light.action.healthPlan.uploadToServer();
        },

        toDetail: function () {
            Light.app.navigate({ view: 'PlanDetail' });
        },

        toDetail998: function () {
            Light.app.navigate({ view: 'PlanDetail', plan: "998" });
        },

        buy998Click: function () {
            buyToWeb(1);
        },

        toDetail868: function () {
            Light.app.navigate({ view: 'PlanDetail', plan: "868" });
        },

        buy868Click: function () {
            buyToWeb(2);
        },

        toDetailYasu: function () {
            Light.app.navigate({ view: 'PlanDetail', plan: "yasu" });
        },

        buyYasuClick: function () {
            buyToWeb(3);
        },

        toDetailAili: function () {
            Light.app.navigate({ view: 'PlanDetail', plan: "aili" });
        },

        buyAiliClick: function () {
            buyToWeb(4);
        },

        toDetailOther: function () {
            Light.app.navigate({ view: 'PlanDetail', plan: "other" });
        },

        buyOtherClick: function () {
            buyToWeb(5);
        },

        btnSubmit: function () {

            if (iStatus == -1) {
                flag = 3;
                viewModel.tipTxt(Globalize.localize("plan-tip-delete"));
                viewModel.tipVisible(true);
            } else {
                viewModel.popupDateVisible(true);
            }
        },

        popupDateConfirmClick: function () {

            var selDate = Globalize.format(new Date(viewModel.popupDateSelector()), 'yyyyMMdd');

            if (iPlanId == "") {
                //新建计划
                Light.action.healthPlan.createPlan(1, selDate,
                function () {
                    Light.action.notification.renewNotification(function () {
                        Light.action.notification.renewSystemNotification(null, null);
                        viewModel.popupDateVisible(false);
                        if (isPlan) {
                            //Light.app.navigate('Plan', { root: true });
                            Light.app.navigate('HealthIndex', { root: true });
                        } else {
                            Light.app.navigate('Home', { root: true });
                        }
                    }, null);
                }, null);
            } else {
                //恢复计划
                Light.action.healthPlan.continuePlan(iPlanId, selDate,
                function () {
                    Light.action.healthPlan.uploadToServer(null, null);
                    //Light.app.navigate('Plan', { root: true });
                    Light.app.navigate('HealthIndex', { root: true });
                    viewModel.popupDateVisible(false);
                    viewModel.tipVisible(false);
                }, null);
            }
        },

        popupCancelClick: function () {
            viewModel.popupDateVisible(false);
        },

        clickOne: function () {
            if (params.show == String(true)) {
                DevExpress.hardwareBackButton.fire();
            }
            else {
                if (iStatus == 0) {//暂停
                    flag = 1;
                    viewModel.tipTxt(Globalize.localize("plan-tip-stop"));
                    viewModel.tipVisible(true);
                } else if (iStatus == 3) {//继续
                    flag = 2;
                    viewModel.popupDateSelector(Globalize.format(tommorrow, 'yyyy/MM/dd'));
                    viewModel.popupDateVisible(true);
                }
            }
        },

        clickEnd: function () {
            //结束
            flag = 4;
            viewModel.tipTxt(Globalize.localize("plan-tip-end"));
            viewModel.tipVisible(true);
        },

        tipDefine: function () {

            var done = function () {
                Light.action.healthPlan.uploadToServer(null, null);
                //Light.app.navigate('Plan', { root: true });
                Light.app.navigate('HealthIndex', { root: true });
            }

            if (flag == 1) {//暂停
                Light.action.healthPlan.suspendPlan(iPlanId, Light.tool.getDate(), done, function () { });
            } else if (flag == 3) {//删除
                Light.action.healthPlan.deletePlan(iPlanId, done, function () { });
            } else if (flag == 4) {//结束
                Light.action.healthPlan.endPlan(iPlanId, Light.tool.getDate(), done, function () { });
            }

            viewModel.tipVisible(false);
        },

        tipCancel: function () {
            viewModel.tipVisible(false);
        },

    };

    function buyToWeb(type) {

        var url = "";

        switch (type) {
            case 1://1)、 轻之伴-28天健康计划（惊喜套餐） 
                url = "http://51jk.cc/m_index.php?app=m_detail&id=11992";
                break;
            case 2://2）、轻之伴-28天健康计划（超值套餐）
                url = "http://51jk.cc/m_index.php?app=m_detail&id=11991";
                break;
            case 3://3）、 轻之伴-28天健康计划（雅塑）
                url = "http://51jk.cc/m_index.php?app=m_detail&id=11995";
                break;
            case 4://4）、 轻之伴-28天健康计划（艾丽）
                url = "http://51jk.cc/m_index.php?app=m_detail&id=11994";
                break;
            case 5://5）、轻之伴-28天健康计划（智能设备）
                url = "http://51jk.cc/m_index.php?app=m_detail&id=11993";
                break;
        }

        switch (DevExpress.devices.real().platform) {
            case "ios":
                Light.action.serverTo51jkIos(Light.rtdata.memberAcc, url);
                break;
            case "android":
                var fullurl = Light.action.serverTo51jkAndroid(Light.rtdata.memberAcc, url);
                Light.app.navigate({view:'Shop', url:fullurl}, { root: true });
                break;
            default :
                if (window.plugins && window.plugins.seioinappbrowser) {
                    window.plugins.seioinappbrowser(url, "_system", "location=no");
                } else if (window.open) {
                    window.open(url, "_system", 'location=no');
                }
                break;
        }
    };

    return viewModel;
};