﻿Light.BMIResult = function (params) {

    var viewModel = {
        BMI: ko.observable(''),
        metabolism: ko.observable(0),
        weightStart: ko.observable(0),
        weightEnd: ko.observable(0),
        standardWeight: ko.observable(0),
        currentWeight: ko.observable(0),
        BMIInfo: ko.observable(''),

        stdLeft: ko.observable('50%'),
        crtLeft: ko.observable('50%'),
        maxWidth: ko.observable('66.66%'),
        minWidth: ko.observable('33.33%'),

        //画面init
        viewShown: function () {
            Light.action.setting.initRtdata();

            var objHeight = parseFloat(Light.rtdata.common_height);//身高
            var objWeight = parseFloat(Light.rtdata.common_weight);//体重
            var minStd = parseFloat(((objHeight * objHeight) * 18.5 / 10000).toFixed(2));//最低标准体重
            var maxStd = parseFloat(((objHeight * objHeight) * 23.9 / 10000).toFixed(2));//最高标准体重

            viewModel.weightStart(minStd);
            viewModel.weightEnd(maxStd);

            viewModel.metabolism(Light.action.health.getDefaultCalorie().toFixed(2));//基础代谢

            //标准体重
            var stdWeight = 0;
            if (Light.rtdata.common_sex == 0) {
                stdWeight = ((objHeight - 80) * 0.7).toFixed(2);
            } else {
                stdWeight = ((objHeight - 70) * 0.6).toFixed(2);
            }

            viewModel.standardWeight(stdWeight);
            viewModel.currentWeight(objWeight);

            var objMax = parseFloat(maxStd + (maxStd - minStd));
            var objMin = parseFloat(minStd - (maxStd - minStd));

            if (objWeight < objMin) {
                viewModel.crtLeft("0%");
            } else if (objWeight > objMax) {
                viewModel.crtLeft("100%");
            } else {
                viewModel.crtLeft(((objWeight - objMin) / ((objMax - objMin) / 100)).toFixed(1) + "%");
            }

            var objBmi = ((10000 * objWeight) / (objHeight * objHeight)).toFixed(2);

            if (objBmi < 18.5) {
                viewModel.BMI(Globalize.localize('health-BMI') + '=' + objBmi + " " + Globalize.localize('health-BIM-low'));
                viewModel.BMIInfo(Globalize.localize('health-BIM-lowTxt'));
            } else if (objBmi < 23.9) {
                viewModel.BMI(Globalize.localize('health-BMI') + '=' + objBmi + " " + Globalize.localize('health-BIM-normal'));
                viewModel.BMIInfo(Globalize.localize('health-BIM-normalTxt'));
            } else if (objBmi < 26.9) {
                viewModel.BMI(Globalize.localize('health-BMI') + '=' + objBmi + " " + Globalize.localize('health-BIM-high'));
                viewModel.BMIInfo(Globalize.localize('health-BIM-highTxt'));
            } else {
                viewModel.BMI(Globalize.localize('health-BMI') + '=' + objBmi + " " + Globalize.localize('health-BIM-fat'));
                viewModel.BMIInfo(Globalize.localize('health-BIM-fatTxt'));
            }
        },

        loseBtnClick: function () {
            Light.app.navigate({ view: "SelSolution", planId: "" });
        },
        acceBtnClick: function () {
            Light.rtdata.accefrom = 1;
            Light.app.navigate({ view: "acce", planId: "" });
        },
    };

    return viewModel;
};