﻿Light.HealthDevicePairingLexinPedometer = function (params) {

    //ui 旋转圆圈
    var circle_deg = 0;
    var circle_start = false;
    var _circleInterval;
    var circleInterTime = 1;
    function circleInterval() {
        circle_deg = circle_deg + 1;
        if (circle_deg > 360) {
            circle_deg = 0;
        }
        $(".load-circle-bg").css({
            "-webkit-transform": "rotate(" + circle_deg + "deg)",
            "-moz-transform": "rotate(" + circle_deg + "deg)",
            "-o-transform": "rotate(" + circle_deg + "deg)",
            "-ms-transform": "rotate(" + circle_deg + "deg)",
            "transform": "rotate(" + circle_deg + "deg)"
        });
    }
    function startCircle() {
        circle_start = true;
        clearInterval(_circleInterval);
        _circleInterval = setInterval(circleInterval, circleInterTime);
    }

    function stopCircle() {
        circle_start = false;
        clearInterval(_circleInterval);
    }

    //
    var yunyueWeightFlg, lexinWeightFlg, lexinPedometerFlg, healthSyncFlg;

    //获取数据
    function getHealthSettingData() {
        var done = function (rt) {
            yunyueWeightFlg = rt.yunyueWeightSwitch;
            lexinWeightFlg = rt.lexinWeightSwitch;
            lexinPedometerFlg = rt.lexinPedometerSwitch;
            healthSyncFlg = rt.healthSyncSwitch;
        };

        Light.action.setting.getHealthSetting(done);
    };

    //配对状态
    Light.HealthDevicePairingLexinPedometer.lexin_PluginState = function () {

        if (Light.HealthPluginData.health_state == 1) {
            viewModel.deviceMessage(Globalize.localize('health-deviceMessage-lexin-scaning'));

        } else if (Light.HealthPluginData.health_state == 3) {

            viewModel.deviceMessage(Globalize.localize('health-deviceMessage-lexin-discover'));

        } else if (Light.HealthPluginData.health_state == 4) {

            viewModel.deviceMessage(Globalize.localize('health-deviceMessage-lexin-pair_error'));
            stopCircle();

        } else if (Light.HealthPluginData.health_state == 40) {

            viewModel.deviceMessage(Globalize.localize('health-deviceMessage_no_bluetooth'));
            stopCircle();

        } else if (Light.HealthPluginData.health_state == 103) {
            
            viewModel.deviceMessage(Globalize.localize('health-deviceMessage-lexin-pair_device_error'));
            stopCircle();
        }
    };

    //乐心plugin 配对信息取得
    Light.HealthDevicePairingLexinPedometer.lexin_PluginPairInfo = function () {

        if (Light.HealthPluginData.lexinPairInfo.LEXIN_BT_PAIR_TYPE ==102) {

            viewModel.deviceMessage(Globalize.localize('health-deviceMessage-lexin-pair_ok'));

            Light.action.setting.setHealthSwitch(yunyueWeightFlg, lexinWeightFlg, 1, healthSyncFlg);
            Light.action.setting.setLexinPedometerEquipmentId(Light.HealthPluginData.lexinPairInfo.LEXIN_BT_PAIR_DID);
            stopCircle();

        }
    };

    var viewModel = {
        deviceMessage: ko.observable(''),
        pairMessage: ko.observable(''),

        //配对 按钮
        pairClick: function () {
            if (window.plugins && window.plugins.Lexin) {
                startCircle();
                window.plugins.Lexin.startPair([2]);
                Light.HealthPluginData.health_lexin_onState();
                Light.HealthPluginData.health_lexin_onPairInfo();
            }    
        },

        //画面init
        viewShown: function () {
            viewModel.pairMessage(Globalize.localize('profile-healthDevicePairingLexinPedometer-message_ios'));
            switch (DevExpress.devices.real().platform) {
                case "ios":
                    viewModel.pairMessage(Globalize.localize('profile-healthDevicePairingLexinPedometer-message_ios'));
                    break;
                case "android":
                    viewModel.pairMessage(Globalize.localize('profile-healthDevicePairingLexinPedometer-message_android'));
                    break;
            }
            Light.HealthPluginData.startpage = 4;
            stopCircle();
            viewModel.deviceMessage('');
            getHealthSettingData();
        },

        viewHidden: function () {
            viewModel.deviceMessage('');
            stopCircle();
        },

    };

    return viewModel;
};