﻿Light.HealthSetting = function (params) {

    //保存数据
    function dataSave() {
        var tempList = viewModel.deviceSource();
        if (tempList.length == 0) return;

        var autoSyncFlg = 0;
        if (viewModel.input_AutoSync()) {
            autoSyncFlg = 1;
        }
        // Light.action.setting.setHealthSwitch(tempList[0].btnFlg(), tempList[1].btnFlg(), tempList[1].btnFlg(), autoSyncFlg);
        Light.action.setting.setHealthSwitch(tempList[0].btnFlg(), 0, tempList[1].btnFlg(), autoSyncFlg);
    };

    //获取设备list btn Text
    function setBtnText(value) {
        var text = '';
        if (value == 1) {
            text = Globalize.localize('common-delete');
        } else {
            text = Globalize.localize('common-add');
        }
        return text;
    };

    var viewModel = {
        pageVisible: ko.observable(false),
        popupPageVisible: ko.observable(false),

        input_AutoSync: ko.observable(false),
        deviceSource: ko.observable([]),

        //设备list item [xxx]按钮
        deviceItemClick: function (object) {
            tempList = viewModel.deviceSource();

            switch (object.model.id) {
                case 0:
                    //云悦体脂称
                    if (object.model.btnFlg() == 0) {
                        //添加的时候，乐心是否已经添加
                        /*
                        if (tempList[1].btnFlg() == 1) {
                            DevExpress.ui.notify(Globalize.localize('health-deviceMessage-yunyue-pair-weight_keyRepeat'), "error", 2000);
                            break;
                        } else {
                            object.model.btnFlg(1);
                            object.model.btnText(Globalize.localize('common-delete'));
                        }
                        */
                        object.model.btnFlg(1);

                    } else {
                        object.model.btnFlg(0);
                    }

                    object.model.btnText(setBtnText(object.model.btnFlg()));
                    dataSave();
                    break;

                case 1:
                    //乐心体脂称
                    if (object.model.btnFlg() == 0) {
                        //添加的时候，云悦是否已经添加
                        if (tempList[0].btnFlg() == 1) {
                            DevExpress.ui.notify(Globalize.localize('health-deviceMessage-lexin-pair-weight_keyRepeat'), "error", 2000);
                        } else {
                            Light.app.navigate("HealthDevicePairingLexinWeight");
                        }
                    } else {
                        object.model.btnFlg(0);
                        object.model.btnText(setBtnText(object.model.btnFlg()));
                        dataSave();
                    }

                    break;

                case 2:

                    var isPlatformIOS = function(){
                          return device.platform == "iPhone" || device.platform == "iPad" || device.platform == "iPod touch" || device.platform == "iOS"
                        };

                    if (!isPlatformIOS() && device.version >= 5.0) {
                        DevExpress.ui.notify("当前安卓系统不支持乐心手环", "error", 2000);
                        return;
                    }

                    //乐心手环
                    if (object.model.btnFlg() == 0) {
                        //添加的时候，
                        Light.app.navigate("HealthDevicePairingLexinPedometer");
                    } else {
                        object.model.btnFlg(0);
                        object.model.btnText(setBtnText(object.model.btnFlg()));
                        dataSave();
                    }

                    break;
            }

        },

        //上传数据 按钮
        autoSyncClick: function () {
            dataSave();
        },

        //清空缓存 按钮
        clearHealthData: function () {
            var resetnativedata = function () {
                Light.action.resetUserHealthDB();
                DevExpress.ui.notify(Globalize.localize('profile-clearCache-message'), "success", 2000);
            }

            var uploadPedometer = function () {
                Light.action.pedometer.uploadToServer(resetnativedata, resetnativedata);
            }

            Light.action.weight.uploadToServer(uploadPedometer, uploadPedometer);
        },

        //画面Shown
        viewShown: function () {
            viewModel.popupPageVisible(true);
            viewModel.deviceSource([]);

            var done = function (rt) {
                viewModel.input_AutoSync(rt.healthSyncSwitch);

                var tempList = [];
                tempList.push({
                    id: Light.config.deviceList[0].id,
                    name: Light.config.deviceList[0].name,
                    btnFlg: ko.observable(rt.yunyueWeightSwitch),
                    btnText: ko.observable(setBtnText(rt.yunyueWeightSwitch)),
                });
                /*
                tempList.push({
                    id: Light.config.deviceList[1].id,
                    name: Light.config.deviceList[1].name,
                    btnFlg: ko.observable(rt.lexinWeightSwitch),
                    btnText: ko.observable(setBtnText(rt.lexinWeightSwitch)),
                });
                */
                tempList.push({
                    id: Light.config.deviceList[2].id,
                    name: Light.config.deviceList[2].name,
                    btnFlg: ko.observable(rt.lexinPedometerSwitch),
                    btnText: ko.observable(setBtnText(rt.lexinPedometerSwitch)),
                });

                viewModel.deviceSource(tempList);
                viewModel.popupPageVisible(false);
                viewModel.pageVisible(true);
            };

            Light.action.setting.getHealthSetting(done);
        },

        //画面Hidden
        viewHidden: function () {
            viewModel.pageVisible(false);
        }
    };

    return viewModel;
};