﻿Light.PersonalSetting = function (params) {

    var oldPassword;
    var newPassword;
    var flg;

    var viewModel = {

        img_head: ko.observable(''),
        memuberAcc: ko.observable(''),
        sexSource: Light.config.sexList,
        selectedSex: ko.observable(0),
        personalSource: [
            { id: 0, key: "realName", title: Globalize.localize('profile-realName'), value: ko.observable(""), displayValue: ko.observable("") },
            { id: 1, key: "telphone", title: Globalize.localize('profile-telphone'), value: ko.observable(""), displayValue: ko.observable("") },
            { id: 2, key: "userName", title: Globalize.localize('profile-user'), value: ko.observable(""), displayValue: ko.observable("") },
            { id: 3, key: "birthday", title: Globalize.localize('profile-birthday'), value: ko.observable(""), displayValue: ko.observable("") },
            { id: 4, key: "height", title: Globalize.localize('profile-height'), value: ko.observable(""), displayValue: ko.observable("") },
            { id: 5, key: "weight", title: Globalize.localize('profile-weight'), value: ko.observable(""), displayValue: ko.observable("") },
            { id: 6, key: "city", title: Globalize.localize('profile-city'), value: ko.observable(""), displayValue: ko.observable("") },
            { id: 7, key: "group", title: Globalize.localize('profile-group'), value: ko.observable(""), displayValue: ko.observable("") },
            { id: 8, key: "sick", title: Globalize.localize('profile-sick'), value: ko.observable(""), displayValue: ko.observable("") },
        ],
        actionSheetData: [

            {
                text: Globalize.localize('profile-takenPhoto'), clickAction: function () {
                    function onSuccess(imageURI) {
                        Light.rtdata.common_imgHead = "data:image/jpeg;base64," + imageURI;
                        viewModel.img_head(Light.rtdata.common_imgHead);
                        Light.action.setting.setUserHeadImg(Light.rtdata.common_imgHead);
                    }

                    function onFail(message) {
                        //alert('Failed because: ' + message);
                    }

                    if (navigator.camera) {
                        navigator.camera.getPicture(onSuccess, onFail, {
                            quality: 100,
                            destinationType: Camera.DestinationType.DATA_URL,
                            sourceType: Camera.PictureSourceType.CAMERA,
                            allowEdit: true,
                            encodingType: Camera.EncodingType.JPEG,
                            targetWidth: 100,
                            targetHeight: 100,
                            saveToPhotoAlbum: false
                        });
                    }

                }
            },
            {
                text: Globalize.localize('profile-selectPhoto'), clickAction: function () {
                    function onSuccess(imageURI) {
                        Light.rtdata.common_imgHead = "data:image/jpeg;base64," + imageURI;
                        viewModel.img_head(Light.rtdata.common_imgHead);
                        Light.action.setting.setUserHeadImg(Light.rtdata.common_imgHead);
                    }

                    function onFail(message) {
                        //alert('Failed because: ' + message);
                    }

                    if (navigator.camera) {
                        navigator.camera.getPicture(onSuccess, onFail, {
                            quality: 100,
                            destinationType: Camera.DestinationType.DATA_URL,
                            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                            allowEdit: true,
                            encodingType: Camera.EncodingType.JPEG,
                            targetWidth: 100,
                            targetHeight: 100,
                            saveToPhotoAlbum: false
                        });
                    }
                }
            }
        ],
        popupPasswordVisible: ko.observable(false),
        actionSheetVisible: ko.observable(false),
        input_password: ko.observable(''),
        popupTitle: ko.observable(''),
        btnTitle: ko.observable(''),

        //性别tab click
        sexSelectClick: function (e) {
            var s1 = "7dec90cf376700899998018541c35ead";
            var s2 = "478d4831e165fb8b157e2cb2ef70c216";
            var s3 = "" + CryptoJS.MD5(Light.rtdata.common_imgHead);

            if (s3 == s1 || s3 == s2) {
                viewModel.img_head(Light.config.imgHeadList[e.itemData.id].src);
                Light.rtdata.common_imgHead = Light.config.imgHeadList[e.itemData.id].src;
                Light.action.setting.setUserHeadImg(Light.config.imgHeadList[e.itemData.id].src);
            }

            //保存
            if (e.itemData.id) {
                Light.rtdata.common_sex = e.itemData.id;
            } else {
                Light.rtdata.common_sex = 0;
            }
            Light.action.setting.setUserInfoSex(Light.rtdata.common_sex);
        },

        //list 行选择
        personalItemClick: function (e) {
            switch (e.itemData.key) {
                case "realName":
                    Light.app.navigate({ view: 'TextInput', txtFlg: 1, name: e.itemData.title, value: e.itemData.value(), placeholder: Globalize.localize('profile-realName-message') });
                    break;
                case "telphone":
                    Light.app.navigate({ view: 'TextInput', txtFlg: 1, name: e.itemData.title, value: e.itemData.value(), placeholder: Globalize.localize('profile-telphone-placeholder'), mode: 'tel' });
                    break;
                case "userName":
                    Light.app.navigate({ view: 'TextInput', txtFlg: 1, name: e.itemData.title, value: e.itemData.value(), placeholder: Globalize.localize('profile-user-message') });
                    break;
                case "birthday":
                    Light.app.navigate({ view: 'Birth', value: e.itemData.value(), isChange: true });
                    break;
                case "height":
                    Light.app.navigate({ view: 'Height', value: e.itemData.value(), isChange: true });
                    break;
                case "weight":
                    Light.app.navigate({ view: 'Weight', value: e.itemData.value(), isChange: true });
                    break;
                case "city":
                    Light.app.navigate({ view: 'City', value: e.itemData.value(), isChange: true });
                    break;
                case "group":
                    Light.app.navigate({ view: 'Job', value: e.itemData.value(), isChange: true });
                    break;
                case "sick":
                    Light.app.navigate({ view: 'Sick', value: e.itemData.value() });
                    break;
            }
        },

        //密码 变更
        passwordChangeClick: function () {
            flg = 1;
            viewModel.popupPasswordVisible(true);
            viewModel.popupTitle(Globalize.localize('profile-updatePassword-title1'));
            viewModel.input_password('');
            viewModel.btnTitle(Globalize.localize('common-next'));
            newPassword = "";
        },

        //头像 变更
        headImageChangeClick: function () {
            viewModel.actionSheetVisible(true);
        },

        //密码popup 确认按钮
        popupPasswordConfirmClick: function () {
            switch (flg) {
                case 1:
                    var memberPassword = "" + CryptoJS.MD5(viewModel.input_password());
                    if (memberPassword == oldPassword) {
                        viewModel.input_password('');
                        viewModel.popupTitle(Globalize.localize('profile-updatePassword-title2'));
                        viewModel.btnTitle(Globalize.localize('common-next'));
                        flg = 2;
                    } else {
                        viewModel.popupPasswordVisible(false);
                        if (!Light.tool.trim(viewModel.input_password())) {
                            DevExpress.ui.notify(Globalize.localize('profile-updatePassword-length'), "error", 2000);
                        } else {
                            DevExpress.ui.notify(Globalize.localize('profile-updatePassword-message-error'), "error", 2000);
                        }
                    }
                    break;

                case 2:
                    viewModel.input_password(Light.tool.trim(viewModel.input_password()))
                    if (viewModel.input_password() != "") {
                        if (/\s+/g.test(viewModel.input_password())) {
                            DevExpress.ui.notify(Globalize.localize('profile-updatePassword-context-space'), "error", 2000);
                            return;
                        }
                        if (viewModel.input_password().length >= 6 && viewModel.input_password().length <= 16) {
                            newPassword = viewModel.input_password();
                            viewModel.input_password('');
                            viewModel.popupTitle(Globalize.localize('profile-updatePassword-title3'))
                            viewModel.btnTitle(Globalize.localize('common-save'))
                            flg = 3;
                        } else {
                            DevExpress.ui.notify(Globalize.localize('profile-updatePassword-length'), "error", 2000);
                        }
                    } else {
                        DevExpress.ui.notify(Globalize.localize('profile-password') + Globalize.localize('message-notNull'), "error", 2000);
                    }
                    break;

                case 3:
                    if (viewModel.input_password() != "") {
                        console.log(viewModel.input_password());
                        if (newPassword == viewModel.input_password()) {
                            newPassword = "" + CryptoJS.MD5(newPassword);
                            var done = function () {
                                Light.action.setting.setPassword(newPassword);
                                oldPassword = newPassword;
                                viewModel.popupPasswordVisible(false);
                                DevExpress.ui.notify(Globalize.localize('profile-updatePassword-message-success'), "success", 2000);
                            }
                            Light.action.serverEditPassword(oldPassword, newPassword, done,
                                function () { DevExpress.ui.notify(Globalize.localize('profile-updatePassword-message-error'), "error", 2000); });

                        } else {
                            DevExpress.ui.notify(Globalize.localize('profile-updatePassword-different'), "error", 2000);
                        }
                    } else {
                        DevExpress.ui.notify(Globalize.localize('profile-password') + Globalize.localize('message-notNull'), "error", 2000);
                    }
                    break;
            }
        },

        //popup 取消按钮
        popupCancelClick: function () {
            viewModel.popupPasswordVisible(false);
        },
        //画面init
        viewShown: function () {
            var done = function (rt) {

                viewModel.memuberAcc(Globalize.localize('profile-account') + ': ' + rt.memberAcc);
                oldPassword = rt.memberPassword;

                //头像
                viewModel.img_head(rt.userHeadImg);
                Light.rtdata.common_imgHead = rt.userHeadImg;

                //性别
                viewModel.selectedSex(rt.userSex);

                //真实姓名
                viewModel.personalSource[0].displayValue(rt.realName);
                viewModel.personalSource[0].value(rt.realName);

                //联系电话
                viewModel.personalSource[1].displayValue(rt.memberTelephone);
                viewModel.personalSource[1].value(rt.memberTelephone);

                //昵称
                viewModel.personalSource[2].displayValue(rt.userName);
                viewModel.personalSource[2].value(rt.userName);

                //出生年月
                var date = Globalize.format(new Date(Light.tool.getStandardDate(rt.userBirthday)), 'yyyy-MM');
                viewModel.personalSource[3].displayValue(date);
                viewModel.personalSource[3].value(rt.userBirthday);

                //身高
                viewModel.personalSource[4].displayValue(rt.userHeight + Globalize.localize('common-unit-cm'));
                viewModel.personalSource[4].value(rt.userHeight);

                //体重
                viewModel.personalSource[5].displayValue(rt.userWeight + Globalize.localize('common-unit-kg'));
                viewModel.personalSource[5].value(rt.userWeight);

                //城市
                var cityId = 0;
                if (rt.userAddress && rt.userAddress != "") {
                    cityId = Globalize.parseInt(rt.userAddress + '');
                }
                if (Light.config.cityGPSList[cityId].state == Light.config.cityGPSList[cityId].city) {
                    viewModel.personalSource[6].displayValue(Light.config.cityGPSList[cityId].city);
                } else {
                    viewModel.personalSource[6].displayValue(Light.config.cityGPSList[cityId].state + ' ' + Light.config.cityGPSList[cityId].city);
                }
                viewModel.personalSource[6].value(rt.userAddress);

                //人群
                viewModel.personalSource[7].displayValue(Light.config.groupList[rt.userJob].name);
                viewModel.personalSource[7].value(rt.userJob);

                //疾病史
                var disease = "无";
                for (var i = 0; i < rt.disease.length; i++) {
                    if (rt.disease[i] == 1) {
                        disease = "有";
                    }
                }
                viewModel.personalSource[8].displayValue(disease);
                viewModel.personalSource[8].value(rt.disease);

            };
            Light.action.setting.getUserInfo(done);

            if (Light.rtdata.thirdPartyType == 1 || Light.rtdata.thirdPartyType == 2 || Light.rtdata.thirdPartyType == 3) {
                $("#updatePassword").css("visibility", "hidden");
            } else {
                $("#updatePassword").css("visibility", "visible");
            }

            var qrdiv = $('#qrcode');
            qrdiv.empty();
            qrdiv.qrcode({ width: 200, height: 200, text: Light.config.QRCODE_MEMBERID + Light.rtdata.leanCloudSocialId });
        },

        viewHidden: function () {
            Light.action.setting.uploadToServer();
            Light.action.leancloud.user.setUserInfoById(function () { }, function () { });
        }
    };

    return viewModel;
};