﻿Light.Profile = function (params) {

    //返回 按钮
    backClick = function (e) {
        Light.app.navigate('Home', { root: true });
    };

    //menu bar
    toolbarItems = [
            { location: 'before', widget: 'button', options: { icon: 'light-back', clickAction: backClick } },
            { location: 'center', text: Globalize.localize('navbar-profile') },
    ];

    var day = 0;

    var viewModel = {
        img_head: ko.observable(''),
        user: ko.observable(''),
        city: ko.observable(''),

        silverStarNum: ko.observable(0),
        goldStarNum: ko.observable(0),
        moonNum: ko.observable(0),
        sunNum: ko.observable(0),

        meunSource: [
            {
                title: Globalize.localize('favorite-myFavorite'),
                img_icon: "./resource/icon/wealth.png",
                clickAction: "#MyFavorite",
            },
            /*
            {
                title: Globalize.localize('wealth-myWealth'),
                img_icon: "./resource/icon/wealth.png",
                clickAction: "#MyWealth",
            },*/
            {
                title: Globalize.localize('profile-healthSetting'),
                img_icon: "./resource/icon/health.png",
                clickAction: "#HealthSetting",
            },
            {
                title: Globalize.localize('profile-setting'),
                img_icon: "./resource/icon/setup.png",
                clickAction: "#Setting",
            },
            {
                title: Globalize.localize('ibeacon-shake'),
                img_icon: "./resource/icon/shake.png",
                clickAction: "#Shake",
            },
            {
                title: Globalize.localize('profile-aboutApp'),
                img_icon: "./resource/icon/sign.png",
                clickAction: "#AboutApp",
            },
            {
                title: Globalize.localize('profile-exit'),
                img_icon: "./resource/icon/exit.png",
                clickAction: function () { viewModel.popupLogoutVisible(true); },
            },
        ],

        popupTryVisible: ko.observable(false),
        popupLogoutVisible: ko.observable(false),
        popupExitLoadingVisible: ko.observable(false),
        popupLogoutConfirmVisible: ko.observable(false),

        //个人信息
        PersonalSettingClick: function(){
            if (Light.rtdata.memberAcc == Light.config.TRIAL_USER_KEY) {
                //试用用户
                viewModel.popupTryVisible(true);
            } else {
                //正式用户
                Light.app.navigate('PersonalSetting');
            }
        },

        //星星说明
        starExplainClick:function(){
            Light.app.navigate({ view: 'StarExplain', day: day });
        },

        //试用popup 确认按钮
        popupTryConfirmClick: function () {
            viewModel.popupTryVisible(false);
            Light.app.navigate('Register');
        },

        popupLogoutConfirmYes: function () {
            viewModel.popupLogoutConfirmVisible(false);
            Light.action.resetNative();
            Light.action.leancloud.user.signOut();
        },

        popupLogoutConfirmNo: function () {
            viewModel.popupLogoutConfirmVisible(false);
        },


        //退出popup 确认按钮
        popupLogoutConfirmClick: function () {
            viewModel.popupLogoutVisible(false);
            viewModel.popupExitLoadingVisible(true);

            if (Light.rtdata.memberAcc == Light.config.TRIAL_USER_KEY) {
                Light.action.resetNative();
            } else {
                
                var typelist = [
                    "setting",
                    "pedometer",
                    "weight",
                    "surveys",
                    "calorie",
                    "customMedicine",
                    "customMedicinePlan",
                    "healthPlan",
                    "coin",
                    "honor",
                    "favorite",
                    "leancloud"];
                var resultlist = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
                var callback = function (tag, isSuccess) {
                    for (var i = 0; i < typelist.length; i++) {
                        if (typelist[i] == tag) {
                            if (isSuccess) {
                                resultlist[i] = 1;
                            } else {
                                resultlist[i] = 2;
                            }
                            break;
                        }
                    }
                    for (var i = 0; i < resultlist.length; i++) {
                        if (resultlist[i] == 0) {
                            return;
                        }
                    }
                    //all response 
                    var rt = "";
                    for (var i = 0; i < resultlist.length; i++) {
                        rt = rt + "\n" + typelist[i] + ":" + resultlist[i];
                    }

                    //退出
                    Light.action.serverUnbindMemberDevice(
                        Light.rtdata.memberAcc,
                        Light.rtdata.memberPassword,
                        function () {
                            viewModel.popupExitLoadingVisible(false);
                            Light.action.resetNative();
                            Light.action.leancloud.user.signOut();
                        },
                        function () {
                            viewModel.popupExitLoadingVisible(false);
                            //viewModel.popupLogoutConfirmVisible(true);
                            DevExpress.ui.notify(Globalize.localize('profile-exit-message_error'), "error", 1000);
                            Light.action.resetNative();
                            Light.action.leancloud.user.signOut();
                        }
                    );
                }
                Light.action.coin.uploadToServer(function () { callback("coin", true); }, function () { callback("coin", false); });
                Light.action.honor.uploadToServer(function () { callback("honor", true); }, function () { callback("honor", false); });
                Light.action.pedometer.uploadToServer(function () { callback("pedometer", true); }, function () { callback("pedometer", false); });
                Light.action.weight.uploadToServer(function () { callback("weight", true); }, function () { callback("weight", false); });
                Light.action.surveys.uploadToServer(function () { callback("surveys", true); }, function () { callback("surveys", false); });
                Light.action.customMedicine.uploadToServer(function () { callback("customMedicine", true); }, function () { callback("customMedicine", false); });
                Light.action.customMedicinePlan.uploadToServer(function () { callback("customMedicinePlan", true); }, function () { callback("customMedicinePlan", false); });
                Light.action.healthPlan.uploadToServer(function () { callback("healthPlan", true); }, function () { callback("healthPlan", false); });
                Light.action.calorie.uploadToServer(function () { callback("calorie", true); }, function () { callback("calorie", false); });
                Light.action.setting.uploadToServer(function () { callback("setting", true); }, function () { callback("setting", false); });
                Light.action.favorite.uploadToServer(function () { callback("favorite", true); }, function () { callback("favorite", false); });
                Light.action.leancloud.user.setUserInfoById(function () { callback("leancloud", true); }, function () { callback("leancloud", false); });
            }

        },

        //popup 取消按钮
        popupCancelClick: function () {
            viewModel.popupTryVisible(false);
            viewModel.popupLogoutVisible(false);
        },

        //画面init
        viewShown: function () {
            //leanCloud 初期化
            Light.action.leancloud.user.signIn(function () { }, function () { });

            //用户信息
            viewModel.img_head(Light.rtdata.common_imgHead);
            viewModel.user(Light.rtdata.common_userName);
            var cityId = Globalize.parseInt(Light.rtdata.common_city + '');
            if (Light.config.cityGPSList[cityId].state == Light.config.cityGPSList[cityId].city) {
                 viewModel.city(Light.config.cityGPSList[cityId].city);
            } else {
                viewModel.city(Light.config.cityGPSList[cityId].state + ' ' + Light.config.cityGPSList[cityId].city);
            }

            //获得星星
            var starDone = function (rs) {
                for (var i = 0; i < rs.length; i++) {
                    switch (rs[i].name) {
                        case 'yinxing':
                            viewModel.silverStarNum(rs[i].total);
                            break;
                        case 'jinxing':
                            viewModel.goldStarNum(rs[i].total);
                            break;
                        case 'yueliang':
                            viewModel.moonNum(rs[i].total);
                            break;
                        case 'taiyang':
                            viewModel.sunNum(rs[i].total);
                            day = rs[i].current;
                            break;
                    }
                }
            };
            Light.action.honor.getAll(starDone, function () { });
        },
    };

    return viewModel;
};