﻿Light.Setting = function (params) {

    //提醒数据保存
    function notifyDataSave() {

        if (viewModel.notifySource[0].value()) {
            Light.rtdata.medicine_notification_switch = 1;
        } else {
            Light.rtdata.medicine_notification_switch = 0;
        }

        if (viewModel.notifySource[1].value()) {
            Light.rtdata.health_notification_switch = 1;
        } else {
            Light.rtdata.health_notification_switch = 0;
        }

        Light.action.setting.setPlanNotificationSwitch(Light.rtdata.medicine_notification_switch, Light.rtdata.health_notification_switch, 0, 0);

    };


    //隐私数据保存
    function privacyDataSave() {
        Light.rtdata.common_privacy_sex = viewModel.privacySource[0].value()?1:0;
        Light.rtdata.common_privacy_birth = viewModel.privacySource[1].value()?1:0;
        Light.rtdata.common_privacy_height = viewModel.privacySource[2].value() ? 1 : 0;
        Light.rtdata.common_privacy_weight = viewModel.privacySource[3].value() ? 1 : 0;
        Light.rtdata.common_privacy_city = viewModel.privacySource[4].value() ? 1 : 0;
        Light.rtdata.common_privacy_job = viewModel.privacySource[5].value() ? 1 : 0;
        Light.rtdata.common_privacy_disease = viewModel.privacySource[6].value() ? 1 : 0;

        
        Light.action.setting.setPrivacy(Light.rtdata.common_privacy_sex, Light.rtdata.common_privacy_birth, Light.rtdata.common_privacy_height, Light.rtdata.common_privacy_weight, Light.rtdata.common_privacy_city, Light.rtdata.common_privacy_job, Light.rtdata.common_privacy_disease);
    };

    var viewModel = {

        notifySource: [
            { id: 0, name: Globalize.localize('profile-medicineNotify'), value: ko.observable(1) },
            { id: 1, name: Globalize.localize('profile-healthNotify'), value: ko.observable(1) },
        ],

        privacySource: [
            { id: 0, name: Globalize.localize('profile-sex'), value: ko.observable(0) },
            { id: 1, name: Globalize.localize('profile-birthday'), value: ko.observable(0) },
            { id: 2, name: Globalize.localize('profile-height'), value: ko.observable(0) },
            { id: 3, name: Globalize.localize('profile-weight'), value: ko.observable(0) },
            { id: 4, name: Globalize.localize('profile-city'), value: ko.observable(0) },
            { id: 5, name: Globalize.localize('profile-group'), value: ko.observable(0) },
            { id: 6, name: Globalize.localize('profile-sick'), value: ko.observable(0) },
        ],
        privacySelectSource: Light.config.privacySelectList,

        //数据保存
        saveNotifyClick: function (object) {
            notifyDataSave();
        },

        //数据保存
        savePrivacyClick: function (object) {
            privacyDataSave();
        },

        //画面Shown
        viewShown: function () {
            var done = function (rt) {
                //服药提醒
                viewModel.notifySource[0].value(rt.medicineNotificationSwitch);
                //健康提醒
                viewModel.notifySource[1].value(rt.healthNotificationSwitch);

                //性别
                viewModel.privacySource[0].value(rt.privacySex);
                //生日
                viewModel.privacySource[1].value(rt.privacyBirthday);
                //身高
                viewModel.privacySource[2].value(rt.privacyHeight);
                //体重
                viewModel.privacySource[3].value(rt.privacyWeight);
                //城市
                viewModel.privacySource[4].value(rt.privacyCity);
                //人群
                viewModel.privacySource[5].value(rt.privacyGroup);
                //疾病
                viewModel.privacySource[6].value(rt.privacySick);

            };
            Light.action.setting.getPlanNotificationSwitch(done);

        },

        //画面Hidden
        viewHidden: function () {
            Light.action.setting.uploadToServer();
            Light.action.leancloud.user.setUserInfoById(function () { }, function () { });

            Light.action.notification.renewNotification(
                function () { Light.action.notification.renewSystemNotification(null, null); },
                null);
        }
    };

    return viewModel;
};