﻿Light.initApp = function (params) {

    var jpushid = "testjpushid";
    var deviceinfo = {
        model: "testmodel",
        platform: "testplatform",
        version: "0.0.0"
    };

    //init rtdata 
    var init_rtdata_data = function () {
        Light.rtdata.jpush_id = "testjpushid";
        Light.rtdata.device_info = {
            model: "testmodel",
            platform: "testplatform",
            version: "0.0.0"
        };

        Light.action.setting.initRtdata();
    };

    //prepare device info and jpush id
    var prepareInfo = function (donefunc) {

        if (window.device) {
            Light.rtdata.device_info.model = "" + window.device.model + "";
            Light.rtdata.device_info.platform = "" + window.device.platform + "";
            Light.rtdata.device_info.version = "" + window.device.version + "";
        }

        donefunc();
    }

    var go2home = function () {

        if (window.plugins && window.plugins.NativePush) {
            var getStartPushDone = function (id) {
                if (id && id != "") {
                    Light.rtdata.notification_onstart_flag = 1;
                    var typedate = id.split(",");
                    Light.rtdata.notification_onstart_datetime = typedate[2];
                    Light.rtdata.notification_onstart_type_detail = typedate[1];
                    Light.rtdata.notification_onstart_type = typedate[0];
                    Light.app.navigate('Schedule', { root: true });
                } else {
                    Light.rtdata.notification_onstart_flag = 0;
                    Light.rtdata.notification_onstart_datetime = "";
                    Light.rtdata.notification_onstart_type = "";
                    Light.rtdata.notification_onstart_type_detail = "";
                    Light.app.navigate('Home', { root: true });
                }
            };

            window.plugins.NativePush.getPushOnStart(getStartPushDone);
        } else {
            Light.app.navigate('Home', { root: true });
        }
    };

    //init native notification
    var init_notification = function (donefunc) {
        var renewdone = function (count) {

            Light.action.notification.renewSystemNotification(
                donefunc,
                function () {
                    DevExpress.ui.notify("通知更新失败.", "error", 300);
                    donefunc();
                }
                );
        };

        Light.action.notification.renewNotification(renewdone, donefunc);
    };

    var onNativePush = function (item) {

        try {
            var list = item.split(",");
            var type = list[0];
            var typedetail = list[1];
            var datetime = list[2];
            var content = Light.config.scheduleItemsList[0].notify[0];
            if (type == "health") {
                content = Light.config.scheduleItemsList[typedetail].notify[0];
            }
            if (list.length > 3) {
                Light.rtdata.notification_onstart_flag = 1;
                Light.rtdata.notification_onstart_datetime = datetime;
                Light.rtdata.notification_onstart_type_detail = typedetail;
                Light.rtdata.notification_onstart_type = type;
                if (window.location.href.indexOf('Schedule') != -1) {
                    Light.Schedule.shown();
                } else {
                    Light.app.navigate('Schedule', { root: true });
                }
            } else {
                DevExpress.ui.notify(content + "", "info", 2000);
            }

        } catch (exception) {
            console.log(exception);
        }
    };

    //init plugins 
    var initPlugins = function () {
        if (window.plugins.Yunyue) {
            window.plugins.Yunyue.registStateCallback(Light.HealthPluginData.health_yunyue_onState);
            window.plugins.Yunyue.registAllDataCallback(Light.HealthPluginData.health_yunyue_onAllData);
            window.plugins.Yunyue.initService(null);
        }
        if (window.plugins.Lexin) {
            window.plugins.Lexin.registStateCallback(Light.HealthPluginData.health_lexin_onState);
            window.plugins.Lexin.registWeightCallback(Light.HealthPluginData.health_lexin_onWeight);
            window.plugins.Lexin.registPedometerCallback(Light.HealthPluginData.health_lexin_onPedometer);
            window.plugins.Lexin.registPairInfoCallback(Light.HealthPluginData.health_lexin_onPairInfo);
            window.plugins.Lexin.initService(null);
        }
        if (window.plugins.NativePush) {
            window.plugins.NativePush.registPushCallback(onNativePush);
        }
        //if (window.plugins.SharesdkAuth) {
        //    window.plugins.SharesdkAuth.registAuthCallback(Light.action.onauth);
        //};
    };

    //download init data from server
    var serverForData = function () {
        //lock screen
        viewModel.network_request = "for_data";
        viewModel.retryvisible(false);
        viewModel.loadtextvisible(true);
        viewModel.loadvisible(true);

        //console.log("downloadData:");
        var typelist = ["solution", "food", "movement"];
        var resultlist = [0, 0, 0];

        var callback = function (tag, isSuccess) {
            for (var i = 0; i < typelist.length; i++) {
                if (typelist[i] == tag) {
                    if (isSuccess) {
                        resultlist[i] = 1;
                    } else {
                        resultlist[i] = 2;
                    }
                    break;
                }
            }
            for (var i = 0; i < resultlist.length; i++) {
                if (resultlist[i] == 0) {
                    return;
                }
            }

            for (var i = 0; i < resultlist.length; i++) {
                if (resultlist[i] == 2) {
                    //unlock screen
                    viewModel.network_request = "for_data";
                    viewModel.retryvisible(true);
                    viewModel.loadtextvisible(false);
                    viewModel.loadvisible(false);
                    if (type == "logic") {
                        DevExpress.ui.notify("网络状况异常，请检查网络是否联通.", "error", 500);
                        return;
                    }
                }
            }

            viewModel.network_request = "";
            //unlock screen
            Light.app.navigate('Welcome', { root: true });
        }

        Light.action.healthSolution.downloadFromServer(function () { callback("solution", true); }, function () { callback("solution", false); });
        Light.action.food.downloadFromServer(function () { callback("food", true); }, function () { callback("food", false); });
        Light.action.movement.downloadFromServer(function () { callback("movement", true); }, function () { callback("movement", false); });


    };

    //get udid from server
    var serverForUDID = function () {
        viewModel.network_request = "for_udid";
        viewModel.retryvisible(false);
        viewModel.loadtextvisible(true);
        viewModel.loadvisible(true);
        //lock screen
        Light.network.getUDID(
                                      Light.rtdata.jpush_id, Light.rtdata.device_info,
                                      function (UDID) {
                                          Light.rtdata.UDID = UDID;
                                          Light.action.setting.saveUDID(UDID);
                                          Light.action.setting.initRtdata();
                                          serverForData();
                                      },
                                      function (type) {
                                          viewModel.retryvisible(true);
                                          viewModel.loadtextvisible(false);
                                          viewModel.loadvisible(false);
                                          if (type == "logic") {
                                              
                                              DevExpress.ui.notify("网络状况异常，请检查网络是否联通.", "error", 500);
                                          }
                                      }
                                      );
    };

    //upload data to server
    var uploadData = function () {
        //lock screen
        var typelist = [
            "setting",
            "pedometer",
            "weight",
            "surveys",
            "calorie",
            "customMedicine",
            "customMedicinePlan",
            "healthPlan",
            "coin",
            "honor",
            "favorite"];
        var resultlist = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        var callback = function (tag, isSuccess) {
            for (var i = 0; i < typelist.length; i++) {
                if (typelist[i] == tag) {
                    if (isSuccess) {
                        resultlist[i] = 1;
                    } else {
                        resultlist[i] = 2;
                    }
                    break;
                }
            }
            for (var i = 0; i < resultlist.length; i++) {
                if (resultlist[i] == 0) {
                    return;
                }
            }
            //all response 
            var rt = "";
            for (var i = 0; i < resultlist.length; i++) {
                rt = rt + "\n" + typelist[i] + ":" + resultlist[i];
            }

            //unlock screen
            go2home();
        }

        Light.action.coin.uploadToServer(function () { callback("coin", true); }, function () { callback("coin", false); });
        Light.action.honor.uploadToServer(function () { callback("honor", true); }, function () { callback("honor", false); });

        Light.action.pedometer.uploadToServer(function () { callback("pedometer", true); }, function () { callback("pedometer", false); });
        Light.action.weight.uploadToServer(function () { callback("weight", true); }, function () { callback("weight", false); });
        Light.action.surveys.uploadToServer(function () { callback("surveys", true); }, function () { callback("surveys", false); });
        Light.action.customMedicine.uploadToServer(function () { callback("customMedicine", true); }, function () { callback("customMedicine", false); });
        Light.action.customMedicinePlan.uploadToServer(function () { callback("customMedicinePlan", true); }, function () { callback("customMedicinePlan", false); });
        Light.action.healthPlan.uploadToServer(function () { callback("healthPlan", true); }, function () { callback("healthPlan", false); });
        Light.action.calorie.uploadToServer(function () { callback("calorie", true); }, function () { callback("calorie", false); });
        Light.action.setting.uploadToServer(function () { callback("setting", true); }, function () { callback("setting", false); });
        Light.action.favorite.uploadToServer(function () { callback("favorite", true); }, function () { callback("favorite", false); });

    };

    var viewModel = {

        //  Put the binding properties here
        network_request: "",
        retryvisible: ko.observable(false),
        loadvisible: ko.observable(true),
        loadtextvisible: ko.observable(true),
        Retry: function () {
            //alert(" retry start");
            if (this.network_request == "for_udid") {
                serverForUDID();
            } else if (this.network_request == "for_data") {
                serverForData();
            }
        },

        viewShown: function () {
            

            if (navigator["splashscreen"]) {
                navigator["splashscreen"].hide();
            }

            var get_account_done = function (rt) {

                if (rt.memberLoginFlg == "1" && rt.memberAcc != "" && rt.UDID != "") {
                    //init rtdata 
                    init_rtdata_data();

                    var login2server = function () {
                        Light.action.serverLogin(
                                function () {
                                    //DevExpress.ui.notify("debug:login with network.", "info", 1000);
                                    uploadData();
                                },
                                function(key) {
                                    if (key == "acc") {
                                        //nothing
                                    } else {
                                        go2home();
                                    }
                                }
                                );
                    };

                    if (rt.memberAcc == Light.config.TRIAL_USER_KEY) {
                        init_notification(go2home);
                    } else {
                        init_notification(login2server);
                    }
                } else {
                    //app first init
                    Light.action.resetAllDB();

                    //prepare device info
                    prepareInfo(serverForUDID);
                }
            };

            //init plugins
            if (window.plugins) {
                initPlugins();
            }
            setTimeout(function () {
                Light.action.setting.getAccount(get_account_done, function () { get_account_done({}); });
            }, 500);
            //restore app setting (udid, acc ...)
            //Light.action.setting.getAccount(get_account_done, function () { get_account_done({}); });
        },

        viewHidden: function () {

        },
    };

    return viewModel;
};
