﻿Light.City = function (params) {

    var viewModel = {

        txtNext: ko.observable(''),
        dataCity: ko.observable(''),
        objCity: Light.config.cityGPSList,

        nextClick: function () {
            selectId = viewModel.dataCity() + '';
            if (isNaN(Globalize.parseInt(selectId))) {
                selectId = '0';
            }

            Light.rtdata.common_city = Globalize.parseInt(selectId + '');
            Light.action.setting.setUserInfoAddress(selectId);

            if (params.isChange == String(true)) {
                DevExpress.hardwareBackButton.fire();
            } else {
                Light.app.navigate({ view: 'Job', register: params.register, other: params.other });
            }
        },

        //画面init
        viewShown: function () {

            if (params.isChange == String(true)) {
                viewModel.txtNext(Globalize.localize('common-confirm'));
                viewModel.dataCity(params.value);

            } else {
                //定位
                viewModel.txtNext(Globalize.localize('profile-continue'));

                var onIosSuccess = function (position) {
                    var city = Light.tool.getCity(position.coords.latitude, position.coords.longitude, Light.config.cityGPSList);
                    viewModel.dataCity(city.id);
                };

                var onAndroidSuccess = function (position) {
                    if ((position.code == 61) || (position.code == 161)) {
                        var city = Light.tool.getCity(position.coords.latitude, position.coords.longitude, Light.config.cityGPSList);
                        viewModel.dataCity(city.id);
                    } else {
                        viewModel.dataCity('0');
                    }
                };

                var onError = function (error) {
                    viewModel.dataCity('0');
                }

                switch (DevExpress.devices.real().platform) {
                    case "ios":
                        navigator.geolocation.getCurrentPosition(onIosSuccess, onError);
                        break;
                    case "android":
                        window.BaiduGeolocation.getCurrentPosition(onAndroidSuccess, onError);
                        break;
                    default:
                        viewModel.dataCity('0');
                        break;
                }
            }
        },
    };

    return viewModel;
};