﻿Light.TextInput = function (params) {

    var viewModel = {
        titleName: params.name,
        flg: params.txtFlg,
        input_value: ko.observable(""),
        input_mode: ko.observable(""),
        input_placeholder: ko.observable(""),

        //确定click
        confirmClick: function () {
            switch (params.name) {
                case Globalize.localize('profile-realName'):
                    //真实姓名
                    var realName = viewModel.input_value();
                    if (Light.tool.trim(realName) == '') {
                        DevExpress.ui.notify(Globalize.localize('profile-realName') + Globalize.localize('message-notNull'), "error", 2000);
                        return;

                    } else {
                        var len = realName.replace(/[^\x00-\xff]/g, "xx");
                        if (len.length > 10) {
                            DevExpress.ui.notify(Globalize.localize('profile-realName-message'), "error", 2000);
                            return;
                        }
                        Light.rtdata.common_realName = realName;
                        Light.action.setting.setRealName(realName);
                    }
                    DevExpress.hardwareBackButton.fire();
                    break;

                case Globalize.localize('profile-user'):
                    //昵称
                    var user = viewModel.input_value();
                    if (Light.tool.trim(user) == '') {
                        DevExpress.ui.notify(Globalize.localize('profile-user') + Globalize.localize('message-notNull'), "error", 2000);
                        return;

                    } else {
                        var userlen = user.replace(/[^\x00-\xff]/g, "xx");
                        if (userlen.length > 20) {
                            DevExpress.ui.notify(Globalize.localize('profile-user-message'), "error", 2000);
                            return;
                        }

                        Light.rtdata.common_userName = user;
                        Light.action.setting.setUserInfoUserName(user);
                    }
                    DevExpress.hardwareBackButton.fire();
                    break;

                case Globalize.localize('profile-telphone'):
                    //手机号
                    var tel = viewModel.input_value();
                    if (Light.tool.trim(tel) == '') {
                        DevExpress.ui.notify(Globalize.localize('profile-telphone-placeholder') + Globalize.localize('message-notNull'), "error", 2000);
                        return;

                    } else {
                        var reTel = new RegExp("^[1][3578][0-9]{9}$");
                        if (!reTel.test(tel)) {
                            DevExpress.ui.notify(Globalize.localize('profile-regist-phoneNumberfail'), "error", 2000);
                            return;
                        } else {
                            Light.rtdata.common_phone = tel;
                            Light.action.setting.setTelephoneEmail(tel, null);
                        }
                    }
                    DevExpress.hardwareBackButton.fire();
                    break;

                case Globalize.localize('partner-groupName'):
                    //群名称
                    var name = Light.tool.trim(viewModel.input_value());
                    if (name) {
                        var namelen = name.replace(/[^\x00-\xff]/g, "xx");
                        if (namelen.length > 20) {
                            DevExpress.ui.notify(Globalize.localize('partner-groupName-message'), "error", 2000);
                            return;
                        }
                    }

                    if (window.plugins && window.plugins.LeanChat) {
                        window.plugins.LeanChat.registStatusCallback(Light.PartnerPluginData.groupData_onState);
                        window.plugins.LeanChat.editGroupName(Light.rtdata.leanCloudSocialId, params.groupId, name);
                    }

                    break;

                case Globalize.localize('partner-groupIntroduction'):
                    //群介绍
                    var desc = viewModel.input_value();

                    if (window.plugins && window.plugins.LeanChat) {
                        window.plugins.LeanChat.registStatusCallback(Light.PartnerPluginData.groupData_onState);
                        window.plugins.LeanChat.editGroupDesc(Light.rtdata.leanCloudSocialId, params.groupId, desc);
                    }

                    break;
            }

            
        },

        //画面init
        viewShown: function () {
            if (params.value) {
                viewModel.input_value(params.value);
            } else {
                if (params.placeholder) {
                    viewModel.input_placeholder(params.placeholder);
                }
            }

            if (params.mode) {
                viewModel.input_mode(params.mode);
            } else {
                viewModel.input_mode('text');
            }
        },

        //画面Hidden
        viewHidden: function () {
            viewModel.input_value("");
            viewModel.input_placeholder("");
        },

    };

    return viewModel;
};