﻿Light.Shop = function (params) {

    function displayShop() {

        viewModel.img_info('');
        viewModel.infoText('');
        viewModel.popupPageVisible(true);

        //网络check
        if (Light.network.checkConnection()) {
            viewModel.networkFlg(true);
        } else {
            viewModel.networkFlg(false);
        }

        viewModel.popupPageVisible(false);

        if (viewModel.networkFlg()) {
            //有网络
            switch (DevExpress.devices.real().platform) {
                case "ios":
                    Light.action.serverTo51jkIos(Light.rtdata.memberAcc, Light.config.CC_51JK.REDIRECT_URL);
                    break;
                case "android":
                    var url = Light.action.serverTo51jkAndroid(Light.rtdata.memberAcc, Light.config.CC_51JK.REDIRECT_URL);
                    if (params.url) {
                        url = params.url;
                    }
                    document.getElementById("showframe").src = url;
                    break;
                default:
                    var url = Light.config.CC_51JK.REDIRECT_URL;
                    if (params.url) {
                        url = params.url;
                    }
                    if (window.open) {
                        window.open(url, "_system", 'location=no');
                    }
                    break;
            }
        } else {
            //无网络
            viewModel.img_info('./resource/img/noNetwork.gif');
            viewModel.infoText(Globalize.localize('profile-network-disconnect'));
        }
    }

    var viewModel = {
        networkFlg: ko.observable(true),

        img_info: ko.observable(''),
        infoText: ko.observable(''),

        popupPageVisible: ko.observable(false),

        //返回
        backClick: function(){
            Light.app.navigate('Home', { root: true });
        },

        //页面刷新
        refreshClick: function(){
            displayShop();
        },

        //画面Shown
        viewShown: function () {
            displayShop();
        }
    };

    return viewModel;
};